/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "my_util.h"
#include "carray_util.h" 
struct dll_slist *dll_string_get_init()
{
  struct dll_slist *d;
  d = (struct dll_slist *)myalloc(sizeof(struct dll_slist));
  d->n = 0;
  d->first = d->last = NULL;
  return d;
}
void dll_string_free(d)
     struct dll_slist *d;
{
  struct strel *t,*t1;
  t = d->first;
  while(t!=NULL){
    t1 = t;
    t = t->next;
    myfree(t1->s);
    myfree(t1);
  }
  myfree(d);
}
void dll_string_print(d)
     struct dll_slist *d;
{
  struct strel *t;
  t = d->first;
  while(t!=NULL){
    printf("%s\n",t->s);
    t = t->next;
  }
}
void dll_string_write_file(d,outfile)
     struct dll_slist *d;
     char outfile[];
{
  struct strel *t;
  FILE *fopen(),*fout;
  if ((fout = fopen(outfile,"w"))==NULL)
    exit_error("DLL_STRING_WRITE_FILE","Cannot open file");
  t = d->first;
  while(t!=NULL){
    fprintf(fout,"%s\n",t->s);
    t = t->next;
  }
  fclose(fout);
}
void dll_string_insert(d,str)
     struct dll_slist *d;
     char *str;
{
  struct strel *t,*tt;
  if (d->n == 0){
    d->first = (struct strel *)myalloc(sizeof(struct strel));
    d->first->s = strdup(str);
    d->first->prev = d->first->next = NULL;
    d->n += 1;
    d->last = d->first;
  }else{
    t = d->first;
    while((strcmp(t->s,str)<0)&&(t->next != NULL))
      t = t->next;
    if (strcmp(t->s,str)==0){ 
      ;
    }else{ 
      tt = (struct strel *)myalloc(sizeof(struct strel));
      tt->s = strdup(str);
      d->n += 1;
      if (strcmp(t->s,str)<0){ 
	tt->prev = t;
	tt->next = NULL;
	t->next = tt;
	d->last = tt;
      }else{
	tt->prev = t->prev;
	tt->next = t;
	t->prev = tt;
	if (tt->prev != NULL){ 
	  tt->prev->next = tt;
	}else{
	  d->first = tt; 
	}
      }
    }
  }
}
struct strel *dll_string_search(d,str)
     struct dll_slist *d;
     char *str;
{
  struct strel *t,*tt;
  tt = NULL;
  if (d->n > 0){
    t = d->first;
    while((strcmp(t->s,str)!=0)&&(t->next != NULL))
      t = t->next;
    if (strcmp(t->s,str)==0){ 
      tt = t;
    }
  }
  return tt;
}
void dll_string_append(d,str,repflag)
     struct dll_slist *d;
     char *str;
     int repflag;  
{
  int fflag;
  struct strel *t,*tt;
  if (d->n == 0){
    d->first = (struct strel *)myalloc(sizeof(struct strel));
    d->first->s = strdup(str);
    d->first->prev = d->first->next = NULL;
    d->n += 1;
    d->last = d->first;
  }else{
    if (dll_string_search(d,str) == NULL)
      fflag = 0;
    else
      fflag = 1;
    if ((fflag == 0) || ((fflag == 1) && repflag)){
      tt = (struct strel *)myalloc(sizeof(struct strel));
      tt->s = strdup(str);
      tt->prev = d->last;
      tt->next = NULL;
      d->last->next = tt;
      d->last = tt;
      d->n += 1;
    }
  }
}
char **dll_string_get_slist(d)
     struct dll_slist *d;
{
  int i;
  int n;
  char **slist;
  struct strel *t;
  n = d->n;
  slist = (char **)myalloc(n*sizeof(char *));
  i = 0;
  t = d->first;
  while(t!=NULL){
    slist[i] = strdup(t->s);
    t = t->next;
    i += 1;
  }
  return slist;
}
char *dll_string_get_nth_string_ptr(d,n)
     struct dll_slist *d;
     int n;
{
  int i;
  char *s;
  struct strel *t;
  if (d == NULL)
    exit_error("DLL_STRING_GET_NTH_STRING_PTR","dll is null");
  if ((d->first == NULL) && (d->n > 0))
    exit_error("DLL_STRING_GET_NTH_STRING_PTR","First is null");
  s = NULL;
  if (n < d->n){
    t = d->first;
    for(i=0;i<n;i++){
      t = t->next;
      if (t == NULL)
	exit_error("DLL_STRING_GET_NTH_STRING_PTR","Unexpected null");
    }
    s = t->s;
  }
  return s;
}
int string_count_char(s,c)
     char *s;   
     char c;    
{
  int i;
  int n,cnt;
  cnt = 0;
  n = strlen(s);
  for(i=0;i<n;i++)
    if (s[i] == c)
      cnt += 1;
  return cnt;
}
void string_make_lower_case(s)
     char *s;
{
  int i,k;
  int n;
  n = strlen(s);
  for(i=0;i<n;i++){
    k = (int)s[i];
    if ((k >= 65) && (k <= 90))
      s[i] = (char)(k+32);
  }
}
int is_digit_char(c)
     char c;
{
  if (((int)c >= (int)'0') && ((int)c <= (int)'9'))
    return 1;
  else
    return 0;
}
int is_numeric_char(c)
     char c;
{
  int i;
  int n;
  char numchar[13];
  strcpy(numchar,"0123456789.-");
  n = strlen(numchar);
  for(i=0;i<n;i++)
    if (c==numchar[i])
      return 1;
  return 0;
}
int is_name_char(c)
     char c;
{
  int i;
  int n;
  char namechar[SLEN];
  strcpy(namechar,
	 "1234567890_ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz");
  n = strlen(namechar);
  for(i=0;i<n;i++)
    if (c == namechar[i])
      return 1;
  return 0;
}
int is_number_string(s)
     char *s;
{
  int i;
  int n,pflag,flag,okend;
  char c,numchar[13];
  flag = 1; 
  n = strlen(s);
  if (n < 1)
    flag = 0;
  pflag = 0;
  okend = 0; 
  i = 0;
  while ((i < n) && (flag == 1)){
    c = s[i];
    if (pflag == 0){ 
      if (is_digit_char(c)){
	pflag = 2;
	okend = 1;
      }else if (c == '.')
	pflag = 3;
      else if (c == '-')
	pflag = 1;
      else
	flag = 0;
    }else if (pflag == 1){
      okend = 0;
      if (is_digit_char(c)){
	pflag = 2;
	okend = 1;
      }else if (c == '.')
	pflag = 3;
      else
	flag = 0;
    }else if (pflag == 2){
      if (c == '.'){
	pflag = 3;
	okend = 1;
      }else if (c == 'e'){
	pflag = 5;
	okend = 0;
      }else if (!is_digit_char(c))
	flag = 0;
    }else if (pflag == 3){
      if (is_digit_char(c)){
	pflag = 4;
	okend = 1;
      }else
	flag = 0;
    }else if (pflag == 4){
      if (c == 'e'){
	pflag = 5;
	okend = 0;
      }else if (!is_digit_char(c))
	flag = 0;
    }else if (pflag == 5){
      if ((c == '-')||(c == '+')){
	pflag = 6;
	okend = 0;
      }else
	flag = 0;
    }else if (pflag == 6){
      if (is_digit_char(c)){
	pflag = 7;
	okend = 1;
      }else
	flag = 0;
    }else if (pflag == 7){
      if (!is_digit_char(c))
	flag = 0;
    }
    i += 1;
  }
  if (!okend){ 
    flag = 0;
  }
  return flag;
}
char ***get_2d_pointer_carray(m,n)
     int m,n;
{
  int i;
  char ***c;
  c = (char ***)myalloc(m*sizeof(char **));
  for(i=0;i<m;i++)
    c[i] = (char **)myalloc(n*sizeof(char *));
  return c;
}
void free_2d_pointer_carray(data,m,n)
     char ***data;
     int m,n;
{
  int i,j;
  if (data != NULL){
    for(i=0;i<m;i++){
      for(j=0;j<n;j++)
	myfree(data[i][j]);
      myfree(data[i]);
    }
    myfree(data);
  }
}
void free_2d_pointer_var_count_carray(data,n,cnt)
     char ***data;
     int n,*cnt;
{
  int i,j;
  if (data != NULL){
    for(i=0;i<n;i++){
      for(j=0;j<cnt[i];j++)
	myfree(data[i][j]);
      myfree(data[i]);
    }
    myfree(data);
  }
}
void free_string_list_carray(data,n,cnt)
     char ***data;
     int n,*cnt;
{
  int i,j;
  for(i=0;i<n;i++){
    for(j=0;j<cnt[i];j++)
      myfree(data[i][j]);
    myfree(data[i]);
  }
  myfree(data);
}
void append_null_to_carray(pdata,n)
     char **pdata;
     int n;
{
  int i;
  char *t;
  t = (char *)myalloc((n+1)*sizeof(char));
  for(i=0;i<n;i++)
    t[i] = (*pdata)[i];
  t[n] = '\0';
  myfree(*pdata);
  *pdata = t;
}
char **copy_2d_carray(c,n)
     char **c;
     int n;
{
  int i;
  char **t;
  t = (char **)myalloc(n*sizeof(char *));
  for(i=0;i<n;i++)
    t[i] = strdup(c[i]);
  return t;
}
char **concat_2d_carrays(c1,n1,c2,n2,rn)
     char **c1;
     int n1;
     char **c2;
     int n2,*rn;
{
  int i;
  int n;
  char **t;
  n = n1 + n2;
  t = (char **)myalloc(n*sizeof(char *));
  for(i=0;i<n1;i++)
    t[i] = strdup(c1[i]);
  for(i=0;i<n2;i++)
    t[n1+i] = strdup(c2[i]);
  *rn = n;
  return t;
}
int is_const_2d_carray(c,n)
     char **c;
     int n;
{
  int i;
  int done;
  done = 0;
  i = 1;
  while(!done){
    if (i>=n)
      done = 1;
    else{
      if (strcmp(c[i],c[0])==0)
	i += 1;
      else{
	done = 1;
      }
    }
  }
  if (i==n){
    return 1;
  }else{
    return 0;
  }
}
int is_suffix_string(s,suf)
     char s[],suf[];
{
  int i,k;
  int n1,n2,min;
  k = 0;
  n1 = strlen(s);
  n2 = strlen(suf);
  if (n1 >= n2){
    k = 1;
    for(i=0;i<n2;i++)
      if (s[n1-n2 + i] != suf[i])
	k = 0;
  }
  return k;
}
int compare_prefix_string(s1,s2)
     char s1[],s2[];
{
  int i,k;
  int n1,n2,min;
  n1 = strlen(s1);
  n2 = strlen(s2);
  if (n1 <= n2)
    min = n1;
  else
    min = n2;
  k = 1;
  for(i=0;i<min;i++)
    if (s1[i] != s2[i])
      k = 0;
  return k;
}
int compare_prefix_string_order(s1,s2)
     char s1[],s2[];
{
  int i,k;
  int n1,n2,min;
  n1 = strlen(s1);
  n2 = strlen(s2);
  if (n1 <= n2)
    min = n1;
  else
    return 0; 
  k = 1;
  for(i=0;i<min;i++)
    if (s1[i] != s2[i])
      k = 0;
  return k;
}
char *replace_html_gtlt(s)
     char *s;
{
  int i,k;
  int n,nn,cnt;
  char *newstr;
  n = strlen(s);
  cnt = 0;
  for(i=0;i<n;i++){
    if ((s[i] == '<') || (s[i] == '>'))
      cnt += 1;
  }
  newstr = NULL;
  if (cnt > 0){
    nn = n + cnt*3 + 1;   
    newstr = (char *)myalloc(nn*sizeof(char));
    k = 0;
    for(i=0;i<n;i++){
      if (s[i] == '<'){
	newstr[k]   = '&';
	newstr[k+1] = 'l';
	newstr[k+2] = 't';
	newstr[k+3] = ';';
	k += 4;
      }else if (s[i] == '>'){
	newstr[k]   = '&';
	newstr[k+1] = 'g';
	newstr[k+2] = 't';
	newstr[k+3] = ';';
	k += 4;
      }else{
	newstr[k] = s[i];
	k += 1;
      }
    }
    newstr[k] = '\0';
    k += 1;
    if (k != nn)
      exit_error("WYETH","This should not happen");
  }
  return newstr;
}
char **replace_html_gtlt_2d_carray(c,n)
     char **c;
     int n;
{
  int i;
  char **cnew;
  cnew = (char **)myalloc(n*sizeof(char *));
  for(i=0;i<n;i++){
    if (c[i] != NULL){
      cnew[i] = replace_html_gtlt(c[i]);
      if (cnew[i] == NULL)  
	cnew[i] = strdup(c[i]);
    }else
      cnew[i] = NULL;
  }
  return cnew;
}
char *replace_string_segment(s,newstr,k,n)
     char *s;        
     char *newstr;   
     int k;          
     int n;          
{
  int i;
  int nn,tn,sn,en;
  char *repstr;
  tn = strlen(s);
  if (tn < k+n)
    exit_error("REPLACE_STRING_SEGMENT","String too short");
  nn = strlen(newstr);
  sn = tn - n + nn + 1;  
  repstr = (char *)myalloc(sn*sizeof(char));
  en = tn - (k+n);
  for(i=0;i<k;i++)
    repstr[i] = s[i];  
  for(i=0;i<nn;i++)
    repstr[k+i] = newstr[i];  
  for(i=0;i<en;i++)
    repstr[k+nn+i] = s[k+n+i];  
  repstr[sn-1] = '\0'; 
  return repstr;
}
char *replace_string(s,oldstr,newstr,rn)
     char *s;
     char *oldstr;
     char *newstr;
     int *rn;
{
  int i,k;
  int n,replen,nnew,nold;
  char *tp,*cp,*repstr,*tt;
  if (oldstr == NULL)
    exit_error("REPLACE_STRING","oldstr is NULL");
  if (newstr == NULL)
    exit_error("REPLACE_STRING","newstr is NULL");
  if (s == NULL)
    exit_error("REPLACE_STRING","string is NULL");
  nnew = strlen(newstr);
  nold = strlen(oldstr);
  n = 0;  
  tp = strstr(s,oldstr);
  while(tp != NULL){
    n += 1;
    tp += nold;
    tt = strstr(tp,oldstr);
    tp = tt;
  }
  if (n == 0){
    repstr = NULL;
  }else{
    replen = 1 + strlen(s) + n * (nnew - nold);
    repstr = (char *)myalloc(replen*sizeof(char));
    cp = s;  
    k = 0;   
    tp = strstr(s,oldstr);
    while(tp != NULL){
      while(cp != tp){  
	repstr[k] = *cp;
	k += 1;
	cp += 1;
      }
      cp += nold;  
      for(i=0;i<nnew;i++){  
	repstr[k] = newstr[i];
	k += 1;
      }
      tp += nold;  
      tt = strstr(tp,oldstr);  
      tp = tt;
    }
    while(*cp != '\0'){
      repstr[k] = *cp;
      k += 1;
      cp += 1;
    }
    repstr[k] = '\0';  
    k += 1;
  }
  *rn = n;
  return repstr;
}
char **replace_string_2d_carray(c,n,oldstr,newstr,rn)
     char **c;       
     int n;          
     char *oldstr;   
     char *newstr;   
     int *rn;        
{
  int i;
  int ntot,nrep;
  char **cnew;
  cnew = (char **)myalloc(n*sizeof(char *));
  ntot = 0;
  for(i=0;i<n;i++){
    if (c[i] != NULL){
      cnew[i] = replace_string(c[i],oldstr,newstr,&nrep);
      if (nrep == 0)
	cnew[i] = strdup(c[i]);
    }else
      cnew[i] = NULL;
    ntot += nrep;
  }
  *rn = ntot;
  return cnew;
}
char *get_string_from_int(k)
     int k;
{
  char tstr[SLEN];
  sprintf(tstr,"%d",k);
  return strdup(tstr);
}
char *get_leading_zero_string_from_int(k,n)
     int k;  
     int n;  
{
  int i;
  int klen;
  char tstr[SLEN],*t;
  t = (char *)myalloc((n+1)*sizeof(char));
  for(i=0;i<n;i++)
    t[i] = '0';
  t[n] = '\0';
  sprintf(tstr,"%d",k);
  klen = strlen(tstr);
  if (klen > n)
    exit_error("GET_LEADING_ZERO_STRING_FROM_INT","n is too small");
  for(i=0;i<klen;i++)
    t[n-1-i] = tstr[klen-1-i];
  return t;
}
char *get_bit_string_from_int(k,n)
     int k,n;
{
  int i;
  int *data;
  char *t;
  data = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++)
    data[n-1-i] = (k>>i) & 1;
  t = (char *)myalloc((n+1)*sizeof(char));
  for(i=0;i<n;i++)
    if (data[i])
      t[i] = '1';
    else
      t[i] = '0';
  t[n] = '\0';
  myfree(data);
  return t;
}
void print_bit_string_for_int(k,n)
     int k,n;
{
  char *s;
  s = get_bit_string_from_int(k,n);
  printf("%s",s);
  myfree(s);
}
void convert_01_string_to_iarray(cstr,invert_flag,rdata,rn)
     char cstr[];
     int invert_flag,**rdata,*rn;
{
  int i;
  int *data,n;
  n = strlen(cstr);
  data = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++){
    data[i] = (cstr[i]=='1');
    if (invert_flag == 1)
      data[i] = 1-data[i];
  }
  *rdata = data; *rn = n;
}
void convert_n0p_string_to_iarray(cstr,invert_flag,rdata,rn)
     char cstr[];
     int invert_flag,**rdata,*rn;
{
  int i;
  int *data,n;
  n = strlen(cstr);
  data = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++){
    if (cstr[i]=='n')
      data[i] = -1;
    else if (cstr[i]=='0')
      data[i] = 0;
    else if (cstr[i]=='p')
      data[i] = 1;
    else
      exit_error("CONVERT_n0p_STRING_TO_IARRAY","Bad ternary value");
    if (invert_flag == 1)
      data[i] = -data[i];
  }
  *rdata = data; *rn = n;
}
void convert_digit_string_to_iarray(cstr,invert_flag,rdata,rn)
     char cstr[];
     int invert_flag,**rdata,*rn;
{
  int i;
  int *data,n;
  n = strlen(cstr);
  data = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++){
    data[i] = (int)(cstr[i]) - (int)'0';
  }
  *rdata = data; *rn = n;
}
void convert_multi_string_to_iarray(cstr,ndim,dn,nbl,blank,rdata,rn)
     char cstr[];
     int ndim;     
     int *dn;      
     int nbl;      
     char blank;   
     int **rdata,*rn;
{
  int i,j,k; 
  int *data,n,slen,si,nstim,nstimreg,*cdn;
  char *t,dummy;
  slen = strlen(cstr);
  if (slen <= 0)
    exit_error("CONVERT_MULTI_STRING_TO_IARRAY","Empty string");
  n = 1;
  for(i=0;i<slen;i++)
    if (cstr[i] == '-')
      n += 1;
  nstim = 1;
  for(i=0;i<ndim;i++){
    nstim *= dn[i];
  }
  nstimreg = nstim;
  if (nbl > 0)
    nstim += 1;  
  cdn = get_zero_iarray(ndim);
  for(i=0;i<ndim;i++){
    cdn[i] = 1;
    for(j=i+1;j<ndim;j++)
      cdn[i] *= dn[j];
  }
  data = (int *)myalloc(n*sizeof(int));
  t = cstr;
  printf("    %s  =  ",cstr);
  for(i=0;i<n;i++){
    if (t[0] == blank){
      if (nbl == 0)
	exit_error("CONVERT_MULTI_STRING_TO_IARRAY","No blanks");
      data[i] = nstim - 1; 
      t += 2; 
    }else{
      si = 0;
      for(j=0;j<ndim;j++){
	sscanf(t,"%c%d",&dummy,&k);
	t += 1; 
	while(is_digit_char(*t)){
	  t += 1; 
	}
	si += (k-1)*cdn[j];
      }
      if (si >= nstimreg){
	printf("    si = %d  k = %d\n",si,k);
	exit_error("CONVERT_MULTI_STRING_TO_IARRAY","Stim index too high");
      }
      data[i] = si;
      t += 1; 
    }
    printf(" %d",data[i]);
  }
  printf("\n");
  *rdata = data; *rn = n;
}
void append_string_to_file(outfile,data)
     char outfile[];
     char *data;
{
  FILE *fopen(),*fout;
  if ((fout = fopen(outfile,"a"))==NULL){
    printf("  FILENAME:  %s\n",outfile);
    exit_error("APPEND_STRING_TO_FILE","Cannot open file");
  }
  fprintf(fout,"%s",data);
  fclose(fout);
}
int is_int_string(sdata)
     char *sdata;
{
  int i;
  int slen;
  char sdigit[11];
  strcpy(sdigit,"0123456789");
  slen = strlen(sdata);
  for(i=0;i<slen;i++)
    if (strchr(sdigit,sdata[i]) == NULL)
      return 0;
  return 1;
}
int is_float_string(sdata)
     char *sdata;
{
  int i;
  int slen;
  char sdigit[11];
  sdigit[0] = '0';
  sdigit[1] = '1';
  sdigit[2] = '2';
  sdigit[3] = '3';
  sdigit[4] = '4';
  sdigit[5] = '5';
  sdigit[6] = '6';
  sdigit[7] = '7';
  sdigit[8] = '8';
  sdigit[9] = '9';
  sdigit[10] = '.';
  slen = strlen(sdata);
  for(i=0;i<slen;i++){
    if ((i==0) && (sdata[i] == '-'))  
      ; 
    else if (strchr(sdigit,sdata[i]) == NULL)
      return 0;
  }
  return 1;
}
int count_decimals(sdata)
     char *sdata;
{
  int n;
  char *tdata;
  tdata = strrchr(sdata,'.');
  if (tdata == NULL){
    n = 0;
  }else{
    n = strlen(sdata) - ((long)tdata - (long)sdata + 1);
  }
  return n;
}
int count_items_in_string(sdata)
     char *sdata;
{
  int n;
  char white[4],*tdata;
  white[0] = (char)9;   
  white[1] = (char)32;  
  white[2] = '\n';      
  white[3] = '\0';
  tdata = strdup(sdata);
  if (strtok(tdata,white) != NULL){
    n = 1;
    while(strtok(NULL,white)!=NULL)
      n += 1;
  }else
    n = 0;
  myfree(tdata);
  return n;
}
void get_items_from_string(sdata,rlist,rn)
     char *sdata;
     char ***rlist;
     int *rn;
{
  int i;
  int n;
  char **list,white[5],*tdata;
  white[0] = (char)9;   
  white[1] = (char)32;  
  white[2] = '\n';      
  white[3] = '\0';
  white[4] = (char)13;  
  tdata = strdup(sdata);
  if (strtok(tdata,white) != NULL){
    n = 1;
    while(strtok(NULL,white)!=NULL)
      n += 1;
  }else
    n = 0;
  myfree(tdata);
  tdata = strdup(sdata);
  if (n > 0){
    list = (char **)myalloc(n*sizeof(char *));
    list[0] = strdup(strtok(tdata,white));
    for(i=1;i<n;i++){
      list[i] = strdup(strtok(NULL,white));
    }
  }else
    list = NULL;
  myfree(tdata);
  *rlist = list; *rn = n;
}
char *get_first_item_from_string(s)
     char *s;
{
  int n;
  char **slist,*t;
  get_items_from_string(s,&slist,&n);
  if (n < 1)
    t = (char *)NULL;
  else
    t = strdup(slist[0]);
  free_2d_carray(slist,n);
  return t;
}
void get_iarray_from_string(sdata,rdata,rn)
     char *sdata;
     int **rdata,*rn;
{
  int i;
  int n,*data;
  char **list;
  get_items_from_string(sdata,&list,&n);
  data = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++)
    data[i] = atoi(list[i]);
  *rdata = data; *rn = n;
}
void get_farray_from_string(sdata,rdata,rn)
     char *sdata;
     float **rdata;
     int *rn;
{
  int i;
  int n;
  float *data;
  char **list;
  get_items_from_string(sdata,&list,&n);
  data = (float *)myalloc(n*sizeof(float));
  for(i=0;i<n;i++)
    data[i] = atof(list[i]);
  *rdata = data; *rn = n;
}
float *get_farray_from_carray(sdata,n)
     char **sdata;
     int n;
{
  int i;
  float *data;
  data = (float *)myalloc(n*sizeof(float));
  for(i=0;i<n;i++)
    data[i] = atof(sdata[i]);
  return data;
}
int *get_iarray_from_carray(sdata,n)
     char **sdata;
     int n;
{
  int i;
  int *data;
  data = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++)
    data[i] = atoi(sdata[i]);
  return data;
}
char *make_string_from_items(cdata,n)
     char **cdata;
     int n;
{
  int i,j,k;
  int sn;
  char *s;
  sn = n; 
  for(i=0;i<n;i++)
    sn += strlen(cdata[i]);
  s = (char *)myalloc(sn*sizeof(char));
  k = 0;
  for(i=0;i<n;i++){
    for(j=0;j<strlen(cdata[i]);j++){
      s[k] = cdata[i][j];
      k += 1;
    }
    s[k] = ' ';
    k += 1;
  }
  s[k-1] = '\0'; 
  return s;
}
void check_string_exit_carray(s1,s2)
     char s1[],s2[];
{
  if (strcmp(s1,s2)!=0){
    printf("*** %s and %s not equal\n",s1,s2);
    exit_error("CHECK_STRING_EXIT_CARRAY","Strings not equal");
  }
}
void bubble_sort_2d_carray(data,n)
     char **data;
     int n;
{
  int i;
  int done,bottom;
  char *t;
  bottom = n-1;
  done = 0;
  while (!done){
    done = 1;
    for (i=0;i<bottom;i++)
      if (strcmp(data[i],data[i+1]) > 0){
	done = 0;
	t = data[i];
	data[i] = data[i+1];
	data[i+1] = t;
      }
    bottom -= 1;
  }
}
int is_unique_sorted_2d_carray(c,n)
     char **c;
     int n;
{
  int i;
  for(i=1;i<n;i++)
    if (strcmp(c[i-1],c[i])==0)
      return 0;
  return 1;
}
int is_unique_2d_carray(c,n)
     char **c;
     int n;
{
  int flag;
  char **cs;
  cs = copy_2d_carray(c,n);
  bubble_sort_2d_carray(cs,n);  
  flag = is_unique_sorted_2d_carray(cs,n);
  free_2d_carray(cs,n);
  return flag;
}
char *carray_get_duplicate_ptr(c,n)
     char **c;
     int n;
{
  int i,j;
  i = 0;
  while(i<(n-1)){
    j = i+1;
    while(j<n){
      if (strcmp(c[i],c[j])==0)
	return c[i];
      j += 1;
    }
    i += 1;
  }
  return NULL;
}
int search_2d_carray(c,s,n)
     char **c,*s;
     int n;
{
  int k;
  int done;
  done = 0;
  k = 0;
  while((!done)&&(k<n)){
    if (strcmp(c[k],s)==0)
      done = 1;
    else
      k += 1;
  }
  if (done)
    return k;
  else
    return -1;
}
int search_2d_carray_exit(c,s,n)
     char **c,*s;
     int n;
{
  int k;
  k = search_2d_carray(c,s,n);
  if (k < 0){
    printf("  string = %s\n",s);
    exit_error("SEARCH_2D_CARRAY_EXIT","String not found in list");
  }
  return k;
}
int search_2d_carray_flag(c,s,n,flag)
     char **c,*s;
     int n,*flag;
{
  int k;
  int done;
  done = 0;
  k = 0;
  while((!done)&&(k<n)){
    if (flag[k] != 0)
      if (strcmp(c[k],s)==0)
	done = 1;
      else
	k += 1;
    else
      k += 1;
  }
  if (done)
    return k;
  else
    return -1;
}
void update_key_value_pair_carray(oldname,oldval,nold,newname,newval,nnew,
				  rname,rval,rn)
     char **oldname,**oldval;
     int nold;
     char **newname,**newval;
     int nnew;
     char ***rname,***rval;
     int *rn;
{
  int i,k;
  int *flag,count,n;
  char **name,**val;
  count = 0;
  flag = get_zero_iarray(nold);
  for(i=0;i<nold;i++){
    flag[i] = search_2d_carray(newname,oldname[i],nnew);
    if (flag[i] < 0)
      count += 1;
  }
  n = count + nnew;
  name = (char **)myalloc(n*sizeof(char *));
  val = (char **)myalloc(n*sizeof(char *));
  for(i=0;i<nnew;i++){
    name[i] = strdup(newname[i]);
    val[i] = strdup(newval[i]);
  }
  k = nnew;
  for(i=0;i<nold;i++){
    if (flag[i] < 0){
      name[k] = strdup(oldname[i]);
      val[k] = strdup(oldval[i]);
      k += 1;
    }
  }
  myfree(flag);
  *rname = name; *rval = val; *rn = n;
}     
void print_carray(cdata,n)
     char **cdata;
     int n;
{
  int i;
  for(i=0;i<n;i++)
    printf("%s\n",cdata[i]);
}
void print_2d_pointer_carray(cdata,m,n)
     char ***cdata;
     int m,n;
{
  int i,j;
  if ((m>0) && (n>0)){
    for(i=0;i<m;i++){
      for(j=0;j<n;j++)
	printf("%s ",cdata[i][j]);
      printf("\n");
    }
  }
}
void print_string_list_carray(data,n,cnt)
     char ***data;
     int n,*cnt;
{
  int i,j;
  for(i=0;i<n;i++){
    for(j=0;j<cnt[i];j++)
      printf("%s ",data[i][j]);
    printf("\n");
  }
}
void read_carray(infile,data,n)
     char infile[];
     char **data;
     int *n;
{
  FILE *fopen(),*fin;
  int i;
  if ((fin = fopen(infile,"r"))==NULL){
    printf("  filename = %s\n",infile);
    exit_error("READ_CARRAY","Cannot open file");
  }
  *n = 0;
  while (getc(fin) != EOF) 
    *n += 1;
  fclose(fin);
  fin = fopen(infile,"r");
  *data = (char *)myalloc(*n*sizeof(char));
  for(i=0;i<*n;i++)
    (*data)[i] = (char)getc(fin);
  fclose(fin);
}
void read_2d_carray(infile,remove_nl,blank_flag,rdata,rn)
     char infile[];
     int remove_nl;
     int blank_flag;  
     char ***rdata;
     int *rn;
{
  FILE *fopen(),*fin;
  int k;
  int n,ns;
  char **data,**slist,line[SLINE_MAX];
  if ((fin = fopen(infile,"r"))==NULL){
    *rdata = NULL;
    *rn = -1;
    return;
  }
  n = 0;
  while((fgets(line,SLINE_MAX,fin) != NULL)){
    if ((strlen(line) >= SLINE_MAX-2))
      exit_error("READ_2D_CARRAY","LINE TOO LONG");
    get_items_from_string(line,&slist,&ns);
    if (ns > 0){
      n += 1;
      free_2d_carray(slist,ns);
    }else if (blank_flag == 1){
      n += 1;                    
    }
  }
  fclose(fin);
  if ((fin = fopen(infile,"r"))==NULL){
    *rdata = NULL;
    *rn = -1;
    return;
  }
  data = (char **)myalloc(n*sizeof(char *));
  k = 0;
  while((fgets(line,SLINE_MAX,fin) != NULL)){
    get_items_from_string(line,&slist,&ns);
    if ((ns > 0) || (blank_flag == 1)){
      if (remove_nl){
	if (strlen(line) > 0){  
	  if (line[strlen(line)-1]=='\n')  
	    line[strlen(line)-1] = '\0';   
	  if (strlen(line) > 0){  
	    if (line[strlen(line)-1]==(char)13)  
	      line[strlen(line)-1] = '\0';   
	  }
	}
      }
      data[k] = strdup(line);
      k += 1;
      if (ns > 0)
	free_2d_carray(slist,ns);
    }
  }
  fclose(fin);
  *rdata = data; *rn = k;
}
int search_file_2d_carray(infile,s)
     char infile[];
     char *s;
{
  FILE *fopen(),*fin;
  int ns;
  char line[SLINE_MAX];
  if ((fin = fopen(infile,"r"))==NULL)
    exit_error("SEARCH_FILE_2D_CARRAY","Cannot open file");
  while((fgets(line,SLINE_MAX,fin) != NULL)){
    if ((strlen(line) >= SLINE_MAX-2))
      exit_error("SEARCH_FILE_2D_CARRAY","LINE TOO LONG");
    ns = strlen(line);
    if (ns > 0){
      if (line[ns-1]=='\n')
	line[ns-1] = '\0';
    }
    ns = strlen(line);
    if (strcmp(s,line)==0)
      return 1;
  }
  fclose(fin);
  return 0;
}
void write_carray(outfile,data,n)
     char outfile[];
     char *data;
     int n;
{
  FILE *fopen(),*fout;
  int i;
  fout = fopen(outfile,"w");
  for(i=0;i<n;i++)
    fprintf(fout,"%c",data[i]);
  fclose(fout);
}
void write_carray_segment(outfile,data,n,start,period)
     char outfile[];
     char *data;
     int n,start,period;
{
  FILE *fopen(),*fout;
  int i;
  fout = fopen(outfile,"w");
  for(i=start;i<(start+period);i++)
    fprintf(fout,"%c",data[i]);
  fclose(fout);
}
void encode_slist_as_carray(slist,ns,rc,rn)
     char **slist;
     int ns;
     char **rc;
     int *rn;
{
  int i,j,k;
  int n,tn;
  char *t,*s,tstr[SLEN];
  exit_error("ENCODE_SLIST_AS_CARRAY","WYETH - NEVER TESTED");
  n = 0;
  for(i=0;i<ns;i++){
    n += strlen(slist[i]);
    n += 1; 
  }
  sprintf(tstr,"%d",ns);
  n += strlen(tstr) + 1;  
  s = (char *)myalloc(n*sizeof(char));
  sprintf(s,"%d",ns); 
  k = strlen(s) + 1;
  for(i=0;i<ns;i++){ 
    t = slist[i];
    tn = strlen(t);
    for(j=0;j<tn;j++){
      s[k] = t[j];
      k += 1;
    }
    s[k] = '\0';
    k += 1;
  }
  *rc = s;
  *rn = n;
}
void carray_nchar_read(p,fin,revflag)
     char **p;
     FILE *fin;
     int revflag;
{
  int n;
  int nread;
  nread = revflag_fread((char *)&n,sizeof(int),1,fin,revflag);
  if (nread == 0)
    exit_error("CARRAY_NCHAR_READ","Error");
  *p = (char *)myalloc((n+1)*sizeof(char));
  nread = fread((char *)(*p),sizeof(char),n,fin);
  (*p)[n] = '\0';
}
void carray_nchar_write(p,fout)
     char *p;
     FILE *fout;
{
  int n;
  n = strlen(p);
  fwrite((char *)&n,sizeof(int),1,fout);
  fwrite((char *)p,sizeof(char),n,fout);
}
void get_exclusive_index_compare_2d_carrays(cdata1,n1,cdata2,n2,rindex,rn)
     char **cdata1;
     int n1;
     char **cdata2;
     int n2,**rindex,*rn;
{
  int i,j,k;
  int *ndx,*t,done;
  k = 0; 
  ndx = (int *)myalloc(n1*sizeof(int));
  for(i=0;i<n1;i++){ 
    done = 0;
    j = 0;
    while(!done){ 
      if (j >= n2)
	done = 1;
      else if (strcmp(cdata1[i],cdata2[j])==0)
	done = 1;
      else
	j += 1;
    }
    if (j >= n2){ 
      ndx[k] = i;
      k += 1;
    }
  }
  t = (int *)myalloc(k*sizeof(int));
  for(i=0;i<k;i++)
    t[i] = ndx[i];
  *rindex = t;
  *rn = k;
}
int *get_shared_index_compare_2d_carrays(cdata1,n1,cdata2,n2)
     char **cdata1;
     int n1;
     char **cdata2;
     int n2;
{
  int i;
  int *ndx;
  ndx = (int *)myalloc(n1*sizeof(int));
  for(i=0;i<n1;i++) 
    ndx[i] = search_2d_carray(cdata2,cdata1[i],n2);
  return ndx;
}
char **get_column_3d_carray(cdata,k,nrow,ncol)
     char ***cdata;
     int k,nrow,ncol;
{
  int i;
  char **data;
  data = (char **)myalloc(nrow*sizeof(char *));
  for(i=0;i<nrow;i++)
    data[i] = strdup(cdata[i][k]);
  return data;
}
char **get_unique_slist_from_3d_carray(cdata,xn,yn,rn)
     char ***cdata;
     int xn,yn;
     int *rn;          
{
  int i,j,k;
  int un,uflag;
  char **u,**t,*tt;
  if ((xn*yn) < 1)
    exit_error("GET_UNIQUE_STRINGS_FROM_3D_CARRAY","No elements");
  un = 1;
  t = (char **)myalloc(xn*yn*sizeof(char *));
  t[0] = cdata[0][0];
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      tt = cdata[i][j];  
      uflag = 1;         
      for(k=0;k<un;k++){
	if (strcmp(tt,t[k])==0)  
	  uflag = 0;
      }
      if (uflag){     
	t[un] = tt;
	un += 1;
      }
    }
  }
  u = (char **)myalloc(un*sizeof(char *));
  for(i=0;i<un;i++)
    u[i] = strdup(t[i]);
  myfree(t);
  *rn = un;
  return u;
}
int *carray_util_parse_underscore(s,rn)
     char *s;   
     int *rn;   
{
  int i,k;
  int n,cnt,*ival;
  char *a,*tstr;
  tstr = strdup(s);
  n = strlen(s);
  cnt = 0;
  for(i=0;i<n;i++){
    if (tstr[i] == '_')
      cnt += 1;
  }
  ival = (int *)myalloc((cnt+1)*sizeof(int));
  k = 0;
  a = tstr;
  for(i=0;i<n;i++){
    if (tstr[i] == '_'){
      tstr[i] = ' ';
      sscanf(a,"%d",&(ival[k]));
      k += 1;
      a = &(tstr[i+1]);
    }
  }
  sscanf(a,"%d",&(ival[k]));
  *rn = cnt + 1;
  return ival;
}
int carray_util_underscore_int_final(s)
     char *s;   
{
  int i;
  int n,ui,ival;
  char *a;
  n = strlen(s);
  ui = -1; 
  for(i=0;i<n;i++){
    if (s[i] == '_')
      ui = i;
  }
  if (ui == -1){
    printf("   string:  %s\n",s);
    exit_error("CARRAY_UTIL_UNDERSCORE_INT_FINAL",
	       "No underscore found in string");
  }else if (ui > (n-2)){
    printf("   string:  %s\n",s);
    exit_error("CARRAY_UTIL_UNDERSCORE_INT_FINAL",
	       "Underscore index too large");
  }
  a = &(s[ui+1]);
  sscanf(a,"%d",&ival);
  return ival;
}
int carray_get_float_val_underscore_eq(s,name,rval)
     char s[],name[];
     float *rval;
{
  int i,j,k;
  int slen,done;
  char tname[SLEN],vstr[SLEN];
  slen = strlen(s);
  j = 0;
  k = 0;  
  done = 0;
  while(!done){
    if (k >=slen){
      return 0;
    }else{
      if (s[k] == '='){
	tname[j] = '\0'; 
	if (strcmp(name,tname)==0){ 
	  i = 0;
	  k += 1; 
	  while(!done){
	    if (k >= slen){ 
	      done = 1;
	      vstr[i] = '\0';
	    }else if (s[k] == '_'){ 
	      done = 1;
	      vstr[i] = '\0';
	    }else{
	      vstr[i] = s[k];
	      i += 1;
	      k += 1;
	    }
	  }
	  done = 1;
	}else{ 
	  while(s[k] != '_'){
	    k += 1;
	    if (k >= slen)
	      return 0; 
	  }
	  k += 1; 
	  j = 0; 
	}
      }else{
	tname[j] = s[k];
	k += 1;
	j += 1;
      }
    }
  }
  *rval = atof(vstr);
  return 1;
}
char *carray_item_list_remove_comment(s)
     char s[];
{
  int k;
  int sn,done;
  char **slist,*ss;
  get_items_from_string(s,&slist,&sn);
  if (sn > 1){  
    k = 0;
    done = 0;
    while(!done){
      if (k >= sn)
	done = 1;
      else if (slist[k][0] == '#')
	done = 1;
      else
	k++;
    }
    if (k < sn){  
      ss = make_string_from_items(slist,k);
    }else
      ss = strdup(s);
  }else
    ss = strdup(s);
  free_2d_carray(slist,sn);
  return ss;
}
struct math_strel *mstrel_get_init()
{
  struct math_strel *ms;
  ms = (struct math_strel *)myalloc(sizeof(struct math_strel));
  ms->etype = NULL;
  ms->fval = 0.0;
  ms->ival = 0;
  ms->sval = NULL;
  ms->prev = ms->next = NULL;
  return ms;
}
void mstrel_free(ms)
     struct math_strel *ms;
{
  if (ms->etype != NULL)
    myfree(ms->etype);
  if (ms->sval != NULL)
    myfree(ms->sval);
  myfree(ms);
}
void mstrel_push(ps,e)
     struct math_strel **ps;  
     struct math_strel *e;    
{
  if (*ps == NULL){  
    *ps = e;
  }else{
    (*ps)->prev = e;
    e->next = *ps;
    *ps = e;
  }
}
struct math_strel *mstrel_pop(ps)
     struct math_strel **ps;  
{
  struct math_strel *e;
  if (*ps == NULL)  
    e = NULL;
  else{
    e = (*ps);             
    if (e->next != NULL) 
      e->next->prev = NULL;  
    *ps = e->next;        
    e->next = e->prev = NULL;  
  }
  return e;
}
void mstrel_free_stack(ps)
     struct math_strel **ps;  
{
  struct math_strel *e;
  e = mstrel_pop(ps);
  while(e != NULL){
    mstrel_free(e);
    e = mstrel_pop(ps);
  }
}
int mstrel_stack_size(s)
     struct math_strel *s;  
{
  int n;
  struct math_strel *t;
  t = s;
  n = 0;
  while(t != NULL){
    t = t->next;
    n += 1;
  }
  return n;
}
int mstrel_etype_n(s,n,etype)
     struct math_strel *s;  
     int n;
     char *etype;
{
  int k;
  struct math_strel *t;
  t = s;
  k = 1;
  while(t != NULL){
    if (k == n){
      if (strcmp(t->etype,etype)==0)
	return 1;
      else
	return 0;
    }
    t = t->next;
    k += 1;
  }
  return 0;
}
void mstrel_stack_print(s)
     struct math_strel *s;  
{
  struct math_strel *t;
  printf("--------------STACK------------\n");
  t = s;
  while(t != NULL){
    printf("  %s %s %f\n",t->etype,t->sval,t->fval);
    t = t->next;
  }
  printf("-------------------------------\n");
}
int mstrel_paren_match_remove(ps)
     struct math_strel **ps;  
{
  int flag;
  struct math_strel *e1,*e2;
  flag = 0;
  if (mstrel_etype_n(*ps,2,"group")){
    if (strcmp((*ps)->next->sval,"(")==0){
      e1 = mstrel_pop(ps);
      e2 = mstrel_pop(ps);
      myfree(e2);
      mstrel_push(ps,e1);
      flag = 1;
    }
  }
  return flag;
}
void mstrel_calc(ps,errstr)
     struct math_strel **ps;  
     char *errstr;
{
  float v1,v2,a;
  struct math_strel *e1,*e2,*e3,*e;
  e1 = mstrel_pop(ps);
  if (e1 == NULL)
    strcpy(errstr,"MSTREL_CALC - No elements on stack");
  if (strcmp(e1->etype,"fval")!=0)
    strcpy(errstr,"MSTREL_CALC - Top element should be value");
  v2 = e1->fval;
  e2 = mstrel_pop(ps);
  if (e2 == NULL)
    strcpy(errstr,"MSTREL_CALC - No operator element");
  if ((strcmp(e2->etype,"op1")!=0) && (strcmp(e2->etype,"op2")!=0))
    strcpy(errstr,"MSTREL_CALC - Second element should be operator");
  e3 = mstrel_pop(ps);
  if (e3 == NULL)
    strcpy(errstr,"MSTREL_CALC - No third element");
  if (strcmp(e3->etype,"fval")!=0)
    strcpy(errstr,"MSTREL_CALC - Third element should be value");
  v1 = e3->fval;
  if (strcmp(e2->sval,"+")==0)
    a = v1 + v2;
  else if (strcmp(e2->sval,"-")==0)
    a = v1 - v2;
  else if (strcmp(e2->sval,"*")==0)
    a = v1 * v2;
  else if (strcmp(e2->sval,"/")==0)
    a = v1 / v2;
  e = mstrel_get_init();
  e->etype = strdup("fval");
  e->fval = a;
  mstrel_push(ps,e);
  mstrel_free(e1);
  mstrel_free(e2);
  mstrel_free(e3);
}
struct math_strel *get_next_math_string_element(pmstr)
     char **pmstr;
{
  int k;
  char c,*t,tstr[SLEN];
  struct math_strel *ms;
  ms = mstrel_get_init();
  t = *pmstr;  
  while(t[0] == ' '){
    t += 1;
  }
  c = t[0];
  if ((c == '(') || (c == ')')){
    ms->etype = strdup("group");
    sprintf(tstr,"%c",t[0]);
    ms->sval = strdup(tstr);
    *pmstr = t+1;
  }else if ((c == '+') || (c == '-')){
    ms->etype = strdup("op1");
    sprintf(tstr,"%c",t[0]);
    ms->sval = strdup(tstr);
    *pmstr = t+1;
  }else if ((c == '*') || (c == '/')){
    ms->etype = strdup("op2");
    sprintf(tstr,"%c",t[0]);
    ms->sval = strdup(tstr);
    *pmstr = t+1;
  }else if (is_digit_char(c)){
    ms->etype = strdup("fval");
    k = 0;
    while (is_digit_char(*t) || (*t == '.')){
      tstr[k] = *t;
      t += 1;
      k += 1;
    }
    tstr[k] = '\0';
    ms->sval = strdup(tstr);
    ms->fval = atof(ms->sval);
    *pmstr = t;
  }else if (c == '\0'){
    return NULL;
  }else{
    ms->etype = strdup("var");
    k = 0;
    while (is_name_char(*t)){
      tstr[k] = *t;
      t += 1;
      k += 1;
    }
    tstr[k] = '\0';
    ms->sval = strdup(tstr);
    *pmstr = t;
  }
  return ms;
}
float mstr_evaluate(mstr,nv,vname,vval,rer)
     char *mstr;
     int nv;         
     char **vname;   
     char **vval;    
     char **rer;     
{
  int k;
  int done,pflag,ssize;
  float x;
  char errstr[SLEN];
  struct math_strel *ms,*ms1,*mstack;
  pflag = 0;
  mstack = NULL;
  errstr[0] = '\0';   
  *rer = NULL;        
  done = 0;
  while(!done){
    ms = get_next_math_string_element(&mstr);
    if (ms == NULL){
      done = 1;
      while (mstrel_stack_size(mstack) >= 3){
	if (pflag)
	  printf("  calling calc:  end of input reached\n");
	mstrel_calc(&mstack,errstr);
	if (errstr[0] != '\0'){
	  *rer = strdup(errstr);
	  return 0.0;
	}
      }
      ssize = mstrel_stack_size(mstack);
      if (ssize != 1){
	sprintf(errstr,"MSTR_EVALUATE - Final stack size %d",ssize);
	*rer = strdup(errstr);
	return 0.0;
      }
      x = mstack->fval;
      mstrel_free_stack(&mstack);
    }else{
      if (strcmp(ms->etype,"op1")==0){
	if (!mstrel_etype_n(mstack,1,"fval")){
	  if (strcmp(ms->sval,"+")==0)
	    mstrel_free(ms); 
	  else{  
	    ms1 = mstrel_get_init();
	    ms1->etype = strdup("fval");
	    ms1->fval = -1.0;
	    ms1->sval = strdup("-1.0");
	    mstrel_push(&mstack,ms1);
	    myfree(ms->etype);
	    myfree(ms->sval);
	    ms->etype = strdup("op2");
	    ms->sval = strdup("*");
	    mstrel_push(&mstack,ms);
	  }
	}else{
	  if (mstrel_stack_size(mstack) >= 3){
	    if (!mstrel_etype_n(mstack,2,"group")){
	      if (pflag)
		printf("  calling calc - op1 found, and stack >= 3\n");
	      mstrel_calc(&mstack,errstr);
	      if (errstr[0] != '\0'){
		*rer = strdup(errstr);
		return 0.0;
	      }
	    }
	  }
	  mstrel_push(&mstack,ms);
	}
      }else if (strcmp(ms->etype,"op2")==0){
	mstrel_push(&mstack,ms);
      }else if (strcmp(ms->etype,"group")==0){
	if (strcmp(ms->sval,"(")==0)
	  mstrel_push(&mstack,ms);
	else if (strcmp(ms->sval,")")==0){
	  if (!mstrel_paren_match_remove(&mstack)){
	    if (mstrel_stack_size(mstack) >= 3){
	      if (pflag)
		printf("  calling calc - parenthetical end\n");
	      mstrel_calc(&mstack,errstr);
	      if (errstr[0] != '\0'){
		*rer = strdup(errstr);
		return 0.0;
	      }
	      mstrel_paren_match_remove(&mstack);
	    }
	  }
	  if (mstrel_etype_n(mstack,2,"op2")){
	    if (pflag)
	      printf("  calling calc - op2 before parenthetical\n");
	    mstrel_calc(&mstack,errstr);
	    if (errstr[0] != '\0'){
	      *rer = strdup(errstr);
	      return 0.0;
	    }
	  }
	}
      }else{
	mstrel_push(&mstack,ms);
	if (!is_float_string(ms->sval)){
	  k = search_2d_carray(vname,ms->sval,nv);
	  if (k < 0){
	    sprintf(errstr,"MSTR_EVALUATE - Variable name '%s' not found",
		    ms->sval);
	    *rer = strdup(errstr);
	    return 0.0;
	  }
	  ms->fval = atof(vval[k]);
	  myfree(ms->etype);
	  ms->etype = strdup("fval");
	  myfree(ms->sval);
	  ms->sval = strdup(vval[k]);
	}
	if (mstrel_stack_size(mstack) >= 3){
	  if (mstrel_etype_n(mstack,2,"op2")){
	    if (pflag)
	      printf("  calling calc - value pushed and previous is op2\n");
	    mstrel_calc(&mstack,errstr);
	    if (errstr[0] != '\0'){
	      *rer = strdup(errstr);
	      return 0.0;
	    }
	  }
	}
      }
    }
    if (pflag)
      mstrel_stack_print(mstack);
  }
  return x;
}
