/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "my_util.h"
#include "nr_util.h"
void zero_iarray(data,n)
     int *data,n;
{
  int i;
  for(i=0;i<n;i++)
    data[i] = 0;
}
int **get_const_2d_iarray(m,n,c)
     int m,n;
     int c;
{
  int i,j;
  int **data;
  data = (int **)myalloc(m*sizeof(int *));
  for(i=0;i<m;i++){
    data[i] = (int *)myalloc(n*sizeof(int));
    for(j=0;j<n;j++)
      data[i][j] = c;
  }
  return data;
}
int **get_zero_2d_iarray(m,n)
     int m,n;
{
  return get_const_2d_iarray(m,n,0);
}
int **get_2d_iarray(m,n)
     int m,n;
{
  int i;
  int **data;
  data = (int **)myalloc(m*sizeof(int *));
  for(i=0;i<m;i++)
    data[i] = (int *)myalloc(n*sizeof(int));
  return data;
}
int ***get_2d_pointer_iarray(m,n)
     int m,n;
{
  int i;
  int ***a;
  a = (int ***)myalloc(m*sizeof(int **));
  for(i=0;i<m;i++)
    a[i] = (int **)myalloc(n*sizeof(int *));
  return a;
}
void free_2d_iarray(data,n)
     int **data;
     int n;
{
  int i;
  for(i=0;i<n;i++)
    myfree(data[i]);
  myfree(data);
}
int ***get_3d_iarray(d1,d2,d3)
     int d1,d2,d3;
{
  int i1,i2;
  int ***data;
  data = (int ***)myalloc(d1*sizeof(int **));
  if (d2 >= 0)
    for(i1=0;i1<d1;i1++){
      data[i1] = (int **)myalloc(d2*sizeof(int *));
      if (d3 >= 0)
	for(i2=0;i2<d2;i2++)
	  data[i1][i2] = (int *)myalloc(d3*sizeof(int));
    }
  return data;
}
int ***get_zero_3d_iarray(d1,d2,d3)
     int d1,d2,d3;
{
  int i1;
  int ***data;
  data = (int ***)myalloc(d1*sizeof(int **));
  if (d2 >= 0)
    for(i1=0;i1<d1;i1++)
      data[i1] = get_zero_2d_iarray(d2,d3);
  return data;
}
void free_3d_iarray(data,d1,d2,d3)
     int ***data;
     int d1,d2,d3;
{
  int i1,i2;
  for(i1=0;i1<d1;i1++){
    for(i2=0;i2<d2;i2++)
      myfree(data[i1][i2]);
    myfree(data[i1]);
  }
  myfree(data);
}
int *copy_iarray(data,n)
     int *data,n;
{
  int i;
  int *cdata;
  cdata = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++)
    cdata[i] = data[i];
  return cdata;
}
int **copy_2d_iarray(data,xn,yn)
     int **data;  
     int xn,yn;
{
  int i;
  int **cdata;
  cdata = (int **)myalloc(xn*sizeof(int *));
  for(i=0;i<xn;i++)
    cdata[i] = copy_iarray(data[i],yn);
  return cdata;
}
void append_iarray(pd1,n1,d2,n2)
     int **pd1;     
     int n1;
     int *d2;       
     int n2;
{
  int i;
  int *t;
  t = (int *)myalloc((n1+n2)*sizeof(int));
  for(i=0;i<n1;i++)
    t[i] = (*pd1)[i];
  for(i=0;i<n2;i++)
    t[n1+i] = d2[i];
  myfree(*pd1);
  *pd1 = t;
}
int sum_iarray(data,n,start,duration)
     int *data,n,start,duration;
{
  int i;
  int sum,stop;
  stop = start+duration-1;
  if ((start < 0)||(stop >= n)||(duration < 0))
    exit_error("SUM_IARRAY","Parameter error");
  sum = 0;
  for(i=start;i<=stop;i++)
    sum += data[i];
  return sum;
}
int is_const_iarray(data,n)
     int *data,n;
{
  int i;
  int flag;
  flag = 1;
  for(i=1;i<n;i++)
    if (data[i] != data[0])
      flag = 0;
  return flag;
}
int is_const_col_2d_iarray(data,n,k)
     int **data,n,k;
{
  int i;
  int flag;
  flag = 1;
  for(i=1;i<n;i++)
    if (data[i][k] != data[0][k])
      flag = 0;
  return flag;
}
int is_nondecreasing_iarray(data,n)
     int *data,n;
{
  int i;
  int flag;
  flag = 1;
  i = 0;
  while((i<(n-1))&&(flag==1))
    if (data[i] > data[i+1])
      flag = 0;
    else
      i += 1;
  return flag;
}
int is_nonnegative_iarray(data,n)
     int *data,n;
{
  int i;
  for(i=0;i<n;i++){
    if (data[i] < 0)
      return 0;
  }
  return 1;
}
int *convert_2dv_to_iarray(data,n,cnt,rn)
     int **data,n,*cnt;
     int *rn; 
{
  int i,j,k;
  int *d,nn;
  if (!is_nonnegative_iarray(cnt,n))
    exit_error("CONVERT_2DV_TO_IARRAY","Negative count found");
  nn = sum_iarray(cnt,n,0,n);
  d = (int *)myalloc(nn*sizeof(int));
  k = 0;
  for(i=0;i<n;i++)
    for(j=0;j<cnt[i];j++){
      d[k] = data[i][j];
      k += 1;
    }
  *rn = nn;
  return d;
}
void reverse_iarray(data,n)
     int *data,n;
{
  int i;
  int t,mid;
  mid = n/2;
  for(i=0;i<mid;i++){
    t = data[i];
    data[i] = data[n-1-i];
    data[n-1-i] = t;
  }
}
void rotate_iarray(data,n,k)
     int *data;
     int n,k;
{
  int i,j;
  int *t;
  while(k<0) 
    k += n;
  while(k>=n)
    k -= n;
  if ((n > 0)&&(k != 0)){
    t = (int *)myalloc(n*sizeof(int));
    for(i=0;i<n;i++){
      j = (i+k)%n;
      t[j] = data[i];
    }
    for(i=0;i<n;i++)
      data[i] = t[i];
    myfree(t);
  }
}
char *get_string_from_iarray(data,n,sepstr)
     int *data,n;
     char sepstr[];
{
  int i,k;
  int slen,nsep;
  char tstr[1024],*t,c0;
  nsep = strlen(sepstr);
  slen = (n-1)*nsep + 1; 
  for(i=0;i<n;i++){
    sprintf(tstr,"%d",data[i]);
    slen += strlen(tstr);
  }
  t = (char *)myalloc(slen*sizeof(char));
  k = 0;
  for(i=0;i<(n-1);i++){
    sprintf(tstr,"%d",data[i]);
    sprintf((char *)(t+k),"%s%s",tstr,sepstr);
    k += strlen(tstr) + strlen(sepstr);
  }
  c0 = '\0';
  sprintf((char *)(t+k),"%d%c",data[i],c0);
  return t;
}
int count_occurrences_iarray(data,n,k)
     int *data,n,k;
{
  int i;
  int count;
  count = 0;
  for(i=0;i<n;i++)
    if (data[i] == k)
      count += 1;
  return count;
}
int get_index_min_search_iarray(data,n,k)
     int *data,n,k;
{
  int i;
  int t,max,tmin;
  i = 0;
  t = tmin = -1;
  max = k+1; 
  while((i<n)&&(t==-1)){
    if (data[i]==k)
      t = i;
    else{
      if (data[i] < k){
	if (tmin == -1){
	  tmin = i;
	  max = data[i];
	}else if (data[i] > max){
	  tmin = i;
	  max = data[i];
	}
      }
      i+=1;
    }
  }
  if (t >= 0)
    return t;
  else
    return tmin;
}
int get_index_search_iarray(data,n,k)
     int *data,n,k;
{
  int i;
  int t;
  i = 0;
  t = -1;
  while((i<n)&&(t==-1))
    if (data[i]==k)
      t = i;
    else
      i+=1;
  return t;
}
int get_index_search_nth_iarray(data,n,k,nn)
     int *data,n,k,nn;
{
  int i;
  int t,count;
  i = count = 0;
  t = -1;
  while((i<n)&&(t==-1))
    if (data[i]==k){
      count += 1;
      if (count == nn)
	t = i;
      else
	i+=1;
    }else
      i+=1;
  return t;
}
int get_index_search_range_iarray(data,n,min,max)
     int *data,n,min,max;
{
  int i;
  int t;
  i = 0;
  t = -1;
  while((i<n)&&(t==-1))
    if ((data[i]>=min)&&(data[i]<=max))
      t = i;
    else
      i+=1;
  return t;
}
int diff_iarrays(data1,n1,data2,n2)
     int *data1,n1,*data2,n2;
{
  int i;
  int flag;
  flag = 0;
  if (n1 != n2)
    flag = 1;
  for(i=0;i<n1;i++)
    if (data1[i] != data2[i])
      flag = 1;
  return flag;
}
int get_index_max_diff_iarrays(data1,data2,n)
     int *data1,*data2,n;
{
  int i,k;
  int max;
  k = -1;
  max = 0;
  for(i=0;i<n;i++)
    if (abs(data1[i]-data2[i]) > max){
      k = i;
      max = abs(data1[i]-data2[i]);
    }
  return k;
}
int get_max_diff_iarrays(data1,data2,n)
     int *data1,*data2,n;
{
  int k;
  k = get_index_max_diff_iarrays(data1,data2,n);
  if (k>=0)
    return(data1[k] - data2[k]);
  else
    return 0;
}
int *add_iarrays(data1,data2,n)
     int *data1,*data2;
     int n;
{
  int i;
  int *data;
  data = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++)
    data[i] = data1[i] + data2[i];
  return data;
}
void add_const_iarray(data,n,c)
     int *data,n,c;
{
  int i;
  for(i=0;i<n;i++)
    data[i] += c;
}
int *multiply_iarray(data,n,f)
     int *data,n;
     float f;
{
  int i;
  int *mdata;
  mdata = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++)
    mdata[i] = (int)(f * (float)data[i] + 0.5);
  return mdata;
}
void subsample_iarray(data,n,rdata,rn,ss,origin)
     int *data,n;     
     int **rdata,*rn; 
     int ss;          
     int origin;      
{
  int i;
  int pos,start;
  check_int_range(0,n-1,origin,"subsample_iarray: origin");
  check_int_range(0,n-1,ss,"subsample_iarray: ss");
  if (n > 0){
    start = origin - (origin/ss)*ss;
    *rn = origin/ss + 1 + (n-origin-1)/ss;
  }else{
    start = 0;
    *rn = 0;
  }
  *rdata = (int *)myalloc(*rn*sizeof(int));
  pos = 0;
  for (i=start;i<n;i+=ss){
    (*rdata)[pos] = data[i];
    pos += 1;
  }
  if (pos != *rn)
    exit_error("SUBSAMPLE_IARRAY","pos != rn");
}
int count_min_runs_middle_iarray(data,n,x,min_run)
     int *data,n,x,min_run;
{
  int k;
  int flag,count,rlen;
  if (min_run < 1)
    exit_error("COUNT_MIN_RUNS_MIDDLE_IARRAY","min_run is less than 1");
  k = 0; 
  flag = 0;
  while((k<(n-1))&&(!flag)){ 
    if (data[k] != x)
      flag = 1;
    k += 1;
  }
  count = 0; 
  rlen = 0;
  while(k<n){
    if (data[k]!=x){
      if (rlen >= min_run) 
	count += 1;
      rlen = 0;
    }else
      rlen += 1;
    k += 1;
  }
  return count;
}
void replace_min_runs_middle_iarray(data,n,x,y,min_run)
     int *data,n,x,y,min_run;
{
  int i,j,k;
  k = 0; 
  for(i=1;i<n;i++)
    if ((data[i] != x)&&(k > 0)&&(k < min_run)){ 
      for(j=i-k;j<i;j++)
	data[j] = y;
      k = 0;
    }else if ((data[i] == x)&&(data[i-1] != x)){ 
      k = 1;
    }else if ((data[i] == x)&&(k >= 1)){ 
      k += 1;
    }
}
int *get_column_2d_iarray(data,m,n,k)
     int **data,m,n,k;
{
  int i;
  int *col;
  col = (int *)myalloc(m*sizeof(int));
  for(i=0;i<m;i++)
    col[i] = data[i][k];
  return col;
}
int get_decimal_number_from_iarray(data,n)
     int *data,n;
{
  int i,k;
  int total;
  if (n<=0)
    return 0;
  k = 1;
  total = 0;
  for(i=(n-1);i>=0;i--){
    total += k*data[i];
    k *= 10;
  }
  return total;
}
void get_bit_iarray_from_int(k,n,rdata)
     int k,n,**rdata;
{
  int i;
  int *data;
  data = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++)
    data[n-1-i] = (k>>i) & 1;
  *rdata = data;
}
int count_digits(k)
     int k;
{
  int count;
  count = 1;
  if (k < 0){
    count += 1;
    k = -k;
  }
  while ((k/10) >= 1){
    k = k/10;
    count += 1;
  }
  return count;
}
void print_iarray_80_column(fout,data,n)
     FILE *fout;
     int *data,n;
{
  int i;
  int char_count,digits;
  if (n > 0){
    char_count = 0;
    for (i=0;i<n;i++){
      digits = count_digits(data[i]);
      if ((char_count + digits + 1) >= 80){
	fprintf(fout,"\n");
	char_count = 0;
      }
      if (char_count == 0){
	fprintf(fout,"%d",data[i]);
	char_count += digits;
      }else{
	fprintf(fout," %d",data[i]);
	char_count += digits + 1;
      }
    }
    fprintf(fout,"\n");
  }
}
void heap_sort_iarray(data,n)
     int *data,n;
{
  hpsort_int((unsigned long)n,data-1);
}
void bubble_sort_iarray(data,n)
     int *data,n;
{
  int i;
  int done,bottom,t;
  bottom = n-1;
  done = 0;
  while (!done){
    done = 1;
    for (i=0;i<bottom;i++)
      if (data[i] > data[i+1]){
	done = 0;
	t = data[i];
	data[i] = data[i+1];
	data[i+1] = t;
      }
    bottom -= 1;
  }
}
int *index_bubble_sort_iarray_double(dhi,dlo,n)
     int *dhi,*dlo,n;
{
  int i;
  int *index,done,bottom,t;
  index = (int *)myalloc(n*sizeof(int));
  for (i=0;i<n;i++)
    index[i] = i;
  bottom = n-1;
  done = 0;
  while (!done){
    done = 1;
    for (i=0;i<bottom;i++)
      if ((dhi[index[i]] > dhi[index[i+1]]) ||
	  ((dhi[index[i]] == dhi[index[i+1]]) &&
	   (dlo[index[i]]  > dlo[index[i+1]]))){
	done = 0;
	t = index[i];
	index[i] = index[i+1];
	index[i+1] = t;
      }
    bottom -= 1;
  }
  return index;
}
int *index_bubble_sort_iarray(data,n)
     int *data,n;
{
  int i;
  int *index,done,bottom,t;
  index = (int *)myalloc(n*sizeof(int));
  for (i=0;i<n;i++)
    index[i] = i;
  bottom = n-1;
  done = 0;
  while (!done){
    done = 1;
    for (i=0;i<bottom;i++)
      if (data[index[i]] > data[index[i+1]]){
	done = 0;
	t = index[i];
	index[i] = index[i+1];
	index[i+1] = t;
      }
    bottom -= 1;
  }
  return index;
}
int *get_permutation_iarray(n)
     int n;
{
  int i;
  int *p;
  p = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++)
    p[i] = i;
  return p;
}
void permute_iarray(data,n,perm)
     int *data,n,*perm;
{
  int i;
  int *t;
  t = copy_iarray(data,n);
  for(i=0;i<n;i++)
    data[i] = t[perm[i]];
  myfree(t);
}
int get_next_permutation_pattern(data,n)
     int *data,n;
{
  int i,k;
  int done,p;
  k = n-2;
  p = -1;
  while((p < 0)&&(k >= 0)){
    if ((data[k] == 1)&&(data[k+1] == 0))
      p = k;
    k -= 1;
  }
  if (p >= 0){
    data[p+1] = 1; data[p] = 0; 
    done = 0;
    while(!done){
      done = 1;
      for(i=p+3;i<n;i++)
	if ((data[i]==1)&&(data[i-1]==0)){
	  data[i] = 0;
	  data[i-1] = 1;
	  done = 0;
	}
    }
  }
  if (p == -1)
    return 0;
  else
    return 1;
}
void include_component_permutation(data,n,perm,np,k)
     int *data,n,*perm,np,k;
{
  int i,j;
  j = 0; 
  for(i=0;i<n;i++){
    if (data[i] == -1){
      if (perm[j] == 1)
	data[i] = k;
      j += 1;
    }
  }
}
void get_all_permutations_iarray(k,cnt,rperm,rn)
     int k,*cnt,***rperm,*rn;
{
  int i,j,j0,j1,l,m,m1;
  int n,**perm,nperm,*t,flag,***pc,*nc;
  int nr0,nr1;
  n = sum_iarray(cnt,k,0,k); 
  nc = (int *)myalloc(k*sizeof(int));
  j = n;
  nperm = my_rint(n_choose_m(j,cnt[0]));
  nc[0] = nperm;
  for(i=1;i<k;i++){
    j -= cnt[i-1];
    nc[i] = my_rint(n_choose_m(j,cnt[i]));
    nperm *= nc[i];
  }
  l = n;
  pc = (int ***)myalloc((k-1)*sizeof(int **));
  for(i=0;i<(k-1);i++){
    pc[i] = (int **)myalloc(nc[i]*sizeof(int *));
    t = get_zero_iarray(l);
    for(j=0;j<cnt[i];j++)
      t[j] = 1;
    pc[i][0] = copy_iarray(t,l);
    m = 1;
    flag =  get_next_permutation_pattern(t,l);
    while(flag == 1){
      pc[i][m] = copy_iarray(t,l);
      flag =  get_next_permutation_pattern(t,l);
      m += 1;
    }
    myfree(t);
    l -= cnt[i];
  }
  perm = get_2d_iarray(nperm,n);
  for(i=0;i<nperm;i++)
    for(j=0;j<n;j++)
      perm[i][j] = -1;
  l = n;
  nr1 = nperm;
  for(i=0;i<(k-1);i++){
    m1 = 0;
    nr0 = nperm/nr1;
    nr1 = nperm/(nc[i]*nr0);
    for(j0=0;j0<nr0;j0++) 
      for(j=0;j<nc[i];j++)
	for(j1=0;j1<nr1;j1++){ 
	  include_component_permutation(perm[m1],n,pc[i][j],l,i);
	  m1 += 1;
	}
    l -= cnt[i];
  }
  for(i=0;i<nperm;i++)
    for(j=0;j<n;j++)
      if (perm[i][j] == -1)
	perm[i][j] = k-1;
  for(i=0;i<(k-1);i++)
    free_2d_iarray(pc[i],nc[i]);
  myfree(nc);
  *rperm = perm; *rn = nperm;
}
int convert_multi_index_to_1d(n,cnt,ndx)
     int n;      
     int *cnt;   
     int *ndx;   
{
  int i,k;
  int nn;
  nn = 1;
  k = 0;
  for(i=(n-1);i>=0;i--){   
    k += ndx[i] * nn;
    nn *= cnt[i];
  }
  return k;
}
void get_nd_cross_product_list_iarray(n,cnt,rlist,rntot)
     int n,*cnt,***rlist,*rntot;
{
  int i,j,k;
  int done,**list,ntot,*counter;
  ntot = 1; 
  for(i=0;i<n;i++)
    ntot *= cnt[i];
  list = get_2d_iarray(ntot,n);
  counter = get_zero_iarray(n);
  k = 0;
  for(i=0;i<ntot;i++){
    for(j=0;j<n;j++){
      list[i][j] = counter[j];
    }
    counter[k] += 1;
    done = 0; 
    while (!done){
      if (counter[k] == cnt[k]){ 
	counter[k] = 0;
	k += 1;
	if (k < n)
	  counter[k] += 1;
	else
	  done = 1;
      }else
	done = 1;
    }
    k = 0; 
  }
  myfree(counter);
  *rlist = list; *rntot = ntot;
}
int *get_unique_iarray(data,n,rn)
     int *data;
     int n;
     int *rn;
{
  int i,j,k;
  int *udata,*rdata,temp,done;
  udata = (int *)myalloc(n*sizeof(int));
  udata[0] = data[0]; 
  k = 1;
  for(i=1;i<n;i++){
    temp = data[i];
    j = 0;
    done = 0;
    while(!done){
      if (j==k)
	done = 1;
      else if (temp == udata[j])
	done = 1;
      else
	j += 1;
    }
    if (j==k){ 
      udata[k] = temp;
      k += 1;
    }
  }
  rdata = copy_iarray(udata,k);
  myfree(udata);
  *rn = k;
  return rdata;
}
int *get_unique_sort_iarray(data,n,rn)
     int *data,n,*rn;
{
  int i,k;
  int *sdata,*udata;
  sdata = copy_iarray(data,n);
  heap_sort_iarray(sdata,n);
  k = 1; 
  for(i=1;i<n;i++)
    if (sdata[i] != sdata[i-1])
      k += 1;
  udata = (int *)myalloc(k*sizeof(int));
  udata[0] = sdata[0];
  k = 1; 
  for(i=1;i<n;i++)
    if (sdata[i] != sdata[i-1]){
      udata[k] = sdata[i];
      k += 1;
    }
  myfree(sdata);
  *rn = k;
  return udata;
}
void get_unique_count_iarray(data,n,runiq,rcnt,rn)
     int *data,n;
     int **runiq,**rcnt,*rn;
{
  int i,j,k;
  int *uniq,*cnt,nu;
  uniq = get_unique_sort_iarray(data,n,&nu);
  cnt = get_zero_iarray(nu);
  for(i=0;i<nu;i++){
    k = uniq[i];
    for(j=0;j<n;j++){
      if (data[j] == k)
	cnt[i] += 1;
    }
  }
  *runiq = uniq; *rcnt = cnt; *rn = nu;
}
void mean_sdev_freq_hist(data,n,mean,sdev)
     int *data,n;
     float *mean,*sdev;
{
  int i;
  float m,s,weight,totw;
  m = 0.0;
  totw = 0.0;
  for(i=0;i<n;i++){
    weight = (float)data[i];
    m += weight * (float)i;
    totw += weight;
  }
  if (totw>0) m /= totw;
  s = 0.0;
  for(i=0;i<n;i++){
    weight = (float)data[i];
    s += weight*(((float)i-m)*((float)i-m));
  }
  if (totw>1)
    s = sqrt(s/(float)(totw-1.0));
  else
    s = -1.0;
  *mean = m;
  *sdev = s;
}
void mean_sdev_iarray(data,n,mean,sdev)
     int *data,n;
     float *mean,*sdev;
{
  int i;
  float m,s;
  m = 0.0;
  for(i=0;i<n;i++)
    m += (float)data[i];
  if (n>0) m /= (float)n;
  s = 0.0;
  for(i=0;i<n;i++)
    s += (((float)data[i]-m)*((float)data[i]-m));
  if (n>1) s = sqrt(s/(float)(n-1));
  *mean = m;
  *sdev = s;
}
void make_mean_zero_iarray(data,n,oldmean)
     int *data,n;
     float *oldmean;
{
  int i;
  float mean,sdev,fdata;
  mean_sdev_iarray(data,n,&mean,&sdev);
  for(i=0;i<n;i++){
    fdata = (float)data[i];
    data[i] = (int)(fdata - mean + 0.5);
  }
  *oldmean = mean;
}
int *f2iarray(data,n)
     float *data;
     int n;
{
  int i;
  int *idata;
  idata = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++)
    idata[i] = (int)data[i];
  return idata;
}
int *f2iarray_round(data,n)
     float *data;
     int n;
{
  int i;
  int *idata;
  idata = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++)
    idata[i] = my_rint(data[i]);
  return idata;
}
int count_non_zero_iarray(data,n)
     int *data,n;
{
  int i;
  int count;
  count = 0;
  for(i=0;i<n;i++)
    if (data[i] != 0)
      count += 1;
  return count;
}
int sum_column_2d_iarray(data,m,n,k)
     int **data,m,n,k;
{
  int sum,*col;
  col = get_column_2d_iarray(data,m,n,k);
  sum = sum_iarray(col,m,0,m);
  myfree(col);
  return sum;
}
int min_of_iarray(data,n)
     int *data,n;
{
  int i,min;
  if (n > 0){
    min = data[0];
    for(i=0;i<n;i++)
      if (data[i] < min)
	min = data[i];
  }else
    min = 0;
  return min;
}
int max_of_iarray(data,n)
     int *data,n;
{
  int i,max;
  if (n > 0){
    max = data[0];
    for(i=0;i<n;i++)
      if (data[i] > max)
	max = data[i];
  }else
    max = 0;
  return max;
}
int max_coord_iarray(data,n)
     int *data;
     int n;
{
  int i,k,max;
  if (n < 0){
    printf("(max_coord_iarray):  Array length < 0.\n");
    return(-1);
  }
  k = 0;
  max = data[0];
  for (i=1;i<n;i++)
    if (data[i] > max){
      max = data[i];
      k = i;
    }
  return k;
}
int min_coord_iarray(data,n)
     int *data;
     int n;
{
  int i,k,min;
  if (n < 0) {
    printf("(min_coord_iarray):  Array length < 0.\n");
    return(-1);
  }
  k = 0;
  min = data[0];
  for (i=1;i<n;i++)
    if (data[i] < min){
      min = data[i];
      k = i;
    }
  return k;
}
int max_of_2d_iarray(data,n,m)
     int **data,n,m;
{
  int i,j;
  int max;
  if ((n <= 0) || (m <= 0))
    exit_error("MAX_OF_2D_IARRAY","Empty array");
  max = data[0][0];
  for(i=0;i<n;i++){
    for(j=0;j<m;j++){
      if (data[i][j] > max)
	max = data[i][j];
    }
  }
  return max;
}
void min_max_2d_iarray(data,xn,yn,rmin,rmax)
     int **data;
     int xn,yn;
     int *rmin,*rmax;
{
  int i,j;
  int min,max;
  min = max = data[0][0];
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      if (data[i][j] > max)
	max = data[i][j];
      else if (data[i][j] < min)
	min = data[i][j];
    }
  }
  *rmin = min;
  *rmax = max;
}
void print_min_max_2d_iarray(data,xn,yn,name)
     int **data;
     int xn,yn;
     char *name;
{
  int i,j;
  int n_nan;
  int min,max;
  printf("===> ARRAY:  %s\n",name);
  n_nan = 0;
  min = max = data[0][0];
  for(i=0;i<xn;i++)
    for(j=0;j<yn;j++){
      if (isnan(data[i][j])){
	printf("  Element %d %d  is NaN\n",i,j);
	n_nan += 1;
	if (n_nan > 10){
	  printf(" ...  exiting\n");
	  exit(0);
	}
      }else if (data[i][j] > max){
	max = data[i][j];
      }else if (data[i][j] < min){
	min = data[i][j];
      }
    }
  printf("  [%d,%d]  min,max  %d %d\n",xn,yn,min,max);
}
void print_2d_iarray(data,m,n)
     int **data;
     int m,n;
{
  int i,j;
  for(i=0;i<m;i++){
    for(j=0;j<n;j++)
      printf("%d ",data[i][j]);
    printf("\n");
  }
}
void read_iarray(infile,data,n)
     char infile[];
     int **data,*n;
{
  FILE *fopen(),*fin;
  int i;
  int temp,ns;
  if ((fin = fopen(infile,"r"))==NULL){
    printf("  *** File %s\n",infile);
    exit_error("READ_IARRAY","Can't open file");
  }
  *n = 0;
  while (fscanf(fin,"%d",&temp)!= EOF)
    *n += 1;
  fclose(fin);
  *data = (int *)myalloc(*n*sizeof(int));
  fin = fopen(infile,"r");
  for(i=0;i<*n;i++)
    ns = fscanf(fin,"%d",&(*data)[i]);
  fclose(fin);
}
void write_iarray(outfile,data,n)
     char outfile[];
     int *data,n;
{
  FILE *fopen(),*fout;
  int i;
  if ((fout = fopen(outfile,"w"))==NULL){
    printf("  *** File %s\n",outfile);
    exit_error("WRITE_IARRAY","Can't open file");
  }
  for (i=0;i<n;i++)
    fprintf(fout,"%d\n",data[i]);
  fclose(fout);
}
void write_iarray_plot(outfile,data,n)
     char outfile[];
     int *data,n;
{
  FILE *fopen(),*fout;
  int i;
  fout = fopen(outfile,"w");
  for (i=0;i<n;i++)
    fprintf(fout,"%d %d\n",i,data[i]);
  fclose(fout);
}
void write_iarray_xy_plot(outfile,xdata,ydata,n)
     char outfile[];
     int *xdata,*ydata;
     int n;
{
  FILE *fopen(),*fout;
  int i;
  fout = fopen(outfile,"w");
  for (i=0;i<n;i++)
    fprintf(fout,"%d %d\n",xdata[i],ydata[i]);
  fclose(fout);
}
void append_iarray_xy_plot(outfile,name,xdata,ydata,n)
     char outfile[],name[];
     int *xdata,*ydata;
     int n;
{
  FILE *fopen(),*fout;
  int i;
  fout = fopen(outfile,"a");
  fprintf(fout,"/newplot\n");
  fprintf(fout,"/plotname %s\n",name);
  for (i=0;i<n;i++)
    fprintf(fout,"%d %d\n",xdata[i],ydata[i]);
  fclose(fout);
}
void append_iarray_plot(outfile,name,data,n,xscale)
     char outfile[],name[];
     int *data,n,xscale;
{
  FILE *fopen(),*fout;
  int i;
  fout = fopen(outfile,"a");
  fprintf(fout,"/newplot\n");
  fprintf(fout,"/plotname %s\n",name);
  for (i=0;i<n;i++)
    fprintf(fout,"%d %d\n",i*xscale,data[i]);
  fclose(fout);
}
void append_iarray_plot_offset(outfile,name,data,n,xscale,xoffset)
     char outfile[],name[];
     int *data,n,xscale,xoffset;
{
  FILE *fopen(),*fout;
  int i;
  fout = fopen(outfile,"a");
  fprintf(fout,"/newplot\n");
  fprintf(fout,"/plotname %s\n",name);
  for (i=0;i<n;i++)
    fprintf(fout,"%d %d\n",xoffset + i*xscale,data[i]);
  fclose(fout);
}
float lin_interp_iarray(x,y,n,inx)
     int *x,*y;
     int n;
     float inx;
{
  int i;
  printf("*** NOT TESTED*** Copied from similar routine in farray_util.c\n");
  if (inx < (float)x[0])
    return (float)y[0];
  else if (inx > (float)x[n-1])
    return (float)y[n-1];
  else{
    i=0;
    while(i<(n-1)){
  printf("%d %d %d %f\n",i,x[i],y[i],inx);
      if ((float)x[i] == inx)
	return (float)y[i];
      else if (((float)x[i] < inx)&&((float)x[i+1] > inx)){
	return (float)y[i] + (inx-(float)x[i])/(float)(x[i+1]-x[i]) *
	  (float)(y[i+1]-y[i]);
      }else
	i += 1;
    }
  }
  exit_error("LIN_INTERP_IARRAY","Error");
  return 0.0; 
}
int *pascal_triangle(n)
     int n;
{
  int i,j;
  int *p1,*p2,*t;
  if (n < 1)
    return NULL;
  p1 = get_zero_iarray(n);
  p2 = get_zero_iarray(n);
  p1[0] = 1;
  for(i=1;i<n;i++){
    p2[0] = 1;
    for(j=1;j<=i;j++){
      p2[j] = p1[j-1]+p1[j];
    }
    t = p1;
    p1 = p2;
    p2 = t;
  }
  myfree(p2);
  return p1;
}
