/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include "my_util.h"
#include "carray_util.h"
#include "paramfile_util.h"
#include "mctrl_util.h"
int DIR_FLAG = 0;
char MCTRL_DIR_ADMIN[SLEN];
char MCTRL_DIR_USR[SLEN];
char MCTRL_DIR_WORK[SLEN];       
char MCTRL_DIR_WORK_STIM[SLEN];
char MCTRL_DIR_MM2[SLEN];
char MCTRL_DIR_M[SLEN];
char MCTRL_DIR_MM[SLEN];
char MCTRL_DIR_M_RSP[SLEN];
char MCTRL_DIR_M_STM[SLEN];
char MCTRL_DIR_M_UPT[SLEN];
void mctrl_util_determine_dir_structure()
{
  if (file_exists(MAIN_DIR_WORK)){
    strcpy(MCTRL_DIR_ADMIN,MAIN_DIR_ADMIN);
    strcpy(MCTRL_DIR_USR  ,MAIN_DIR_USR);
    strcpy(MCTRL_DIR_WORK ,MAIN_DIR_WORK);
    strcpy(MCTRL_DIR_WORK_STIM,MAIN_DIR_WORK_STIM);
    strcpy(MCTRL_DIR_MM2  ,MAIN_DIR_MM2);
    strcpy(MCTRL_DIR_M,    MAIN_DIR_M);
    strcpy(MCTRL_DIR_MM,   MAIN_DIR_MM);
    strcpy(MCTRL_DIR_M_RSP,MAIN_DIR_M_RSP);
    strcpy(MCTRL_DIR_M_STM,MAIN_DIR_M_STM);
    strcpy(MCTRL_DIR_M_UPT,MAIN_DIR_M_UPT);
  }else{
    printf("  Using Apple directory structure.\n");
    strcpy(MCTRL_DIR_ADMIN,MAC_DIR_ADMIN);
    strcpy(MCTRL_DIR_USR  ,MAC_DIR_USR);
    strcpy(MCTRL_DIR_WORK ,MAC_DIR_WORK);
    strcpy(MCTRL_DIR_WORK_STIM,MAC_DIR_WORK_STIM);
    strcpy(MCTRL_DIR_MM2  ,MAC_DIR_MM2);
    strcpy(MCTRL_DIR_M,    MAC_DIR_M);
    strcpy(MCTRL_DIR_MM,   MAC_DIR_MM);
    strcpy(MCTRL_DIR_M_RSP,MAC_DIR_M_RSP);
    strcpy(MCTRL_DIR_M_STM,MAC_DIR_M_STM);
    strcpy(MCTRL_DIR_M_UPT,MAC_DIR_M_UPT);
  }
  DIR_FLAG = 1;
}
void mctrl_util_report_pid_run()
{
  int pid,ppid;
  char tstr[SLEN],outfile[SLEN];
  pid = getpid();
  ppid = getppid();  
  sprintf(outfile,"%s/%s",MCTRL_DIR_ADMIN,FILE_ADM_PID_JOB);
  sprintf(tstr,"%d %d\n",pid,ppid);
  append_string_to_file(outfile,tstr);
}
struct onode *mctrl_util_modlist_get_onode(modname,errstr)
     char *modname;
     char **errstr;  
{
  char modlist_file[SLEN],terr[SLEN];
  struct onode *omods,*mo,*o;
  sprintf(modlist_file,"%s/%s",MCTRL_DIR_MM,FILE_MOD_MODLIST);
  omods = paramfile_onode_file_read(modlist_file,0);
  if (omods == NULL){
    sprintf(terr,"MCTRL_UTIL_MODLIST_GET_ONODE  Model List Not Found:  %s",
	    modlist_file);
    *errstr = strdup(terr);
    return NULL;
  }
  mo = onode_get_node_type_item_val(omods,"model","name",modname);
  if (mo == NULL){
    sprintf(terr,"MCTRL_UTIL_MODLIST_GET_ONODE  Model node not found:  %s",
	    modname);
    *errstr = strdup(terr);
    return NULL;
  }
  o = onode_copy(mo);  
  paramfile_onode_free(omods);  
  *errstr = NULL;
  return o;
}
char *mctrl_util_cmd_line_pars(tn,pstr)
     int tn;
     char *pstr;
{
  char sstr[LONG_SLEN],fstr[LONG_SLEN*2],*tstr;
  if (tn > 0){
    sprintf(sstr,"tn %d",tn);
  }else
    strcpy(sstr,"");  
  if (strcmp(pstr,"none")!=0){
    if (strlen(sstr) > 0)
      sprintf(fstr,"%s %s",pstr,sstr);
    else
      sprintf(fstr,"%s",pstr);
  }else{
    sprintf(fstr,"%s",sstr);
  }
  tstr = strdup(fstr);
  return tstr;
}
void mctrl_util_uf_fi_read(infile,rn,ra,ru)
     char *infile;  
     int *rn;       
     char ***ra;    
     char ***ru;    
{
  FILE *fopen(),*fin;
  int i,n,ns;
  char **sa,**su,ta[SLEN],tu[SLEN];
  if ((fin = fopen(infile,"r"))==NULL){
    printf("  *** File %s\n",infile);
    exit_error("MCTRL_UTIL_UF_FI_READ","Can't open file");
  }
  ns = fscanf(fin,"%d",&n);  
  if (n <= 0){
    sa = su = (char **)NULL;
  }else{
    sa = (char **)myalloc(n*sizeof(char *));
    su = (char **)myalloc(n*sizeof(char *));
    for(i=0;i<n;i++){
      ns = fscanf(fin,"%s %s",ta,tu);
      sa[i] = strdup(ta);
      su[i] = strdup(tu);
    }
  }
  fclose(fin);
  *rn = n;
  *ra = sa;
  *ru = su;
}
char *mctrl_util_uf_fman_get(uname,ftype,field)
     char *uname;  
     char *ftype;  
     char *field;  
{
  int i,k;
  int dn,ns,fi,done;
  char *infile,**data,**slist,*sval;
  infile = mctrl_util_uf_fname("fman",uname,NULL,NULL);
  read_2d_carray(infile,1,0,&data,&dn);
  get_items_from_string(data[0],&slist,&ns);
  fi = search_2d_carray(slist,field,ns);
  free_2d_carray(slist,ns);
  if (k < 0){
    printf("  *** field:  %s\n",field);
    exit_error("MCTRL_UTIL_UF_FMAN_GET","Could not find field name");
  }
  k = -1;
  done = 0;
  i = 1;
  sval = NULL;
  while(done == 0){
    get_items_from_string(data[i],&slist,&ns);
    if (strcmp(slist[0],ftype)==0){
      sval = strdup(slist[fi]);
      done = 1;
    }else{
      i += 1;
      if (i >= dn)
	done = 1;
    }
    free_2d_carray(slist,ns);
  }
  myfree(infile);
  free_2d_carray(data,dn);
  return sval;
}
char *mctrl_util_uf_fname(mode,uname,ftype,tname)
     char *mode;   
     char *uname;  
     char *ftype;  
     char *tname;  
{
  int k;
  int n;
  char *locpath,*rstr,fname[LONG_SLEN],**alist,**ulist;
  rstr = NULL;  
  if ((strcmp(mode,"fi")==0) || (strcmp(mode,"aname")==0)){
    locpath = mctrl_util_uf_fman_get(uname,ftype,"Path");
    sprintf(fname,"%s/%s/uf/%s/file_index",MCTRL_DIR_USR,uname,locpath);
    if (strcmp(mode,"fi")==0){
      rstr = strdup(fname);
    }else if (strcmp(mode,"aname")==0){
      mctrl_util_uf_fi_read(fname,&n,&alist,&ulist);
      k = search_2d_carray(ulist,tname,n);
      if (k >= 0){
	sprintf(fname,"%s/%s/uf/%s/%s",MCTRL_DIR_USR,uname,locpath,alist[k]);
	rstr = strdup(fname);
      }
      free_2d_carray(alist,n);
      free_2d_carray(ulist,n);
      if (locpath != NULL)
	myfree(locpath);
    }
  }else if (strcmp(mode,"fman")==0){
    sprintf(fname,"%s/%s/uf/file_manager",MCTRL_DIR_USR,uname);
    rstr = strdup(fname);
  }else if (strcmp(mode,"arch")==0){
    locpath = mctrl_util_uf_fman_get(uname,ftype,"Path");
    sprintf(fname,"%s/%s/uf/%s/%s",MCTRL_DIR_USR,uname,locpath,tname);
    if (locpath != NULL)
      myfree(locpath);
    rstr = strdup(fname);
  }else{
    printf("  *** mode = %s\n",mode);
    exit_error("MCTRL_UTIL_UF_FNAME","Unknown 'mode' value");
  }
  return rstr;
}
