#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "my_util.h"
#include "iarray_util.h"
#include "farray_util.h"
#define GLIMIT 100.0                 
#define TINY 1.0e-20                 
#define GOLDRAT 1.61803399           
#define GRATIO 0.381966              
#define MAX_ITER  99                 
#define MAX_ITER_PR  222             
#define EPS_0     1.0e-10            
#define SHFT(a,b,c,d) (a)=(b); (b)=(c); (c)=(d);
#define SIGN(a,b) ((b) >= 0.0 ? fabs(a) : -fabs(a))
static float maxarg1,maxarg2;
#define FMAX(a,b) (maxarg1=(a),maxarg2=(b),(maxarg1) > (maxarg2) ?\
        (maxarg1) : (maxarg2))
#define TOLERANCE  2.0e-4
int     min_util_glob_n;             
float  *min_util_glob_x;             
float  *min_util_glob_v;             
float (*min_util_glob_f)(float []);  
float minu_test_func(x)
  float *x;
{
  float r;
  float x0,x1,c;
  if (1){
    c = 3.0;
    x0 = x[0];
    x1 = x[1];
    r = 1.0 + (x0-c)*(x0-c) + x1*x1;
  }else{
    ;
  }
  return r;
}
int minu_test_funcd(x,d)
  float *x;
  float *d;  
{
  float c;
  if (1){
    c = 3.0;
    d[0] = 2.0*(x[0]-c);  
    d[1] = 2.0*x[1];  
  }else{
    d[0] = 0.0;
    d[1] = 0.0;
  }
  return 1;
}
float minu_fa(float a)  
{
  int i;
  float f,*xt;
  xt = get_farray(min_util_glob_n);
  for(i=0;i<min_util_glob_n;i++)
    xt[i] = min_util_glob_x[i] + a * min_util_glob_v[i];
  f = min_util_glob_f(xt);
  myfree(xt);
  return f;
}
void minu_init_range(ax,bx,cx,fa,fb,fc,f)
     float *ax;  
     float *bx;  
     float *cx;  
     float *fa;
     float *fb;
     float *fc;
     float (*f)(float);
{
  float ulim,u,r,q,fu,dum;
  *fa = (*f)(*ax);
  *fb = (*f)(*bx);
  if (*fb > *fa){
    SHFT(dum,*ax,*bx,dum);
    SHFT(dum,*fb,*fa,dum);
  }
  *cx = (*bx) + GOLDRAT*(*bx - *ax);       
  *fc = (*f)(*cx);
  while(*fb > *fc){
    r = (*bx - *ax) * (*fb - *fc);
    q = (*bx - *cx) * (*fb - *fa);
    u = (*bx) - ((*bx - *cx)*q - (*bx - *ax)*r) /
      (2.0 * SIGN(FMAX(fabs(q-r),TINY),q-r));
    ulim = (*bx) + GLIMIT * (*cx - *bx);
    if ((*bx - u) * (u - *cx) > 0.0){  
      fu = (*f)(u);
      if (fu < *fc){        
	*ax = (*bx);
	*bx = u;
	*fa = (*fb);
	*fb = fu;
	return;
      }else if (fu > *fb){  
	*cx = u;
	*fc = fu;
	return;
      }
      u = (*cx) + GOLDRAT * (*cx - *bx);  
      fu = (*f)(u);
    }else if ((*cx-u) * (u - ulim) > 0.0){
      fu = (*f)(u);
      if (fu < *fc){
	SHFT(*bx,*cx,u,*cx + GOLDRAT*(*cx - *bx));
	SHFT(*fb,*fc,fu,(*f)(u));
      }
    }else if (((u - ulim) * (ulim - *cx)) >= 0.0){
      u = ulim;
      fu = (*f)(u);
    }else{
      u = (*cx) + GOLDRAT * (*cx - *bx);
      fu = (*f)(u);
    }
    SHFT(*ax,*bx,*cx,u);
    SHFT(*fa,*fb,*fc,fu);
  }
}
float minu_brent_1d(ax,bx,cx,f,tlrnc,xmin)
     float ax;          
     float bx;          
     float cx;          
     float (*f)(float); 
     float tlrnc;       
     float *xmin;       
{
  float a,b,d,e,etemp,fu,fv,fw,fx,p,q,r,tol1,tol2,u,v,w,x,xm;
  int i;
  if (ax < cx){
    a = ax;
    b = cx;
  }else{
    a = cx;
    b = ax;
  }
  x = w = v = bx;
  fw = fv = fx = (*f)(x);
  e = 0.0;
  for(i=0;i<MAX_ITER;i++){
    xm = 0.5 * (a+b);
    tol2 = 2.0 * (tol1 = tlrnc*fabs(x)+EPS_0);
    if (fabs(x-xm) <= (tol2-0.5*(b-a))){      
      *xmin = x;
      return fx;
    }
    if (fabs(e) > tol1){
      r = (x-w) * (fx-fv);
      q = (x-v) * (fx-fw);
      p = (x-v)*q - (x-w)*r;
      q = 2.0*(q-r);
      if (q > 0.0)
	p = -p;
      q = fabs(p);
      etemp = e;
      e = d;
      if (fabs(p) >= fabs(0.5*q*etemp) || (p <= q*(a-x)) || (p >= q*b-x)){
	d = GRATIO * (e = (x >= xm ? a-x : b-x));
      }else{
	d = p/q;
	u = x+d;
	if ((u-a < tol2) || ((b-u) < tol2))
	  d = SIGN(tol1,xm-x);
      }
    }else{
      d = GRATIO * (e = (x >= xm ? a-x : b-x));
    }
    u = (fabs(d) >= tol1 ? x+d : x+SIGN(tol1,d));
    fu = (*f)(u);  
    if (fu <= fx){
      if (u >= x)
	a = x;
      else
	b = x;
      SHFT(v,w,x,u);
      SHFT(fv,fw,fx,fu);
    }else{
      if (u < x)
	a = u;
      else
	b = u;
      if ((fu <= fw) || (w == x)){
	v = w;
	w = u;
	fv = fw;
	fw = fu;
      }else if ((fu <= fv) || (v == x) || (v == w)){
	v = u;
	fv = fu;
      }
    }
  }
  printf("  *** (MINU_BRENT_1D)  Maximum iterations exceeded\n");
  *xmin = x;
  return fx;
}
float minu_line(x,v,n,func)
     float *x;                
     float *v;                
     int n;                   
     float (*func)(float *);  
{
  float xx,xmin,fx,fb,fa,bx,ax;
  float minu_fa(float x);
  int i;
  float min_val;
  min_util_glob_n = n;
  min_util_glob_x = (float *)myalloc(n*sizeof(float));
  min_util_glob_v = (float *)myalloc(n*sizeof(float)); 
  min_util_glob_f = func;
  for(i=0;i<n;i++){
    min_util_glob_x[i] = x[i];
    min_util_glob_v[i] = v[i];
  }
  ax = 0.0;
  xx = 1.0;
  minu_init_range(&ax,&xx,&bx,&fa,&fx,&fb,minu_fa);
  min_val = minu_brent_1d(ax,xx,bx,minu_fa,TOLERANCE,&xmin);
  for(i=0;i<n;i++){
    v[i] *= xmin;
    x[i] += v[i];
  }
  myfree(min_util_glob_x);
  myfree(min_util_glob_v);
  return min_val;
}
void minu_pr(x,n,tlrnc,func,dfunc,riter,rval)
     float *x;                
     int n;                   
     float tlrnc;             
     float (*func)(float *);  
     int (*dfunc)(float *, float *);  
     int   *riter;            
     float *rval;             
{
  int i,j;
  int dflag;
  float gg,gam,fp,dgg;
  float *g,*h,*v;
  g = (float *)myalloc(n*sizeof(float));
  h = (float *)myalloc(n*sizeof(float));
  v = (float *)myalloc(n*sizeof(float));
  fp = (*func)(x);
  dflag = (*dfunc)(x,v);    
  for(j=0;j<n;j++){
    g[j] = -v[j];
    v[j] = h[j] = g[j];
  }
  for(i=0;i<MAX_ITER_PR;i++){
    *riter = i;
    *rval = minu_line(x,v,n,func);
    if (isnan(x[0])){
      *riter = -2;  
      myfree(g);
      myfree(h);
      myfree(v);
      return;
    }
    if (2.0*fabs(*rval-fp) <= tlrnc*(fabs(*rval)+fabs(fp)+EPS_0)){
      myfree(g);
      myfree(h);
      myfree(v);
      return;
    }
    fp = (*func)(x);
    dflag = (*dfunc)(x,v);
    if (dflag < 0){  
      printf("(min_util.c)  dflag = %d\n",dflag);
      *riter = dflag;
      myfree(g);
      myfree(h);
      myfree(v);
      return;
    }
    dgg = gg = 0.0;
    for(j=0;j<n;j++){
      gg += g[j]*g[j];
      dgg += (v[j] + g[j]) * v[j];
    }
    if (gg == 0.0){
      myfree(g);
      myfree(h);
      myfree(v);
      printf("(minu_pr) gradient is zero\n");
      return;
    }
    gam = dgg/gg;
    for(j=0;j<n;j++){
      g[j] = -v[j];
      v[j] = h[j] = g[j] = gam*h[j];
    }
  }
  *riter = -1;
  printf("  *** MINU_PR  Too many iterations\n");
}
void minu_test_fit()
{
  int n,niter;
  float minval,tlrnc,*x;
  float (*func)(float *);
  int (*dfunc)(float *, float *);
  tlrnc = 0.00001;
  n = 2;  
  x = (float *)myalloc(n*sizeof(float));
  x[0] = 10.0;
  x[1] =  7.0;
  func  = minu_test_func;
  dfunc = minu_test_funcd;
  minu_pr(x,n,tlrnc,func,dfunc,&niter,&minval);
  printf("    Number of iterations:  %d\n",niter);
  printf("    Minimum value:  %f\n",minval);
  printf("    x0,x1 = %f %f\n",x[0],x[1]);
  printf("\n");
  exit(0);
}
