#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>  
#include <math.h>
#include <string.h>
#include "my_util.h"
#include "nr_util.h"
#include "iarray_util.h"
#include "carray_util.h"
#include "farray_util.h"
#include "myrand_util.h"
#include "data_util.h"
#include "min_util.h"
#include "paramfile_util.h"
#include "mod_util.h"
#include "ifc.h"           
#include "mod.h"           
#include "paramfile.h"
static int myid = -1;         
static int numproc = -1;      
static char *mylogf = NULL;   
char ggstr[LONG_SLEN];        
int mod_dcn_action;           
float *stim_data;  
int i2;
int         mod_dcn_xn;      
int         mod_dcn_yn;      
int         mod_dcn_tn;      
float       mod_dcn_tscale;  
float       mod_dcn_sscale;  
struct layer{
  char *type;   
  int  nkern;   
  int  kw;      
  int  kh;      
  float ***kern;  
  int  rnx;     
  int  rny;     
  float ***r;   
};
void mod_dcn_prep_laytype_conv(m,lay)
     struct model_struct *m;    
     struct onode *lay;
{
  mylog(mylogf,"  MOD_DCN_PREP_CONV\n");
}     
void mod_dcn_prep_laytype_relu(m,lay)
     struct model_struct *m;    
     struct onode *lay;
{
  mylog(mylogf,"  MOD_DCN_PREP_RELU\n");
}     
void mod_dcn_01_prep(m,s,r)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
{
  int xn,yn,tn;
  float tscale,sscale;
  struct onode *fito,*s1o,*c1o,*s2o,*c2o;
  int n,k;
  struct onode *t;
  char *laytype;
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  mylog(mylogf,"  MOD_DCN_01_PREP\n");
  xn     = mod_dcn_xn     = onode_getpar_int_exit(m->o,"xn");
  yn     = mod_dcn_yn     = onode_getpar_int_exit(m->o,"yn");
  tn     = mod_dcn_tn     = onode_getpar_int_exit(m->o,"tn");
  tscale = mod_dcn_tscale = onode_getpar_flt_exit(m->o,"tscale");
  sscale = mod_dcn_sscale = onode_getpar_flt_exit(m->o,"sscale");
  printf("  xn = %d\n",xn);
  printf("  yn = %d\n",yn);
  n = onode_count_otype(m->o,"layer");
  printf("    %d layers\n",n);
  k = 0;
  t = onode_get_next_type(m->o->o,"layer");
  while(t != NULL){
    printf("  Layer %d,  name %s\n",k,onode_getpar_chr_exit(t,"name"));
    laytype = onode_getpar_chr_exit(t,"type");
    if (strcmp(laytype,"Convolution")==0){
      mod_dcn_prep_laytype_conv(m,t);
    }else if (strcmp(laytype,"ReLU")==0){
      mod_dcn_prep_laytype_relu(m,t);
    }else{
      exit_error("MOD_DCN_01_PREP","Unknown layer type.");
    }
    k += 1;
    t = onode_get_next_type(t->next,"layer");
  }
  exit_error("MOD_DCN_01_PREP","Under development.");
}
void mod_dcn_01_done(m)
     struct model_struct *m;        
{
  mylog(mylogf,"  MOD_DCN_01_DONE\n");
}
void mod_dcn_01_get_response(m,s,r)
     struct model_struct *m;        
     struct stim_struct *s;         
     struct response_struct *r;     
{
  int i,j,ii,jj;
  int xn,yn,xi,yi,gi,oi,nw,s2n;
  float *w,*x,***stim,u;
  char tstr[SLEN];
  struct dcn_s2_par *s2;
  xn = mod_dcn_xn;
  yn = mod_dcn_yn;
  stim = f3tensor(1,1,1,xn,1,yn);  
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      stim[1][i+1][j+1] = s->d[i+1][j+1][1];  
    }
  }
}
void mod_dcn_run_01(m,s,r,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  numproc = m->process_n;
  mod_dcn_action = action;
  if ((action == 0) || (action == 2) || (action == 10)){
    mod_dcn_01_prep(m,s,r);
  }else if (action == 1){
    mod_dcn_01_get_response(m,s,r);
  }else if (action == -1){
    mod_dcn_01_done(m);
  }
}
