/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <GL/glx.h>
#include <GL/gl.h>
#include "my_util.h"
#include "nr_util.h"
#include "carray_util.h"
#include "iarray_util.h"
#include "farray_util.h"
#include "func_util.h"
#include "myrand_util.h"
#include "data_util.h"
#include "ndata_util.h"
#include "paramfile_util.h"
#include "glplot_util.h"
#include "wygit_util.h"
#include "kernel_util.h"
#include "stim_util.h"
#include "pop_cell_util.h"
#include "mod_conn_util.h"
#include "pop_util.h"
#include "mod_util.h"
#include "mod_mon_util.h"
#include "mod_gr_util.h"  
#include "wygit.h"
#include "mod.h" 
#include "ifc.h" 
#include "paramfile.h"
#include "wyplot.h" 
#include "ndata.h"
int pflag = 0;
int mod_gui_win_init = 1;
int mod_gui_winw = 500;
int mod_gui_winh = 500;
int mod_gui_win2w = 498;
int mod_gui_win2h = 498;
int mod_gui_winx;
int mod_gui_winy;
int mod_gui_win2x;
int mod_gui_win2y;
float mod_gui_zoom = 1.0;
float winfracx = 0.95;    
float winfrac1 = 0.8;  
float winfrac2 = 0.8995;  
float headx  = -0.95;
float heady  = 0.85;
float headdx = 0.1;
float headdy = 0.1;
Display *mod_gui_dpy;
Window mod_gui_win;
GLXContext mod_gui_cx;
int mod_gui_dbflag;
struct mgui_win_struct{
  int initflag;
  Display *dpy;
  Window win;
  GLXContext cx;
  int dbflag;
  int redrawflag;
};
struct layer_label{
  char *coord;         
  char *layname;       
  char *message;       
  char *w2_coord;      
  char *w2_message;    
  char *w2_eye;        
  char *w2_layname;    
};
struct gui_view{
  char *area;       
  int x0,y0;        
  int xn,yn;        
};
struct mgui_struct{
  struct pop_top *mpt;     
  int xn,yn;               
  struct pop_icon *gicon;  
  struct gui_gpar *gstim;  
  int tn;
  float tscale;
  float sscale;
  int tsamp;
  char *stimtype;
  char *stimform;          
  int nrpt;
  int nstim;
  int nview;                
  struct gui_view *view;    
  int curi;                       
  struct pop_layer *pl,*opl,*tl;  
  struct pop_layer *tlgn;         
  int lgn_flag;                   
  int targflag_lgn;               
  int targflag_eye;               
  struct gui_gpar *gcurr;         
  int ci,cj,ck;                   
  int win2_zi;                    
  struct layer_label *laylab;     
  struct mgui_win_struct *win1;   
  struct mgui_win_struct *win2;   
  float ***sdata;                 
  float ***sdata_r;               
  int ***c3data;                  
  int sdn;                        
  float cfx0,cfy0;                
  float cfw,cfh;
  float winfrac;
  float winfrac_x;                
  float winfrac_y;
  float gridfrac;
  int synnorm;                    
  float cprob;                    
  int colormapflag;               
  int overlay_flag;               
  int syn_dump_flag;              
  int stimflag;                   
  int stimno;                     
  int drawcon;
  int draw_level;                 
  int mon_state;                  
  int run_state;                  
  int conn_reg_xi1;    
  int conn_reg_yi1;    
  int conn_reg_xi2;    
  int conn_reg_yi2;    
  int conn_reg_llx;    
  int conn_reg_lly;
  int conn_reg_urx;
  int conn_reg_ury;
  float lgn_sig1;        
  float lgn_sig2;        
  float lgn_amp1;        
  float lgn_amp2;        
  struct ndata_struct *replay_nd;        
  int replay_dt;                         
  int replay_tn;                         
  int replay_xn,replay_yn;               
  float ***replay_d;                     
  int replay_ti;                         
  int replay_file_i;                     
  int wgrid_win;   
  int wgrid_w;     
  int wgrid_h;     
  float **wgrid_r;   
  float **wgrid_g;   
  float **wgrid_b;   
};
struct mgui_struct *mgs = NULL;
int glob_win1_ci = -1;
int glob_win1_cj = -1;
int glob_win1_ck = -1;
int glob_win2_ci = -1;       
int glob_win2_cj = -1;       
int glob_flag_rev_map = 0;   
void mod_gui_wgrid_set_element(i,j,r,g,b,w)
     int i,j;
     float r,g,b;
     float w;
{
  mgs->wgrid_r[i][j] = r * w;
  mgs->wgrid_g[i][j] = g * w;
  mgs->wgrid_b[i][j] = b * w;
}
void mod_gui_wgrid_init(xn,yn,c)
     int xn;
     int yn;
     float c;
{
  int i,j;
  if (pflag == 1){
    printf("  MOD_GUI_WGRID_INIT\n");
    printf("    xn,yn  %d,%d   c %f\n",xn,yn,c);
  }
  if (mgs->wgrid_r != NULL){
    if ((mgs->wgrid_w != xn) || (mgs->wgrid_h != yn)){
      if (pflag == 1){
	printf("    Freeing old storage, length %d\n",mgs->wgrid_w);
      }
      free_2d_farray(mgs->wgrid_r,mgs->wgrid_w);
      free_2d_farray(mgs->wgrid_g,mgs->wgrid_w);
      free_2d_farray(mgs->wgrid_b,mgs->wgrid_w);
      mgs->wgrid_r = NULL;
      mgs->wgrid_g = NULL;
      mgs->wgrid_b = NULL;
    }
  }
  if (mgs->wgrid_r == NULL){
    if (pflag == 1){
      printf("    Allocating new storage, length %d\n",mgs->wgrid_w);
    }
    mgs->wgrid_w = xn;
    mgs->wgrid_h = yn;
    mgs->wgrid_r = get_const_2d_farray(mgs->wgrid_w,mgs->wgrid_h,c);
    mgs->wgrid_g = get_const_2d_farray(mgs->wgrid_w,mgs->wgrid_h,c);
    mgs->wgrid_b = get_const_2d_farray(mgs->wgrid_w,mgs->wgrid_h,c);
  }else{
    for(i=0;i<xn;i++)
      for(j=0;j<yn;j++){  
	mod_gui_wgrid_set_element(i,j,c,c,c,1.0);
      }
  }
}
void mod_gui_wgrid_write_ps(outfile,colorflag,normflag,shape)
     char outfile[];
     int colorflag,normflag;
     int shape;  
{
  FILE *fout,*fopen();
  int i,j;
  int n,width,height;
  float r,g,b,dr,dg,db,tx,ty,xc,yc,d,dmax,xsize,ysize;
  float dx,dy,boxw,boxh,maxr,minr,maxg,ming,maxb,minb;
  char shape_str[SLEN];
  printf("  MOD_GUI_WGRID_WRITE_PS\n");
  if (mgs->drawcon == 4){
    shape = 1;
    normflag = 0;
  }
  width = (int)(6.5 * 72.0);  
  height = (int)(9.0 * 72.0); 
  xsize =  2.0 * 72.0;  
  ysize =  2.0 * 72.0;  
  if (normflag){
    get_min_max_2d_farray(mgs->wgrid_r,mgs->wgrid_w,mgs->wgrid_h,&minr,&maxr);
    get_min_max_2d_farray(mgs->wgrid_g,mgs->wgrid_w,mgs->wgrid_h,&ming,&maxg);
    get_min_max_2d_farray(mgs->wgrid_b,mgs->wgrid_w,mgs->wgrid_h,&minb,&maxb);
    if (maxr > maxg)
      dmax = maxr;
    else
      dmax = maxg;
    if (maxb > dmax)
      dmax = maxb;
  }else{
    dmax = 1.0;
  }
  xc = (8.5*72.0 - xsize)/2.0; 
  yc = (11.0*72.0 - ysize)/2.0;
  dx = xsize/mgs->wgrid_w;
  dy = ysize/mgs->wgrid_h;
  fout = fopen(outfile,"w");
  fprintf(fout,"%%!\n");
  fprintf(fout,"%%%%BoundingBox: %d %d %d %d\n",(int)xc,(int)yc,(int)xc+width,
	  (int)yc+height);
  if (shape == 0){
    boxw = 0.4 * dx;  
    boxh = 0.4 * dy;
    strcpy(shape_str,"circle");
    fprintf(fout,"%%%% Define point style %s.\n",shape_str);
    fprintf(fout,"/circle  %%stack x,y => ...\n");  
    fprintf(fout,"  {newpath %.1f 0 360 arc\n",boxw);
    fprintf(fout,"   closepath} def\n\n");
  }else{
    if (mgs->drawcon == 4){
      boxw = 1.02 * dx;  
      boxh = 1.02 * dy;
    }else{
      boxw = 0.8 * dx;  
      boxh = 0.8 * dy;
    }
  }
  for(i=0;i<mgs->wgrid_w;i++){
    for(j=0;j<mgs->wgrid_h;j++){
      dr = mgs->wgrid_r[i][j];
      dg = mgs->wgrid_g[i][j];
      db = mgs->wgrid_b[i][j];
      r = dr/dmax;
      g = dg/dmax;
      b = db/dmax;
      tx = (float)i*dx + xc;
      ty = (float)j*dy + yc;
      if (shape == 0){ 
	fprintf(fout,"%%%% DRAW_POINT\n");
	fprintf(fout,"newpath\n");
	fprintf(fout,"%.2f setlinewidth\n",1.0);
	fprintf(fout,"%10.2f %10.2f %s ",tx,ty,shape_str);
	fprintf(fout,"%.4f %.4f %.4f setrgbcolor\n",r,g,b);
	fprintf(fout,"fill\n");
      }else{
	fprintf(fout,"newpath\n");
	fprintf(fout,"%.2f %.2f moveto\n",tx     ,ty);
	fprintf(fout,"%.2f %.2f lineto\n",tx+boxw,ty);
	fprintf(fout,"%.2f %.2f lineto\n",tx+boxw,ty-boxh);
	fprintf(fout,"%.2f %.2f lineto\n",tx     ,ty-boxh);
	fprintf(fout,"closepath %.2f %.2f %.2f setrgbcolor fill\n",r,g,b);
      }
    }
  }
  fprintf(fout,"showpage\n");
  fclose(fout);
}
void mod_gui_replay_compute_response()
{
  int i,j,k;
  int xn,yn,tn,ti,*s,ns,si,ntr,reci;
  float ***d,*psth,binsize,sampling,vmin,vmax;
  char tname[SLEN];
  struct ndtrial_struct *tr;
  printf("    MOD_GUI_REPLAY_COMPUTE_RESPONSE\n");
  ntr = mgs->replay_nd->ntrial;
  ti = 0; 
  printf("*** WYETH HERE - mod_guid_util - assuming trial index is 0\n");
  tr = &(mgs->replay_nd->t[ti]);
  sprintf(tname,"%s_0_0",mgs->pl->name);
  k = ndata_trial_get_record_index(tr,tname);
  if (k < 0){
    printf("    Data not found for %s\n",tname);
    return;
  }
  sampling = ndata_trial_get_sampling_chan(tr,tname);
  xn = mgs->pl->xn;
  yn = mgs->pl->yn;
  tn = ((float)mgs->tn * mgs->tscale * 1000.0 / (float)(mgs->replay_dt));
  if (mgs->replay_d != NULL){
    if (mgs->replay_tn != tn){
      free_3d_farray(mgs->replay_d,mgs->replay_tn,mgs->replay_xn,
		     mgs->replay_yn);
      mgs->replay_d = get_3d_farray(tn,xn,yn);
    }else if ((mgs->replay_xn != xn)||(mgs->replay_yn != yn)){
      for(i=0;i<tn;i++){
	free_2d_farray(mgs->replay_d[i],mgs->replay_xn);
	mgs->replay_d[i] = get_2d_farray(xn,yn);
      }
    }
  }else{
    mgs->replay_d = get_3d_farray(tn,xn,yn);
  }
  d = mgs->replay_d; 
  psth = (float *)myalloc(tn * sizeof(float));
  binsize = sampling * (float)mgs->replay_dt / 1000.0;
  reci = 0;
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){  
      sprintf(tname,"%s_%d_%d",mgs->pl->name,i,j);
      for(k=0;k<tn;k++) 
	psth[k] = 0.0;
      for(ti=0;ti<ntr;ti++){
	tr = &(mgs->replay_nd->t[ti]);
	if (0){
	  s = ndata_trial_getp_point_chan(tr,tname,&ns);
	}else{
	  ns = tr->r[reci].n;
	  s = tr->r[reci].p;
	}
	for(si=0;si<ns;si++){ 
	  k = (int)((float)s[si]/binsize);
	  if ((k >= 0)&&(k<tn))
	    psth[k] += 1.0;
	}
      }
      for(k=0;k<tn;k++)
	d[k][i][j] = psth[k]/(float)ntr;
      reci += 1;  
    }
  }
  myfree(psth);
  get_min_max_3d_farray(d,0,tn,0,xn,0,yn,&vmin,&vmax);
  printf("  min,max  was %f %f\n",vmin,vmax);
  multiply_3d_farray(d,0,tn,0,xn,0,yn,1.0/vmax);
}
int mod_gui_replay_load()
{
  struct ndata_struct *nd;
  char fname[SLEN];
  printf("    MOD_GUI_REPLAY_LOAD\n");
  if (mgs->replay_file_i == 0){
    sprintf(fname,"zz.nd");
    mgs->replay_file_i = 1;
  }else if (mgs->replay_file_i == 1){
    sprintf(fname,"zz1.nd");
    mgs->replay_file_i = 2;
  }else if (mgs->replay_file_i == 2){
    sprintf(fname,"zz2.nd");
    mgs->replay_file_i = 0;
  }
  read_ndata(fname,&nd);
  if (nd == NULL)
    return 0;
  mgs->replay_nd = nd;
  mgs->replay_dt = 10;    
  mgs->replay_d = NULL;  
  mgs->replay_ti = 0;    
  printf("    tn = %d\n",mgs->tn);
  printf("    tscale = %.5f\n",mgs->tscale);
  printf("    Current Layer: %s\n",mgs->pl->name);
  printf("       %d x %d\n",mgs->pl->xn,mgs->pl->yn);
  mgs->replay_xn = mgs->pl->xn;
  mgs->replay_yn = mgs->pl->yn;
  mgs->replay_tn = ((float)mgs->tn * mgs->tscale * 1000.0 / 
		    (float)(mgs->replay_dt));
  printf("      Length of replay data:  %d\n",mgs->replay_tn);
  mod_gui_replay_compute_response();
  return 1;
}
void mod_gui_get_last_event_of_type(dpy,evtype,pev)
     Display *dpy;
     int evtype;   
     XEvent *pev;  
{
  int n;
  XEvent peekev,ignorev;
  n = XQLength(dpy);
  while (n > 0){
    XPeekEvent(dpy,&peekev);
    if (peekev.type == evtype){
      XNextEvent(dpy,pev);          
    }else{
      XNextEvent(dpy,&ignorev);     
    }
    n -= 1;
  }
}
int *mod_gui_get_savflag_list(c,slist,ns)
  struct pop_cell *c;
  char **slist;
  int ns;
{     
  int i;
  int *flag;
  struct wyp_struct *wyp;
  struct wyp_plot_struct *p;
  wyp = mod_mon_get_wyp_pointer();
  if (wyp == NULL)
    exit_error("MOD_GUI_GET_SAVFLAG_LIST","wyp is null");
  flag = get_zero_iarray(ns);
  p = wyp->p;
  while(p != NULL){  
    if (p->c == c){  
      i = search_2d_carray(slist,p->name,ns);
      if (i == -1){
	printf("  *** item name %s\n",p->name);
	exit_error("MOD_GUI_GET_SAVFLAG_LIST","String not a saved item");
      }else
	flag[i] = 1; 
    }
    p = p->next;
  }
  return flag;
}
void mod_gui_mon_save(pl)
     struct pop_layer *pl;
{
  int i;
  int hn,ns,nmdaflag,*sflag;
  float x,y,w,dy,r,g,b;
  char **slist,*dname,units[SLEN];
  struct wygit_struct *ws;
  struct pop_cell *c;
  struct pop_syn *syn;
  printf("  MOD_GUI_MON_SAVE\n");
  w = 0.5;
  dy = 0.08;
  hn = 8;
  x = -w/2.0;
  y = -(float)hn * dy / 2.0;
  slist = dll_string_get_slist(pl->save_name_list);
  ns = pl->save_name_list->n;
  c = &(pl->c[mgs->ci][mgs->cj][mgs->ck]);
  sflag = mod_gui_get_savflag_list(c,slist,ns);
  ws = wygit_select_make(mod_gui_winw,mod_gui_winh,mgs->cfx0,mgs->cfy0,
			 mgs->cfw,mgs->cfh,slist,ns,x,y,w,dy,hn);
  ws->select_1 = 0; 
  ws->select_xm = 4.0 * mgs->cfw/(float)mod_gui_winw; 
  for(i=0;i<ns;i++)
    ws->select_flag[i] = sflag[i];
  wygit_select(mgs->win1->dpy,mgs->win1->win,ws);
  for(i=0;i<ns;i++){  
    if (ws->select_flag[i] != sflag[i]){  
      dname = ws->select_list[i];
      if (ws->select_flag[i] == 1){  
	syn = NULL;  
	mod_mon_get_color(dname,&r,&g,&b);
	mod_mon_get_units(dname,units);
	mod_mon_plot_add_init_plot_glob(c,syn,dname,r,g,b,units);
      }else{ 
	mod_mon_plot_remove_plot_glob(c,dname);
      }
    }
  }
  free_2d_carray(slist,ns);
  wygit_free(ws);
  myfree(sflag);
}
struct gui_view *mod_gui_get_view_for_lay(lay)
     struct pop_layer *lay;
{
  int i;
  struct gui_view *gv;
  char *aname;
  if (lay->area == NULL){
    aname = strdup("stim");
  }else{
    aname = strdup(lay->area->name);
  }
  gv = NULL;
  for(i=0;i<mgs->nview;i++){
    if (strcmp(aname,mgs->view[i].area)==0)
      gv = &(mgs->view[i]);
  }
  myfree(aname);
  if (gv == NULL){
    gv = &(mgs->view[0]);  
    printf("mod_gui_get_view_for_lay ------************* Using stim view\n");
  }
  return gv;
}
float mod_gui_get_dd_pix(oglppix,dd)
     float oglppix;  
     float dd;       
{
  float dd_new;
  if (dd < oglppix)
    dd_new = oglppix;     
  else{
    dd_new = oglppix * (float)((int)(dd/oglppix));
  }
  return dd_new;
}
float mod_gui_get_dx_lay(lay,winfrac)
     struct pop_layer *lay;
     float winfrac;
{
  float dx;
  struct gui_view *gv;
  struct pop_area *pa;
  if (pflag == 1) printf("  MOD_GUI_GET_DX_LAY\n");
  gv = mod_gui_get_view_for_lay(lay);
  if (gv->xn == -1){  
    pa = pop_util_get_area_by_name(mgs->mpt,gv->area);
    gv->xn = pa->xn;   
    gv->yn = pa->yn;
  }
  if (pflag == 1) printf("    View for %s   xn,yn  %d,%d\n",lay->name,
			 gv->xn,gv->yn);
  dx = winfrac * mgs->cfw / (float)gv->xn; 
  if (strcmp(lay->name,"lgn")==0){
    double oglpix;
    float dx_new;
    oglpix =  mgs->cfw / (float)mod_gui_win2w;
    dx_new = mod_gui_get_dd_pix(oglpix,dx);
    dx = dx_new;
  }
  return dx;
}
float mod_gui_get_dy_lay(lay,winfrac)
     struct pop_layer *lay;
     float winfrac;
{
  float dy;
  struct gui_view *gv;
  gv = mod_gui_get_view_for_lay(lay);
  if (gv->xn == -1){  
    gv->xn = my_rint((float)(lay->xn) * lay->xf);
    gv->yn = my_rint((float)(lay->yn) * lay->yf);
  }
  dy = winfrac * mgs->cfh / (float)gv->yn; 
  if (strcmp(lay->name,"lgn")==0){
    double oglpix;
    float dy_new;
    oglpix =  mgs->cfh / (float)mod_gui_win2h;
    dy_new = mod_gui_get_dd_pix(oglpix,dy);
    dy = dy_new;
  }
  return dy;
}
void mod_gui_stim_grid_update(gc,winfrac)
     struct gui_gpar *gc;   
     float winfrac;
{
  float gdx,gdy,dx,dy,oglpix;
  gc->geom_flag = 0;  
  gc->xn = mgs->xn;
  gc->yn = mgs->yn;
  gc->oglppix_x = mgs->cfw / (float)mod_gui_win2w;
  gc->oglppix_y = mgs->cfh / (float)mod_gui_win2h;
  dx = winfrac * mgs->cfw / (float)gc->xn;
  dy = winfrac * mgs->cfh / (float)gc->yn;
  gdx = mod_gui_get_dd_pix(gc->oglppix_x,dx);
  gdy = mod_gui_get_dd_pix(gc->oglppix_y,dy);
  gc->gdx = gdx;
  gc->gdy = gdy;
  gc->bw = gdx - gc->oglppix_x;
  gc->bh = gdy - gc->oglppix_y;
  gc->dx = gdx;
  gc->dy = gdy;
  gc->oddxoff = 0.0;
}
struct gui_gpar *mod_gui_get_grid_params_stim(winfrac)
     float winfrac;
{
  float gdx,gdy,dx,dy,oglpix;
  struct gui_gpar *gc;
  gc = (struct gui_gpar *)myalloc(sizeof(struct gui_gpar));
  gc->geom_flag = 0;  
  gc->xn = mgs->xn;
  gc->yn = mgs->yn;
  gc->oglppix_x = mgs->cfw / (float)mod_gui_win2w;
  gc->oglppix_y = mgs->cfh / (float)mod_gui_win2h;
  dx = winfrac * mgs->cfw / (float)gc->xn;
  dy = winfrac * mgs->cfh / (float)gc->yn;
  gdx = mod_gui_get_dd_pix(gc->oglppix_x,dx);
  gdy = mod_gui_get_dd_pix(gc->oglppix_y,dy);
  gc->gdx = gdx;
  gc->gdy = gdy;
  gc->x0 = mgs->cfx0 + (1.0 - winfrac) * mgs->cfw/2.0;
  gc->y0 = mgs->cfy0 + (1.0 - winfrac) * mgs->cfh/2.0;
  gc->bw = gdx - gc->oglppix_x;
  gc->bh = gdy - gc->oglppix_y;
  gc->dx = gdx;
  gc->dy = gdy;
  gc->oddxoff = 0.0;
  return gc;
}
void mod_gui_set_grid_params(gp,pl,winfracx,winfracy)
     struct gui_gpar *gp;
     struct pop_layer *pl;
     float winfracx,winfracy;
{
  float gdx,gdy,x0,y0,size_f;
  if (pflag == 1){
    printf("  MOD_GUI_SET_GRID_PARAMS\n");
    printf("    Layer %s  xn,yn  %d,%d\n",pl->name,pl->xn,pl->yn);
  }
  gp->xn = pl->xn;
  gp->yn = pl->yn;
  gdx = mod_gui_get_dx_lay(pl,winfracx);
  gdy = mod_gui_get_dy_lay(pl,winfracy);
  if (pl->geomt == NULL){
    exit_error("MOD_GUI_SET_GRID_PARAMS_LAY","goemt is null");
  }
  gp->oglppix_x = mgs->cfw / (float)mod_gui_win2w;
  gp->oglppix_y = mgs->cfh / (float)mod_gui_win2h;
  size_f = 1.0;
  if (strcmp(pl->geomt,"irregular")==0){
    gp->geom_flag = 1;  
    gp->irr_x = pl->irr_x;
    gp->irr_y = pl->irr_y;
    gp->irr_id = pl->irr_id;
    gp->irr_dens = pl->irr_dens;  
    size_f = 1.0 * sqrt(1.0/(sqrt(3.0)/2.0*pl->irr_dens)) / mgs->sscale;
    gp->gdx = gdx;
    gp->gdy = gdy;
  }else{
    gp->geom_flag = 0;  
    gp->gdx = gdx;
    gp->gdy = gdy;
  }
  x0 = mgs->cfx0 + (1.0 - winfracx) * mgs->cfw/2.0; 
  y0 = mgs->cfy0 + (1.0 - winfracy) * mgs->cfh/2.0;
  gp->x0 = x0 + pl->x0 * gdx;  
  gp->y0 = y0 + pl->y0 * gdy;
  gp->bw = gdx * size_f - gp->oglppix_x;
  gp->bh = gdy * size_f - gp->oglppix_y;
  gp->dx = pl->xf * gdx;
  gp->dy = pl->yf * gdy;
  gp->oddxoff = pl->oddxoff * gdx;  
  if (pflag == 1) printf("  done:  MOD_GUI_SET_GRID_PARAMS\n");
  if (pflag == 1){
    printf("        gdx,gdy %f %f\n",gp->gdx,gp->gdy);
    printf("        x0,y0   %f %f\n",gp->x0,gp->y0);
    printf("        xn,yn   %d %d\n",gp->xn,gp->yn);
    printf("        gp  bw  %f\n",gp->bw);
    printf("        gp  bh  %f\n",gp->bh);
    printf("        gp  dx  %f\n",gp->dx);
    printf("        gp  dy  %f\n",gp->dy);
    printf("        gp odd  %f\n",gp->oddxoff);
  }
}
struct gui_gpar *mod_gui_get_grid_params_lay(pl,winfracx,winfracy)
     struct pop_layer *pl;
     float winfracx,winfracy;
{
  struct gui_gpar *gc;
  if (pflag == 1) printf("  MOD_GUI_SET_GRID_PARAMS_LAY\n");
  gc = (struct gui_gpar *)myalloc(sizeof(struct gui_gpar));
  mod_gui_set_grid_params(gc,pl,winfracx,winfracy);
  return gc;
}
void mod_gui_color_conn(r,g,b,xn,yn,x,y,n,r0,g0,b0)
     float **r,**g,**b;         
     int xn,yn;
     int *x,*y,n;               
     float r0,g0,b0;            
{
  int i,j,k;
  for(k=0;k<n;k++){
    i = x[k];
    j = (yn-1) - y[k];
    r[i][j] = r0;
    g[i][j] = g0;
    b[i][j] = b0;
  }
}
void mod_gui_write_ppm(pl,ci,cj,ck,cfx0,cfy0,cfw,cfh)
     struct pop_layer *pl;
     int ci,cj,ck;            
     float cfx0,cfy0,cfw,cfh; 
{
  int i,j;
  float **r,**g,**b;
  int xn,yn,space;
  struct pop_cell *c;
  struct pop_lgn_in *ln;
  printf("  MOD_GUI_WRITE_PPM\n");
  space = 1;
  c = &(pl->c[ci][cj][ck]);
  ln = pop_cell_get_lgn_input_by_lay(c,mgs->tl);
  if (ln == NULL)
    exit_error("MOD_GUI_WRITE_PPM","No LGN inputs from target layer.");
  xn = ln->lay->xn * space;
  yn = ln->lay->yn * space;
  r = get_zero_2d_farray(xn,yn);
  g = get_zero_2d_farray(xn,yn);
  b = get_zero_2d_farray(xn,yn);
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      r[i][j] = 0.0;
      g[i][j] = 0.0;
      b[i][j] = 0.0;
    }
  }
  mod_gui_color_conn(r,g,b,xn,yn,ln->cx1,ln->cy1,ln->cn1,1.0,0.0,0.0); 
  mod_gui_color_conn(r,g,b,xn,yn,ln->cx0,ln->cy0,ln->cn0,0.4,0.4,1.0); 
  write_ppm_6_rgb_data("zzz.conn.ppm",xn,yn,r,g,b);
  free_2d_farray(r,xn);
  free_2d_farray(g,xn);
  free_2d_farray(b,xn);
}
void mod_gui_get_grid_index_for_coord(mx,my,pixw,pixh,cx0,cy0,cw,ch,gc,ri,rj)
     int mx,my;      
     int pixw,pixh;  
     float cx0,cy0;  
     float cw,ch;    
     struct gui_gpar *gc; 
     int *ri,*rj;    
{
  int i,j;
  int n,imin;
  float x,y,bx,by;
  float *fx,*fy,dmin,d,si,sj;
  if (pflag == 1) printf("  MOD_GUI_GET_GRID_INDEX_FOR_COORD\n");
  x = cx0 + cw *        (float)mx/(float)pixw  - gc->x0;
  y = cy0 + ch * (1.0 - (float)my/(float)pixh) - gc->y0;
  if (pflag == 1) printf("    OpenGL units w.r.t. lower left  %f,%f\n",x,y);
  if (gc->geom_flag == 1){
    i = j = -1;
    x -= gc->bw / 2.0; 
    y -= gc->bh / 2.0; 
    if ((x < 0.0) || (y < 0.0)){
      si = sj = -1.0;
    }else{
      sj = y/gc->gdy;  
      si = x/gc->gdx;  
    }
    if ((si > (mgs->xn-1)) || (sj > (mgs->yn-1))){
      si = sj = -1.0;
    }
    if (si >= 0.0){
      n = gc->xn;
      fx = gc->irr_x;
      fy = gc->irr_y;
      imin = -1;      
      dmin = 99999.0;   
      for(i=0;i<n;i++){
	d = (si - fx[i]) * (si - fx[i]) + (sj - fy[i])*(sj - fy[i]);
	if (d < dmin){
	  imin = i;
	  dmin = d;
	}
      }
      if (imin != -1){
	i = imin;
	j = 0;
      }
    }
  }else{
    if (y < 0.0){
      i = j = -1;
    }else{
      j = (int)(y/gc->dy);  
      if (j%2 == 1)
	x -= gc->oddxoff;
      if (x < 0.0){
	i = j = -1;
      }else{
	i = (int)(x/gc->dx);  
	if ((i >= gc->xn) || (j >= gc->yn)){
	  i = j = -1;
	}else{  
	  bx = x - (float)i*gc->dx;  
	  by = y - (float)j*gc->dy;
	  if ((bx > gc->gdx) || (by > gc->gdy)){
	    i = j = -1;
	  }
	}
      }
    }
  }
  *ri = i; *rj = j;
}
void mod_gui_get_head_index_for_coord(mx,my,pixw,pixh,cx0,cy0,cw,ch,
				      gx0,gy0,gw,gh,gdx,gdy,ri,rj)
     int mx,my;      
     int pixw,pixh;  
     float cx0,cy0;  
     float cw,ch;    
     float gx0,gy0;  
     int gw,gh;      
     float gdx,gdy;  
     int *ri,*rj;    
{
  int i,j;
  float x,y;
  x = cx0 + cw * (float)mx/(float)pixw;
  y = cy0 + ch * (1.0 - (float)my/(float)pixh);
  if ((x < gx0) || (y < gy0)){
    i = j = -1;
  }else{
    i = (int)((x-gx0)/gdx);
    j = (int)((y-gy0)/gdy);
    if ((i >= gw) || (j >= gh)) 
      i = j = -1;
  }
  *ri = i; *rj = j;
}
void mod_gui_init_win(winw,winh,winz,plotname,w)
     int winw,winh;
     float winz;
     char plotname[];
     struct mgui_win_struct *w;
{
  glplot_init(winw,winh,winz,plotname,&(w->dpy),&(w->win),&(w->cx),
	      &(w->dbflag),0);
  w->initflag = 1;
  glplot_clear_double(w->dpy,w->win);
}
void mod_gui_init(plotname)
     char plotname[];
{
  glplot_init(mod_gui_winw,mod_gui_winh,mod_gui_zoom,plotname,&mod_gui_dpy,
	      &mod_gui_win,&mod_gui_cx,&mod_gui_dbflag,0);
  glplot_clear_double(mod_gui_dpy,mod_gui_win);
}
void mod_gui_get_index_for_coord(mx,my,pixw,pixh,cx0,cy0,cw,ch,
				 gx0,gy0,gw,gh,gdx,gdy,cx,cy,cn,sz,rk)
     int mx,my;      
     int pixw,pixh;  
     float cx0,cy0;  
     float cw,ch;    
     float gx0,gy0;  
     int gw,gh;      
     float gdx,gdy;  
     float *cx,*cy;  
     int cn;         
     float sz;       
     int *rk;        
{
  int i,k;
  float x,y,dx,dy,dist,min;
  x = cx0 + cw * (float)mx/(float)pixw;
  y = cy0 + ch * (1.0 - (float)my/(float)pixh);
  x = -0.5 + (x - gx0)/gdx; 
  y = -0.5 + (y - gy0)/gdy;
  k = -1;
  min = sz;
  for(i=0;i<cn;i++){
    dx = x - cx[i];
    dy = y - cy[i];
    dist = sqrt(dx*dx + dy*dy);
    if (dist < min){
      k = i;
      min = dist;
    }
  }
  *rk = k;
}
struct layer_label *mod_gui_get_init_laylab()
{
  struct layer_label *ll;
  ll = (struct layer_label *)myalloc(sizeof(struct layer_label));
  ll->coord = NULL;
  ll->layname = NULL;
  ll->message = NULL;
  ll->w2_coord = NULL;
  ll->w2_message = NULL;
  ll->w2_eye = NULL;
  ll->w2_layname = NULL;
  return ll;
}
void mod_gui_update_laylab(pstr,tstr)
     char **pstr;
     char *tstr;
{
  if (*pstr != NULL)
    myfree(*pstr);
  if (tstr != NULL)
    *pstr = strdup(tstr);
  else
    *pstr = NULL;
}
void mod_gui_set_targflag(pl,ocdom)
     struct pop_layer *pl;   
     int ocdom;
{
  if (pflag == 1) printf("  MOD_GUI_SET_TARGFLAG\n");
  if (pflag == 1) printf("      Layer %s\n",pl->name);
  if (pflag == 1) printf("      ocdom %d\n",ocdom);
  if (pop_util_lclass_is_lgn0(pl)){
    if (strcmp(pl->name,"retina0_gc0")==0){
      mgs->targflag_eye = 0;
      mgs->targflag_lgn = 0;
      mod_gui_update_laylab(&(mgs->laylab->w2_eye),NULL);
    }else{
      mgs->targflag_eye = ocdom;  
      mgs->targflag_lgn = 1;
      if (ocdom == -1)
	mod_gui_update_laylab(&(mgs->laylab->w2_eye),"LEFT");
      else
	mod_gui_update_laylab(&(mgs->laylab->w2_eye),"RIGHT");
    }
  }else if ((strcmp(pl->name,"lgn_on_r")==0)||
	    (strcmp(pl->name,"lgn_off_r")==0)){
    exit_error("MOD_GUI_SET_TARGFLAG","OLD lgn names");
  }else{
    mgs->targflag_eye = 0;  
    mgs->targflag_lgn = 0;
    mod_gui_update_laylab(&(mgs->laylab->w2_eye),NULL);
  }
  if (pflag == 1) printf("      targflag_lgn = %d\n",mgs->targflag_lgn);
  if (pflag == 1) printf("      targflag_eye = %d\n",mgs->targflag_eye);
  if (pflag == 1) printf("  done  MOD_GUI_SET_TARGFLAG\n");
}
void mod_gui_set_targ_layer_by_name(layname,ocdom)
     char *layname;
     int ocdom;
{
  int n;
  struct pop_layer *pl;
  pl = pop_util_get_layer_by_name(mgs->mpt,layname);
  if (pl != NULL){
    mgs->tl = pop_util_get_layer_by_name(mgs->mpt,layname);
    mgs->win2_zi = -1;
  }else{
    printf("  *** %s\n",layname);
    exit_error("MOD_GUI_SET_TARG_LAYER_BY_NAME","Cannot find layer by name");
  }
  mod_gui_set_targflag(mgs->tl,ocdom);
}
void mod_gui_draw_cones_on_grid(gw,gh,gx0,gy0,gdx,gdy,cx,cy,cid,cn,sz,pn)
     int gw,gh;
     float gx0,gy0,gdx,gdy;
     float *cx,*cy;
     int *cid,cn;
     float sz;      
     int pn;        
{
  int i;
  float x,y;
  for(i=0;i<cn;i++){
    x = cx[i] + 0.5; 
    y = cy[i] + 0.5; 
    if (cid[i] == 0)
      mod_gr_draw_poly(gw,gh,gx0,gy0,gdx,gdy,x,y,sz,pn,0.0,0.0,1.0);
    else if (cid[i] == 1)
      mod_gr_draw_poly(gw,gh,gx0,gy0,gdx,gdy,x,y,sz,pn,0.0,1.0,0.0);
    else
      mod_gr_draw_poly(gw,gh,gx0,gy0,gdx,gdy,x,y,sz,pn,1.0,0.0,0.0);
  }
}
void mod_gui_cone_replay(dpy,win,rpyd,rpytn,gw,gh,gx0,gy0,gdx,gdy,
			 cx,cy,cid,cn,sz,pn)
     Display *dpy;
     Window win;
     float **rpyd;   
     int gw,gh;
     float gx0,gy0,gdx,gdy;
     float *cx,*cy;
     int *cid,cn;
     float sz;      
     int pn;        
{
  int i,ti;
  float x,y,a,dmin,dmax;
  int tn;
  glDisable(GL_DEPTH_TEST);  
  get_min_max_2d_farray(rpyd,cn,rpytn,&dmin,&dmax);
  printf("min,max = %f %f\n",dmin,dmax);
  norm_01_2d_farray(rpyd,cn,rpytn,0);  
  for(ti=0;ti<rpytn;ti++){
    glClear(GL_COLOR_BUFFER_BIT);
    for(i=0;i<cn;i++){
      x = cx[i] + 0.5; 
      y = cy[i] + 0.5; 
      a = rpyd[i][ti]; 
      if (cid[i] == 0)
	mod_gr_draw_poly(gw,gh,gx0,gy0,gdx,gdy,x,y,sz,pn,0.0,0.0,a);
      else if (cid[i] == 1)
	mod_gr_draw_poly(gw,gh,gx0,gy0,gdx,gdy,x,y,sz,pn,0.0,a,0.0);
      else
	mod_gr_draw_poly(gw,gh,gx0,gy0,gdx,gdy,x,y,sz,pn,a,0.0,0.0);
    }
    glXSwapBuffers(dpy,win); 
  }
}
void mod_gui_draw_cones_on_grid_sumsd(gw,gh,gx0,gy0,gdx,gdy,cx,cy,cid,cn,sz,pn,
				      outid,sd,sdmin,gcs_code,gcs_distr)
     int gw,gh;
     float gx0,gy0,gdx,gdy;
     float *cx,*cy;
     int *cid,cn;
     float sz;       
     int pn;         
     int outid;      
     float sd;       
     float sdmin;    
     int gcs_code;   
     int gcs_distr;  
{
  int i;
  float x,y,w,tsz,tcx,tcy;
  tcx = cx[outid] + 0.5;  
  tcy = cy[outid] + 0.5;
  for(i=0;i<cn;i++){
    x = cx[i] + 0.5; 
    y = cy[i] + 0.5;
    w = mod_util_cone_weight(NULL,x,y,tcx,tcy,sd,cid[i],gcs_code,gcs_distr);
    if (w >= sdmin){
      tsz = sqrt(w) * sz;  
      if (cid[i] == 0)
	mod_gr_draw_poly(gw,gh,gx0,gy0,gdx,gdy,x,y,tsz,pn,0.0,0.0,1.0);
      else if (cid[i] == 1)
	mod_gr_draw_poly(gw,gh,gx0,gy0,gdx,gdy,x,y,tsz,pn,0.0,1.0,0.0);
      else
	mod_gr_draw_poly(gw,gh,gx0,gy0,gdx,gdy,x,y,tsz,pn,1.0,0.0,0.0);
    }
  }
}
void mod_gui_draw_grid_lines(gw,gh,gx0,gy0,gdx,gdy,r,g,b)
     int gw,gh;
     float gx0,gy0,gdx,gdy;
     float r,g,b;
{
  int i,j;
  float tx,ty;
  gx0 += gdx/2.0;  
  gy0 += gdy/2.0;
  glClear(GL_DEPTH_BUFFER_BIT);
  glColor3f(r,g,b);
  glBegin(GL_LINES);
  for(i=0;i<gw;i++){
    tx = gx0 + (float)i*gdx;
    glVertex2f(tx,gy0);
    glVertex2f(tx,gy0+(gh-1)*gdy);
  }
  for(j=0;j<gh;j++){
    ty = gy0 + (float)j*gdy;
    glVertex2f(gx0,ty);
    glVertex2f(gx0+(gw-1)*gdx,ty);
  }
  glEnd();
}
void mod_gui_draw_grid_full_color(gc,r,g,b)
     struct gui_gpar *gc;
     float **r,**g,**b;           
{
  int i,j;
  int seed,xn,yn;
  float x,y,x0,y0,dx,dy,bw,bh;
  if (pflag == 1) printf("  MOD_GUI_DRAW_GRID_FULL_COLOR\n");
  x0 = gc->x0;
  y0 = gc->y0;
  xn = gc->xn;
  yn = gc->yn;
  dx = gc->dx;
  dy = gc->dy;
  bw = gc->bw;
  bh = gc->bh;
  seed = -23985;
  glClear(GL_DEPTH_BUFFER_BIT);
  glBegin(GL_QUADS);
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      x = x0 + (float)i*dx;
      y = y0 + (float)j*dy;
      glColor3f(r[i][j],g[i][j],b[i][j]);
      if (mgs->wgrid_win == 1)
	mod_gui_wgrid_set_element(i,j,r[i][j],g[i][j],b[i][j],1.0);
      glVertex2f(x,y);
      glVertex2f(x+bw,y);
      glVertex2f(x+bw,y+bh);
      glVertex2f(x,y+bh);
    }
  }
  glEnd();
}
void mod_gui_color_grid_list(gc,r,g,b,cx,cy,cn,prob)
     struct gui_gpar *gc;
     float r,g,b;
     int *cx,*cy,cn;
     float prob;
{
  int i;
  int seed;
  float x,y,x0,y0,dx,dy,bw,bh;
  if (pflag == 1) printf("  MOD_GUI_COLOR_GRID_LIST\n");
  x0 = gc->x0;
  y0 = gc->y0;
  dx = gc->dx;
  dy = gc->dy;
  bw = gc->bw;
  bh = gc->bh;
  seed = -23985;
  glClear(GL_DEPTH_BUFFER_BIT);
  glBegin(GL_QUADS);
  for(i=0;i<cn;i++){
    if (myrand_util_ran2(&seed) <= prob){
      if (cx[i] >= 0){                      
	x = x0 + (float)(cx[i])*dx;
	y = y0 + (float)(cy[i])*dy;
	glColor3f(r,g,b);
	glVertex2f(x,y);
	glVertex2f(x+bw,y);
	glVertex2f(x+bw,y+bh);
	glVertex2f(x,y+bh);
	if (mgs->wgrid_win == 1){
	  if (r > 0.5){
	    mod_gui_wgrid_set_element(cx[i],cy[i],1.0,1.0,1.0,1.0);
	  }else{
	    mod_gui_wgrid_set_element(cx[i],cy[i],0.0,0.0,0.0,1.0);
	  }
	}
      }
    }
  }
  glEnd();
}
void mod_gui_color_grid_lgn_subclass(gc,pl,subclass,r,g,b)
     struct gui_gpar *gc;
     struct pop_layer *pl;   
     char *subclass;
     float r,g,b;
{
  int i,j;
  float x,y,xn,yn,x0,y0,dx,dy,bw,bh;
  char *tclass;
  if (pflag == 1) printf("  MOD_GUI_COLOR_GRID_LGN_SUBCLASS\n");
  x0 = gc->x0;
  y0 = gc->y0;
  dx = gc->dx;
  dy = gc->dy;
  bw = gc->bw;
  bh = gc->bh;
  xn = gc->xn;
  yn = gc->yn;
  glClear(GL_DEPTH_BUFFER_BIT);
  glBegin(GL_QUADS);
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
printf("  (%d,%d)\n",i,j);
      tclass = pl->c[i][j][0].subclass;
      if (strcmp(tclass,subclass)==0){
printf("  (%d,%d) is of type %s\n",i,j,tclass);
	x = x0 + (float)i*dx;
	y = y0 + (float)j*dy;
	glColor3f(r,g,b);
	glVertex2f(x,y);
	glVertex2f(x+bw,y);
	glVertex2f(x+bw,y+bh);
	glVertex2f(x,y+bh);
      }
    }
  }
  glEnd();
  if (pflag == 1) printf("  done  MOD_GUI_COLOR_GRID_LGN_SUBCLASS\n");
}
void mod_gui_draw_grid(gc,icon,colw,clearflag)
     struct gui_gpar *gc;
     struct pop_icon *icon;
     float colw;          
     int clearflag;
{
  int i,j;
  int xn,yn;
  float x,y,x0,y0,dx,dy,bw,bh,xoff;
  if (pflag == 1) printf("  MOD_GUI_DRAW_GRID\n");
  x0 = gc->x0;
  y0 = gc->y0;
  xn = gc->xn;
  yn = gc->yn;
  dx = gc->dx;
  dy = gc->dy;
  bw = gc->bw;
  bh = gc->bh;
  xoff = gc->oddxoff;
  if (clearflag){
    glClearColor(0.0,0.0,0.0,0.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  }else{
    glClear(GL_DEPTH_BUFFER_BIT);
  }
  if (gc->geom_flag == 0){        
    if (pflag == 1) printf("    Geometry is regular, xn,yn  %d,%d\n",xn,yn);
    for(i=0;i<xn;i++){
      for(j=0;j<yn;j++){
	x = x0 + (float)i*dx;
	if (j%2 != 0)
	  x += xoff;
	y = y0 + (float)j*dy;
	mod_gr_draw_unit_icon(x,y,bw,bh,icon,colw,0);
      }
    }
  }else if (gc->geom_flag == 1){  
    if (pflag == 1) printf("    Geometry is irregular, xn,yn  %d,%d\n",xn,yn);
    for(i=0;i<xn;i++){
      x = x0 + gc->irr_x[i]*dx;
      y = y0 + gc->irr_y[i]*dy;
      mod_gr_draw_unit_icon(x,y,bw,bh,icon,colw,0);
    }
  }
  if (pflag == 1) printf("  done:  MOD_GUI_DRAW_GRID\n");
}
void mod_gui_draw_grid_stim_frame(gc,s,k)
     struct gui_gpar *gc;
     float ***s; 
     int k;      
{
  int i,j;
  int xn,yn;
  float x,y,x0,y0,dx,dy,bw,bh,ori;
  struct pop_icon *icon;
  if (pflag == 1) printf("  MOD_GUI_DRAW_GRID_STIM_FRAME\n");
  if (s == NULL)
    return;
  x0 = gc->x0;
  y0 = gc->y0;
  xn = gc->xn;
  yn = gc->yn;
  dx = gc->dx;
  dy = gc->dy;
  bw = gc->bw;
  bh = gc->bh;
  icon = (struct pop_icon *)myalloc(sizeof(struct pop_icon));
  icon->shape = strdup("square");
  glClearColor(0.0,0.0,0.0,0.0);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      x = x0 + (float)i*dx;
      y = y0 + (float)j*dy;
      icon->r = icon->g = icon->b = s[i+1][j+1][k+1];
      mod_gr_draw_unit_icon(x,y,bw,bh,icon,1.0,0);
    }
  }
  myfree(icon->shape);
  myfree(icon);
}
void mod_gui_draw_grid_stim_frame_c3(gc,s,k)
     struct gui_gpar *gc;
     int ***s;   
     int k;      
{
  int i,j;
  int xn,yn;
  float x,y,x0,y0,dx,dy,bw,bh,ori;
  struct pop_icon *icon;
  if (pflag == 1) printf("  MOD_GUI_DRAW_GRID_STIM_FRAME_C3\n");
  if (s == NULL)
    return;
  x0 = gc->x0;
  y0 = gc->y0;
  xn = gc->xn;
  yn = gc->yn;
  dx = gc->dx;
  dy = gc->dy;
  bw = gc->bw;
  bh = gc->bh;
  icon = (struct pop_icon *)myalloc(sizeof(struct pop_icon));
  icon->shape = strdup("square");
  glClearColor(0.0,0.0,0.0,0.0);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      x = x0 + (float)i*dx;
      y = y0 + (float)j*dy;
      data_util_t11_get_rgb_01(s[i][j][k],&(icon->r),&(icon->g),&(icon->b));
      mod_gr_draw_unit_icon(x,y,bw,bh,icon,1.0,0);
    }
  }
  myfree(icon->shape);
  myfree(icon);
}
void mod_gui_draw_grid_ori_color(gc,pl,flag,csf,mapflag)
     struct gui_gpar *gc;
     struct pop_layer *pl;   
     int flag;
     float csf;    
     int mapflag;  
{
  int i,j;
  int xn,yn,ai_ori,ai_ocdom,ai_sf,cid;
  float x0,y0,dx,dy,bw,bh,tx,ty,xoff,ori,od,sf,r,g,b;
  char tstr[SLEN];
  struct pop_icon *icon;
  if (pflag == 1){
    printf("  MOD_GUI_DRAW_GRID_ORI_COLOR\n");
    printf("    map_flag = %d\n",mapflag);
  }
  ai_ori   = pop_cell_attrib_index_f(pl,"ori");    
  ai_ocdom = pop_cell_attrib_index_f(pl,"ocdom");  
  ai_sf    = pop_cell_attrib_index_f(pl,"sf");     
  x0 = gc->x0;
  y0 = gc->y0;
  xn = gc->xn;
  yn = gc->yn;
  dx = gc->dx;
  dy = gc->dy;
  bw = gc->bw;
  bh = gc->bh;
  xoff = gc->oddxoff;
  icon = (struct pop_icon *)myalloc(sizeof(struct pop_icon));
  icon->shape = pl->icon->shape; 
  icon->nside = pl->icon->nside;
  glClearColor(0.0,0.0,0.0,0.0);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      if (gc->geom_flag == 0){  
	tx = x0 + (float)i*dx;
	ty = y0 + (float)j*dy;
	if (j%2 != 0)
	  tx += xoff;
	if (mapflag == 0){
	  ori = pl->c[i][j][0].attrib_f[ai_ori];   
	  mod_conn_color_angle(ori*2.0,&r,&g,&b);
	}else if (mapflag == 1){
	  od = pl->c[i][j][0].attrib_f[ai_ocdom];  
	  r = g = b = 0.2;
	  if (od > 0.0)
	    g += od*0.8;
	  else if (od < 0.0)
	    r += -od*0.8;
	}else if (mapflag == 2){
	  sf = pl->c[i][j][0].attrib_f[ai_sf];  
	  mod_conn_color_sf(sf,&r,&g,&b);
	}
      }else if (gc->geom_flag == 1){  
	tx = x0 + gc->irr_x[i]*dx;
	ty = y0 + gc->irr_y[i]*dy;
	cid = gc->irr_id[i];
	if (cid == 0){
	  r = 0.2;
	  g = 0.2;
	  b = 1.0;
	}else if (cid == 1){
	  r = 0.0;
	  g = 1.0;
	  b = 0.0;
	}else if (cid == 2){
	  r = 1.0;
	  g = 0.0;
	  b = 0.0;
	}else{
	  r = g = b = 0.5;
	}
      }
      icon->r = r*csf;
      icon->g = g*csf;
      icon->b = b*csf;
      if (flag == 2){
	printf("%3d %3d %5.1f\n",i,j,ori);
	sprintf(tstr,"%d",my_rint(ori));
	if ((icon->r + 2*icon->g + icon->b) <= 2.0)
	  glplot_draw_txt(tstr,tx+bw*0.2,ty+bh*0.1,1.0,1.0,1.0);
	else
	  glplot_draw_txt(tstr,tx+bw*0.2,ty+bh*0.1,0.0,0.0,0.0);
      }
      mod_gr_draw_unit_icon(tx,ty,bw,bh,icon,1.0,0);
      if (mgs->wgrid_win == 0)
	mod_gui_wgrid_set_element(i,j,r,g,b,csf);
    }
  }
  myfree(icon);  
  if (pflag == 1) printf("  done:  MOD_GUI_DRAW_GRID_ORI_COLOR\n");
}
void mod_gui_draw_grid_replay(gc,pl,csf,colormapflag)
     struct gui_gpar *gc;
     struct pop_layer *pl;   
     float csf;              
     int colormapflag;
{
  int i,j;
  int xn,yn,ai_ori,ai_sf;
  float x0,y0,dx,dy,bw,bh,tx,ty,xoff,r,g,b,**d,ori,sf;
  struct pop_icon *icon;
  struct pop_cell *c;
  ai_ori  = pop_cell_attrib_index_f(pl,"ori");   
  ai_sf   = pop_cell_attrib_index_f(pl,"sf");   
  x0 = gc->x0;
  y0 = gc->y0;
  xn = gc->xn;
  yn = gc->yn;
  dx = gc->dx;
  dy = gc->dy;
  bw = gc->bw;
  bh = gc->bh;
  xoff = gc->oddxoff;
  bw *= 1.5;
  bh *= 1.5;
  icon = (struct pop_icon *)myalloc(sizeof(struct pop_icon));
  icon->shape = pl->icon->shape; 
  icon->nside = pl->icon->nside;
  d = mgs->replay_d[mgs->replay_ti]; 
  glClearColor(0.0,0.0,0.0,0.0);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      tx = x0 + (float)i*dx;
      ty = y0 + (float)j*dy;
      if (j%2 != 0)
	tx += xoff;
      if (1){
	c = &(pl->c[i][j][0]);
	if (colormapflag == 4){ 
	  sf = c->attrib_f[ai_sf];  
	  mod_conn_color_sf(sf,&r,&g,&b);
	}else{
	  ori = c->attrib_f[ai_ori];   
	  mod_conn_color_angle(ori*2.0,&r,&g,&b);
	}
	icon->r = 2.0 * r * d[i][j] + 0.1;  
	icon->g = 2.0 * g * d[i][j] + 0.1;
	icon->b = 2.0 * b * d[i][j] + 0.1;
	if (icon->r > 1.0){
	  icon->g /= icon->r;
	  icon->b /= icon->r;
	  icon->r = 1.0;
	}else if (icon->g > 1.0){
	  icon->r /= icon->g;
	  icon->b /= icon->g;
	  icon->g = 1.0;
	}else if (icon->b > 1.0){
	  icon->r /= icon->b;
	  icon->g /= icon->b;
	  icon->b = 1.0;
	}
      }else{
	r = g = b = d[i][j];
	if (r < 0.01)
	  r = g = b = 0.1;
	icon->r = r*csf;
	icon->g = g*csf;
	icon->b = b*csf;
      }
      mod_gr_draw_unit_icon(tx,ty,bw,bh,icon,1.0,0);
    }
  }
  myfree(icon);  
}
void mod_gui_draw_grid_mark_inputs(gc,pl,xi,yi,onflag,r,g,b,oriflag,lgn_eye)
     struct gui_gpar *gc;
     struct pop_layer *pl;
     int xi,yi;             
     int onflag;
     float r,g,b;
     int oriflag;           
     int lgn_eye;           
{
  int i,j,k,l;
  int cn,*cx,*cy,ai_ocdom,ai_ori;
  float ori,feye;
  struct pop_cell *c;
  struct pop_icon *ticon;
  struct pop_lgn_in *ln;
  if (pflag == 1) printf("  MOD_GUI_DRAW_GRID_MARK_INPUTS\n");
  feye = (float)lgn_eye;
  ai_ocdom = pop_cell_attrib_index_f(pl,"ocdom"); 
  ai_ori   = pop_cell_attrib_index_f(pl,"ori");   
  ticon = (struct pop_icon *)myalloc(sizeof(struct pop_icon));
  ticon->shape = pl->icon->shape; 
  ticon->nside = pl->icon->nside;
  ticon->r = r;
  ticon->g = g;
  ticon->b = b;
  for(i=0;i<pl->xn;i++)
    for(j=0;j<pl->yn;j++)
      for(k=0;k<pl->zn;k++){
	c = &(pl->c[i][j][k]);
	if (c->attrib_f[ai_ocdom] == feye){ 
	  ln = pop_cell_get_lgn_input_by_lay(c,mgs->tl);
	  if (ln != NULL){
	    if (oriflag > 0){
	      ori = c->attrib_f[ai_ori];   
	      mod_conn_color_angle(ori*2.0,&(ticon->r),&(ticon->g),
				   &(ticon->b));
	    }
	    if (onflag){
	      cn = ln->cn1;
	      cx = ln->cx1;
	      cy = ln->cy1;
	    }else{
	      cn = ln->cn0;
	      cx = ln->cx0;
	      cy = ln->cy0;
	    }
	    for(l=0;l<cn;l++){
	      if ((cx[l]==xi)&&(cy[l]==yi)){
		mod_gr_draw_grid_single(i,j,gc,ticon,1.0,1.0,0);
	      }
	    }
	  }
	}
      }
  myfree(ticon);
}
void mod_gui_draw_grid_mark_in(gc,pl,cpre,r,g,b,oriflag)
     struct gui_gpar *gc;
     struct pop_layer *pl;    
     struct pop_cell *cpre;   
     float r,g,b;
     int oriflag;             
{
  int i,j,k,l;
  int cn,*cx,*cy,nsyn;
  float ori,wmax,wtot,w;
  struct pop_cell *c;
  struct pop_icon *ticon;
  struct pop_syn *tsyn;
  if (pflag == 1) printf("  MOD_GUI_DRAW_GRID_MARK_IN\n");
  ticon = (struct pop_icon *)myalloc(sizeof(struct pop_icon));
  ticon->shape = pl->icon->shape; 
  ticon->nside = pl->icon->nside;
  ticon->r = r;
  ticon->g = g;
  ticon->b = b;
  printf("WYETH HERE -----------------------00 1\n");
  printf("tsynNULLLLLLLL    lay: %s   cpre: %s\n",pl->name,cpre->name);
  tsyn = pop_cell_get_next_syn_layer_name(cpre->out,0,pl->name); 
  wmax = pop_cell_max_weight_from_cell_to_layer(pl->name,cpre);
  if (tsyn == NULL){
    printf("tsynNULLLLLLLL    lay: %s   cpre: %s\n",pl->name,cpre->name);
    ;
  }else{
printf("HERE 003\n");
    wtot = 0.0;
    nsyn = 0;
    while (tsyn != NULL){
      i = tsyn->post->layx;
      j = tsyn->post->layy; 
      w = tsyn->w;
      wtot += w;
      nsyn += 1;
      w = 1.0;
      mod_gr_draw_grid_single(i,j,gc,pl->icon,w,1.0,0);
      tsyn = tsyn->pre_next;
      tsyn = pop_cell_get_next_syn_layer_name(tsyn,0,pl->name); 
    }
    printf("    %d synapses, total weight %.4f, max weight %.4f\n",nsyn,wtot,
	   wmax);
  }
  myfree(ticon);
}
void mod_gui_draw_grid_header(pllist,npl,x,y,dx,dy)
     struct pop_layer **pllist;   
     int npl;                     
     float x,y,dx,dy;
{
  int i;
  float xcurr;
  struct mgui_struct *mg;
  struct pop_layer *pl;   
  if (pflag == 1) printf("  MOD_GUI_DRAW_GRID_HEADER\n");
  xcurr = x;
  for(i=0;i<npl;i++){
    pl = pllist[i];
    mod_gr_draw_unit_icon(xcurr,y,dx,dy,pl->icon,1.0,0);
    xcurr += dx;
  }
  xcurr = 0.5;
  y = 0.85;
  mg = mgs;
  glplot_set_xfont_generic(mg->win1->dpy,mg->win1->win,mg->win1->cx,"large");
  glplot_draw_txt(mg->pl->name,xcurr,y,1.0,1.0,1.0);
  glplot_set_xfont_generic(mg->win1->dpy,mg->win1->win,mg->win1->cx,"medium");
}
void mod_gui_draw_grid_scale_lgn_deg()
{
  int i;
  float r,g,b,x,y,w,h,y0,y1,cfx,cfy,degx,dx1deg,dhalf,sblen;
  char sbstr[SLEN];
  if (pflag == 1) printf("  MOD_GUI_DRAW_GRID_SCALE_LGN_DEG\n");
  cfy = 2.0 / (float)mod_gui_win2h;  
  cfx = 2.0 / (float)mod_gui_win2w;  
  r = 0.4;
  g = 0.8;
  b = 0.2;
  degx = (float)mgs->xn * mgs->sscale;  
  dx1deg = 2.0*winfrac2 / degx;  
  dhalf = degx / 2.0;  
  if (5.0 <= dhalf){
    sblen = 5.0;
    sprintf(sbstr,"5 deg");
  }else if (2.0 <= dhalf){
    sblen = 2.0;
    sprintf(sbstr,"2 deg");
  }else if (1.0 <= dhalf){
    sblen = 1.0;
    sprintf(sbstr,"1 deg");
  }else if (0.5 <= dhalf){
    sblen = 0.5;
    sprintf(sbstr,"0.5 deg");
  }else if (0.25 <= dhalf){
    sblen = 0.25;
    sprintf(sbstr,"0.25 deg");
  }else if (0.2 <= dhalf){
    sblen = 0.2;
    sprintf(sbstr,"0.2 deg");
  }else if (0.1 <= dhalf){
    sblen = 0.1;
    sprintf(sbstr,"0.1 deg");
  }else if (0.05 <= dhalf){
    sblen = 0.05;
    sprintf(sbstr,"0.05 deg");
  }else
    sblen = 0.0;  
  x = -0.8;
  y = winfrac2 + cfy * 6.0; 
  w = sblen * dx1deg;
  h = 6.0 * cfy;  
  glplot_draw_box(r,g,b,x,y,w,h);
  x += w + 8.0 *cfx;  
  glplot_draw_txt(sbstr,x,y,r,g,b);
}
void mod_gui_draw_grid_scale_bars(pllist,npl,cli)
     struct pop_layer **pllist;   
     int npl;                     
     int cli;                     
{
  int i;
  int xn;
  float r,g,b,x,y,w,h,blen,um,cfx,cfy,degr,gdx;
  struct pop_layer *pl;   
  char tstr[SLEN];
  if (pflag == 1) printf("  MOD_GUI_DRAW_GRID_SCALE_BARS\n");
  pl = pllist[cli];
  gdx = mod_gui_get_dx_lay(pl,mgs->winfrac_x);
  xn = pl->xn;
  if (pl->geomt != NULL){
    if (strcmp(pl->geomt,"irregular")==0){
      xn = pl->area->xn;
    }
  }
  blen = (float)xn * pl->xf / 8.0; 
  if (pflag == 1) printf("    Bar length  %f grid units (xn %d)\n",
			 blen,pl->xn);
  cfy = 2.0 / (float)mod_gui_winh;  
  cfx = 2.0 / (float)mod_gui_winw;  
  r = 0.7;
  g = 0.7;
  b = 0.7;
  x = 0.0;
  y = -1.0 + cfy * 30.0; 
  w = blen * gdx; 
  h = 6.0 * cfy;  
  um = pl->area->umx;  
  degr = mgs->sscale;  
  sprintf(tstr,"%d um / %.2f deg = %.2f mm/deg",my_rint(um*blen),degr*blen,
	  um/degr/1000.0);	  
  glplot_draw_txt(tstr,x,y-14.0*cfy,r,g,b);
  glplot_draw_box(r,g,b,x,y,w,h);
}
void mod_gui_draw_grid_laylist(pllist,npl,li,ci,cj,colormapflag,ll)
     struct pop_layer **pllist;   
     int npl;                     
     int li;  
     int ci;  
     int cj;  
     int colormapflag;
     struct layer_label *ll;
{
  int i;
  int gxi,gyi,onflag,offlag;
  float rm,gm,bm,csf;
  struct pop_layer *pl;   
  struct pop_cell *c,*cpre;
  if (pflag == 1) printf("  MOD_GUI_DRAW_GRID_LAYLIST\n");
  pl = pllist[li]; 
  if (mgs->wgrid_win == 0){
    mod_gui_wgrid_init(pl->xn,pl->yn,0.0);  
  }
  csf = 1.0; 
  if (glob_flag_rev_map == 1){  
    if (pflag == 1) printf("    .... inside ....\n");
    gxi = glob_win2_ci;  
    gyi = glob_win2_cj;  
    if (pop_util_lclass_is_lgn0(mgs->tl) == 1){ 
      c = &(pl->c[glob_win1_ci][glob_win1_cj][glob_win1_ck]);
      onflag = mod_conn_is_lgn_connected((char *)NULL,c,gxi,gyi,1);
      offlag = mod_conn_is_lgn_connected((char *)NULL,c,gxi,gyi,0);
      if ((onflag == 0) && (offlag == 0))
	glob_flag_rev_map = 0;
      else{
	rm = pl->icon->r; gm = pl->icon->g; bm = pl->icon->b;
	csf = 0.4;
      }
    }
  }
  if (((colormapflag == 1) || (colormapflag == 2)) &&
      (strcmp(pl->icon->shape,"cs")!=0)){
    mod_gui_draw_grid_ori_color(mgs->gcurr,pl,colormapflag,csf,0);
  }else if ((colormapflag == 3) && (strcmp(pl->icon->shape,"cs")!=0)){
    mod_gui_draw_grid_ori_color(mgs->gcurr,pl,colormapflag,csf,1);
  }else if ((colormapflag == 4) && (strcmp(pl->icon->shape,"cs")!=0)){
    mod_gui_draw_grid_ori_color(mgs->gcurr,pl,colormapflag,csf,2);
  }else{
    mod_gui_draw_grid(mgs->gcurr,pl->icon,csf,1);
  }
  if (glob_flag_rev_map == 1){  
    if (pop_util_lclass_is_lgn0(mgs->tl) == 1){ 
      mod_gui_draw_grid_mark_inputs(mgs->gcurr,pl,gxi,gyi,onflag,rm,gm,bm,
				    colormapflag,mgs->targflag_eye);
    }else{  
      ;
    }
    glob_flag_rev_map = 0;
  }
  if ((ci != -1) && (cj != -1)){
    mod_gr_draw_grid_single(ci,cj,mgs->gcurr,pl->icon,-1.0,1.0,0);
  }
  if (mgs->mon_state >= 0){
    struct wyp_struct *wyp;
    struct wyp_plot_struct *p;
    wyp = mod_mon_get_wyp_pointer();
    if (wyp == NULL)
      exit_error("MOD_GUI_DRAW_GRID_LAYLIST","wyp is null");
    p = wyp->p;
    while(p != NULL){
      if (p->nc == 1){  
	if (p->c == NULL){
	  if (p->syn == NULL){
	    printf(" *** Plot name:  %s\n",p->name);
	    printf(" ***   cell pointer is null for this plot\n");
	    exit_error("MOD_GUI_DRAW_GRID_LAYLIST",
		       "Neither cell nor syn pointer for this plot\n");
	  }
	}
	if (p->c != NULL)
	  if (p->c->pl == pl){  
	    mod_gr_draw_grid_single(p->c->layx,p->c->layy,mgs->gcurr,pl->icon,
				    -1.0,0.6,0);
	  }
      }else if (p->nc > 1){  
	if (p->c->pl == pl){  
	  mod_gr_draw_grid_single(p->c->layx,p->c->layy,mgs->gcurr,pl->icon,
				  -1.0,0.6,0);
	}
      }
      p = p->next;
    }
  }
  headdx = headdy * (float)mod_gui_winh / (float)mod_gui_winw;
  mod_gui_draw_grid_header(pllist,npl,headx,heady,headdx,headdy);
  if (strcmp(pl->icon->shape,"cs")!=0)
    mod_gui_draw_grid_scale_bars(pllist,npl,li);
  if (ll->coord != NULL)
    glplot_draw_txt(ll->coord,-0.95,-0.95,1.0,1.0,1.0);
  if (ll->message != NULL){
    glplot_draw_txt(ll->message,-0.50,-0.95,0.4,1.0,0.4);
    mod_gui_update_laylab(&(ll->message),NULL);
  }
  if (pflag == 1) printf("  done:  MOD_GUI_DRAW_GRID_LAYLIST\n");
}
void mod_gui_lgn_region_update()
{
  if (pflag == 1) printf("  MOD_GUI_LGN_REGION_UPDATE\n");
  if ((mgs->conn_reg_xi1 >= 0) && (mgs->conn_reg_xi2 >= 0)){
    if (mgs->conn_reg_xi1 <= mgs->conn_reg_xi2){
      mgs->conn_reg_llx = mgs->conn_reg_xi1;
      mgs->conn_reg_urx = mgs->conn_reg_xi2;
    }else{
      mgs->conn_reg_llx = mgs->conn_reg_xi2;
      mgs->conn_reg_urx = mgs->conn_reg_xi1;
    }
    if (mgs->conn_reg_yi1 <= mgs->conn_reg_yi2){
      mgs->conn_reg_lly = mgs->conn_reg_yi1;
      mgs->conn_reg_ury = mgs->conn_reg_yi2;
    }else{
      mgs->conn_reg_lly = mgs->conn_reg_yi2;
      mgs->conn_reg_ury = mgs->conn_reg_yi1;
    }
  }
}
void mod_gui_draw_grid_gray(tl)
     struct pop_layer *tl;    
{
  struct gui_gpar *gc;
  if (pflag == 1) printf("  MOD_GUI_DRAW_GRID_GRAY\n");
  gc = mod_gui_get_grid_params_lay(tl,winfrac2,winfrac2);
  mod_gui_draw_grid(gc,mgs->gicon,1.0,1); 
  mod_gui_draw_grid_scale_lgn_deg();      
  if (mgs->conn_reg_llx >= 0){
    gc->xn = mgs->conn_reg_urx - mgs->conn_reg_llx + 1;
    gc->yn = mgs->conn_reg_ury - mgs->conn_reg_lly + 1;
    gc->x0 += (float)(mgs->conn_reg_llx) * gc->dx;
    gc->y0 += (float)(mgs->conn_reg_lly) * gc->dy;
    mod_gui_draw_grid(gc,mgs->gicon,1.2,0); 
  }
  if (tl->c[0][0] != NULL){
    if (pflag == 1) printf("-------------WYETH HERE in ...subclass\n");
  }
  myfree(gc);
}
void mod_gui_draw_grid_conn(pl,ll,ci,cj,ck,tl,prob,cpflag)
     struct pop_layer *pl;    
     struct layer_label *ll;
     int ci,cj,ck;            
     struct pop_layer *tl;    
     float prob;              
     int cpflag;              
{
  int cflag,iocdom;
  float dens;
  struct pop_cell *c;
  struct gui_gpar *gc;
  struct pop_lgn_in *ln;
  if (pflag == 1) printf("  MOD_GUI_DRAW_GRID_CONN\n");
  if (mgs->wgrid_win == 1)
    mod_gui_wgrid_init(tl->xn,tl->yn,0.5);  
  cflag = 0; 
  if ((ci >= 0)&&(cj >= 0)&&(ck >= 0) &&
      (pop_util_lclass_is_lgn0(pl) != 1)){ 
    c = &(pl->c[ci][cj][ck]);
    iocdom = my_rint(pop_cell_attrib_get_f(c,"ocdom"));
    if (iocdom != mgs->targflag_eye){
      mod_gui_set_targ_layer_by_name(mgs->tlgn->name,iocdom);
    }
    cflag = 1;
  }
  if (cflag){
    ln = pop_cell_get_lgn_input_by_lay(c,tl);
    if (ln == NULL){
      ln = pop_cell_get_lgn_input_pair_by_lay(c,tl);
      if (ln != NULL)
	mod_gui_update_laylab(&(ll->w2_message),"Paired inputs.");
    }
    if (ln != NULL){
      gc = mod_gui_get_grid_params_lay(tl,winfrac2,winfrac2);
      mod_gui_color_grid_list(gc,1.0,1.0,1.0,ln->cx1,ln->cy1,ln->cn1,prob);
      mod_gui_color_grid_list(gc,0.0,0.0,0.0,ln->cx0,ln->cy0,ln->cn0,prob);
      dens = (float)(ln->cn1 + ln->cn0) / (float) ln->nposs;
      if (cpflag){
	printf("    (%d %d %d) has %d ON, %d OFF, %d/%d = %.4f\n",
	       ci,cj,ck,ln->cn1,ln->cn0,ln->cn0+ln->cn1,ln->nposs,dens);
	printf("        rfx,y  (%.2f,%.2f)\n",c->rfx,c->rfy);
	pop_cell_attrib_print_f(c);
      }
      myfree(gc);
    }else{
      printf("NO LGN INPUTS FROM THIS LGN POP\n");
    }
  }
  if (pflag == 1) printf("  done  MOD_GUI_DRAW_GRID_CONN\n");
}
void mod_gui_draw_aggregate_grid(pl,ci,cj,ck,layname,ll,odflag)
     struct pop_layer *pl;    
     int ci,cj,ck;            
     char *layname;           
     struct layer_label *ll;
     int odflag;              
{
  int i;
  int cflag,ti,tj,xn,yn,iocdom;
  float dens,**agg,w,agmin,agmax;
  struct pop_cell *c,*cpre;
  struct pop_syn *tsyn;
  struct pop_lgn_in *ln;
  if (pflag == 1) printf("  MOD_GUI_DRAW_AGGREGATE_GRID\n");
  if (mgs->wgrid_win == 1)
    mod_gui_wgrid_init(mgs->tl->xn,mgs->tl->yn,0.0);  
  xn = mgs->xn;
  yn = mgs->yn;
  cflag = 0; 
  if ((ci >= 0)&&(cj >= 0)&&(ck >= 0) &&
      (pop_util_lclass_is_lgn0(pl) != 1)){ 
    c = &(pl->c[ci][cj][ck]);
    cflag = 1;
  }
  mod_gui_stim_grid_update(mgs->gstim,winfrac2); 
  mod_gui_draw_grid(mgs->gstim,mgs->gicon,1.0,1);
  mod_gui_draw_grid_scale_lgn_deg();      
  if (cflag){
    agg = get_zero_2d_farray(xn,yn); 
    tsyn = pop_cell_get_next_syn_layer_name(c->in,1,layname); 
    if (tsyn == NULL){
      mod_gui_update_laylab(&(ll->w2_message),"No connections.");
    }else{
      while (tsyn != NULL){
	w = tsyn->w;       
	cpre = tsyn->pre;  
	iocdom = (int)pop_cell_attrib_get_f(cpre,"ocdom");
	if ((odflag == 0) || (odflag == iocdom)){
	  ln = pop_cell_get_lgn_input_by_lay(cpre,mgs->tl);
	  if (ln != NULL){
	    for(i=0;i<ln->cn0;i++){ 
	      ti = ln->cx0[i];
	      tj = ln->cy0[i];
	      agg[ti][tj] -= w;
	    }
	    for(i=0;i<ln->cn1;i++){  
	      ti = ln->cx1[i];
	      tj = ln->cy1[i];
	      agg[ti][tj] += w;
	    }
	  }
	}
	tsyn = tsyn->post_next;
	tsyn = pop_cell_get_next_syn_layer_name(tsyn,1,layname); 
      }
    }
    get_min_max_2d_farray(agg,xn,yn,&agmin,&agmax);
    if ((agmax == 0.0) && (agmin == 0.0))
      ; 
    else if (agmax > -agmin)
      multiply_2d_farray(agg,xn,yn,0.5/agmax);
    else
      multiply_2d_farray(agg,xn,yn,-0.5/agmin);
    add_const_2d_farray(agg,0,xn,0,yn,0.5);
    mod_gui_draw_grid_full_color(mgs->gstim,agg,agg,agg);
    free_2d_farray(agg,xn);
  }
}
float **mod_gui_get_lgn_rf(pl,ll,ci,cj,ck,llay)
     struct pop_layer *pl;     
     struct layer_label *ll;   
     int ci,cj,ck;             
     struct pop_layer *llay;   
{
  int i;
  int xn,yn;
  float tsig,**dc,**ds,amp,**smap,**dog,dmin,dmax;
  struct pop_cell *c;
  struct pop_lgn_in *ln;
  if (pflag == 1) printf("  MOD_GUI_GET_LGN_RF\n");
  if (pflag == 1) printf("    LGN layer name:  %s\n",llay->name);
  if ((ci < 0)||(cj < 0)||(ck < 0))
    return NULL;
  c = &(pl->c[ci][cj][ck]);
  if (pop_util_lclass_is_lgn0(llay) == 0)  
    return NULL;
  ln = pop_cell_get_lgn_input_by_lay(c,llay);
  if (ln == NULL){
    ln = pop_cell_get_lgn_input_pair_by_lay(c,llay);
    if (ln == NULL)
      return NULL;  
    mod_gui_update_laylab(&(ll->w2_message),"Paired inputs.");
  }
  xn = mgs->xn;
  yn = mgs->yn;
  smap = get_zero_2d_farray(xn,yn); 
  for(i=0;i<ln->cn1;i++){
    smap[ln->cx1[i]][ln->cy1[i]] = 1.0;
  }
  for(i=0;i<ln->cn0;i++){
    smap[ln->cx0[i]][ln->cy0[i]] = -1.0;
  }
  tsig = mgs->lgn_sig1/mgs->sscale; 
  dc = smooth_2d_with_gaussian(smap,xn,yn,tsig,0.01);
  amp = mgs->lgn_amp1 * 2.0*M_PI*tsig*tsig; 
  multiply_2d_farray(dc,xn,yn,amp);
  tsig = mgs->lgn_sig2/mgs->sscale; 
  ds = smooth_2d_with_gaussian(smap,xn,yn,tsig,0.01);
  amp = mgs->lgn_amp2 * 2.0*M_PI*tsig*tsig; 
  multiply_2d_farray(ds,xn,yn,amp);
  dog = subtract_2d_farrays(dc,ds,xn,yn);  
  free_2d_farray(dc,xn);
  free_2d_farray(ds,xn);
  free_2d_farray(smap,xn);
  get_min_max_2d_farray(dog,xn,yn,&dmin,&dmax);
  if ((dmax == 0.0) && (dmin == 0.0))
    ; 
  else if (dmax > -dmin)
    multiply_2d_farray(dog,xn,yn,0.5/dmax);
  else
    multiply_2d_farray(dog,xn,yn,-0.5/dmin);
  add_const_2d_farray(dog,0,xn,0,yn,0.5);  
  if (pflag == 1) printf("  done  MOD_GUI_GET_LGN_RF\n");
  return dog;
}
float **mod_gui_get_lgn_rf_region(pl,ll,ci,cj,ck,rnx,rny)
     struct pop_layer *pl;    
     struct layer_label *ll;  
     int ci,cj,ck;            
     int *rnx,*rny;           
{
  int i,j;
  int nx,ny,x0,y0;
  float **d,**dr;
  if (pflag == 1) printf("  MOD_GUI_GET_LGN_RF_REGION\n");
  d = mod_gui_get_lgn_rf(pl,ll,ci,cj,ck,mgs->tl);
  if (d != NULL){
    if (mgs->conn_reg_urx != -1){
      nx = 1 + mgs->conn_reg_urx - mgs->conn_reg_llx;
      ny = 1 + mgs->conn_reg_ury - mgs->conn_reg_lly;
      x0 = mgs->conn_reg_llx;
      y0 = mgs->conn_reg_lly;
      dr = get_2d_farray(nx,ny);
      for(i=0;i<nx;i++){
	for(j=0;j<ny;j++){
	  dr[i][j] = d[x0+i][y0+j];
	}
      }
      free_2d_farray(d,mgs->xn);
    }else{
      dr = d;
      nx = mgs->xn;
      ny = mgs->yn;
    }
  }else{
    dr = NULL;
    nx = ny = 0;
  }
  *rnx = nx;
  *rny = ny;
  return dr;
}
void mod_gui_draw_rf_grid(pl,ll,ci,cj,ck)
     struct pop_layer *pl;    
     struct layer_label *ll;
     int ci,cj,ck;            
{
  int i;
  int xn,yn;
  float **d;
  struct pop_cell *c;
  if (pflag == 1) printf("  MOD_GUI_DRAW_RF_GRID\n");
  if (mgs->wgrid_win == 1)
    mod_gui_wgrid_init(mgs->tl->xn,mgs->tl->yn,0.0);  
  if ((ci >= 0)&&(cj >= 0)&&(ck >= 0)){ 
    xn = mgs->xn;
    yn = mgs->yn;
    mod_gui_stim_grid_update(mgs->gstim,winfrac2); 
    mod_gui_draw_grid(mgs->gstim,mgs->gicon,1.0,1);
    mod_gui_draw_grid_scale_lgn_deg();      
    d = mod_gui_get_lgn_rf(pl,ll,ci,cj,ck,mgs->tl);  
    if (d != NULL){
      mod_gui_draw_grid_full_color(mgs->gstim,d,d,d); 
      free_2d_farray(d,xn);
    }
  }
  if (pflag == 1) printf("  done  MOD_GUI_DRAW_RF_GRID\n");
}
void mod_gui_draw_grid_stim()
{ 
  float ***s;             
  int k;                  
  k = mgs->sdn;
  mod_gui_stim_grid_update(mgs->gstim,winfrac2); 
  if (strcmp(mgs->stimform,"3c")==0){
    mod_gui_draw_grid_stim_frame_c3(mgs->gstim,mgs->c3data,k);
  }else{
    if (mgs->stimflag == 1)
      s = mgs->sdata;
    else if (mgs->stimflag == 2)
      s = mgs->sdata_r;
    mod_gui_draw_grid_stim_frame(mgs->gstim,s,k);
  }
  mod_gui_draw_grid_scale_lgn_deg();
}
void mod_gui_draw_labels_w2(ll)
     struct layer_label *ll;
{
  char tstr[SLEN];
  if (pflag == 1) printf("  MOD_GUI_DRAW_LABELS_W2\n");
  if (ll->w2_message != NULL){
    glplot_draw_txt(ll->w2_message,-0.20,-0.95,0.4,1.0,0.4);
    mod_gui_update_laylab(&(ll->w2_message),NULL);
  }
  if (ll->w2_layname != NULL){
    glplot_draw_txt(ll->w2_layname,0.40,0.92,0.9,0.9,0.0);
    mod_gui_update_laylab(&(ll->w2_message),NULL);
  }
  if (ll->w2_coord != NULL){
    glplot_draw_txt(ll->w2_coord,-0.95,-0.96,1.0,1.0,1.0);
  }else{
    sprintf(tstr,"zi %d\n",mgs->win2_zi);
    glplot_draw_txt(tstr,-0.95,-0.96,1.0,1.0,1.0);
  }
  if (ll->w2_eye != NULL){
    if (strcmp(ll->w2_eye,"LEFT")==0)
      glplot_draw_txt(ll->w2_eye,0.6,-0.96,1.0,0.0,0.0);
    else if (strcmp(ll->w2_eye,"RIGHT")==0)
      glplot_draw_txt(ll->w2_eye,0.6,-0.96,0.0,1.0,0.0);
    else
      glplot_draw_txt(ll->w2_eye,0.6,-0.96,1.0,1.0,1.0);
  }
}
void mod_gui_draw_syn_conn(pl,ci,cj,ck,tl,preflag,normflag,ll,colormapflag)
     struct pop_layer *pl;    
     int ci,cj,ck;            
     struct pop_layer *tl;    
     int preflag;             
     int normflag;            
     struct layer_label *ll;
     int colormapflag;
{
  int i,j,k,l;
  int xn,yn,cn,*cx,*cy,nsyn,cid,openflag;
  float w,wmax,wtot,ori;
  struct pop_cell *c;
  struct pop_syn *tsyn;
  struct gui_gpar *gc;
  struct pop_lgn_in *ln;
  struct pop_icon *ticon;
  if (pflag == 1) printf("  MOD_GUI_DRAW_SYN_CONN\n");
  if (mgs->wgrid_win == 1)
    mod_gui_wgrid_init(tl->xn,tl->yn,0.0);  
  gc = mod_gui_get_grid_params_lay(tl,winfrac2,winfrac2);
  openflag = 0;  
  mod_gui_draw_grid(gc,tl->icon,0.3,1); 
  xn = tl->xn;
  yn = tl->yn;
  if ((ci == -1)||(cj == -1)||(ck == -1))
    return;
  if (pop_util_lclass_is_lgn0(pl)){  
    if (preflag == 0){
      for(i=0;i<tl->xn;i++)
	for(j=0;j<tl->yn;j++)
	  for(k=0;k<tl->zn;k++){
	    c = &(tl->c[i][j][k]);
	    ln = pop_cell_get_lgn_input_by_lay(c,pl);
	    if (ln != NULL){  
	      if (ck == 1){  
		cn = ln->cn1;
		cx = ln->cx1;
		cy = ln->cy1;
	      }else{
		cn = ln->cn0;
		cx = ln->cx0;
		cy = ln->cy0;
	      }
	      for(l=0;l<cn;l++){
		if ((cx[l]==ci)&&(cy[l]==cj)){
		  mod_gr_draw_grid_single(i,j,gc,tl->icon,1.0,1.0,0);
		}
	      }
	    }
	  }
    }
    return;
  }
  c = &(pl->c[ci][cj][ck]);
  if (preflag == 0){
    tsyn = pop_cell_get_next_syn_layer_name(c->out,0,tl->name); 
    wmax = pop_cell_max_weight_from_cell_to_layer(tl->name,c);
  }else{
    tsyn = pop_cell_get_next_syn_layer_name(c->in,1,tl->name); 
    wmax = pop_cell_max_weight_from_layer_to_cell(tl->name,c);
  }
  if (tsyn == NULL){
    mod_gui_update_laylab(&(ll->w2_message),"No connections.");
  }else{
    if (mgs->syn_dump_flag == 1){
      if (preflag)
	pop_cell_print_pre_synaptic_list(c);
      else
	pop_cell_print_post_synaptic_list(c);
    }
    ticon = (struct pop_icon *)myalloc(sizeof(struct pop_icon));
    ticon->shape = tl->icon->shape; 
    ticon->nside = tl->icon->nside;
    wtot = 0.0;
    nsyn = 0;
    while (tsyn != NULL){
      if (preflag == 0){
	i = tsyn->post->layx;
	j = tsyn->post->layy;
	k = tsyn->post->layz;
	ori = pop_cell_attrib_get_f(tsyn->post,"ori");
      }else{
	i = tsyn->pre->layx;
	j = tsyn->pre->layy;
	k = tsyn->pre->layz;
	ori = pop_cell_attrib_get_f(tsyn->pre,"ori");
      }
      if ((mgs->win2_zi == -1) || (mgs->win2_zi == k)){  
	w = tsyn->w;
	wtot += w;
	nsyn += 1;
	if (normflag == 1) 
	  w /= wmax;
	else if (normflag == 2) 
	  w = 1.0;
	if (w > 1.0)
	  w = 1.0;
	if (colormapflag > 0){
	  if (gc->geom_flag == 1){  
	    cid = gc->irr_id[i];
	    if (cid == 0){
	      ticon->r = 0.2;
	      ticon->g = 0.2;
	      ticon->b = 1.0;
	    }else if (cid == 1){
	      ticon->r = 0.0;
	      ticon->g = 1.0;
	      ticon->b = 0.0;
	    }else if (cid == 2){
	      ticon->r = 1.0;
	      ticon->g = 0.0;
	      ticon->b = 0.0;
	    }else{
	      ticon->r = ticon->g = ticon->b = 0.5;
	    }
	    if (k == 0)
	      openflag = 1;  
	    else
	      openflag = 0;  
	  }else{
	    mod_conn_color_angle(ori*2.0,&(ticon->r),&(ticon->g),&(ticon->b));
	  }
	}
	ticon->r += 0.3;  
	ticon->g += 0.3;
	ticon->b += 0.3;
	if (ticon->r > 1.0) ticon->r = 1.0;
	if (ticon->g > 1.0) ticon->g = 1.0;
	if (ticon->b > 1.0) ticon->b = 1.0;
	if (colormapflag > 0){
	  mod_gr_draw_grid_single(i,j,gc,ticon,w,1.0,openflag);
	  if (mgs->wgrid_win == 1)
	    mod_gui_wgrid_set_element(i,j,ticon->r,ticon->g,ticon->b,w);
	}else{
	  mod_gr_draw_grid_single(i,j,gc,tl->icon,w,1.0,openflag);
	  if (mgs->wgrid_win == 1)
	    mod_gui_wgrid_set_element(i,j,tl->icon->r,tl->icon->g,
				      tl->icon->b,w);
	}
      }
      if (preflag == 0){
	tsyn = tsyn->pre_next;
	tsyn = pop_cell_get_next_syn_layer_name(tsyn,0,tl->name); 
      }else{
	tsyn = tsyn->post_next;
	tsyn = pop_cell_get_next_syn_layer_name(tsyn,1,tl->name); 
      }
    }
    printf("    %d synapses, total weight %.4f, max weight %.4f, ",nsyn,wtot,
	   wmax);
    printf("position (%.2f, %.2f)\n",c->cx,c->cy);
  }
  myfree(gc);  
  if (pflag == 1) printf("  done:  MOD_GUI_DRAW_SYN_CONN\n");
}
void mod_gui_layer_view_help()
{
  printf("  MOD_GUI_LAYER_VIEW_HELP\n");
  printf("    Mouse Left - show presynaptic inputs\n");
  printf("    Mouse Middle - show aggregate LGN field (see: 1,2 below).\n");
  printf("    Mouse Right - show post-synaptic contacts\n");
  printf("    SPACE - interactive mode - clear all recorded signals\n");
  printf("    1,2 - draw level 1-direct, 2-indirect LGN RF\n");
  printf("    b - binarize synapse map - show all synapses bright\n");
  printf("    c - toggle orientation color map\n");
  printf("    C - toggle orientation color map w/ numbers\n");
  printf("    d - toggle synapse output: print list or not\n");
  printf("    e - toggle stimulus eye for binocular stimuli\n");
  printf("    f - interactive mode - select items to plot\n");
  printf("    h - help (print this list)\n");
  printf("    i - interactive mode\n");
  printf("    l - load file for replay (currently 'zz.nd')\n");
  printf("    m - norm synapse strength to max\n");
  printf("    o - ocular dominance color map (red=left)\n");
  printf("    q - quit gui, return to model\n");
  printf("    p - write a PPM file 'zzz.conn.ppm' of the LGN connections\n");
  printf("    P - write a PostScript image of the connections window.\n");
  printf("    r - run - interactive or replay\n");
  printf("    s - stimulus mode: show stimuli on input grid\n");
  printf("    x - exit program\n");
  printf("    z - set/increment connections window 'z' layer\n");
  printf("    =- - change probability for drawing connections\n");
  printf("    ,. - increment/decrement stimulus frame number\n");
  printf("    <> - increment/decrement stimulus number\n");
  printf("    ARROW KEYS - navigate in current layer grid\n");
  printf("    ? - help (print this list)\n");
}
void mod_gui_layer_view_conn_help()
{
  printf("  MOD_GUI_LAYER_VIEW_CONN_HELP\n");
  printf("    Mouse Left - Mark region, print coord\n");
  printf("    Mouse Middle - show units to which an LGN unit projects.\n");
  printf("    Mouse Right - Mark region, print coord\n");
  printf("    SPACE - refresh grid, remove region\n");
  printf("    h - help (print this list)\n");
  printf("    l - print a list of layers\n");
  printf("    w - write a .2d data file of the region, if defined\n");
  printf("    x - exit program\n");
  printf("    z - set/increment the 'z' layer\n");
  printf("    ? - help (print this list)\n");
}
void mod_gui_view_cones_help()
{
  printf("\n");
  printf("    Mouse Left - print cone ID number\n");
  printf("    Mouse Middle - change cone type: S, M, L\n");
  printf("    SPACE - Toggle display of underlying cartesian grid\n");
  printf("    h - help (print this list)\n");
  printf("    q - quit GUI, continue with model\n");
  printf("    S - save mosaic coordinates and colors to 'zz.mosaic.txt'\n");
  printf("    s - stimulus mode\n");
  printf("    r - replay mosaic reponse file: mesh_replay_file in .rsp\n");
  printf("    t - toggle showing of cones at their true estimated size\n");
  printf("    x - exit program\n");
  printf("    w - Show weighting over cones in final summation\n");
  printf("    ? - help (print this list\n");
  printf("    ARROW  Left - lower  stimulus frame number\n");
  printf("    ARROW Right - higher stimulus frame number\n");
  printf("\n");
}
int mod_gui_view_layer_event2(laylist,npl,ll,event)
     struct pop_layer **laylist;   
     int npl;                      
     struct layer_label *ll;       
     XEvent event;
{
  int i,j;
  int ci,cj,ck,redrawflag,winw,winh,gi,gj,dx,dy,dnx,dny,n;
  char tstr[SLEN];
  float **d2d;
  struct pop_cell *c;
  struct mgui_struct *mg;
  struct gui_gpar *gc;
  XKeyEvent *kevent;
  XWindowAttributes xwa;
  char kbuf[10];
  Display *dpy;
  Window win;
  mg = mgs;
  dpy = mg->win2->dpy; 
  win = mg->win2->win;
  glplot_util_make_current(dpy,win,mg->win2->cx);
  XGetWindowAttributes(dpy,win,&xwa);
  winw = xwa.width;
  winh = xwa.height;
  gc = mod_gui_get_grid_params_lay(mg->tl,winfrac2,winfrac2);
  redrawflag = 0;
  switch(event.type){
  case ButtonPress:
    switch(event.xbutton.button){
    case 1:  
      mod_gui_get_grid_index_for_coord(event.xbutton.x,event.xbutton.y,
				       winw,winh,-1.0,-1.0,2.0,2.0,gc,&gi,&gj);
      if (gi != -1){
	mg->conn_reg_xi1 = gi;  
	mg->conn_reg_yi1 = gj;
	mod_gui_lgn_region_update();  
	glob_win2_ci = ci = gi;
	glob_win2_cj = cj = gj;
	if (mgs->win2_zi == -1)
	  sprintf(tstr,"%3d %3d",ci,cj);
	else
	  sprintf(tstr,"%3d %3d %3d",ci,cj,mgs->win2_zi);
	mod_gui_update_laylab(&(ll->w2_coord),tstr);
      }else{
	mod_gui_update_laylab(&(ll->w2_coord),NULL);
      }
      glob_flag_rev_map = -1; 
      redrawflag = 1;
      break;
    case 2: 
      mod_gui_get_grid_index_for_coord(event.xbutton.x,event.xbutton.y,
				       winw,winh,-1.0,-1.0,2.0,2.0,gc,&gi,&gj);
      if (gi != -1){
	glob_win2_ci = ci = gi;
	glob_win2_cj = cj = gj;
	if ((glob_win1_ci >= 0) && (glob_win1_cj >= 0)){
	  glob_flag_rev_map = 1;
	}
	if (mgs->win2_zi == -1)
	  sprintf(tstr,"%3d %3d",ci,cj);
	else
	  sprintf(tstr,"%3d %3d %3d",ci,cj,mgs->win2_zi);
	mod_gui_update_laylab(&(ll->w2_coord),tstr);
      }else{
	mod_gui_update_laylab(&(ll->w2_coord),NULL);
      }
      redrawflag = 1;
      break;
    case 3:
      mod_gui_get_grid_index_for_coord(event.xbutton.x,event.xbutton.y,
				       winw,winh,-1.0,-1.0,2.0,2.0,gc,&gi,&gj);
      if (gi != -1){
	mg->conn_reg_xi2 = gi;  
	mg->conn_reg_yi2 = gj;
	mod_gui_lgn_region_update();  
	if (mg->conn_reg_xi1  != -1){
	  dx = mg->conn_reg_xi1 - mg->conn_reg_xi2;
	  if (dx > 0)
	    dx += 1;
	  else
	    dx = -dx + 1;
	  dy = mg->conn_reg_yi1 - mg->conn_reg_yi2;
	  if (dy > 0)
	    dy += 1;
	  else
	    dy = -dy + 1;
	  printf("  Region is %d x %d\n",dx,dy);
	}
	glob_win2_ci = ci = gi;
	glob_win2_cj = cj = gj;
	if (mgs->win2_zi == -1)
	  sprintf(tstr,"%3d %3d",ci,cj);
	else
	  sprintf(tstr,"%3d %3d %3d",ci,cj,mgs->win2_zi);
	mod_gui_update_laylab(&(ll->w2_coord),tstr);
      }else{
	mod_gui_update_laylab(&(ll->w2_coord),NULL);
      }
      break;
    }
    break;
  case MotionNotify:
    break;
  case KeyPress:
    kevent = (XKeyEvent *)&event;
    XLookupString(kevent,kbuf,sizeof(kbuf),NULL,NULL);
    if (kbuf[0]==' '){
      redrawflag = 1;
      mg->conn_reg_xi1 = mg->conn_reg_yi1 = -1;
      mg->conn_reg_xi2 = mg->conn_reg_yi2 = -1;
    }else if ((kbuf[0]=='h')||(kbuf[0]=='?')){
      mod_gui_layer_view_conn_help();
    }else if (kbuf[0]=='l'){
      printf("    Layers\n");
      for(i=0;i<npl;i++)
	printf("    %4d %s\n",i,laylist[i]->name);
    }else if (kbuf[0]=='q'){
      printf("  Quit from main window only.\n");
    }else if (kbuf[0]=='r'){
      if ((mg->ci >= 0)&&(mg->cj >= 0)&&(mg->ck >= 0) &&
	  (pop_util_lclass_is_lgn0(mg->pl) != 1)){ 
	d2d = mod_gui_get_lgn_rf_region(mg->pl,mg->laylab,mg->ci,mg->cj,
					mg->ck,&dnx,&dny);
	write_2d_data("zz.rf.2d",d2d,0,0,dnx,dny,4,2,1,1);
	free_2d_farray(d2d,dnx);
      }
    }else if (kbuf[0]=='w'){
      if ((mg->ci >= 0)&&(mg->cj >= 0)&&(mg->ck >= 0) &&
	  (pop_util_lclass_is_lgn0(mg->pl) != 1)){ 
	c = &(mg->pl->c[mg->ci][mg->cj][mg->ck]);
	d2d = mod_conn_image_2d_lgn_grid(c,mg->conn_reg_xi1,mg->conn_reg_yi1,
					 mg->conn_reg_xi2,mg->conn_reg_yi2,
					 &dnx,&dny);
	write_2d_data("zz.conn.2d",d2d,0,0,dnx,dny,4,2,1,1);
	free_2d_farray(d2d,dnx);
      }
    }else if (kbuf[0]=='x'){
      printf("\n");
      exit(0);
    }else if (kbuf[0]=='z'){
      if (mgs->tl->zn > 1){
	mgs->win2_zi += 1;
	if (mgs->win2_zi >= mgs->tl->zn)
	  mgs->win2_zi = -1;
      }
      mod_gui_update_laylab(&(mgs->laylab->w2_coord),NULL);
      redrawflag = 1;
    }
    break;
  case ConfigureNotify:
    mod_gui_get_last_event_of_type(dpy,ConfigureNotify,&event);
    winw = event.xconfigure.width;
    winh = event.xconfigure.height;
    if ((winw != mod_gui_win2w) || (winh != mod_gui_win2h)){
      glViewport(0,0,winw,winh);
      mod_gui_win2w = winw;
      mod_gui_win2h = winh;
      redrawflag = 1;
    }
    break;
  case Expose:
    redrawflag = 1;
    n = XQLength(dpy);
    while (n > 0){
      XNextEvent(dpy,&event);
      n -= 1;
    }
    break;
    if (pflag == 1) printf("DONE event 2\n");
  }
  myfree(gc);
  return redrawflag;
}
void mod_gui_view_layer_init(laylist,npl,mpt,m,s,r)
     struct pop_layer **laylist;  
     int npl;                     
     struct pop_top *mpt;         
     struct model_struct *m;      
     struct stim_struct *s;       
     struct response_struct *r;   
{
  int i,k;
  int narea,win2w,win2h;
  float stim_samp;
  struct mgui_struct *mg;
  struct onode *o;
  printf("  MOD_GUI_VIEW_LAYER_INIT\n");
  if (npl < 1)
    exit_error("MOD_GUI_VIEW_LAYER_INIT","No layers");
  mg = (struct mgui_struct *)myalloc(sizeof(struct mgui_struct));
  mgs = mg;
  mg->mpt = mpt;
  mg->mon_state = -1; 
  mg->run_state =  0; 
  if (m->ppl != NULL){
    mg->tn = paramfile_get_int_param_or_exit(m->ppl,"tn");
    mg->tscale = paramfile_get_float_param_or_exit(m->ppl,"tscale");
    mg->sscale = paramfile_get_float_param_or_exit(m->ppl,"sscale");
  }else{
    mg->tn = mpt->tn;
    mg->tscale = mpt->tscale;
    mg->sscale = mpt->sscale;
  }
  stim_samp = paramfile_get_float_param_or_exit(s->ppl,"stim_samp");
  mg->tsamp = my_rint(1.0/(mg->tscale*stim_samp)); 
  if (mg->tsamp <= 0)
    mg->tsamp = 1; 
  mg->stimtype = paramfile_get_char_param_or_exit(s->ppl,"stim_type");
  mg->nrpt = paramfile_get_int_param_or_exit(s->ppl,"stim_nrpt");
  mg->nstim = s->ntr / mg->nrpt;
  mg->stimform = paramfile_get_char_param_default(s->ppl,"stim_form","3d");
  mod_gui_winw = paramfile_get_int_param_default(r->ppl,"gui_win_w",500);
  mod_gui_winh = paramfile_get_int_param_default(r->ppl,"gui_win_h",500);
  mod_gui_win2w = paramfile_get_int_param_default(r->ppl,"gui_win2_w",500);
  mod_gui_win2h = paramfile_get_int_param_default(r->ppl,"gui_win2_h",500);
  mod_gui_winx = paramfile_get_int_param_default(r->ppl,"gui_win_x",0);
  mod_gui_winy = paramfile_get_int_param_default(r->ppl,"gui_win_y",0);
  mod_gui_win2x = paramfile_get_int_param_default(r->ppl,"gui_win2_x",
						  mod_gui_winx);
  mod_gui_win2y = paramfile_get_int_param_default(r->ppl,"gui_win2_y",
						  mod_gui_winw);
  mg->curi = 0;  
  mg->pl = laylist[mg->curi];
  printf("    Layer is %d x %d x %d\n",mg->pl->xn,mg->pl->yn,mg->pl->zn);
  mg->tl = NULL;
  i = 0;
  while((i<npl) && (mg->tl == NULL)){
    if (pop_util_lclass_is_lgn0(laylist[i]) ||
	pop_util_lclass_is_rgci(laylist[i]))
      mg->tl = laylist[i];
    i += 1;
  }
  if (mg->tl == NULL){
    printf("    No LGN layer\n");
    mg->lgn_flag = 0;
    if (npl > (mg->curi+1))
      mg->tl = laylist[mg->curi+1];
    else
      mg->tl = laylist[npl-1];
  }else
    mg->lgn_flag = 1;
  mg->xn = mpt->xn; 
  mg->yn = mpt->yn;
  mg->gicon = (struct pop_icon *)myalloc(sizeof(struct pop_icon));
  mg->gicon->shape = strdup("square");
  mg->gicon->r = mg->gicon->g = mg->gicon->b = 0.5;
  mg->win2_zi = -1;
  if (mpt != NULL)
    narea = mpt->narea;
  else
    narea = 1;  
  mg->nview = narea + 1;
  mg->view = (struct gui_view *)myalloc(mg->nview*sizeof(struct gui_view));
  mg->view[0].area = strdup("stim");
  mg->view[0].x0 = 0;
  mg->view[0].y0 = 0;
  if (mpt != NULL){ 
    mg->view[0].xn = mpt->xn;
    mg->view[0].yn = mpt->yn;
  }else{
    mg->view[0].xn = paramfile_get_int_param_or_exit(m->ppl,"xn");
    mg->view[0].yn = paramfile_get_int_param_or_exit(m->ppl,"yn");
  }
  if (mpt != NULL){
    k = 1;
    for(i=0;i<narea;i++){
      if (strcmp(mpt->area[i]->name,"stim")!=0){
	mg->view[k].area = strdup(mpt->area[i]->name);
	mg->view[k].x0 = 0;
	mg->view[k].y0 = 0;
	mg->view[k].xn = -1;
	mg->view[k].yn = -1;
	k += 1;
      }
    }
    mg->nview = k;  
  }else{
    mg->view[1].area = strdup("V1");
    mg->view[1].x0 = 0;
    mg->view[1].y0 = 0;
    mg->view[1].xn = -1;
    mg->view[1].yn = -1;
  }
  mg->laylab = mod_gui_get_init_laylab();
  mg->laylab->layname = strdup(mg->pl->name);
  mod_gui_set_targflag(mg->tl,-1);  
  mg->sdn = paramfile_get_int_param_default(r->ppl,"gui_stim_frame",0);
  if (mg->sdn >= mg->tn)
    mg->sdn = 0;
  mg->sdata = NULL;   
  mg->sdata_r = NULL; 
  mg->ci = mg->cj = -1;  
  mg->ck = 0;            
  mg->win1 = (struct mgui_win_struct *)myalloc(sizeof(struct mgui_win_struct));
  mg->win2 = (struct mgui_win_struct *)myalloc(sizeof(struct mgui_win_struct));
  mod_gui_init_win(mod_gui_winw,mod_gui_winh,mod_gui_zoom,"current layer",
		   mg->win1);
  mod_gui_init_win(mod_gui_win2w,mod_gui_win2h,mod_gui_zoom,"connections",
		   mg->win2);
  glplot_set_xfont_generic(mg->win1->dpy,mg->win1->win,mg->win1->cx,"medium");
  glplot_set_xfont_generic(mg->win2->dpy,mg->win2->win,mg->win2->cx,"medium");
  glplot_util_make_current(mg->win1->dpy,mg->win1->win,mg->win1->cx);
  glplot_set_window_loc(mgs->win1->dpy,mgs->win1->win,mod_gui_winx,
			mod_gui_winy);
  glplot_set_window_loc(mgs->win2->dpy,mgs->win2->win,mod_gui_win2x,
			mod_gui_win2y);
  mg->cfx0 = mg->cfy0 = -1.0;
  mg->cfw = mg->cfh = 2.0;
  mg->winfrac = winfrac1;
  if (mod_gui_winw > mod_gui_winh)
    mg->winfrac_x = winfracx;
  else
    mg->winfrac_x = winfrac1;
  mg->winfrac_y = winfrac1;
  mg->gridfrac = 0.80;
  mg->synnorm = 0;  
  mg->gcurr = mod_gui_get_grid_params_lay(mg->pl,mg->winfrac_x,mg->winfrac_y);
  mg->gstim = mod_gui_get_grid_params_stim(winfrac2);
  mg->colormapflag = paramfile_get_int_param_default(r->ppl,"gui_colormapflag",
						     1);
  mg->overlay_flag  = 0;  
  mg->syn_dump_flag = 0;
  mg->wgrid_r = NULL;
  mg->wgrid_g = NULL;
  mg->wgrid_b = NULL;
  mg->wgrid_w = mg->wgrid_h = 0;
  mg->wgrid_win = 0;
  mod_gui_draw_grid_laylist(laylist,npl,mg->curi,mg->ci,mg->cj,
			    mg->colormapflag,mg->laylab);
  mg->stimflag = 0;  
  if (mg->nstim == 1)
    mg->stimno = -1;   
  else{
    mg->stimno = paramfile_get_int_param_default(r->ppl,"gui_stim_num",0);
    if (mg->stimno >= mg->nstim)
      mg->stimno = 0;
  }
  mg->cprob = 1.0;  
  mg->drawcon = 1;  
  mg->draw_level = 1;   
  mg->conn_reg_xi1 = -1;
  mg->conn_reg_yi1 = -1;
  mg->conn_reg_xi2 = -1;
  mg->conn_reg_yi2 = -1;
  mg->conn_reg_llx = -1;
  mg->conn_reg_lly = -1;
  mg->conn_reg_urx = -1;
  mg->conn_reg_ury = -1;
  mg->lgn_sig1 = 0.0;      
  mg->lgn_sig2 = 0.0;      
  mg->lgn_amp1 = 0.0;      
  mg->lgn_amp2 = 0.0;      
  mg->tlgn = NULL;
  if (mg->lgn_flag == 1){
    i = 0;
    while((i<npl) && (mg->tlgn == NULL)){
      if (pop_util_lclass_is_lgn0(laylist[i]) ||
	  pop_util_lclass_is_rgci(laylist[i]))
	mg->tlgn = laylist[i];
      else
	i += 1;
    }
    o = onode_get_node_type_item_val(m->o,"pop","name",mg->tlgn->name);
    if (o == NULL){
      printf("*** LGN layer name: %s\n",mg->tlgn->name); 
      exit_error("MOD_GUI_VIEW_LAYER_INIT","population name not found.");
    }
    mg->lgn_sig1   = onode_getpar_flt_exit(o,"sig1");
    mg->lgn_sig2   = onode_getpar_flt_exit(o,"sig2");
    mg->lgn_amp1   = onode_getpar_flt_exit(o,"amp1");
    mg->lgn_amp2   = onode_getpar_flt_exit(o,"amp2");
  }
  mg->replay_file_i = 0;    
  glXSwapBuffers(mg->win1->dpy,mg->win1->win);
  if (pflag == 1) printf("  done:  MOD_GUI_VIEW_LAYER_INIT\n");
}
void mod_gui_view_layer(pllist,npl,m,s,r)
     struct pop_layer **pllist;  
     int npl;                    
     struct model_struct *m;     
     struct stim_struct *s;      
     struct response_struct *r;   
{
  int i,j;
  int redrawflag,redraw2,winw,winh,gi,gj,hi,hj,cpflag,reflag,n;
  char tstr[SLEN];
  struct pop_layer **laylist; 
  XEvent event;
  XKeyEvent *kevent;
  XWindowAttributes xwa;
  char kbuf[10];
  Display *dpy;
  Window win;
  struct mgui_struct *mg;
  KeySym ks;
  printf("  MOD_GUI_VIEW_LAYER\n");
  mg = mgs;
  laylist = pllist;
  dpy = mg->win1->dpy;
  win = mg->win1->win;
  glplot_util_make_current(dpy,win,mg->win1->cx);
  XGetWindowAttributes(dpy,win,&xwa);
  winw = xwa.width; winh = xwa.height;
  redrawflag = redraw2 = 0;
  while(1){
    usleep(1000); 
    if (mgs->mon_state == 0){  
      mod_mon_monitor(m,r,s,pllist,npl,-1.0); 
      glplot_util_make_current(dpy,win,mg->win1->cx);
    }
    if (XCheckIfEvent(dpy,&event,my_true_test,(char *)NULL)){
      switch(event.type){
      case ButtonPress:
	mod_gui_update_laylab(&(mg->laylab->w2_coord),NULL);
	switch(event.xbutton.button){
	case 1:
	  mod_gui_get_grid_index_for_coord(event.xbutton.x,event.xbutton.y,
					   winw,winh,-1.0,-1.0,2.0,2.0,
					   mg->gcurr,&gi,&gj);
	  if (gi != -1){
	    if ((mg->ci == gi) && (mg->cj == gj)){ 
	      mg->ck += 1;
	      if (mg->ck >= mg->pl->zn)  
		mg->ck = 0;
	    }else{
	      mg->ck = 0;  
	    }
	    mg->ci = gi;
	    mg->cj = gj;
	    sprintf(tstr,"  %3d %3d %3d",mg->ci,mg->cj,mg->ck);
	    mod_gui_update_laylab(&(mg->laylab->coord),tstr);
	    if (mg->targflag_lgn){  
	      cpflag = 1;               
	    }
	    mg->drawcon = 1;  
	  }else{
	    mod_gui_get_head_index_for_coord(event.xbutton.x,event.xbutton.y,
					     winw,winh,-1.0,-1.0,2.0,2.0,
					     headx,heady,npl,1,headdx,headdy,
					     &hi,&hj);
	    if ((hi >= 0) && (hi < npl)){
	      mg->curi = hi;
	      mg->opl = mg->pl;
	      mg->pl = laylist[mg->curi];
	      if ((mg->opl->xn != mg->pl->xn)||(mg->opl->yn != mg->pl->yn)){
		mg->ci = mg->cj = -1;
		mod_gui_update_laylab(&(mg->laylab->coord),NULL);
	      }
	      if (pflag) printf("  mouse_click_main_loop\n");
	      mod_gui_set_grid_params(mgs->gcurr,mgs->pl,mgs->winfrac_x,
				      mgs->winfrac_y);
	    }else{
	      mg->ci = mg->cj = -1;  
	      mg->ck = 0;
	      mod_gui_update_laylab(&(mg->laylab->coord),NULL);
	    }
	  }
	  glob_win1_ci = mg->ci; 
	  glob_win1_cj = mg->cj;
	  glob_win1_ck = mg->ck;
	  redrawflag = 1;
	  break;
	case 2:
	  mod_gui_get_grid_index_for_coord(event.xbutton.x,event.xbutton.y,
					   winw,winh,-1.0,-1.0,2.0,2.0,
					   mg->gcurr,&gi,&gj);
	  if (gi != -1){
	    mg->ci = gi;
	    mg->cj = gj;
	    sprintf(tstr,"  %3d %3d",mg->ci,mg->cj);
	    mod_gui_update_laylab(&(mg->laylab->coord),tstr);
	    mg->drawcon = 4;  
	  }
	  redrawflag = 1;
	  break;
	case 3:
	  mod_gui_get_grid_index_for_coord(event.xbutton.x,event.xbutton.y,
					   winw,winh,-1.0,-1.0,2.0,2.0,
					   mg->gcurr,&gi,&gj);
	  if (gi != -1){
	    mg->ci = gi;
	    mg->cj = gj;
	    sprintf(tstr,"  %3d %3d",mg->ci,mg->cj);
	    mod_gui_update_laylab(&(mg->laylab->coord),tstr);
	    mg->drawcon = 2;  
	  }else{
	    mod_gui_get_head_index_for_coord(event.xbutton.x,event.xbutton.y,
					     winw,winh,-1.0,-1.0,2.0,2.0,
					     headx,heady,npl,1,headdx,headdy,
					     &hi,&hj);
	    if ((hi >= 0) && (hi < npl)){
	      mg->tl = laylist[hi];
	      mg->win2_zi = -1;
	      mod_gui_set_targflag(mg->tl,mg->targflag_eye);
	    }
	    mg->stimflag = 0; 
	  }
	  redrawflag = 1;
	  break;
	}
	break;
      case MotionNotify:
	break;
      case KeyPress:
	kevent = (XKeyEvent *)&event;
	XLookupString(kevent,kbuf,sizeof(kbuf),&ks,NULL);
	if (ks==65363){             
	  if (mg->ci != -1){
	    mg->ci += 1;
	    if (mg->ci >= mg->pl->xn)  
	      mg->ci = 0;
	    sprintf(tstr,"  %3d %3d %3d",mg->ci,mg->cj,mg->ck);
	    mod_gui_update_laylab(&(mg->laylab->coord),tstr);
	    glob_win1_ci = mg->ci; 
	    redrawflag = 1;
	  }
	}else if (ks==65361){       
	  if (mg->ci != -1){
	    mg->ci -= 1;
	    if (mg->ci < 0)  
	      mg->ci = mg->pl->xn - 1;
	    sprintf(tstr,"  %3d %3d %3d",mg->ci,mg->cj,mg->ck);
	    mod_gui_update_laylab(&(mg->laylab->coord),tstr);
	    glob_win1_ci = mg->ci; 
	    redrawflag = 1;
	  }
	}else if (ks==65362){       
	  if (mg->cj != -1){
	    mg->cj += 1;
	    if (mg->cj >= mg->pl->yn)  
	      mg->cj = 0;
	    sprintf(tstr,"  %3d %3d %3d",mg->ci,mg->cj,mg->ck);
	    mod_gui_update_laylab(&(mg->laylab->coord),tstr);
	    glob_win1_cj = mg->cj; 
	    redrawflag = 1;
	  }
	}else if (ks==65364){       
	  if (mg->cj != -1){
	    mg->cj -= 1;
	    if (mg->cj < 0)  
	      mg->cj = mg->pl->yn - 1;
	    sprintf(tstr,"  %3d %3d %3d",mg->ci,mg->cj,mg->ck);
	    mod_gui_update_laylab(&(mg->laylab->coord),tstr);
	    glob_win1_cj = mg->cj; 
	    redrawflag = 1;
	  }
	}else if (kbuf[0]==' '){
	  if (m->run_mode == 1){
	    mod_mon_plot_remove_plot_glob(NULL,NULL);  
	  }
	  redrawflag = 1;
	}else if (kbuf[0]=='1'){
	  mg->draw_level = 1;
	}else if (kbuf[0]=='2'){
	  mg->draw_level = 2;
	}else if (kbuf[0]=='b'){
	  if (mg->synnorm != 2)
	    mg->synnorm = 2;
	  else
	    mg->synnorm = 0;
	  redrawflag = 1;
	}else if (kbuf[0]=='c'){
	  if (mg->colormapflag != 1)
	    mg->colormapflag = 1;
	  else
	    mg->colormapflag = 0;
	  redrawflag = 1;
	}else if (kbuf[0]=='C'){
	  if (mg->colormapflag != 2)
	    mg->colormapflag = 2;
	  else
	    mg->colormapflag = 0;
	  redrawflag = 1;
	}else if (kbuf[0]=='d'){
	  if (mg->syn_dump_flag == 1)
	    mg->syn_dump_flag = 0;
	  else
	    mg->syn_dump_flag = 1;
	}else if (kbuf[0]=='o'){
	  if (mg->colormapflag != 3)
	    mg->colormapflag = 3;
	  else
	    mg->colormapflag = 0;
	  redrawflag = 1;
	}else if (kbuf[0]=='u'){      
	  if (mg->colormapflag != 4)
	    mg->colormapflag = 4;
	  else
	    mg->colormapflag = 0;
	  redrawflag = 1;
	}else if (kbuf[0]=='v'){
	  mg->overlay_flag = 1 - mg->overlay_flag;
	  redrawflag = 1;
	}else if (kbuf[0]=='f'){
	  if (m->run_mode == 1){
	    if (mg->ci != -1){
	      mod_gui_mon_save(mgs->pl);
	    }
	  }
	  redrawflag = 1;
	}else if ((kbuf[0]=='h')||(kbuf[0]=='?')){
	  mod_gui_layer_view_help();
	}else if (kbuf[0]=='i'){
	  m->run_mode = 1;  
	  return;
	}else if (kbuf[0]=='l'){
	  m->run_mode = 2;  
	  reflag = mod_gui_replay_load();
	  if (reflag == 0)  
	    m->run_mode = 1;  
	}else if (kbuf[0]=='m'){
	  if (mg->synnorm != 1)
	    mg->synnorm = 1;
	  else
	    mg->synnorm = 0;
	  redrawflag = 1;
	}else if (kbuf[0]=='q'){
	  if (m->run_mode == 0){  
	    glplot_shutdown(mg->win1->dpy,mg->win1->win,mg->win1->cx,1);
	    if (mg->win2->initflag != 0){
	      glplot_shutdown(mg->win2->dpy,mg->win2->win,mg->win2->cx,0);
	    }
	    mg->win1->initflag = 0;
	    mg->win2->initflag = 0;
	  }
	  return;
	}else if (kbuf[0]=='p'){ 
	  mod_gui_write_ppm(mg->pl,mg->ci,mg->cj,mg->ck,mg->cfx0,mg->cfy0,
			    mg->cfw,mg->cfh);
	}else if (kbuf[0]=='P'){ 
	  if (mgs->wgrid_r != NULL)
	    mod_gui_wgrid_write_ps("zzz.ps",0,1,0);
	}else if (kbuf[0]=='r'){ 
	  if (m->run_mode == 1){
	    mg->run_state = 1;
	    return;
	  }else if (m->run_mode == 2){
	    if (mgs->replay_ti >= mgs->replay_tn){
	      mgs->replay_ti = 0;
	      redrawflag = 1; 
	    }
	  }
	}else if (kbuf[0]=='s'){ 
	  if (strcmp(mg->stimtype,"null")!=0){
	    if (mg->sdata == NULL){
	      if ((mg->stimno >= 0) && (mg->stimno < mg->nstim))
		mod_util_substitute_var_params(s,mg->stimno*mg->nrpt,NULL,
					       0,NULL,NULL);
	      if (strcmp(mg->stimform,"3d")==0){
		mg->sdata = get_stim_3d_ppl(NULL,s,mg->xn,mg->yn,mg->tn,
					    mg->sscale,mg->tscale,mg->tsamp);
		if (mg->mpt->binoc == 1)
		  mg->sdata_r = get_stim_3d_ppl(NULL,s,mg->xn,mg->yn,mg->tn,
						mg->sscale,mg->tscale,
						mg->tsamp);
	      }else if (strcmp(mg->stimform,"3d_b")== 0){
		get_stim_3d_b_ppl(NULL,mg->stimtype,s->ppl,mg->xn,mg->yn,
				  mg->tn,mg->sscale,mg->tscale,mg->tsamp,
				  &(mg->sdata),&(mg->sdata_r));
	      }else if (strcmp(mg->stimform,"3c")==0){
		mg->c3data = get_stim_3c_ppl(NULL,mg->stimtype,s->ppl,mg->xn,
					     mg->yn,mg->tn,
					     mg->sscale,mg->tscale,mg->tsamp);
		mg->sdata = NULL;
	      }else{
		exit_error("MOD_GUI_VIEW_LAYER","Unknown stimulus form");
	      }
	    }
	    if (mg->stimflag > 0)
	      mg->stimflag = 0;
	    else
	      mg->stimflag = 1;  
	    if (mg->stimflag == 0)
	      mod_gui_update_laylab(&(mg->laylab->w2_coord),NULL);
	    redrawflag = 1;
	  }
	}else if (kbuf[0]=='='){
	  mg->cprob *= 2.0;
	  if (mg->cprob > 1.0)
	    mg->cprob = 1.0;
	  redrawflag = 1;
	}else if (kbuf[0]=='-'){
	  mg->cprob /= 2.0;
	  if (mg->cprob <= 0.0)
	    mg->cprob = 0.01;
	  redrawflag = 1;
	}else if (kbuf[0]==','){
	  if (mg->stimflag > 0){
	    mg->sdn -= 1;
	    if (mg->sdn < 0)
	      mg->sdn = mg->tn-1;
	  }
	  redrawflag = 1;
	}else if (kbuf[0]=='.'){
	  if (mg->stimflag > 0){
	    mg->sdn += 1;
	    if (mg->sdn >= mg->tn)
	      mg->sdn = 0;
	  }
	  redrawflag = 1;
	}else if (kbuf[0]=='e'){
	  if (strcmp(mg->stimform,"3d_b")==0){  
	    if (mg->stimflag == 1)   
	      mg->stimflag = 2;
	    else if (mg->stimflag == 2)
	      mg->stimflag = 1;
	    redrawflag = 1;
	  }else{
	    printf("  Stimulus is monocular, cannot switch eye.\n");
	  }
	}else if ((kbuf[0]=='<')||(kbuf[0]=='>')){
	  if (mg->stimflag > 0){
	    if (kbuf[0]=='<'){
	      mg->stimno -= 1;
	      if (mg->stimno < 0)
		mg->stimno = mg->nstim - 1;
	    }else if (kbuf[0]=='>'){
	      mg->stimno += 1;
	      if (mg->stimno == mg->nstim)
		mg->stimno = 0;
	    }
	    if (mg->sdata != NULL)
	      free_f3tensor(mg->sdata,1,mg->xn,1,mg->yn,1,mg->tn);
	    if (mg->sdata_r != NULL)
	      free_f3tensor(mg->sdata_r,1,mg->xn,1,mg->yn,1,mg->tn);
	    mod_util_substitute_var_params(s,mg->stimno*mg->nrpt,NULL,
					   0,NULL,NULL);
	    if (strcmp(mg->stimform,"3d")==0){
	      mg->sdata = get_stim_3d_ppl(NULL,s,mg->xn,mg->yn,mg->tn,
					  mg->sscale,mg->tscale,mg->tsamp);
	      if (mg->mpt->binoc == 1)
		mg->sdata_r = get_stim_3d_ppl(NULL,s,mg->xn,mg->yn,mg->tn,
					      mg->sscale,mg->tscale,mg->tsamp);
	    }else if (strcmp(mg->stimform,"3d_b")== 0){
	      get_stim_3d_b_ppl(NULL,mg->stimtype,s->ppl,mg->xn,mg->yn,mg->tn,
				mg->sscale,mg->tscale,mg->tsamp,
				&(mg->sdata),&(mg->sdata_r));
	    }else if (strcmp(mg->stimform,"3c")==0){
	      mg->c3data = get_stim_3c_ppl(NULL,mg->stimtype,s->ppl,mg->xn,
					   mg->yn,mg->tn,
					   mg->sscale,mg->tscale,mg->tsamp);
	      mg->sdata = NULL;
	    }else{
	      exit_error("MOD_GUI_VIEW_LAYER","Unknown stimulus form");
	    }
	  }
	  redrawflag = 1;
	}else if (kbuf[0]=='w'){   
	  mgs->wgrid_win = 1 - mgs->wgrid_win;
	  printf("  PostScript taken from window:  %d\n",mgs->wgrid_win);
	}else if (kbuf[0]=='x'){
	  exit(0);
	}else if (kbuf[0]=='z'){
	  if (mgs->tl->zn > 1){
	    mgs->win2_zi += 1;
	    if (mgs->win2_zi >= mgs->tl->zn)
	      mgs->win2_zi = -1;
	  }
	  mod_gui_update_laylab(&(mgs->laylab->w2_coord),NULL);
	  redrawflag = 1;
	}
	break;
      case ConfigureNotify:
	mod_gui_get_last_event_of_type(dpy,ConfigureNotify,&event);
	winw = event.xconfigure.width;
	winh = event.xconfigure.height;
	if ((winw != mod_gui_winw) || (winh != mod_gui_winh)){
	  glViewport(0,0,winw,winh);
	  mod_gui_winw = winw;
	  mod_gui_winh = winh;
	  redrawflag = 1;
	}
	break;
      case Expose:  
	n = XQLength(dpy);
	while (n > 0){
	  XNextEvent(dpy,&event);
	  n -= 1;
	}
	redrawflag = 1;
	break;
      }
      if (pflag == 1) printf("DONE event 1\n");
    }
    if (mod_gui_win_init == 1){ 
      redrawflag = 1;
      mod_gui_win_init = 0;
    }
    if (XCheckIfEvent(mg->win2->dpy,&event,my_true_test,(char *)NULL)){
      redraw2 = mod_gui_view_layer_event2(laylist,npl,mg->laylab,event);
      glplot_util_make_current(dpy,win,mg->win1->cx);
      if (glob_flag_rev_map != 0)
	redrawflag = 1; 
    }
    if ((m->run_mode == 2) && (mgs->replay_ti < mgs->replay_tn)){
      mod_gui_draw_grid_replay(mgs->gcurr,mg->pl,1.0,mg->colormapflag);
      mgs->replay_ti += 1;
      glXSwapBuffers(dpy,win);
    }else if ((redrawflag) || (redraw2)){
      if (redrawflag){
	mod_gui_draw_grid_laylist(laylist,npl,mg->curi,mg->ci,mg->cj,
				    mg->colormapflag,mg->laylab);
	glXSwapBuffers(dpy,win);
      }
      if (pflag) printf("_______________ win2 ____________________________\n");
      if (mg->stimflag > 0){
	if (mg->stimflag == 1){
	  sprintf(tstr,"  stimulus %d/%d   frame %d/%d    LEFT",mg->stimno,
		  mg->nstim,mg->sdn,mg->tn);
	}else{
	  sprintf(tstr,"  stimulus %d/%d   frame %d/%d    RIGHT",mg->stimno,
		  mg->nstim,mg->sdn,mg->tn);
	}
	mod_gui_update_laylab(&(mg->laylab->w2_coord),tstr);
      }
      glplot_util_make_current(mg->win2->dpy,mg->win2->win,mg->win2->cx);
      if ((mg->targflag_lgn) && (pop_util_lclass_is_rgci(mg->tl) == 0)){
	if ((mg->stimflag == 1) || (mg->stimflag == 2)){
	  mod_gui_draw_grid_stim();
	}else{
	  if (mg->overlay_flag == 0)
	    mod_gui_draw_grid_gray(mg->tl);
	}
	if (mg->drawcon == 1){ 
	  mod_gui_draw_grid_conn(mg->pl,mg->laylab,mg->ci,mg->cj,mg->ck,mg->tl,
				 mg->cprob,cpflag);
	  cpflag = 0;
	}else{ 
	  mod_gui_draw_grid_conn(mg->pl,mg->laylab,-1,-1,-1,mg->tl,
				 mg->cprob,cpflag);
	  cpflag = 0;
	}
      }else if ((mg->stimflag == 1) || (mg->stimflag == 2)){
	mod_gui_draw_grid_stim();
      }else if (mg->drawcon == 1){
	mod_gui_draw_syn_conn(mg->pl,mg->ci,mg->cj,mg->ck,mg->tl,1,
			      mg->synnorm,mg->laylab,mg->colormapflag);
      }else if (mg->drawcon == 2){
	mod_gui_draw_syn_conn(mg->pl,mg->ci,mg->cj,mg->ck,mg->tl,0,
			      mg->synnorm,mg->laylab,mg->colormapflag);
      }
      if (mg->drawcon == 4){
	if (mg->draw_level == 1){
	  mod_gui_draw_rf_grid(mg->pl,mg->laylab,mg->ci,mg->cj,mg->ck);
	}else{
	  mod_gui_draw_aggregate_grid(mg->pl,mg->ci,mg->cj,mg->ck,
				      mg->opl->name,mg->laylab,
				      mg->targflag_eye);
	}
      }
      if (mg->drawcon == 1){
	glplot_set_window_name(mg->win2->dpy,mg->win2->win,"pre-synaptic");
      }else if (mg->drawcon == 2){
	glplot_set_window_name(mg->win2->dpy,mg->win2->win,"post-synaptic");
      }
      mod_gui_update_laylab(&(mgs->laylab->w2_layname),mgs->tl->name);
      mod_gui_draw_labels_w2(mg->laylab);
      glXSwapBuffers(mg->win2->dpy,mg->win2->win);
      glplot_util_make_current(dpy,win,mg->win1->cx);
      redrawflag = 0;
      redraw2 = 0;
    }
    mod_gui_winw = winw;
    mod_gui_winh = winh;
  }
  if (mg->sdata != NULL){
    if (pflag == 1) printf("    Freeing sdata tensor\n");
    free_f3tensor(mg->sdata,1,mg->xn,1,mg->yn,1,mg->tn);
  }
  if (mg->sdata_r != NULL){
    if (pflag == 1) printf("    Freeing sdata_r tensor\n");
    free_f3tensor(mg->sdata_r,1,mg->xn,1,mg->yn,1,mg->tn);
  }
}
void mod_gui_pop_main(laylist,nlay,mpt,m,s,r)
     struct pop_layer **laylist;  
     int nlay;                    
     struct pop_top *mpt;         
     struct model_struct *m;      
     struct stim_struct *s;       
     struct response_struct *r;   
{
  int done;
  printf("  MOD_GUI_POP_MAIN\n");
  if (mgs == NULL){
    mod_gui_view_layer_init(laylist,nlay,mpt,m,s,r); 
  }
  done = 0;
  while(!done){
    mod_gui_view_layer(laylist,nlay,m,s,r);
    if (m->run_mode == 1){
      if (mgs->stimno != -1){
	s->stimno = mgs->stimno;
      }
    }
    if ((m->run_mode == 1) && (mgs->mon_state == -1)){
      mod_mon_init(m,r,s,laylist,nlay,"monitor");
      glplot_set_window_focus(mgs->win1->dpy,mgs->win1->win);
      mgs->mon_state = 0;  
    }
    if (mgs->run_state == 1)
      done = 1;
    if (m->run_mode == 0)
      done = 1;
  }
}
void mod_gui_view_cones(s,xn,yn,tn,sscale,tscale,cx,cy,cid,cn,sz,szt,outid,
			sumsd,sumsdmin,gcs_code,gcs_distr,rpyd,rpytn,
			win_w,win_h,win_title)
     struct stim_struct *s;       
     int xn,yn;      
     int tn;         
     float sscale;   
     float tscale;   
     float *cx,*cy;  
     int *cid;       
     int cn;         
     float sz;       
     float szt;      
     int outid;      
     float sumsd,sumsdmin;
     int gcs_code;   
     int gcs_distr;  
     float **rpyd;   
     int rpytn;      
     int win_w,win_h;  
     char *win_title;  
{
  int i;
  int redrawflag,winw,winh,gw,gh,gk,pn,icenter,stimflag;
  int gridflag,sumsd_flag,truesize_flag;
  float cfx0,cfy0,cfw,cfh,gdx,gdy,gx0,gy0,winfrac,dsz;
  XEvent event;
  XKeyEvent *kevent;
  XWindowAttributes xwa;
  char kbuf[10],tstr[SLEN],fname[SLEN];
  KeySym ks;
  char colbuf[3] = {'S','M','L'};
  Display *dpy;
  Window win;
  float ***sdata;    
  int ***c3data;     
  int sdn;           
  struct gui_gpar *gp;
  int cnt = 0;
  mod_gui_winw = win_w;  
  mod_gui_winh = win_h;  
  pn = 12;              
  gridflag = 0;         
  sumsd_flag = 0;       
  truesize_flag = 0;    
  dsz = sz;             
  stimflag = 0;         
  printf("  MOD_GUI_VIEW_CONES\n");
  if (cn < 1)
    exit_error("MOD_GUI_VIEW_CONES","No cones");
  mod_gui_init(win_title); 
  glplot_util_make_current(mod_gui_dpy,mod_gui_win,mod_gui_cx);
  dpy = mod_gui_dpy;
  win = mod_gui_win;
  cfx0 = cfy0 = -1.0;
  cfw = cfh = 2.0;
  if (s == NULL){
    sdata = NULL;
    sdn = -1;
  }else{
    float stim_samp;
    int tsamp,nrpt,nstim;
    char *stimtype,*stimform;
    sdn = 0;
    stim_samp = paramfile_get_float_param_or_exit(s->ppl,"stim_samp");
    tsamp = my_rint(1.0/(tscale*stim_samp)); 
    if (tsamp <= 0)
      tsamp = 1; 
    stimtype = paramfile_get_char_param_or_exit(s->ppl,"stim_type");
    nrpt = paramfile_get_int_param_or_exit(s->ppl,"stim_nrpt");
    nstim = s->ntr / nrpt;
    stimform = paramfile_get_char_param_default(s->ppl,"stim_form","3d");
    if (strcmp(stimform,"3d")==0){
      sdata = get_stim_3d_ppl(NULL,s,xn,yn,tn,sscale,tscale,tsamp);
      c3data = NULL;
    }else if (strcmp(stimform,"3c")==0){
      c3data = get_stim_3c_ppl(NULL,stimtype,s->ppl,xn,yn,tn,
			       sscale,tscale,tsamp);
      sdata = NULL;
    }else{
      printf("*** STIMFORM = %s, not implemented\n",stimform);
      sdata = NULL;
    }
  }
  gw = xn;
  gh = yn;
  winfrac = 0.90;
  mod_gr_get_grid_params(gw,gh,cfx0,cfy0,cfw,cfh,winfrac,&gx0,&gy0,&gdx,&gdy);
  gp = (struct gui_gpar *)myalloc(sizeof(struct gui_gpar));
  gp->xn = xn;
  gp->yn = yn;
  gp->x0 = gx0;
  gp->y0 = gy0;
  gp->gdx = gdx;
  gp->gdy = gdy;
  gp->dx = gdx;
  gp->dy = gdy;
  gp->bw = gdx * 0.9;  
  gp->bh = gdy * 0.9;  
  gp->oddxoff = 0.0;
  mod_gui_draw_cones_on_grid(gw,gh,gx0,gy0,gdx,gdy,cx,cy,cid,cn,sz,pn);
  glXSwapBuffers(dpy,win);
  XGetWindowAttributes(dpy,win,&xwa);
  winw = xwa.width; winh = xwa.height;
  gk = -1;
  redrawflag = 0;
  while(1){
    usleep(1000); 
    if (XCheckIfEvent(dpy,&event,my_true_test,(char *)NULL)){
      switch(event.type){
      case ButtonPress:
	switch(event.xbutton.button){
	case 1:
	  mod_gui_get_index_for_coord(event.xbutton.x,event.xbutton.y,
				      winw,winh,-1.0,-1.0,2.0,2.0,
				      gx0,gy0,gw,gh,gdx,gdy,cx,cy,cn,sz,&gk);
	  if (gk != -1){
	    printf("  Cone %d  %c\n",gk,colbuf[cid[gk]]);
	  }
	  break;
	case 2:
	  mod_gui_get_index_for_coord(event.xbutton.x,event.xbutton.y,
				      winw,winh,-1.0,-1.0,2.0,2.0,
				      gx0,gy0,gw,gh,gdx,gdy,cx,cy,cn,sz,&gk);
	  if (gk != -1){
	    cid[gk] += 1;
	    if (cid[gk] > 2)
	      cid[gk] = 0;
	    redrawflag = 1;
	    printf("  Cone %d\n",gk);
	  }
	  break;
	case 3:
	  break;
	}
	break;
      case MotionNotify:
	break;
      case KeyPress:
	kevent = (XKeyEvent *)&event;
	XLookupString(kevent,kbuf,sizeof(kbuf),&ks,NULL);
	if (kbuf[0]==' '){
	  gridflag = 1 - gridflag;
	  redrawflag = 1;
	}else if ((kbuf[0]=='h')||(kbuf[0]=='?')){
	  mod_gui_view_cones_help();
	}else if (kbuf[0]=='q'){
	  glplot_shutdown(mod_gui_dpy,mod_gui_win,mod_gui_cx,1);
	  return;
	}else if (kbuf[0]=='S'){
	  strcpy(fname,"zz.mosaic.txt");
	  printf("    Saving mosaic to file %s\n",fname);
	  remove_file(fname);
	  for(i=0;i<cn;i++){
	    sprintf(tstr,"%f %f %c\n",cx[i],cy[i],colbuf[cid[i]]);
	    append_string_to_file(fname,tstr);
	  }
	}else if (kbuf[0]=='r'){
	  if (rpyd == NULL)
	    printf("  No replay data\n");
	  else{
	    mod_gui_cone_replay(dpy,win,rpyd,rpytn,gw,gh,gx0,gy0,gdx,gdy,
				cx,cy,cid,cn,dsz,pn);
	  }
	}else if (kbuf[0]=='s'){
	  stimflag = 1 - stimflag;
	  redrawflag = 1;
	}else if (kbuf[0]=='t'){
	  truesize_flag = 1 - truesize_flag;
	  if (truesize_flag){
	    printf("    True size on.\n");
	    dsz = szt;
	  }else{
	    printf("    True size off.\n");
	    dsz = sz;
	  }
	  redrawflag = 1;
	}else if (kbuf[0]=='w'){
	  sumsd_flag = 1 - sumsd_flag;
	  redrawflag = 1;
	}else if (kbuf[0]=='x'){
	  exit(0);
	}else if (ks==65361){      
	  if (stimflag > 0){
	    sdn -= 1;
	    if (sdn < 0)
	      sdn = tn-1;
	  }
	  printf("  frame %4d of %d\n",sdn,tn);
	  redrawflag = 1;
	}else if (ks==65363){      
	  if (stimflag > 0){
	    sdn += 1;
	    if (sdn >= tn)
	      sdn = 0;
	  }
	  printf("  frame %4d of %d\n",sdn,tn);
	  redrawflag = 1;
	}
	break;
      case ConfigureNotify:
	mod_gui_get_last_event_of_type(dpy,ConfigureNotify,&event);
	glViewport(0,0,event.xconfigure.width,event.xconfigure.height);
	winw = event.xconfigure.width;
	winh = event.xconfigure.height;
	redrawflag = 1;
	break;
      case Expose:
	redrawflag = 1;
	break;
      }
    }
    if (redrawflag){
      glClearColor(0.0,0.0,0.0,0.0);
      glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
      if ((stimflag == 1) && (sdata != NULL)){
	mod_gui_draw_grid_stim_frame(gp,sdata,sdn);
      }else if ((stimflag == 1) && (c3data != NULL)){
	mod_gui_draw_grid_stim_frame_c3(gp,c3data,sdn);
      }else{
	if (sumsd_flag == 1){
	  icenter = gk;
	  if (icenter < 0)
	    icenter = 0;
	  mod_gui_draw_cones_on_grid_sumsd(gw,gh,gx0,gy0,gdx,gdy,cx,cy,cid,cn,
					   sz,pn,icenter,sumsd,sumsdmin,
					   gcs_code,gcs_distr);
	}else
	  mod_gui_draw_cones_on_grid(gw,gh,gx0,gy0,gdx,gdy,cx,cy,cid,cn,dsz,pn);
	mod_gr_draw_poly(gw,gh,gx0,gy0,gdx,gdy,cx[outid]+0.5,cy[outid]+0.5,
			  sz/2.0,pn,1.0,1.0,1.0);
	if (gridflag)
	  mod_gui_draw_grid_lines(gw,gh,gx0,gy0,gdx,gdy,0.4,0.4,0.4);
      }
      glXSwapBuffers(dpy,win); 
      redrawflag = 0;
    }
  }
}
