/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <GL/glx.h>
#include <GL/gl.h>  
#include "my_util.h"
#include "nr_util.h"
#include "carray_util.h"
#include "iarray_util.h"
#include "farray_util.h"
#include "func_util.h"
#include "myrand_util.h"
#include "data_util.h"
#include "ndata_util.h"
#include "paramfile_util.h"
#include "glplot_util.h"
#include "retina_util.h"
#include "stim_util.h"
#include "mod_util.h"
#include "ifc_util.h"
#include "mod_gui_util.h"
#include "pop_cell_util.h"
#include "pop_util.h"
#include "ifc.h"
#include "mod.h"
#include "paramfile.h"
#include "ndata.h"
static int myid = -1;       
static char *mylogf = NULL; 
char ggstr[LONG_SLEN];      
int   mod_wav_xn;          
int   mod_wav_yn;          
int   mod_wav_zn;          
int   mod_wav_tn;          
double mod_wav_tscale;     
float mod_wav_sscale;      
int   mod_wav_reset_time;  
int   mod_wav_tt;          
int   mod_wav_seed;        
int   mod_wav_spike_full;  
float mod_wav_umpix;       
float mod_wav_am_tau;      
float mod_wav_am_fc;       
float mod_wav_am_rad;      
float mod_wav_am_thr;      
float mod_wav_gc_tau;      
float mod_wav_gc_fc;       
float mod_wav_gc_rad;      
float mod_wav_gc_thr;      
int   mod_wav_gc_sgen_n;   
float mod_wav_gc_rate;     
int   mod_wav_gc_seed;     
float mod_wav_gc_prob;     
int ****mod_wav_gc_spk;    
int  ***mod_wav_gc_cnt;    
int    mod_wav_gc_smax;    
float  mod_wav_gc_samp;    
float mod_wav_refr_mu;     
float mod_wav_refr_sd;     
int   mod_wav_refr_seed;   
int **mod_wav_refr_am;     
float mod_wav_spont_prob;  
float mod_wav_act_dur;     
int   mod_wav_act_durn;    
float mod_wav_pop_delay;   
float **mod_wav_x_am;      
float **mod_wav_x_gc;      
float **mod_wav_synin;     
int   **mod_wav_am_state;  
int  **mod_wav_con_aa_n;   
int ***mod_wav_con_aa_x;   
int ***mod_wav_con_aa_y;   
float mod_wav_init_blank;  
#define IM1 2147483563
#define IM2 2147483399
#define AM (1.0/IM1)
#define IMM1 (IM1-1)
#define IA1 40014
#define IA2 40692
#define IQ1 53668
#define IQ2 52774
#define IR1 12211
#define IR2 3791
#define NTAB 32
#define NDIV (1+IMM1/NTAB)
#define EPS 1.2e-7
#define RNMX (1.0-EPS)
/*C  (C) Copr. 1986-92 Numerical Recipes Software #.3.                       */
float mod_wav_util_ran2(idum)
     int *idum; 
{
  int j;
  int k; 
  static int idum2=123456789; 
  static int iy=0; 
  static int iv[NTAB]; 
  float temp;
  if (*idum <= 0) {
    if (-(*idum) < 1) *idum=1;
    else *idum = -(*idum);
    idum2=(*idum);
    for (j=NTAB+7;j>=0;j--) {
      k=(*idum)/IQ1;
      *idum=IA1*(*idum-k*IQ1)-k*IR1;
      if (*idum < 0) *idum += IM1;
      if (j < NTAB) iv[j] = *idum;
    }
    iy=iv[0];
  }
  k=(*idum)/IQ1;
  *idum=IA1*(*idum-k*IQ1)-k*IR1;
  if (*idum < 0) *idum += IM1;
  k=idum2/IQ2;
  idum2=IA2*(idum2-k*IQ2)-k*IR2;
  if (idum2 < 0) idum2 += IM2;
  j=iy/NDIV;
  iy=iv[j]-idum2;
  iv[j] = *idum;
  if (iy < 1) iy += IMM1;
  if ((temp=AM*iy) > RNMX) return RNMX;
  else return temp;
}
#undef IM1
#undef IM2
#undef AM
#undef IMM1
#undef IA1
#undef IA2
#undef IQ1
#undef IQ2
#undef IR1
#undef IR2
#undef NTAB
#undef NDIV
#undef EPS
#undef RNMX
void mod_wav_make_conn_list_rad(xn,yn,rad,rx,ry,rn)
     int xn,yn;           
     float rad;           
     int ****rx,****ry;   
     int ***rn;           
{
  int i,j,ii,jj;
  int ***x,***y,**n,*tx,*ty,cn;
  int ir,r2,d2,x0,x1,y0,y1;
  mylog(mylogf,"  MOD_WAV_MAKE_CONN_LIST_RAD\n");
  printf("    xn %d\n",xn);
  printf("    yn %d\n",yn);
  printf("    rad %f\n",rad);
  n = get_zero_2d_iarray(xn,yn);
  x = get_2d_pointer_iarray(xn,yn);
  y = get_2d_pointer_iarray(xn,yn);
  ir = my_rint(rad + 0.999);    
  r2 = my_rint(rad*rad);        
  tx = (int *)myalloc(xn*yn*sizeof(int));
  ty = (int *)myalloc(xn*yn*sizeof(int));
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      x0 = i - ir;
      x1 = i + ir;
      if (x0 < 0)    x0 = 0;
      if (x1 >= xn)  x1 = xn-1;
      y0 = j - ir;
      y1 = j + ir;
      if (y0 < 0)    y0 = 0;
      if (y1 >= yn)  y1 = yn-1;
      cn = 0;
      for(ii=x0;ii<=x1;ii++){
	for(jj=y0;jj<=y1;jj++){
	  d2 = (ii-i)*(ii-i) + (jj-j)*(jj-j);
	  if (d2 <= r2){
	    tx[cn] = ii;
	    ty[cn] = jj;
	    cn += 1;
	  }
	}
      }
      x[i][j] = copy_iarray(tx,cn);
      y[i][j] = copy_iarray(ty,cn);
      n[i][j] = cn;
    }
  }
  myfree(tx);
  myfree(ty);
  *rx = x;
  *ry = y;
  *rn = n;
}
void mod_wav_debug_write_conn_image(xi,yi)
     int xi,yi;  
{
  int i;
  int xn,yn,nbytes,tcode,transpose,pflag;
  int **data,*tcx,*tcy,tcn;
  xn = mod_wav_xn;
  yn = mod_wav_yn;
  data = get_zero_2d_iarray(xn,yn);  
  tcx = mod_wav_con_aa_x[xi][yi];
  tcy = mod_wav_con_aa_y[xi][yi];
  tcn = mod_wav_con_aa_n[xi][yi];
  for(i=0;i<tcn;i++){
    data[tcx[i]][tcy[i]] += 1;
  }
  nbytes = 4;
  tcode = 1;  
  transpose = 1;  
  pflag = 0;
  write_2d_data("zz.conn.2d",data,0,0,xn,yn,nbytes,tcode,transpose,pflag);
  free_2d_iarray(data,xn);
}
void mod_wav_fbars_make_mpt(m,s,r)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
{
  int i,j,k;
  int stype,xn,yn,*ctx,*cty,ctn;
  short inindex;
  float w,tdelay;
  struct pop_top *mpt;
  struct pop_layer *pl;
  struct pop_syn *tsyn;
  struct pop_cell *pre,*post;
  struct onode *ot,*o;
  mylog(mylogf,"  MOD_WAV_FBARS_MAKE_MPT\n");
  mpt = (struct pop_top *)myalloc(sizeof(struct pop_top));
  if  (mylogf == NULL){
    mpt->logf = NULL;
  }else
    mpt->logf = strdup(mylogf);
  mpt->tscale = onode_getpar_flt_exit(m->o,"tscale");
  mpt->sscale = onode_getpar_flt_exit(m->o,"sscale");
  mpt->xn = onode_getpar_int_exit(m->o,"xn");
  mpt->yn = onode_getpar_int_exit(m->o,"yn");
  mpt->tn = onode_getpar_int_exit(m->o,"tn");
  mpt->x1 = 0.0;
  mpt->x2 = mpt->tscale * (float)mpt->tn;
  mpt->out_prefix = NULL;
  if (r != NULL){
    if (r->ppl != NULL)
      mpt->out_prefix = param_getc_dflt(r->ppl,"outfile","zz");
  }
  mpt->binoc = 0;   
  mpt->retflag = 0; 
  mpt->conn_rw = NULL;
  mpt->conn_read_dir = NULL;
  mpt->narea = 0;
  mpt->area = NULL;
  mpt->nmap = 0;
  mpt->map = NULL;
  mpt->nlay = 2;
  mpt->lay = (struct pop_layer **)myalloc(mpt->nlay*
					  sizeof(struct pop_layer *));
  pl = popu_make_layer_cart("amacrine",mpt->xn,mpt->yn,1);
  pl->geomt = strdup("default");
  pl->x0 = pl->y0 = 0.0;
  pl->xf = pl->yf = 1.0;
  mpt->lay[0] = pl;
  mpt->lay[0]->ninlist = 1;
  mpt->lay[0]->inlist = (struct onode **)myalloc(sizeof(struct onode *));
  ot = paramfile_onode_create_onode();
  ot->otype = strdup("input");
  o = paramfile_onode_get_init_onode("item",NULL,"pop_origin","amacrine",
				     1,NULL,NULL,1);
  onode_insert_child_at_end(ot,o);
  mpt->lay[0]->inlist[0] = ot;
  pl = popu_make_layer_cart("rgc",mpt->xn,mpt->yn,1);
  pl->geomt = strdup("default");
  pl->x0 = pl->y0 = 0.0;
  pl->xf = pl->yf = 1.0;
  mpt->lay[1] = pl;
  mpt->lay[1]->ninlist = 1;
  mpt->lay[1]->inlist = (struct onode **)myalloc(sizeof(struct onode *));
  ot = paramfile_onode_create_onode();
  ot->otype = strdup("input");
  o = paramfile_onode_get_init_onode("item",NULL,"pop_origin","amacrine",
				     1,NULL,NULL,1);
  onode_insert_child_at_end(ot,o);
  mpt->lay[1]->inlist[0] = ot;
  stype = 1;
  tdelay = 0.0;
  inindex = 0;
  w = 1.0;
  xn = mod_wav_xn;
  yn = mod_wav_yn;
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){  
      pre = &(mpt->lay[0]->c[i][j][0]);
      ctx = mod_wav_con_aa_x[i][j];   
      cty = mod_wav_con_aa_y[i][j];   
      ctn = mod_wav_con_aa_n[i][j];   
      for(k=0;k<ctn;k++){
	post = &(mpt->lay[0]->c[ctx[k]][cty[k]][0]);
	tsyn = pop_cell_add_synapse(pre,post,stype,w,tdelay,inindex);
	post = &(mpt->lay[1]->c[ctx[k]][cty[k]][0]);
	tsyn = pop_cell_add_synapse(pre,post,stype,w,tdelay,inindex);
      }
    }
  }
  popu_mar_write(mpt,m->marfile,4);  
}
void mod_wav_fbars_prep(m,s,r)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
{
  int i,j;
  int xn,yn,zn,seed,tau_ti,nunits;
  float rad_pix,sr,rmu,rsd;
  mylog(mylogf,"  MOD_WAV_FBARS_PREP\n");
  m->run_mode = 8; 
  mod_wav_xn         = onode_getpar_int_exit(m->o,"xn");
  mod_wav_yn         = onode_getpar_int_exit(m->o,"yn");
  mod_wav_zn         = onode_getpar_int_exit(m->o,"zn");  
  mod_wav_tn         = onode_getpar_int_exit(m->o,"tn");
  mod_wav_tscale     = onode_getpar_dbl_exit(m->o,"tscale");
  mod_wav_sscale     = onode_getpar_flt_exit(m->o,"sscale");
  mod_wav_umpix      = onode_getpar_flt_exit(m->o,"um_per_pix");
  mod_wav_am_tau     = onode_getpar_flt_exit(m->o,"am_tau");
  mod_wav_am_rad     = onode_getpar_flt_exit(m->o,"am_input_rad");
  mod_wav_am_thr     = onode_getpar_flt_exit(m->o,"am_thresh");
  mod_wav_gc_tau     = onode_getpar_flt_exit(m->o,"gc_tau");
  mod_wav_gc_rad     = onode_getpar_flt_exit(m->o,"gc_input_rad");
  mod_wav_gc_thr     = onode_getpar_flt_exit(m->o,"gc_thresh");
  mod_wav_gc_rate    = onode_getpar_flt_exit(m->o,"gc_rate_active");
  mod_wav_gc_seed    = onode_getpar_int_exit(m->o,"gc_spike_seed");
  mod_wav_refr_mu    = onode_getpar_flt_exit(m->o,"refract_mean");
  mod_wav_refr_sd    = onode_getpar_flt_exit(m->o,"refract_sd");
  mod_wav_refr_seed  = onode_getpar_int_exit(m->o,"refract_seed");
  sr                 = onode_getpar_flt_exit(m->o,"spontaneous_rate");
  mod_wav_act_dur    = onode_getpar_flt_exit(m->o,"activation_dur");
  mod_wav_pop_delay  = onode_getpar_flt_dflt(m->o,"population_delay",0.0);
  mod_wav_init_blank = onode_getpar_flt_dflt(m->o,"initial_blank",0.0); 
  mod_wav_act_durn   = my_rint(mod_wav_act_dur / mod_wav_tscale);
  mod_wav_spont_prob = sr * mod_wav_tscale;  
  printf("    act_durn = %d\n",mod_wav_act_durn);
  printf("    spont_prob = %f\n",mod_wav_spont_prob);
  mod_wav_tt = 0;  
  mod_wav_reset_time = 1; 
  tau_ti = mod_wav_am_tau / mod_wav_tscale;  
  mod_wav_am_fc  = exp(-1.0/tau_ti);
  printf("    _am_fc = %f\n",mod_wav_am_fc);
  tau_ti = mod_wav_gc_tau / mod_wav_tscale;  
  mod_wav_gc_fc  = exp(-1.0/tau_ti);
  printf("    _gc_fc = %f\n",mod_wav_gc_fc);
  xn = mod_wav_xn;
  yn = mod_wav_yn;
  zn = mod_wav_zn;  
  mod_wav_x_am     = get_zero_2d_farray(xn,yn);
  mod_wav_x_gc     = get_zero_2d_farray(xn,yn);
  mod_wav_synin    = get_zero_2d_farray(xn,yn);
  mod_wav_am_state = get_zero_2d_iarray(xn,yn);
  seed = mod_wav_refr_seed;
  if (seed > 0)
    seed *= -1;
  rmu = mod_wav_refr_mu / mod_wav_tscale;
  rsd = mod_wav_refr_sd / mod_wav_tscale;
  printf("    rmu = %f\n",rmu);
  printf("    rsd = %f\n",rsd);
  mod_wav_refr_am = get_zero_2d_iarray(xn,yn);
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      mod_wav_refr_am[i][j] = my_rint(rmu + rsd * nr_util_gasdev(&seed));
      if (mod_wav_refr_am[i][j] < 0)
	mod_wav_refr_am[i][j] = 0;
    }
  }
  rad_pix = mod_wav_am_rad / mod_wav_umpix;
  mod_wav_make_conn_list_rad(xn,yn,rad_pix,
			     &mod_wav_con_aa_x,
			     &mod_wav_con_aa_y,
			     &mod_wav_con_aa_n);
  nunits = mod_wav_xn * mod_wav_yn * mod_wav_zn;
  mod_wav_gc_smax = 50000000 / nunits; 
  if (mod_wav_gc_smax > 10000){
    mod_wav_gc_smax = 10000;
  }
  printf("    Maximum number of spikes/unit per trial:  %d\n",mod_wav_gc_smax);
  mod_wav_gc_cnt = get_zero_3d_iarray(mod_wav_zn,mod_wav_xn,mod_wav_yn);
  mod_wav_gc_spk = (int ****)myalloc(zn*sizeof(int ***));
  for (i=0;i<zn;i++)
    mod_wav_gc_spk[i] = get_3d_iarray(mod_wav_xn,mod_wav_yn,mod_wav_gc_smax);
  mod_wav_gc_samp = 1000.0;
  mod_wav_gc_sgen_n = my_rint(mod_wav_gc_samp * mod_wav_tscale);
  printf("    Number of spike sampling units per time step:  %d\n",
	 mod_wav_gc_sgen_n);
  mod_wav_gc_smax -= mod_wav_gc_sgen_n;
  mod_wav_gc_prob = mod_wav_gc_rate / mod_wav_gc_samp;
  if (mod_wav_gc_seed > 0){
    mod_wav_gc_seed = -mod_wav_gc_seed;
  }
  if ((m->action == 10) && (m->marfile != NULL)){
    mod_wav_fbars_make_mpt(m,s,r);
    return;
  }
}
void mod_wav_fbars_done()
{
  mylog(mylogf,"  MOD_WAV_FBARS_DONE\n");
}
void mod_wav_write_ndata()
{
  int i,j,k,pi;
  int n,nchan,ti;
  struct ndata_struct *nd;
  char tstr[SLEN];
  printf("  MOD_WAV_WRITE_NDATA\n");
  nd = get_ndata();
  nd->class = strdup("MODEL");
  nchan = mod_wav_xn * mod_wav_yn * mod_wav_zn;
  nd->nconst = 0; 
  nd->nvar = 0; 
  nd->ntable = 0;
  n = 1;
  nd->ntrial = n;
  nd->t = (struct ndtrial_struct *)myalloc(n*sizeof(struct ndtrial_struct));
  ti = 0; 
  nd->t[ti].tcode = i; 
  nd->t[ti].tref = 0;
  nd->t[ti].nparam = nd->nvar;  
  nd->t[ti].pname = NULL;
  nd->t[ti].pval = NULL;
  nd->t[ti].nrec = nchan;
  nd->t[ti].r = (struct ndrec_struct *)myalloc(nd->t[ti].nrec*
						 sizeof(struct ndrec_struct));
  k = 0;
  for(pi=0;pi<mod_wav_zn;pi++){  
    for(i=0;i<mod_wav_xn;i++){
      for(j=0;j<mod_wav_yn;j++){
	sprintf(tstr,"rgc_%d_%d",i,j);
	nd->t[ti].r[k].name = strdup(tstr);
	nd->t[ti].r[k].rcode = 0;
	nd->t[ti].r[k].sampling = mod_wav_gc_samp;
	nd->t[ti].r[k].t0 = 0;
	nd->t[ti].r[k].tn = 200000; 
	nd->t[ti].r[k].rtype = 0;
	nd->t[ti].r[k].n = mod_wav_gc_cnt[pi][i][j];
	nd->t[ti].r[k].p = mod_wav_gc_spk[pi][i][j];
	k += 1;
      }
    }
  }
  write_ndata("zz.wav.nd",nd);
}
void mod_wav_make_spikes(ti,xi,yi,zi)
     int ti;  
     int xi;  
     int yi;  
     int zi;  
{
  int i;
  int n,tn,*ts,t,delay;
  t = (ti - mod_wav_tt) * mod_wav_gc_sgen_n;  
  ts = mod_wav_gc_spk[zi][xi][yi];
  tn = mod_wav_gc_cnt[zi][xi][yi];
  delay = my_rint(mod_wav_pop_delay * (float)mod_wav_gc_sgen_n /
		  mod_wav_tscale);
  for(i=0;i<mod_wav_gc_sgen_n;i++){
    if (mod_wav_gc_prob > mod_wav_util_ran2(&mod_wav_gc_seed)){
      ts[tn] = t + i + (zi * delay);
      tn += 1;
      if (tn >= mod_wav_gc_smax){
	mod_wav_spike_full = 1;  
      }
    }
  }
  mod_wav_gc_cnt[zi][xi][yi] = tn;  
}
void mod_wav_fbars_get_response(m,s,r)
     struct model_struct *m;        
     struct stim_struct *s;         
     struct response_struct *r;     
{
  int i,j,k;
  int ti,xn,yn,zn,tn,*ctx,*cty,ctn,actn,**am_state,xi,yi,zi,ns,rmu,rsd,seed;
  int cnt_re,cnt_actnew,cnt_spont,done;
  float amfc,amthr,**xam,**xgc,**syn,***amr;
  float gcfc,gcthr;
  mylog(mylogf,"  MOD_WAV_FBARS_GET_RESPONSE\n");
  xn = mod_wav_xn;
  yn = mod_wav_yn;
  zn = mod_wav_zn;
  tn = mod_wav_tn;
  xam = mod_wav_x_am;
  xgc = mod_wav_x_gc;
  syn = mod_wav_synin;
  am_state = mod_wav_am_state;
  amthr = mod_wav_am_thr;
  amfc  = mod_wav_am_fc;
  gcthr = mod_wav_gc_thr;
  gcfc  = mod_wav_gc_fc;
  actn  = mod_wav_act_durn;  
  rmu = mod_wav_refr_mu / mod_wav_tscale;
  rsd = mod_wav_refr_sd / mod_wav_tscale;
  seed = mod_wav_refr_seed;
  if (seed>0)
    seed *= -1;
  mod_wav_spike_full = 0;
  if (mod_wav_tt == 0){
    mod_wav_seed = m->mseed[r->tsi];  
    if (mod_wav_seed > 0)
      mod_wav_seed = -mod_wav_seed;
    for(i=0;i<xn;i++){
      for(j=0;j<yn;j++){
	xam[i][j] = 0.0;
	xgc[i][j] = 0.0;
	am_state[i][j] = 0;
      }
    }
  }
  for(k=0;k<zn;k++){
    for(i=0;i<xn;i++){
      for(j=0;j<yn;j++){
	mod_wav_gc_cnt[k][i][j] = 0;
      }
    }
  }
  ti = mod_wav_tt;
  if (ti < tn)
    done = 0;
  else
    done = 1;
  while(done == 0){
    for(i=0;i<xn;i++){  
      for(j=0;j<yn;j++){
	syn[i][j] = 0.0;
      }
    }
    cnt_re = cnt_actnew = cnt_spont = 0;
    for(i=0;i<xn;i++){
      for(j=0;j<yn;j++){
	if (am_state[i][j] == 0){  
	  if (xam[i][j] > amthr){
	    am_state[i][j] = actn;  
	    cnt_actnew += 1;
	  }else{
	    if (mod_wav_spont_prob > myrand_util_ran2(&mod_wav_seed)){
	      am_state[i][j] = actn;
	      cnt_spont += 1;
	    }
	  }
	}else if (am_state[i][j] < 0){  
	  am_state[i][j] += 1;
	}
	if (am_state[i][j] > 0){
	  ctx = mod_wav_con_aa_x[i][j];   
	  cty = mod_wav_con_aa_y[i][j];   
	  ctn = mod_wav_con_aa_n[i][j];   
	  for(k=0;k<ctn;k++){
	    syn[ctx[k]][cty[k]] += 1.0;   
	  }
	  am_state[i][j] -= 1;            
	  if (am_state[i][j] == 0){
	    am_state[i][j] = -my_rint(rmu + rsd * nr_util_gasdev(&seed));
	    if (am_state[i][j] > 0)
	      am_state[i][j] = 0;
	    cnt_re += 1;
	  }
	}
      }
    }
    for(i=0;i<xn;i++){
      for(j=0;j<yn;j++){
	xam[i][j] = xam[i][j] * amfc  + syn[i][j];
	xgc[i][j] = xgc[i][j] * gcfc  + syn[i][j];
	if (ti >= my_rint(mod_wav_init_blank/mod_wav_tscale)){
	  if (xgc[i][j] > gcthr){
	    for (k=0;k<zn;k++){  
	      mod_wav_make_spikes(ti,i,j,k); 
	    }
	  }
	}
      }
    }
    ti += 1;
    if (ti >= tn)
      done = 1;    
    if (mod_wav_spike_full == 1)
      done = 1;          
  }
  for(i=0;i<r->n;i++){
    if (strcmp(r->plname[i],"gc")==0){
      xi = r->xi[i];
      yi = r->yi[i];
      zi = r->zi[i];
      ns = mod_wav_gc_cnt[zi][xi][yi];
      r->s[i][0] = i2farray(mod_wav_gc_spk[zi][xi][yi],ns);
      r->cnt[i][0] = ns;
    }else{
      printf("  r->plname[%d] = %s\n",i,r->plname[i]);
      exit_error("MOD_WAV_...","Unexpected response request");
    }
  }
  r->ttref = (double)mod_wav_tt * mod_wav_tscale;  
  r->ts0 = 0.0;
  r->tsn = (double)(ti - mod_wav_tt) * mod_wav_tscale;  
  mod_wav_tt = ti;  
  if (ti >= tn)  
    m->run_mode = 9; 
}
void mod_wav_run_fbars(m,s,r,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  if (action == 0){
    mod_wav_fbars_prep(m,s,r);
  }else if (action == 1){
    mod_wav_fbars_get_response(m,s,r);
  }else if (action == -1){
    mod_wav_fbars_done();
  }else if (action == 10){
    mod_wav_fbars_prep(m,s,r);  
  }
}
