/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
struct mchan_struct {
  char    name[SLEN];   
  int     num;          
  int     n;            
  int    *s;            
};
struct multi_trial {
  int     number;       
  int     channels;     
  int     coherency;    
  int     direction;    
  int     response;     
  struct mchan_struct *chan;  
};
struct multi_channel {
  char    name[SLEN];   
  int     ncomments;    
  char  **comments;     
  char    mode[SLEN];   
  int     trials;       
  int     channels;     
  float   sampling;     
  int     start;        
  int     duration;     
  struct multi_trial *trial; 
};
struct pst_struct {
  char   name[SLEN];
  float  sampling;           
  int    trials;             
  int    total_counts;       
  int    binsize;            
  int    rstart,rduration;   
  int    period;             
  int    n;                  
  float *bin;                
};
struct isi_struct {
  char   name[SLEN];
  int    coherency;
  int    direction;
  float  sampling;       
  int    trials;         
  int    interval_total; 
  int    time_total;     
  int    n;              
  int   *bin;            
  float *fraction;       
};
struct p_struct {
  char   name[SLEN];
  int    coherency;
  int    direction;
  int    weight;      
  int    n;           
  int    count;       
  float *mean;        
  float *sdev;        
};
struct pseries_struct {
  char   name[SLEN];
  float  sampling;        
  int    max_lag;         
  int    start;           
  int    duration;        
  int    m;               
  int    k;               
  int    n;               
  int   *svalue;          
  struct p_struct **rec;  
};
struct ac_struct {
  char   name[SLEN];
  int    time;            
  int    count;           
  float  max_freq;        
  int    spk_squared;     
  int    n;               
  float *sdev;            
  float *data;
};
struct jpsth_struct {
  char   name[SLEN];
  float  sampling;           
  int    trials;             
  int    total_counts;       
  int    n;                  
  struct pst_struct *pst1;   
  struct pst_struct *pst2;   
  short int **bin;           
};
struct event_struct {
  int n;   
  int *t;  
};
struct event_trial {
  int nev;                  
  struct event_struct *ev;  
};
