/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "my_util.h"
#include "misc_util.h"
#include "nr_util.h"
#include "carray_util.h"
#include "iarray_util.h"
#include "farray_util.h"
#include "func_util.h"
#include "myrand_util.h"
#include "data_util.h"
#include "paramfile_util.h"
#include "fft_util.h"
#include "sig_util.h"
#include "noise_util.h"
#include "stm_util.h"
#include "stim_util.h"
#include "paramfile.h"
#include "mod.h"
#define VSK_sos_unit 0.015258789 
#define NPAT 256 
#define NAMP 257 
int VSK_sos_n[3] = {6,8,8}; 
int VSK_sos_0[6] = {42,72,162,352,802,1402};
int VSK_sos_1[8] = {14,30,62,126,254,510,1022,2046};
int VSK_sos_2[8] = {15,31,63,127,255,511,1023,2047};
void get_cross_product_params(mylogf,n,cnt,val,nrpt,nvp,nvl,nlinkval,nvs,
			      rn,rlist)
     char *mylogf;
     int n;          
     int *cnt;       
     int nrpt;       
     int nvp;        
     int nvl;        
     int nlinkval;   
     int nvs;        
     char ***val;    
     int *rn;        
     char ****rlist; 
{
  int i,j,k,l;
  int **list,ntot,nlist,t,tn,nsing,*cnt_new,li;
  char ***vv;
  if (n==0)
    mylog_exit(mylogf,"GET_CROSS_PRODUCT_PARAMS  No variable params\n");
  nsing = n - nvp*2 - nvl - nvs; 
  if (nvl > 1)
    tn = nsing + nvp + 1; 
  else
    tn = nsing + nvp;
  cnt_new = (int *)myalloc(tn*sizeof(int));
  for(i=0;i<nsing;i++)
    cnt_new[i] = cnt[i];
  for(i=0;i<nvp;i++)
    cnt_new[i] = cnt[nsing + 2*i];
  if (nvl > 0)
    cnt_new[tn-1] = cnt[n-nvs-1];
  get_nd_cross_product_list_iarray(tn,cnt_new,&list,&nlist);
  ntot = (nlist + nvs) * nrpt;  
  vv = get_2d_pointer_carray(ntot,n);
  t = 0; 
  for(i=0;i<nlist;i++){
    for(j=0;j<nrpt;j++){
      li = 0;
      for(k=0;k<nsing;k++){  
	l = list[i][li];
	vv[t][k] = strdup(val[k][l]);
	li += 1;
      }
      for(k=0;k<nvp;k++){  
	l = list[i][li];
	vv[t][nsing+2*k]   = strdup(val[nsing+2*k][l]);
	vv[t][nsing+2*k+1] = strdup(val[nsing+2*k+1][l]);
	li += 1;
      }
      if ((li != tn) && (nvl == 0)){
	printf("li = %d    tn == %d  nvl =%d\n",li,tn,nvl);
	mylog_exit(mylogf,"GET_CROSS_PRODUCT_PARAMS  bad values, nvl = 0\n");
      }else if ((li != (tn-1)) && (nvl > 0)){
	printf("li = %d    tn == %d\n",li,tn);
	mylog_exit(mylogf,"GET_CROSS_PRODUCT_PARAMS  bad values, nvl > 0\n");
      }
      l = list[i][li];
      for(k=0;k<nvl;k++){    
	vv[t][nsing+2*nvp+k] = strdup(val[nsing+2*nvp+k][l]);
      }
      if (nvs == 1)
	vv[t][n-1] = strdup(val[n-1][0]); 
      t += 1;
    }
  }
  free_2d_iarray(list,nlist);
  myfree(cnt_new);
  *rn = ntot;
  *rlist = vv;
}
int stim_util_get_vargen_list(mylogf,pp,rval)
     char *mylogf;
     struct param_pair *pp;
     char ***rval;
{
  int i;
  int n,dec,seed;
  float m,a,x;
  char *gtype,**val,pstr[SLEN],temp[SLEN];
  gtype = paramfile_get_nth_char_param_pp_or_exit(pp,0);
  dec   = paramfile_get_nth_int_param_ptr_or_exit(pp,1);
  n     = paramfile_get_nth_int_param_ptr_or_exit(pp,2);
  m     = paramfile_get_nth_float_param_ptr_or_exit(pp,3);
  a     = paramfile_get_nth_float_param_ptr_or_exit(pp,4);
  seed  = paramfile_get_nth_int_param_ptr_or_exit(pp,5);
  if (seed > 0)
    seed = -seed;
  val = (char **)myalloc(n*sizeof(char *));
  if (strcmp(gtype,"uniform")==0){
    if (dec > 0)
      sprintf(pstr,"%%.%df",dec);
    else
      sprintf(pstr,"%%d");
    for(i=0;i<n;i++){
      x = a + m*myrand_util_ran2(&seed);
      if (dec > 0)
	sprintf(temp,pstr,x);
      else
	sprintf(temp,pstr,(int)x);
      val[i] = strdup(temp);
    }
  }else
    mylog_exit(mylogf,"STIM_UTIL_GET_VARGEN_LIST  Unknown type\n");
  myfree(gtype);
  *rval = val;
  return n;
}
int stim_util_get_vargenpair_list(mylogf,pp,rval,rval2)
     char *mylogf;
     struct param_pair *pp;
     char ***rval;          
     char ***rval2;         
{
  int i,j,k;
  int n,ti,tio,*tap,tapn,seed,*seedlist;
  char *gtype,**val1,**val2,temp[SLEN];
  n     = paramfile_get_nth_int_param_ptr_or_exit(pp,1);
  gtype = paramfile_get_nth_char_param_pp_or_exit(pp,2);
  if (strcmp(gtype,"list_opp_mseq_tap_11")==0){
    k = paramfile_get_nth_int_param_ptr_or_exit(pp,3);
    get_mseq_tap_array(11,&tap,&tapn);
    if ((k >= tapn) || (k < 0))
      mylog_exit(mylogf,"STIM_UTIL_GET_VARGENPAIR_LIST  Index error\n");
    val1 = (char **)myalloc(n*sizeof(char *));
    val2 = (char **)myalloc(n*sizeof(char *));
    ti = k;
    for(i=0;i<n;i++){
      sprintf(temp,"%d",tap[ti]);
      val1[i] = strdup(temp);
      tio = ti+ tapn/2;  
      if (tio >= tapn)
	tio -= tapn;
      sprintf(temp,"%d",tap[tio]);
      val2[i] = strdup(temp);
      ti += 1;
      if (ti == tapn)
	ti = 0;
    }
  }else if (strcmp(gtype,"unif_100000")==0){
    seed = paramfile_get_nth_int_param_ptr_or_exit(pp,3);
    seedlist = get_seeds(seed,100000,2*n);
    val1 = (char **)myalloc(n*sizeof(char *));  
    val2 = (char **)myalloc(n*sizeof(char *));
    for(i=0;i<n;i++){
      sprintf(temp,"%d",seedlist[2*i]);
      val1[i] = strdup(temp);
      sprintf(temp,"%d",seedlist[2*i+1]);
      val2[i] = strdup(temp);
    }
    myfree(seedlist);
  }else{
    printf(" *** gtype = %s\n",gtype);
    mylog_exit(mylogf,"STIM_UTIL_GET_VARGENPAIR_LIST  Unknown type\n");
  }
  myfree(gtype);
  *rval  = val1;
  *rval2 = val2;
  return n;
}
int stimu_varseq_get_list(mylogf,pp,rval)
     char *mylogf;
     struct param_pair *pp;
     char ***rval;
{
  int i;
  int n,ndec,fv2si,ival,done;
  char *cv1,*cv2,*seqtype,**vlist;
  char tstr[SLEN],fstr[SLEN];
  float finc,fv1,fv2,fscale,x;
  n = 0;
  vlist = NULL;
  seqtype = paramfile_get_nth_char_param_pp_or_exit(pp,0);
  if (strcmp(seqtype,"range_inc")==0){
    cv1 = paramfile_get_nth_char_param_pp_or_exit(pp,1);
    cv2 = paramfile_get_nth_char_param_pp_or_exit(pp,2);
    finc = paramfile_get_nth_float_param_ptr_or_exit(pp,3);
    ndec = count_decimals(cv1);
    fscale = pow((double)10.0,(double)ndec);  
    fv1 = atof(cv1);                
    fv2 = atof(cv2);                
    fv2si = my_rint(fv2 * fscale);  
    x = fv1;
    done = 0;
    while(done == 0){
      ival = my_rint(x * fscale);  
      if (ival > fv2si){
	done = 1;
      }else if (ival == fv2si){
	n += 1;
	done = 1;
      }else{
	n += 1;
	x += finc;
      }
    }
    if (n <= 0){
      exit_error("STIMU_VARSEQ_GET_N","No values defined by sequence");
    }
    myfree(cv1);
    myfree(cv2);
    if (rval != NULL){
      vlist = (char **)myalloc(n*sizeof(char *));
      x = fv1;
      i = 0;
      done = 0;
      while(done == 0){
	ival = my_rint(x * fscale);  
	if (ival > fv2si){
	  done = 1;
	}else{
	  sprintf(fstr,"%%.%df",ndec);
	  sprintf(tstr,fstr,x);
	  vlist[i] = strdup(tstr);
	  i += 1;
	  x += finc;
	  if (ival == fv2si){
	    done = 1;
	  }
	}
      }
    }
  }else{
    printf("  *** sequence type:  %s\n",seqtype);
    exit_error("STIMU_VARSEQ_GET_LIST","Unknown sequence type.");
  }
  myfree(seqtype);
  if (rval != NULL)
    *rval = vlist;
  return n;
}
int stimu_varseq_get_n(mylogf,pp)
     char *mylogf;
     struct param_pair *pp;
{
  int n;
  n = stimu_varseq_get_list(mylogf,pp,NULL);
  return n;
}
void free_var_params(mylogf,vval,vname,vn,n,val,vcnt)
     char *mylogf;
     char **vname;          
     char ***vval;          
     int vn;                
     int n;                 
     char ***val;           
     int *vcnt;             
{
  mylog(mylogf,"  FREE_VAR_PARAMS\n");
  free_2d_pointer_carray(vval,n,vn);
  free_2d_carray(vname,vn);
  free_2d_pointer_var_count_carray(val,vn,vcnt);
  myfree(vcnt);
}
void prep_vpar_vfile(mylogf,sppl,rptflag,rvval,rvname,rvtype,rvn,rn,rval,
		     rvcnt,rnvl,rnvp)
     char *mylogf;
     struct param_pair_list *sppl;   
     int rptflag;             
     char ****rvval;          
     char ***rvname;          
     char **rvtype;           
     int *rvn;                
     int *rn;                 
     char ****rval;           
     int **rvcnt;             
     int *rnvl;               
     int *rnvp;               
{
  FILE *fopen(),*fin;
  int i,j;
  int nvar,nstim,*vcnt,nvl,nvp,tvn,nrpt,nlinkval,nvs,ns;
  char *infile,ts[SLEN],**vname,***tvval,***val,*vtype;
  if (rptflag == 1)
    nrpt = paramfile_get_int_param_or_exit(sppl,"stim_nrpt");
  else
    nrpt = 1; 
  infile = paramfile_get_char_param_or_exit(sppl,"VARFILE");
  if ((fin = fopen(infile,"r")) == NULL){
    printf("  *** Cannot open file %s.\n",infile);
    mylog_exit(mylogf,"Cannot open VARFILE filename'\n");
  }
  sprintf(ts,"    Reading %s\n",infile);
  mylog(mylogf,ts);
  ns = fscanf(fin,"%s %d",ts,&nvar);
  if (strcmp(ts,"npar")!=0)
    mylog_exit(mylogf,"Expecting constant string 'npar'\n");
  vname = (char **)myalloc(nvar*sizeof(char *));
  for(i=0;i<nvar;i++){
    ns = fscanf(fin,"%s",ts);
    vname[i] = strdup(ts);
  }
  ns = fscanf(fin,"%s %d",ts,&nstim);
  if (strcmp(ts,"nstim")!=0)
    mylog_exit(mylogf,"Expecting constant string 'nstim'\n");
  val = get_2d_pointer_carray(nvar,nstim);
  for(i=0;i<nstim;i++){
    for(j=0;j<nvar;j++){
      ns = fscanf(fin,"%s",ts);
      val[j][i] = strdup(ts);
    }
  }
  fclose(fin);
  myfree(infile);
  nvp = 0;     
  nvl = nvar;  
  vcnt = get_const_iarray(nvar,nstim);
  nlinkval = nstim;
  nvs = 0;    
  vtype = (char *)myalloc(nvar*sizeof(char));
  for(i=0;i<nvar;i++){
    vtype[i] = paramfile_get_type_from_comment(sppl,vname[i],'f');
  }
  get_cross_product_params(mylogf,nvar,vcnt,val,nrpt,nvp,nvl,nlinkval,nvs,
			   &tvn,&tvval);
  *rvval = tvval; *rvname = vname; *rvn = nvar; *rn = tvn; *rvtype = vtype;
  *rval = val; *rvcnt = vcnt; *rnvl = nvl;  
  *rnvp = nvp;
}
void prep_var_params(mylogf,sppl,rptflag,rvval,rvname,rvtype,rvn,rn,rval,
		     rvcnt,rnvl,rnvp)
     char *mylogf;
     struct param_pair_list *sppl;   
     int rptflag;             
     char ****rvval;          
     char ***rvname;          
     char **rvtype;           
     int *rvn;                
     int *rn;                 
     char ****rval;           
     int **rvcnt;             
     int *rnvl;               
     int *rnvp;               
{
  int i,j,k;
  int n,nprod,nvar,nv,nvg,nvp,nvl,nlinkval,nrpt,tvn,*vcnt,nvs,nvq;
  char **vname,***tvval,***val,*vtype,tstr[SLEN],*par2;
  struct param_pair *pp;
  char ggstr[LONG_SLEN];
  mylog(mylogf,"  PREP_VAR_PARAMS\n");
  if (paramfile_test_param(sppl,"VARFILE")){
    prep_vpar_vfile(mylogf,sppl,rptflag,rvval,rvname,rvtype,rvn,rn,rval,
		    rvcnt,rnvl,rnvp);
    return;
  }
  nprod = 1;
  nv = 0;
  pp = paramfile_get_first_prefix_pointer(sppl,"VAR_");
  while(pp != NULL){
    strcpy(tstr,&(pp->name[4])); 
    n = paramfile_count_values_pointer(pp);
    sprintf(ggstr,"    `%s' has %d values\n",tstr,n);
    mylog(mylogf,ggstr);
    nprod *= n;
    pp = paramfile_get_next_prefix_pointer(pp,"VAR_");
    nv += 1;
    if (!paramfile_test_param(sppl,tstr))
      mylog_exit(mylogf,"PREP_VAR_PARAMS  var param has no default value\n");
  }
  nvq = 0;
  pp = paramfile_get_first_prefix_pointer(sppl,"VARSEQ_");
  while(pp != NULL){
    strcpy(tstr,&(pp->name[7])); 
    n = paramfile_count_values_pointer(pp);
    if (n != 4)
      mylog_exit(mylogf,"PREP_VAR_PARAMS  VARSEQ needs 4 values\n");
    n = stimu_varseq_get_n(mylogf,pp);  
    sprintf(ggstr,"    `%s' has %d values\n",tstr,n);
    mylog(mylogf,ggstr);
    nprod *= n;
    pp = paramfile_get_next_prefix_pointer(pp,"VARSEQ_");
    nvq += 1;
    if (!paramfile_test_param(sppl,tstr))
      mylog_exit(mylogf,"PREP_VAR_PARAMS  varseq param has no default val\n");
  }
  nvg = 0;
  pp = paramfile_get_first_prefix_pointer(sppl,"VARGEN_");
  while(pp != NULL){
    strcpy(tstr,&(pp->name[7])); 
    n = paramfile_count_values_pointer(pp);
    if (n!=6)
      mylog_exit(mylogf,"PREP_VAR_PARAMS  VARGEN needs 6 values\n");
    n = paramfile_get_nth_int_param_ptr_or_exit(pp,2);
    nprod *= n;
    pp = paramfile_get_next_prefix_pointer(pp,"VARGEN_");
    nvg += 1;
    if (!paramfile_test_param(sppl,tstr))
      mylog_exit(mylogf,"PREP_VAR_PARAMS  vargen param has no default val\n");
  }
  nvp = 0;
  pp = paramfile_get_first_prefix_pointer(sppl,"VARGENPAIR_");
  while(pp != NULL){
    strcpy(tstr,&(pp->name[11]));  
    n = paramfile_count_values_pointer(pp);
    if (n < 3)
      mylog_exit(mylogf,"PREP_VAR_PARAMS  VARGENPAIR needs >= 3 values\n");
    n = paramfile_get_nth_int_param_ptr_or_exit(pp,1);
    nprod *= n;  
    par2 = paramfile_get_nth_char_param_pp_or_exit(pp,0);
    pp = paramfile_get_next_prefix_pointer(pp,"VARGENPAIR_");
    nvp += 1;  
    if (!paramfile_test_param(sppl,tstr))
      mylog_exit(mylogf,"PREP_VAR_PARAMS  vargenpair param1 has no default\n");
    if (!paramfile_test_param(sppl,par2))
      mylog_exit(mylogf,"PREP_VAR_PARAMS  vargenpair param2 has no default\n");
  }
  nvl = 0;
  nlinkval = -1;
  pp = paramfile_get_first_prefix_pointer(sppl,"VARLINK_");
  while(pp != NULL){
    strcpy(tstr,&(pp->name[8]));
    if (nlinkval == -1){
      nlinkval = paramfile_count_values_pointer(pp);
      sprintf(ggstr,"    Linked variables have %d values\n",nlinkval);
      mylog(mylogf,ggstr);
    }else{
      n = paramfile_count_values_pointer(pp);
      if (n != nlinkval){
	printf("  *** %s has %d values\n",tstr,n);
	mylog_exit(mylogf,
          "PREP_VAR_PARAMS  All varlink params need same number of values\n");
      }
    }
    pp = paramfile_get_next_prefix_pointer(pp,"VARLINK_");
    nvl += 1;
    if (!paramfile_test_param(sppl,tstr))
      mylog_exit(mylogf,"PREP_VAR_PARAMS  varlink param has no default val\n");
  }
  if (nlinkval > -1)
    nprod *= nlinkval;
  if (nvl == 1){
    mylogx(mylogf,"PREP_VAR_PARAMS",
	   "The .stm file has a single VARLINK_, please use VAR_\n");
  }
  nvs = 0;
  pp = paramfile_get_first_prefix_pointer(sppl,"VARSINGLE_");
  if (pp != NULL){
    nvs = 1;
    pp = paramfile_get_next_prefix_pointer(pp,"VARSINGLE_");
    if (pp != NULL){
      mylogx(mylogf,"PREP_VAR_PARAMS",
	     "The .stm file can have only one VARSINGLE_\n");
    }
  }
  nvar = nv + nvg + nvp*2 + nvq + nvl + nvs;
  if (rptflag == 1)
    nrpt = paramfile_get_int_param_or_exit(sppl,"stim_nrpt");
  else
    nrpt = 1; 
  if (nvar == 0){
    mylog(mylogf,"    No variable parameters.\n");
    tvval = NULL;
    vname = NULL;
    vcnt = NULL;
    val = NULL;
    nvar = 0;
    tvn = nrpt; 
  }else{
    sprintf(ggstr,"    %d var params, %d unique trials\n",nvar,nprod);
    mylog(mylogf,ggstr);
    vcnt = get_zero_iarray(nvar);
    vname = (char **)myalloc(nvar*sizeof(char *));
    val = (char ***)myalloc(nvar*sizeof(char **));
    for(i=0;i<nv;i++){
      if (i==0)
	pp = paramfile_get_first_prefix_pointer(sppl,"VAR_");
      else
	pp = paramfile_get_next_prefix_pointer(pp,"VAR_");
      vname[i] = strdup(&(pp->name[4]));
      vcnt[i] = paramfile_get_slist_pointer(sppl,pp,&(val[i]));
    }
    k = nv;
    for(i=0;i<nvq;i++){  
      if (i==0)
	pp = paramfile_get_first_prefix_pointer(sppl,"VARSEQ_");
      else
	pp = paramfile_get_next_prefix_pointer(pp,"VARSEQ_");
      vname[k] = strdup(&(pp->name[7]));
      vcnt[k] = stimu_varseq_get_list(mylogf,pp,&(val[k]));
      k += 1;
    }
    for(i=0;i<nvg;i++){  
      if (i==0)
	pp = paramfile_get_first_prefix_pointer(sppl,"VARGEN_");
      else
	pp = paramfile_get_next_prefix_pointer(pp,"VARGEN_");
      vname[k] = strdup(&(pp->name[7]));
      vcnt[k] = stim_util_get_vargen_list(mylogf,pp,&(val[k]));
      k += 1;
    }
    for(i=0;i<nvp;i++){
      if (i==0)
	pp = paramfile_get_first_prefix_pointer(sppl,"VARGENPAIR_");
      else
	pp = paramfile_get_next_prefix_pointer(pp,"VARGENPAIR_");
      par2 = paramfile_get_nth_char_param_pp_or_exit(pp,0);
      vname[k] = strdup(&(pp->name[11]));
      vname[k+1] = strdup(par2);
      vcnt[k] = stim_util_get_vargenpair_list(mylogf,pp,&(val[k]),&(val[k+1]));
      vcnt[k+1] = vcnt[k];
      k += 2;
    }
    for(i=0;i<nvl;i++){
      if (i==0)
	pp = paramfile_get_first_prefix_pointer(sppl,"VARLINK_");
      else
	pp = paramfile_get_next_prefix_pointer(pp,"VARLINK_");
      vname[k] = strdup(&(pp->name[8]));
      vcnt[k] = paramfile_get_slist_pointer(sppl,pp,&(val[k]));
      k += 1;
    }
    if (nvs == 1){
      pp = paramfile_get_first_prefix_pointer(sppl,"VARSINGLE_");
      vname[k] = strdup(&(pp->name[10]));
      vcnt[k] = 2;  
      val[k] = (char **)myalloc(2*sizeof(char *));
      val[k][1] = carray_item_list_remove_comment(pp->value);
      pp = paramfile_get_param_pointer(sppl,vname[k]);
      if (pp == NULL){
	mylogx(mylogf,"PREP_VAR_PARAMS",
	       "Cannot find default value for VARSINGLE_\n");
      }
      val[k][0] = carray_item_list_remove_comment(pp->value);
      k += 1;
    }
    sprintf(ggstr,"    %d repeats of each trial\n",nrpt);
    mylog(mylogf,ggstr);
    get_cross_product_params(mylogf,nvar,vcnt,val,nrpt,nvp,nvl,nlinkval,nvs,
			     &tvn,&tvval);
    if (nvs == 1){ 
      for(j=0;j<(nvar-1);j++){
	pp = paramfile_get_param_pointer(sppl,vname[j]);
	for(i=0;i<nrpt;i++){
	  tvval[tvn-nrpt + i][j] = carray_item_list_remove_comment(pp->value);
	}
      }
      j = nvar - 1;  
      for(i=0;i<nrpt;i++){
	tvval[tvn-nrpt + i][j] = strdup(val[nvar-1][1]);
      }
    }
    sprintf(ggstr,"    %d total stimuli\n",tvn);
    mylog(mylogf,ggstr);
  }
  vtype = (char *)myalloc(nvar*sizeof(char));
  for(i=0;i<nvar;i++){
    vtype[i] = paramfile_get_type_from_comment(sppl,vname[i],'f');
  }
  *rvval = tvval; *rvname = vname; *rvn = nvar; *rn = tvn; *rvtype = vtype;
  *rval = val; *rvcnt = vcnt; *rnvl = nvl;  
  *rnvp = nvp;
}
void stimu_var_param_check(sppl,pname,rn,rval)
     struct param_pair_list *sppl;   
     char *pname;                    
     int *rn;                        
     char ***rval;                   
{
  int k;
  int n,vn,*vcnt,nvl,nvp;
  char **vname,***vval,***val,*vtype;
  prep_var_params(NULL,sppl,0,&vval,&vname,&vtype,&vn,&n,&val,
		  &vcnt,&nvl,&nvp);
  k = search_2d_carray(vname,pname,vn);
  if (k < 0){
    *rn = 0;  
    *rval = NULL;
  }else{
    *rn = vcnt[k];
    *rval = copy_2d_carray(val[k],vcnt[k]);
  }
  free_var_params(NULL,vval,vname,vn,n,val,vcnt);
  myfree(vtype);
}
void prep_const_params(mylogf,s,moo_par,moo_val,nmoo,rcval,rcname,rctype,rncon)
     char *mylogf;
     struct stim_struct *s;  
     char **moo_par;         
     char **moo_val;         
     int nmoo;               
     char ***rcval;          
     char ***rcname;         
     char **rctype;          
     int *rncon;             
{
  int i;
  int ncon,nvar;
  char **cname,**cval,*ctype,*vtype,tstr[SLEN];
  struct param_pair *pp;
  mylog(mylogf,"  PREP_CONST_PARAMS\n");
  ncon = nmoo;  
  pp = s->ppl->p;
  while(pp != NULL){
    if (search_2d_carray(s->vname,pp->name,s->nvar) == -1){
      ncon += 1;
    }
    pp = pp->next;
  }
  cname = (char **)myalloc(ncon*sizeof(char *));
  ctype = (char  *)myalloc(ncon*sizeof(char));
  cval  = (char **)myalloc(ncon*sizeof(char *));
  for(i=0;i<nmoo;i++){
    sprintf(tstr,"MOO_%s",moo_par[i]);
    cname[i] = strdup(tstr);
    ctype[i] = 'c';
    cval[i]  = strdup(moo_val[i]);
  }
  i = nmoo;
  pp = s->ppl->p;
  while(pp != NULL){
    if (search_2d_carray(s->vname,pp->name,s->nvar) == -1){
      cname[i] = strdup(pp->name);
      cval[i] = carray_item_list_remove_comment(pp->value);
      ctype[i] = paramfile_get_type_from_comment(s->ppl,pp->name,'f');
      i += 1;
    }
    pp = pp->next;
  }
  *rcval = cval; *rcname = cname; *rctype = ctype; *rncon = ncon;
}
void update_const_param(mylogf,tname,tval,ttype,cname,cval,ctype,n)
     char *mylogf;      
     char *tname;       
     char *tval;        
     char ttype;        
     char **cname;      
     char **cval;       
     char *ctype;       
     int n;             
{
  int k;
  char *ggstr;
  mylog(mylogf,"  UPDATE_CONST_PARAM\n");
  k = search_2d_carray(cname,tname,n);
  if (k == -1){
    sprintf(ggstr,"Name:  %s\n",tname);
    mylog(mylogf,ggstr);
    mylogx(mylogf,"UPDATE_CONST_PARAM","Cannot find parameter name\n");
  }
  if (tval != NULL){
    if (cval[k] != NULL)
      myfree(cval[k]);
    cval[k] = strdup(tval);
  }
  if (ttype != '\0'){
    ctype[k] = ttype;
  }
}
void get_dot_opp_mo(sscale,framerate,speed,disp0,theta,sizex,sizey,nframes,dpf,
		    seed,corr,rdotx1,rdoty1,rdotx2,rdoty2,rdotn,rampl)
     float sscale;      
     float framerate;   
     float speed;       
     float disp0;       
     float theta;       
     float sizex,sizey; 
     int nframes;       
     int dpf;           
     int seed;          
     int corr;          
     float ***rdotx1,***rdoty1,***rdotx2,***rdoty2;  
     int **rdotn;                                    
     float ***rampl;                                 
{
  int i,j;
  int *dotn;
  float **dotx1,**doty1,**dotx2,**doty2,**dota,x,y,dx0,dy0,tc,a;
  double dx,dy,x1,y1,x2,y2;
  if (seed > 0)
    seed = -seed;
  dotn  = (int *)myalloc(nframes*sizeof(int));
  dotx1 = (float **)myalloc(nframes*sizeof(float *));
  doty1 = (float **)myalloc(nframes*sizeof(float *));
  dotx2 = (float **)myalloc(nframes*sizeof(float *));
  doty2 = (float **)myalloc(nframes*sizeof(float *));
  dota  = (float **)myalloc(nframes*sizeof(float *));
  for(i=0;i<nframes;i++){
    dotn[i]  = dpf;
    dotx1[i] = (float *)myalloc(dpf*sizeof(float));
    doty1[i] = (float *)myalloc(dpf*sizeof(float));
    dotx2[i] = (float *)myalloc(dpf*sizeof(float));
    doty2[i] = (float *)myalloc(dpf*sizeof(float));
    dota[i]  = (float *)myalloc(dpf*sizeof(float));
  }
  tc = (float)(nframes-1)/2.0;  
  dx = (double)speed / (framerate * sscale) * cos(theta/180.0*M_PI);
  dy = (double)speed / (framerate * sscale) * sin(theta/180.0*M_PI);
  dx0 = disp0 * cos(theta/180.0*M_PI);
  dy0 = disp0 * sin(theta/180.0*M_PI);
  for(j=0;j<dpf;j++){
    x = dx0 + myrand_util_ran2(&seed)*sizex;  
    y = dy0 + myrand_util_ran2(&seed)*sizey;
    if (myrand_util_ran2(&seed) < 0.5)
      a = -1.0;
    else
      a = 1.0;
    x1 = x - dx*tc;  
    y1 = y - dy*tc;
    if (corr != 1){
      x = dx0 + myrand_util_ran2(&seed)*sizex;  
      y = dy0 + myrand_util_ran2(&seed)*sizey;
    }
    x2 = x + dx*tc;
    y2 = y + dy*tc;
    wrap_double(&x1,(double)sizex); 
    wrap_double(&x2,(double)sizex);
    wrap_double(&y1,(double)sizey);
    wrap_double(&y2,(double)sizey);
    for (i=0;i<nframes;i++){  
      dotx1[i][j] = (float)x1;  
      doty1[i][j] = (float)y1;
      dotx2[i][j] = (float)x2;
      doty2[i][j] = (float)y2;
      dota[i][j]  = a;          
      x1 += dx;  
      y1 += dy;
      x2 -= dx;
      y2 -= dy;
      if (x1 < 0.0) x1 += sizex; else if (x1 >= sizex) x1 -= sizex; 
      if (x2 < 0.0) x2 += sizex; else if (x2 >= sizex) x2 -= sizex;
      if (y1 < 0.0) y1 += sizey; else if (y1 >= sizey) y1 -= sizey;
      if (y2 < 0.0) y2 += sizey; else if (y2 >= sizey) y2 -= sizey;
    }
  }
  *rdotx1 = dotx1;
  *rdoty1 = doty1;
  *rdotx2 = dotx2;
  *rdoty2 = doty2;
  *rampl  = dota;
  *rdotn  = dotn;
}
void get_coh_dot_movie_ampl(sscale,framerate,coher,speed,theta,sizex,sizey,
			    nframes,dpf,dt,seed,rdotx,rdoty,rdotn,rampl)
     float sscale,framerate,coher,speed,theta,sizex,sizey;
     int nframes,dpf,dt,seed;
     float ***rdotx,***rdoty;
     int **rdotn;
     float ***rampl;
{
  int i,j,k;
  int *dotn,n;
  float **dotx,**doty,x,y,dx,dy,**dota,a;
  if (seed > 0)
    seed = -seed;
  dotn = (int *)myalloc(nframes*sizeof(int));
  dotx = (float **)myalloc(nframes*sizeof(float *));
  doty = (float **)myalloc(nframes*sizeof(float *));
  dota = (float **)myalloc(nframes*sizeof(float *));
  for(i=0;i<nframes;i++){
    dotn[i] = dpf;
    dotx[i] = (float *)myalloc(dpf*sizeof(float));
    doty[i] = (float *)myalloc(dpf*sizeof(float));
    dota[i] = (float *)myalloc(dpf*sizeof(float));
  }
  dy = speed * (float)dt/framerate / sscale * sin(theta/180.0*M_PI);
  dx = speed * (float)dt/framerate / sscale * cos(theta/180.0*M_PI);
  for (i=0;i<nframes;i++){
    n = 0; 
    k = i - dt; 
    if (k >= 0){ 
      for (j=0;j<dpf;j++) 
	if (myrand_util_ran2(&seed) < coher){ 
	  x = dotx[k][j] + dx;
	  y = doty[k][j] + dy;
	  if (x < 0.0) x += sizex; else if (x >= sizex) x -= sizex;
	  if (y < 0.0) y += sizey; else if (y >= sizey) y -= sizey;
	  dotx[i][n] = x; 
	  doty[i][n] = y;
	  dota[i][n] = dota[k][j];  
	  n += 1;
	}
    }
    while (n < dpf){ 
      dotx[i][n] = myrand_util_ran2(&seed)*sizex;
      doty[i][n] = myrand_util_ran2(&seed)*sizey;
      if (myrand_util_ran2(&seed) < 0.5)
	dota[i][n] = -1.0;
      else
	dota[i][n] = 1.0;
      n += 1;
    }
  }
  *rdotn = dotn; *rdotx = dotx; *rdoty = doty; *rampl = dota;
}
void get_coherence_dot_movie(sscale,framerate,coher,speed,theta,sizex,sizey,
			     nframes,dpf,dt,seed,rdotx,rdoty,rdotn)
     float sscale,framerate,coher,speed,theta,sizex,sizey;
     int nframes,dpf,dt,seed;
     float ***rdotx,***rdoty;
     int **rdotn;
{
  int i,j,k;
  int *dotn,n;
  float **dotx,**doty,x,y,dx,dy;
  if (seed > 0)
    seed = -seed;
  dotn = (int *)myalloc(nframes*sizeof(int));
  dotx = (float **)myalloc(nframes*sizeof(float *));
  doty = (float **)myalloc(nframes*sizeof(float *));
  for(i=0;i<nframes;i++){
    dotn[i] = dpf;
    dotx[i] = (float *)myalloc(dpf*sizeof(float));
    doty[i] = (float *)myalloc(dpf*sizeof(float));
  }
  dy = speed * (float)dt/framerate / sscale * sin(theta/180.0*M_PI);
  dx = speed * (float)dt/framerate / sscale * cos(theta/180.0*M_PI);
  for (i=0;i<nframes;i++){
    n = 0; 
    k = i - dt; 
    if (k >= 0){ 
      for (j=0;j<dpf;j++) 
	if (myrand_util_ran2(&seed) < coher){ 
	  x = dotx[k][j] + dx;
	  y = doty[k][j] + dy;
	  if (x < 0.0) x += sizex; else if (x >= sizex) x -= sizex;
	  if (y < 0.0) y += sizey; else if (y >= sizey) y -= sizey;
	  dotx[i][n] = x; 
	  doty[i][n] = y;
	  n += 1;
	}
    }
    while (n < dpf){ 
      dotx[i][n] = myrand_util_ran2(&seed)*sizex;
      doty[i][n] = myrand_util_ran2(&seed)*sizey;
      n += 1;
    }
  }
  *rdotn = dotn; *rdotx = dotx; *rdoty = doty;
}
void mask_dot_movie(dotx,doty,dota,dotn,nframes,x0,y0,cx,cy,w,h,sscale,aptype)
     float **dotx,**doty;    
     float **dota;           
     int *dotn,nframes;
     float x0,y0;            
     float cx,cy,w,h;        
     float sscale;           
     int aptype;
{
  int i,j;
  int n,dflag;
  float x,y,r2pix,tx,ty,apcx,apcy,wo2,ho2;
  wo2 = w/(2.0*sscale);   
  ho2 = h/(2.0*sscale);   
  r2pix = wo2*wo2;        
  apcx = x0 + cx/sscale;
  apcy = y0 + cy/sscale;
  for (i=0;i<nframes;i++){
    n = 0; 
    for (j=0;j<dotn[i];j++){
      tx = dotx[i][j];
      ty = doty[i][j];
      x = tx - apcx;      
      y = ty - apcy;
      dflag = 0;
      if (aptype == 1){ 
	if ((x*x + y*y) <= r2pix)
	  dflag = 1;
      }else if (aptype == 2){ 
	if ((x >= -wo2) && (x <= wo2) && (y >= -ho2) && (y <= ho2))
	  dflag = 1;
      }else{
	printf("*** Aperture type %d not implemented yet\n",aptype);
	dflag = 1;
      }
      if (dflag){
	dotx[i][n] = tx; 
	doty[i][n] = ty;
	if (dota != NULL)
	  dota[i][n] = dota[i][j];
	n += 1;
      }
    }
    dotn[i] = n;
  }
}
void get_dot_stereogram(sscale,framerate,coher,speed,theta,tf,waveform,sizex,
			sizey,ox1,ox2,oy1,oy2,dx,dy,dx0,dy0,nframes,dpf,dt,
			seed,dotcorr,rdxl,rdyl,rdnl,rdxr,rdyr,rdnr,rdampl,
			rdampr)
     float sscale,framerate,coher,speed,theta,tf;
     char *waveform;  
     float sizex,sizey;
     float ox1,ox2;      
     float oy1,oy2;      
     float dx,dy;   
     float dx0,dy0;  
     int nframes,dpf,dt,seed;
     int dotcorr;                 
     float ***rdxl,***rdyl;
     int **rdnl;
     float ***rdxr,***rdyr;
     int **rdnr;
     float ***rdampl,***rdampr;  
{
  int i;
  int fi,n,tn,seed_f,*dnl,*dnr,*dnf;
  float **dxl,**dyl,**dxr,**dyr,**dxf,**dyf,*tx,*ty,*ta;
  float x,y,a,vdx,vdy,tsec,tcyc,nx1,nx2,ny1,ny2;
  float **dampl,**dampr,**dampf,xa,xb,ya,yb;
  if (tf > 0.0){
    xa = dx0 + (dx - dx0)/2.0;  
    xb = (dx - dx0)/2.0;        
    ya = dy0 + (dy - dy0)/2.0;
    yb = (dy - dy0)/2.0;
  }
  seed_f = 7 * seed + 1013;  
  get_coh_dot_movie_ampl(sscale,framerate,coher,speed,theta,sizex,sizey,
			 nframes,dpf,dt,seed,&dxl,&dyl,&dnl,&dampl);
  get_coh_dot_movie_ampl(sscale,framerate,coher,speed,theta,sizex,sizey,
			 nframes,dpf,dt,seed_f,&dxf,&dyf,&dnf,&dampf);
  if (dotcorr == 0){  
    dxr = dxf;
    dyr = dyf;
    dnr = dnf;
    dampr = dampf;
  }else{
    dxr   = (float **)myalloc(nframes*sizeof(float *));
    dyr   = (float **)myalloc(nframes*sizeof(float *));
    dnr   =    (int *)myalloc(nframes*sizeof(int));
    dampr = (float **)myalloc(nframes*sizeof(float *));
    tx = (float *)myalloc(dpf*2 * sizeof(float));
    ty = (float *)myalloc(dpf*2 * sizeof(float));
    ta = (float *)myalloc(dpf*2 * sizeof(float));
    for(fi=0;fi<nframes;fi++){  
      if (tf > 0.0){
	tsec = fi / framerate;
	if (strcmp(waveform,"ramp")==0){
	  tcyc = (tsec * tf) - (int)(tsec * tf);
	  vdx = dx0 + (dx - dx0)*tcyc;
	  vdy = dy0 + (dy - dy0)*tcyc;
	}else if (strcmp(waveform,"sine")==0){
	  vdx = xa + xb*sin(tf*tsec*2.0*M_PI);
	  vdy = ya + yb*sin(tf*tsec*2.0*M_PI);
	}else{
	  printf("  *** patch_waveform:  %s\n",waveform);
	  exit_error("GET_DOT_STEREOGRAM","Unknown 'patch_waveform'");
	}
      }else{
	vdx = dx;
	vdy = dy;
      }
      nx1 = ox1 + vdx;
      nx2 = ox2 + vdx;
      ny1 = oy1 + vdy;
      ny2 = oy2 + vdy;
      n = dnl[fi];  
      tn = 0;       
      for(i=0;i<n;i++){
	x =   dxl[fi][i];
	y =   dyl[fi][i];
	a = dampl[fi][i];
	if ((x >= ox1) && (x <= ox2) && (y >= oy1) && (y <= oy2)){
	  tx[tn] = x + vdx;  
	  ty[tn] = y + vdy;
	  ta[tn] = a;
	  if ((tx[tn] >= ox1) && (tx[tn] <= ox2) &&
	      (ty[tn] >= oy1) && (ty[tn] <= oy2))
	    tn += 1;
	}else{
	  tx[tn] = x;  
	  ty[tn] = y;
	  ta[tn] = a;
	  tn += 1;
	}
      }
      n = dnf[fi];  
      for(i=0;i<n;i++){
	x =   dxf[fi][i];
	y =   dyf[fi][i];
	a = dampf[fi][i];
	if ((x >= ox1) && (x <= ox2) && (y >= oy1) && (y <= oy2)){
	  if (!((x >= nx1) && (x <= nx2) && (y >= ny1) && (y <= ny2))){
	    tx[tn] = x;  
	    ty[tn] = y;
	    ta[tn] = a;
	    tn += 1;
	  }
	}
      }
      dxr[fi]   = copy_farray(tx,tn);
      dyr[fi]   = copy_farray(ty,tn);
      dampr[fi] = copy_farray(ta,tn);
      dnr[fi] = tn;
    }
    myfree(tx); myfree(ty); myfree(ta);
    free_2d_farray(  dxf,nframes);
    free_2d_farray(  dyf,nframes);
    free_2d_farray(dampf,nframes);
    myfree(dnf);
  }
  *rdxl = dxl;  *rdyl = dyl;  *rdnl = dnl;
  *rdxr = dxr;  *rdyr = dyr;  *rdnr = dnr;
  *rdampl = dampl;
  *rdampr = dampr;
}
void get_rds_disp_mod(sscale,framerate,disp0,disp_range,disp_sign,theta,tf,
		      sizex,sizey,dx,dy,dx0,dy0,nframes,dpf,seed,corr,
		      rdxl,rdyl,rdnl,rdxr,rdyr,rdnr,rdampl,rdampr)
     float sscale,framerate;
     float disp0;               
     float disp_range;          
     int disp_sign;             
     float theta,tf,sizex,sizey;
     float dx,dy;   
     float dx0,dy0;  
     int nframes,dpf,seed;
     int corr;                   
     float ***rdxl,***rdyl;      
     int **rdnl;                 
     float ***rdxr,***rdyr;      
     int **rdnr;                 
     float ***rdampl,***rdampr;  
{
  int i,k;
  int fi,n,tn,seed_f,*dotn,nfpc,*dn;
  float **dotx1,**doty1,**dotx2,**doty2,**dota,speed;
  float **dlx,**dly,**drx,**dry,**da;
  speed = (disp_range * 2.0) * tf;   
  if (disp_sign != 1)
    speed *= -1.0;  
  nfpc = my_rint(framerate / tf);  
  get_dot_opp_mo(sscale,framerate,speed,disp0,theta,sizex,sizey,
		 nfpc,dpf,seed,corr,&dotx1,&doty1,&dotx2,&doty2,&dotn,&dota);
  dlx = (float **)myalloc(nframes*sizeof(float *));
  dly = (float **)myalloc(nframes*sizeof(float *));
  drx = (float **)myalloc(nframes*sizeof(float *));
  dry = (float **)myalloc(nframes*sizeof(float *));
  da  = (float **)myalloc(nframes*sizeof(float *));
  dn  = (int    *)myalloc(nframes*sizeof(int));
  k = 0;
  for(i=0;i<nframes;i++){
    dlx[i] = copy_farray(dotx1[k],dotn[k]);
    dly[i] = copy_farray(doty1[k],dotn[k]);
    drx[i] = copy_farray(dotx2[k],dotn[k]);
    dry[i] = copy_farray(doty2[k],dotn[k]);
    da[i]  = copy_farray(dota[k], dotn[k]);
    dn[i]  = dotn[k];
    k += 1;
    if (k == nfpc){
      k = 0;
    }
  }
  free_2d_farray(dotx1,nfpc);
  free_2d_farray(doty1,nfpc);
  free_2d_farray(dotx2,nfpc);
  free_2d_farray(doty2,nfpc);
  free_2d_farray(dota,nfpc);
  myfree(dotn);
  *rdxl = dlx;
  *rdyl = dly;
  *rdnl = dn;
  *rdxr = drx;
  *rdyr = dry;
  *rdnr = copy_iarray(dn,nframes);
  *rdampl = da;
  *rdampr = copy_2d_farray(da,nframes,dpf);
}
float get_vsk_sum_of_sinusoids(snum,p,pratio,t)
     int snum,p;
     float pratio,t;
{
  int i;
  int n;
  float f,y,a,amp,pamp,npamp;
  if ((snum <0)||(snum > 2))
    exit_error("GET_VSK_SUM_OF_SINUSOIDS","Unknown sum index");
  n = VSK_sos_n[snum];
  amp = 1.0/(float)n; 
  npamp = 1.0/(pratio + (float)(n-1));
  pamp = pratio*npamp;
  y = 0.0;
  for(i=0;i<n;i++){
    if (p < 1)
      a = amp; 
    else if ((i+1) == p)
      a = pamp; 
    else
      a = npamp; 
    if (snum == 0)      f = (float)VSK_sos_0[i];
    else if (snum == 1) f = (float)VSK_sos_1[i];
    else if (snum == 2) f = (float)VSK_sos_2[i];
    else                f = 0.0; 
    f *= VSK_sos_unit;
    y += a * sin(f*t*M_PI*2.0);
  }
  return y;
}
void stimu_rangrid(sscale,x0,y0,gw,gn,n,jitr,seed,rx,ry)
     float sscale;  
     float x0,y0;   
     float gw;      
     int gn;        
     int n;         
     float jitr;    
     int seed;      
     float **rx;    
     float **ry;    
{
  int i;
  int *shuff,xi,yi,jseed;
  float *x,*y,jr2,dg,jx,jy,xdeg,ydeg;
  if (n > gn*gn)
    exit_error("STIMU_RANGRID","Too many grid points requested");
  x = (float *)myalloc(n*sizeof(float));
  y = (float *)myalloc(n*sizeof(float));
  if (seed > 0)
    jseed = -(seed + 12307);
  else
    jseed = seed - 12307;
  shuff = get_shuffle_index(gn*gn,7,seed);
  jr2 = jitr*2.0;          
  dg = gw/(float)(gn-1);   
  for(i=0;i<n;i++){
    xi = shuff[i] / gn;
    yi = shuff[i] - (xi * gn);
    jx = -jitr + jr2*myrand_util_ran2(&jseed);  
    jy = -jitr + jr2*myrand_util_ran2(&jseed);  
    xdeg = (float)xi*dg + jx;  
    ydeg = (float)yi*dg + jy;  
    x[i] = (x0 + xdeg) / sscale;  
    y[i] = (y0 + ydeg) / sscale;  
  }
  myfree(shuff);
  *rx = x;
  *ry = y;
}
float *get_stim_1d_ppl_pulse(ppl,n,tscale,tsamp)
     struct param_pair_list *ppl;
     int n;
     float tscale;
     int tsamp;
{
  int i;
  int i0;
  float *data;
  float t0,tn,amp0,amp1,offset0,t;
  t0       = paramfile_get_float_param_or_exit(ppl,"st0");
  tn       = paramfile_get_float_param_or_exit(ppl,"stn");
  amp0     = paramfile_get_float_param_or_exit(ppl,"amp0");
  if (paramfile_test_param(ppl,"amp1"))
    amp1     = paramfile_get_float_param_or_exit(ppl,"amp1");
  else{
    offset0  = paramfile_get_float_param_or_exit(ppl,"offset0");
    amp1 = amp0 + offset0;
  }
  data = (float *)myalloc(n*sizeof(float));
  i0 = my_rint(t0 / tscale);
  for(i=0;i<n;i++){
    t = (float)(i-i0) * tscale; 
    if (((i%tsamp) == 0) && (t >= 0.0) && (t < tn)){
      data[i] = amp1;
    }else
      data[i] = amp0;
  }
  return data;
}
float *get_stim_1d_ppl_sine(ppl,n,tscale,tsamp)
     struct param_pair_list *ppl;
     int n;
     float tscale;
     int tsamp;
{
  int i;
  int i0;
  float *data,ph,f;
  float t0,tn,tf,phase,ampl,offset,bgval,t;
  t0       = paramfile_get_float_param_or_exit(ppl,"st0");
  tn       = paramfile_get_float_param_or_exit(ppl,"stn");
  tf       = paramfile_get_float_param_or_exit(ppl,"tf");
  phase    = paramfile_get_float_param_or_exit(ppl,"phase");
  ampl     = paramfile_get_float_param_or_exit(ppl,"ampl");
  offset   = paramfile_get_float_param_or_exit(ppl,"offset");
  bgval    = paramfile_get_float_param_or_exit(ppl,"bgval");
  data = (float *)myalloc(n*sizeof(float));
  f = tf * 2.0*M_PI;      
  ph = phase*M_PI/180.0;  
  i0 = my_rint(t0 / tscale);
  for(i=0;i<n;i++){
    t = (float)(i-i0) * tscale; 
    if (((i%tsamp) == 0) && (t >= 0.0) && (t < tn)){
      data[i] = offset + ampl * sin(f*t-ph);
    }else
      data[i] = bgval; 
  }
  return data;
}
float *get_stim_1d_ppl_vsksos(ppl,n,tscale,tsamp)
     struct param_pair_list *ppl;
     int n;
     float tscale;
     int tsamp;
{
  int i;
  int i0,vskn,pcomp;
  float *data,pratio;
  float t0,tn,ampl,offset,bgval,t;
  t0     = paramfile_get_float_param_or_exit(ppl,"st0");
  tn     = paramfile_get_float_param_or_exit(ppl,"stn");
  ampl   = paramfile_get_float_param_or_exit(ppl,"ampl");
  offset = paramfile_get_float_param_or_exit(ppl,"offset");
  bgval = paramfile_get_float_param_or_exit(ppl,"bgval");
  vskn   =   paramfile_get_int_param_or_exit(ppl,"vskn");
  pcomp  =   paramfile_get_int_param_or_exit(ppl,"pcomp",-1);
  pratio = paramfile_get_float_param_or_exit(ppl,"pratio",1.0);
  data = (float *)myalloc(n*sizeof(float));
  i0 = my_rint(t0 / tscale);
  for(i=0;i<n;i++){
    t = (float)(i-i0) * tscale; 
    if (((i%tsamp) == 0) && (t >= 0) && (t < tn)){
      data[i] = offset + ampl * get_vsk_sum_of_sinusoids(vskn,pcomp,pratio,t);
    }else
      data[i] = bgval; 
  }
  return data;
}
float *get_stim_1d_ppl_noise(ppl,n,tscale,tsamp)
     struct param_pair_list *ppl;
     int n;
     float tscale;
     int tsamp;
{
  int i;
  int i0,dt,seed,distrib,*rseq,nrseq,cnt,ri;
  float *data,rv,*gseq;
  float t0,tn,mu,sig,bgval,t;
  t0       = paramfile_get_float_param_or_exit(ppl,"st0");
  tn       = paramfile_get_float_param_or_exit(ppl,"stn");
  mu       = paramfile_get_float_param_or_exit(ppl,"mu");
  sig      = paramfile_get_float_param_or_exit(ppl,"sig");
  bgval   = paramfile_get_float_param_or_exit(ppl,"bgval");
  dt       =   paramfile_get_int_param_or_exit(ppl,"dt");
  seed     =   paramfile_get_int_param_or_exit(ppl,"seed");
  distrib  =   paramfile_get_int_param_or_exit(ppl,"distrib");
  if ((distrib < 1) || (distrib > 2))
    exit_error("GET_STIM_1D_PPL_NOISE","Error - must use distrib 1 or 2");
  data = (float *)myalloc(n*sizeof(float));
  cnt = dt;
  ri = 0;
  i0 = my_rint(t0 / tscale);
  for(i=0;i<n;i++){
    t = (float)(i-i0) * tscale; 
    if (((i%tsamp) == 0) && (t >= 0) && (t < tn)){
      if (cnt==dt){
	ri += 1;
	cnt = 0;
      }
      cnt += 1;
    }
  }
  nrseq = ri;
  rseq = NULL;
  gseq = NULL;
  if (distrib == 1)
    gseq = myrand_get_std_gauss_seq(nrseq,seed);  
  else if (distrib == 2)
    rseq = myrand_get_std_bin_seq(nrseq,seed);    
  rv = -1.0; 
  cnt = dt;
  ri = 0;
  i0 = my_rint(t0 / tscale);
  for(i=0;i<n;i++){
    t = (float)(i-i0) * tscale; 
    if (((i%tsamp) == 0) && (t >= 0) && (t < tn)){
      if (cnt==dt){
	if (ri >= nrseq)
	  exit_error("GET_STIM_1D_PPL_NOISE","Exceeded random sequence");
	if (distrib == 1){ 
	  rv = gseq[ri] * sig;
	}else if (distrib == 2){
	  if (rseq[ri])
	    rv = sig;
	  else
	    rv = -sig;
	}
	ri += 1;
	cnt = 0;
      }
      data[i] = mu + rv;
      cnt += 1;
    }else{
      data[i] = bgval;
    }
  }
  if (ri != nrseq){
    printf(" ri = %d   nrseq = %d\n",ri,nrseq);
    exit_error("GET_STIM_1D_PPL_NOISE","Excess random sequence");
  }
  if (distrib == 1)
    myfree(gseq);
  else if (distrib == 2)
    myfree(rseq);
  return data;
}
float *get_stim_1d_ppl_stat1(ppl,n,tscale,tsamp)
     struct param_pair_list *ppl;
     int n;
     float tscale;
     int tsamp;
{
  int i,j,k;
  int seed,nblk,ndur,bi,*ton,*toff,ts,t0,t1,done,**ndx,seqflag;
  int nmask,cn;
  float *data,tau,tsep,ampl,*emask,*ad;
  tau   = paramfile_get_float_param_or_exit(ppl,"tau");  
  seed  = paramfile_get_int_param_or_exit(ppl,"seed");
  nblk  = paramfile_get_int_param_or_exit(ppl,"nblock"); 
  ampl  = paramfile_get_float_param_or_exit(ppl,"ampl"); 
  tsep  = paramfile_get_float_param_or_exit(ppl,"tsep"); 
  seqflag  = paramfile_get_int_param_or_exit(ppl,"seq_type");
  stm_stat1d_get_seq(NULL,nblk,seqflag,seed,tscale,&ndur,&ton,&toff,&ndx);
  ts = my_rint(tsep/tscale);
  data = (float *)myalloc(n*sizeof(float));
  bi = 0; 
  i = 0;  
  done = 0;
  while(!done){
    j = 0;  
    while(done == 0){
      t1 = ton[ndx[bi][j]];
      t0 = toff[ndx[bi][j]];
      if ((i+t1+t0+ts) >= n)  
	done = 1;
      else{
	for(k=0;k<ts;k++){   
	  data[i] = 0.0;
	  i += 1;
	}
	for(k=0;k<t1;k++){   
	  data[i] = ampl;
	  i += 1;
	}
	for(k=0;k<t0;k++){   
	  data[i] = 0.0;
	  i += 1;
	}
      }
      j += 1;
      if (j >= ndur)
	done = 2;
    }
    if (done == 2)  
      done = 0;
    else{
      printf("*** GET_STIM_1D_PPL_STAT1  Warning, Cannot fit\n");
      printf("*** %d blocks in duration %f\n",nblk,(float)n*tscale);
    }
    bi += 1;
    if (bi >= nblk)
      done = 1;
  }
  free_2d_iarray(ndx,nblk);  myfree(ton);  myfree(toff);
  nmask = (int)(tau/tscale) * 10 + 1; 
  cn = (nmask-1)/2;
  emask = get_zero_farray(nmask);
  for(i=cn;i<nmask;i++)
    emask[i] = func_one_sided_exp((double)(i-cn),0.0,(double)(tau/tscale));
  norm_area_farray(emask,nmask,1.0);
  ad = fft_convolve(data,n,emask,nmask,1);
  for(i=0;i<n;i++)
    data[i] +=  -ad[i];
  myfree(ad); myfree(emask);
  return data;
}
void make_frame_flat(data,x0,xn,y0,yn,z0,zn,frame_num,value)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float value;
{
  int i,j;
  for(i=x0;i<(x0+xn);i++)
    for(j=y0;j<(y0+yn);j++)
      data[i][j][frame_num] = value;
}
void make_frame_scale_frame_zmid(data,x0,xn,y0,yn,z0,zn,frame_num,k,scale,
				 blankval)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num,k;
     float scale;
     float blankval;  
{
  int i,j;
  float yoff;
  yoff = -blankval;
  for(i=x0;i<(x0+xn);i++)
    for(j=y0;j<(y0+yn);j++)
      data[i][j][frame_num] = scale * (data[i][j][k] + yoff) - yoff;
}
void make_frame_from_3d(data,x0,xn,y0,yn,z0,zn,fi,d,dxn,dyn,dtn,k,winx0,winy0,
			winxn,winyn,destx0,desty0,bgval,maxlum)
     float ***data;                 
     int x0,xn,y0,yn,z0,zn,fi;      
     float ***d;                    
     int dxn,dyn,dtn,k;             
     int winx0,winy0,winxn,winyn;    
     int destx0,desty0;             
     float bgval,maxlum;           
{     
  int i,j;
  int winx1,winy1;
  winx1 = winx0 + winxn;
  winy1 = winy0 + winyn;
  if ((winx0 < 0) || (winy0 < 0) || (winx1 > dxn) || (winy1 > dyn))
    exit_error("MAKE_FRAME_FROM_3D","Source window coordinate error");
  if ((destx0 < x0) || (desty0 < y0) || ((destx0+winxn) > (x0+xn)) ||
      ((desty0+winyn) > (y0+yn)))
    exit_error("MAKE_FRAME_FROM_3D","Destination coordinate error");
  if ((destx0 > x0) || (desty0 > y0) || (winxn < xn)  || (winyn < yn))
    make_frame_flat(data,x0,xn,y0,yn,z0,zn,fi,bgval);
  for(i=winx0;i<winx1;i++)
    for(j=winy0;j<winy1;j++)
      data[destx0+i][desty0+j][fi] = d[i][j][k];
}
void frame_apply_aperture(data,x0,xn,y0,yn,z0,zn,frame_num,aptype,xc,yc,w,h,r,
			  value)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num,aptype;
     float xc,yc;   
     float w,h;     
     float r;       
     float value;   
{
  int i,j;
  int flag;
  float xf,yf,r2,t2,x1,x2,y1,y2;
  float a,b,c,d,thetar,xo,yo;
  if (aptype == 0)
    return;
  else if (aptype == 3){
    printf("   *** Aptype 3 is Gaussian, implemented elsewhere.\n");
    return;
  }
  r2 = w*w/4.0;
  x1 = -w/2.0;  x2 = w/2.0;
  y1 = -h/2.0;  y2 = h/2.0;
  if (aptype == 4){
    thetar = -r * M_PI/180.0;
    a =  cos(thetar); b = sin(thetar); 
    c = -sin(thetar); d = cos(thetar);
  }
  for(i=0;i<xn;i++){
    xf = (float)i-xc;
    for(j=0;j<yn;j++){
      yf = (float)j-yc;  
      flag = 0;
      if (aptype == 1){
	t2 = xf*xf + yf*yf;
	if (t2 > r2)
	  flag = 1;
      }else if (aptype == -1){
	t2 = xf*xf + yf*yf;
	if (t2 <= r2)
	  flag = 1;
      }else if (aptype == 2){
	if ((xf < x1)||(xf >= x2)||(yf < y1)||(yf >= y2))
	  flag = 1;
      }else if (aptype == -2){
	if ((xf >= x1)&&(xf < x2)&&(yf >= y1)&&(yf < y2))
	  flag = 1;
      }else if (aptype == 3){
	;  
      }else if (aptype == 4){
	xo = a*xf + c*yf;  
	yo = b*xf + d*yf;
	flag = 1;  
	if ((xo > -w/2.0) && (xo < w/2.0) &&
	    (yo > -h/2.0) && (yo < h/2.0))
	  flag = 0;  
      }else
	exit_error("FRAME_APPLY_APERTURE","Unknown aptype");
      if (flag)
	data[1+i][1+j][frame_num] = value;
    }
  }
}
void apply_aperture_scale(data,xn,yn,aptype,xc,yc,w,h,r,value,sval)
     float **data;
     int xn,yn;
     int aptype;
     float xc,yc;   
     float w,h;     
     float r;       
     float value;   
     float sval;    
{
  int i,j;
  int flag;
  float xf,yf,r2,t2,x1,x2,y1,y2;
  float a,b,c,d,thetar,xo,yo;
  if (aptype == 0){
    if (sval != 1.0){
      for(i=0;i<xn;i++){
	for(j=0;j<yn;j++){
	  data[i][j] *= sval;    
	}
      }
    }
    return;
  }else if (aptype == 3){
    printf("   *** Aptype 3 is Gaussian, implemented elsewhere.\n");
    return;
  }
  r2 = w*w/4.0;
  x1 = -w/2.0;  x2 = w/2.0;
  y1 = -h/2.0;  y2 = h/2.0;
  if (aptype == 4){
    thetar = -r * M_PI/180.0;
    a =  cos(thetar); b = sin(thetar); 
    c = -sin(thetar); d = cos(thetar);
  }
  for(i=0;i<xn;i++){
    xf = (float)i-xc;
    for(j=0;j<yn;j++){
      yf = (float)j-yc;
      flag = 0;
      if (aptype == 1){
	t2 = xf*xf + yf*yf;
	if (t2 > r2)
	  flag = 1;
      }else if (aptype == -1){
	t2 = xf*xf + yf*yf;
	if (t2 <= r2)
	  flag = 1;
      }else if (aptype == 2){
	if ((xf < x1)||(xf >= x2)||(yf < y1)||(yf >= y2))
	  flag = 1;
      }else if (aptype == -2){
	if ((xf >= x1)&&(xf < x2)&&(yf >= y1)&&(yf < y2))
	  flag = 1;
      }else if (aptype == 3){
	; 
      }else if (aptype == 4){
	xo = a*xf + c*yf;  
	yo = b*xf + d*yf;
	flag = 1;  
	if ((xo > -w/2.0) && (xo < w/2.0) &&
	    (yo > -h/2.0) && (yo < h/2.0))
	  flag = 0;  
      }else
	exit_error("APPLY_APERTURE","Unknown aptype");
      if (flag)
	data[i][j] = value;   
      else
	data[i][j] *= sval;   
    }
  }
}
void multiply_frame(data,x0,xn,y0,yn,z0,zn,frame_num,value)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float value;
{
  int i,j;
  for(i=x0;i<(x0+xn);i++)
    for(j=y0;j<(y0+yn);j++)
      data[i][j][frame_num] *= value;
}
void multiply_frame_gaussian(data,i1,i2,i3,n1,n2,n3,frame_num,xc,yc,sigma,
			     sscale)
     float ***data;
     int i1,i2,i3,n1,n2,n3,frame_num;
     float xc,yc;                     
     float sigma;                     
     float sscale;                    
{
  int i,j;
  float x,y;
  for(i=0;i<n1;i++){
    x = ((float)i-xc)*sscale;
    for(j=0;j<n2;j++){
      y = ((float)j-yc)*sscale;
      data[i1+i][i2+j][frame_num] *= 
	(float)func_2d_gaussian(x,y,0.0,0.0,sigma,sigma,0);
    }
  }
}
void multiply_frame_gaussian_0(data,n1,n2,xc,yc,sigma,sscale)
     float **data;
     int n1,n2;
     float xc,yc;                     
     float sigma;                     
     float sscale;                    
{
  int i,j;
  float x,y;
  for(i=0;i<n1;i++){
    x = ((float)i-xc)*sscale;
    for(j=0;j<n2;j++){
      y = ((float)j-yc)*sscale;
      data[i][j] *= (float)func_2d_gaussian(x,y,0.0,0.0,sigma,sigma,0);
    }
  }
}
void multiply_frame_sinusoid(data,i1,i2,i3,n1,n2,n3,frame_num,freq,theta,
			     sscale,phase)
     float ***data;
     int i1,i2,i3,n1,n2,n3,frame_num;
     float freq,theta,sscale,phase;
{
  int i,j;
  int xc,yc;
  float x,y,nx,ny,twopif,ph;
  twopif = 2.0*M_PI*freq;
  ph = freq * phase * 2.0*M_PI;
  nx = cos(theta/180.0 * M_PI);
  ny = sin(theta/180.0 * M_PI);
  xc = (n1-1)/2;
  yc = (n2-1)/2;
  for(i=0;i<n1;i++){
    x = (float)(i-xc)*sscale;
    for(j=0;j<n2;j++){
      y = (float)(j-yc)*sscale;
      data[i1+i][i2+j][frame_num] *= cos(ph + twopif*(nx*x+ny*y));
    }
  }
}
void draw_circ_sine_in_frame(data,x0,xn,y0,yn,z0,zn,frame_num,cx,cy,size,freq,
			     theta,phase,sscale,con)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float cx,cy,size,freq,theta,phase,sscale,con;
{
  int i,j;
  int xc,yc,i1,i2,j1,j2;
  float x,y,nx,ny,ph,twopif,r1s;
  r1s = size*size/4.0;
  twopif = 2.0*M_PI*freq;
  ph = phase/180.0 * M_PI;  
  nx = cos(theta/180.0 * M_PI);
  ny = sin(theta/180.0 * M_PI);
  xc = (xn-1)/2 + (int)(cx/sscale);
  yc = (yn-1)/2 + (int)(cy/sscale);
  i1 = xc - xn/2 - 1; 
  if (i1 < 0) i1 = 0;
  i2 = xc + xn/2 + 1; 
  if (i2 >= xn) i2 = xn-1;
  j1 = yc - yn/2 - 1; 
  if (j1 < 0) j1 = 0;
  j2 = yc + yn/2 + 1; 
  if (j2 >= yn) j2 = yn-1;
  for(i=i1;i<=i2;i++){
    x = (float)(i-xc)*sscale;
    for(j=j1;j<=j2;j++){
      y = (float)(j-yc)*sscale;
      if ((x*x + y*y) < r1s) 
	data[x0+i][y0+j][frame_num] = con*cos(twopif*(nx*x+ny*y) - ph);
    }
  }
}
void make_frame_circ_cs_sine(data,x0,xn,y0,yn,z0,zn,frame_num,size,idiam,odiam,
			     freq_c,freq_s,theta_c,theta_s,phase_c,phase_s,
			     sscale,con1,con2,bgampl,cx,cy,cs_flag)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float size,idiam,odiam,freq_c,freq_s,theta_c,theta_s,phase_c,phase_s;
     float sscale,con1,con2,bgampl;
     float cx,cy; 
     int cs_flag; 
{
  int i,j;
  float xc,yc;
  float x,y,nx1,ny1,ph1,nx2,ny2,ph2,twopif1,twopif2,r1s,r2s,r3s;
  r1s = size*size/4.0;
  r2s = idiam*idiam/4.0;
  r3s = odiam*odiam/4.0;
  twopif1 = 2.0*M_PI*freq_c;
  twopif2 = 2.0*M_PI*freq_s;
  ph1 = phase_c/180.0 * M_PI;  
  nx1 = cos(theta_c/180.0 * M_PI);
  ny1 = sin(theta_c/180.0 * M_PI);
  ph2 = phase_s/180.0 * M_PI;  
  nx2 = cos(theta_s/180.0 * M_PI);
  ny2 = sin(theta_s/180.0 * M_PI);
  xc = (float)(xn-1)/2.0 *sscale + cx;  
  yc = (float)(yn-1)/2.0 *sscale + cy;  
  for(i=0;i<xn;i++){
    x = (float)i*sscale - xc;
    for(j=0;j<yn;j++){
      y = (float)j*sscale - yc;
      if ((x*x + y*y) < r1s){ 
	if ((cs_flag == 1) || (cs_flag == 3))
	  data[x0+i][y0+j][frame_num] = con1*cos(twopif1*(nx1*x+ny1*y) - ph1);
	else
	  data[x0+i][y0+j][frame_num] = bgampl; 
      }else if ((x*x + y*y) < r2s) 
	data[x0+i][y0+j][frame_num] = bgampl; 
      else if ((x*x + y*y) < r3s){ 
	if ((cs_flag == 2) || (cs_flag == 3))
	  data[x0+i][y0+j][frame_num] = con2*cos(twopif2*(nx2*x+ny2*y) - ph2);
	else
	  data[x0+i][y0+j][frame_num] = bgampl; 
      }else
	data[x0+i][y0+j][frame_num] = bgampl; 
    }
  }
}
void make_frame_disk_flat(data,x0,xn,y0,yn,z0,zn,frame_num,size,
			  sscale,ampl,bgval)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float size,sscale,ampl,bgval;
{
  int i,j;
  int xc,yc;
  float x,y,r1s;
  r1s = size*size/4.0;
  xc = (xn-1)/2;
  yc = (yn-1)/2;
  for(i=0;i<xn;i++){
    x = (float)(i-xc)*sscale;
    for(j=0;j<yn;j++){
      y = (float)(j-yc)*sscale;
      if ((x*x + y*y) < r1s) 
	data[x0+i][y0+j][frame_num] = ampl;
      else 
	data[x0+i][y0+j][frame_num] = bgval; 
    }
  }
}
void make_frame_circ_cs_flat(data,x0,xn,y0,yn,z0,zn,frame_num,size,idiam,odiam,
			     sscale,campl,sampl,bgval)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float size,idiam,odiam,sscale,campl,sampl,bgval;
{
  int i,j;
  int xc,yc;
  float x,y,r1s,r2s,r3s;
  r1s = size*size/4.0;
  r2s = idiam*idiam/4.0;
  r3s = odiam*odiam/4.0;
  xc = (xn-1)/2;
  yc = (yn-1)/2;
  for(i=0;i<xn;i++){
    x = (float)(i-xc)*sscale;
    for(j=0;j<yn;j++){
      y = (float)(j-yc)*sscale;
      if ((x*x + y*y) < r1s) 
	data[x0+i][y0+j][frame_num] = campl;
      else if ((x*x + y*y) < r2s) 
	data[x0+i][y0+j][frame_num] = bgval; 
      else if ((x*x + y*y) < r3s) 
	data[x0+i][y0+j][frame_num] = sampl;
      else 
	data[x0+i][y0+j][frame_num] = bgval; 
    }
  }
}
void make_frame_add_triangle(data,x0,xn,y0,yn,z0,zn,frame_num,sbot,sleft,sright,
			     xctr,yctr,sscale,ampl,bgval)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float sbot,sleft,sright;    
     float xctr,yctr;            
     float sscale,ampl,bgval;
{
  int i,j;
  int xc,yc;
  float x,y;
  float a,b,c,ta,theta_a,theta_b,ml,mr,h,wl;
  float ax,ay,bx,by,cx,cy,yleft,yright;
  c = sbot;
  a = sleft;
  b = sright;
  theta_a = acos((b*b + c*c - a*a) / (2.0*b*c));     
  theta_b = acos((a*a + c*c - b*b) / (2.0*a*c));     
  ml = tan(theta_b);                                 
  mr = -tan(theta_a);                                
  h = a * sin(theta_b);                              
  wl = a * cos(theta_b);                             
  ax =  sbot / 2.0;                                  
  ay = -h    / 2.0;                                  
  bx = -sbot / 2.0;                                  
  by = -h    / 2.0;                                  
  cx =  ax + wl;                                     
  cy =  h    / 2.0;                                  
  xc = (xn-1)/2;
  yc = (yn-1)/2;
  for(i=0;i<xn;i++){
    x = (float)(i-xc)*sscale;
    yleft  = by + ml * (x - bx);  
    yright = ay + mr * (x - ax);  
    for(j=0;j<yn;j++){
      y = (float)(j-yc)*sscale;
      if ((y >= ay) && (y <= yleft) && (y <= yright)){
	data[x0+i][y0+j][frame_num] = ampl;
      }
    }
  }
}
void make_frame_edge_01(data,x0,xn,y0,yn,z0,zn,frame_num,amp,sd,pseed)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float amp,sd;
     int *pseed;
{
  int i,j,j1,j2;
  int k,tmp_xn,tmp_yn,ymid,yoff,yoffr,cnt;
  float **gt,x,y,dx,s,ss,yran;
  k = (int)(3*sd);
  tmp_xn = 2*k - 1;
  tmp_yn = k;
  gt = get_2d_farray(tmp_xn,tmp_yn);
  for(i=0;i<tmp_xn;i++){
    for(j=0;j<tmp_yn;j++){
      x = i;
      y = j;
      gt[i][j] = func_2d_gaussian(x,y,(float)k,0.0,sd,sd,0);  
      if (gt[i][j] > 1.0)
	printf("%f\n",gt[i][j]);
    }
  }
  for(i=x0;i<(x0+xn);i++)
    for(j=y0;j<(y0+yn);j++)
      data[i][j][frame_num] = 0.0;
  ymid = (y0+yn)/2;
  ss = 0.3 * myrand_util_ran2(pseed);
  dx = tmp_xn;
  cnt = 0;
  for(i=x0+k;i<(x0+xn-k);i++){
    if (cnt == 0){
      yran = myrand_util_ran2(pseed);
      if (yran < 0.333)
	yoffr = ymid - 3;
      else if (yran > 0.667)
	yoffr = ymid + 3;
      else
	yoffr = ymid;
    }
    yoffr = ymid;  
    if (cnt == 1){
      yoff = ymid;
      s = ss;
    }else{
      yoff = yoffr;
      if (ss > 0)
	s = 1.0;
      else
	s = -1.0;
    }
    s = -0.3 + 0.6 * myrand_util_ran2(pseed);
    for(j1=0;j1<tmp_xn;j1++)
      for(j2=0;j2<tmp_yn;j2++)
	data[i+j1-k][yoff-j2][frame_num] += -s * gt[j1][j2];
    for(j1=0;j1<tmp_xn;j1++)
      for(j2=0;j2<tmp_yn;j2++)
	data[i+j1-k][yoff+j2+1][frame_num] += s * gt[j1][j2];
    cnt += 1;
  }
  free_2d_farray(gt,tmp_xn);
}
void make_frame_sinusoid(data,x0,xn,y0,yn,z0,zn,frame_num,freq,theta,sscale,
			 phase,xc,yc)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float freq,theta,sscale,phase;
     float xc,yc;                       
{
  int i,j;
  float x,y,nx,ny,twopif,ph;
  twopif = 2.0*M_PI*freq;
  ph = phase/180.0 * M_PI;
  nx = cos(theta/180.0 * M_PI);
  ny = sin(theta/180.0 * M_PI);
  for(i=0;i<xn;i++){
    x = (float)i*sscale - xc;
    for(j=0;j<yn;j++){
      y = (float)j*sscale - yc;
      data[x0+i][y0+j][frame_num] = cos(twopif*(nx*x+ny*y) - ph);
    }
  }
}
void make_frame_sinusoid_0(data,xn,yn,freq,theta,sscale,phase,xc,yc,ampl)
     float **data;
     int xn,yn;
     float freq;    
     float theta;   
     float sscale;  
     float phase;   
     float xc,yc;   
     float ampl;    
{
  int i,j;
  float x,y,nx,ny,twopif,ph;
  twopif = 2.0*M_PI*freq;
  ph = phase/180.0 * M_PI;
  nx = cos(theta/180.0 * M_PI);
  ny = sin(theta/180.0 * M_PI);
  for(i=0;i<xn;i++){
    x = (float)i*sscale - xc;
    for(j=0;j<yn;j++){
      y = (float)j*sscale - yc;
      data[i][j] = ampl * cos(twopif*(nx*x+ny*y) - ph);
    }
  }
}
void make_frame_sinusoid_scale(data,x0,xn,y0,yn,z0,zn,frame_num,freq,theta,
			       sscale,phase,xc,yc,c,phorg)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float freq,theta,sscale,phase;
     float xc,yc;                       
     float c;                           
     int   phorg;                       
{
  int i,j;
  float x,y,nx,ny,twopif,ph;
  int cxi,cyi;
  if (phorg == 1){   
    cxi = xn/2;
    cyi = yn/2;
  }else{
    cxi = cyi = 0;   
  }
  twopif = 2.0*M_PI*freq;
  ph = phase/180.0 * M_PI;
  nx = cos(theta/180.0 * M_PI);
  ny = sin(theta/180.0 * M_PI);
  for(i=0;i<xn;i++){
    x = (float)(i-cxi)*sscale - xc;  
    for(j=0;j<yn;j++){
      y = (float)(j-cyi)*sscale - yc; 
      data[x0+i][y0+j][frame_num] = c * cos(twopif*(nx*x+ny*y) - ph);
    }
  }
}
void vdp_tilt_rectangle(xcenter,ycenter,width,height,angle,k)
     int xcenter,ycenter,width,height,angle,k;
{
  int ip; 
  short ncols,row;
  int jp; 
  register short col;
  int i;
  int x1,y1,x2,y2,x3,y3,x4,y4,ytop,ybot,left,right,dx1,dy1,dx2,dy2;
  float fh,fw,theta,phi,r,m1,m2,b1,b2,b3,b4,ml,bl,mr,br;
  int ycenter2,xmax,nn;
  int ROWINC;
  ROWINC = 128; 
  ROWINC = 128; 
}
void make_frame_bar_add_0(data,xn,yn,cbx,cby,theta,len,wid,sdaa,sscale,ampl)
     float **data;       
     int xn,yn;          
     float cbx,cby;      
     float theta;        
     float len,wid;      
     float sdaa;         
     float sscale;       
     float ampl;         
{
  int i,j;
  int xc,yc;
  float x,y,xx,yy,f,a,b,c,d,thetar,lo2,wo2,db,dbx,dby,sd,sd4,newval;
  lo2 = len/2.0;
  wo2 = wid/2.0;
  sd = sdaa * sscale;  
  sd4 = sd * 4.0;      
  while(theta >= 180.0)
    theta -= 180.0;
  while(theta < 0.0)
    theta += 180.0;
  thetar = -theta * M_PI/180.0;
  a =  cos(thetar); b = sin(thetar); 
  c = -sin(thetar); d = cos(thetar);
  xc = (xn-1)/2; 
  yc = (yn-1)/2; 
  for(i=0;i<xn;i++){
    xx = (float)(i-xc)*sscale - cbx;  
    for(j=0;j<yn;j++){
      yy = (float)(j-yc)*sscale - cby; 
      x = a*xx + c*yy;  
      y = b*xx + d*yy;
      if (x > 0.0)
	dbx = wo2 - x;  
      else
	dbx = x + wo2;
      if (y > 0.0)
	dby = lo2 - y;  
      else
	dby = y + lo2;
      if (dbx < 0.0){   
	if (dby < 0.0){
	  db = -sqrt(dbx*dbx + dby*dby);  
	}else{
	  db = dbx;
	}
      }else{ 
	if (dby < 0.0){  
	  db = dby;
	}else{ 
	  if (dby < dbx)
	    db = dby;
	  else
	    db = dbx;
	}
      }
      if (sdaa > 0.0){
	if (db > sd)
	  f = 1.0; 
	else if (db < -sd)
	  f = 0.0;  
	else 
	  f = 0.5 + 0.5*sin(db/sd * 0.25*M_PI);
      }else{
	if (db >= 0.0)
	  f = 1.0; 
	else
	  f = 0.0; 
      }
      newval = f * ampl;
      data[i][j] += newval;
    }
  }
}
void make_frame_bar(data,x0,xn,y0,yn,z0,zn,frame_num,cbx,cby,theta,len,wid,
		    sdaa,sscale,ampl,bgval,flag)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float cbx,cby,theta,len,wid,sdaa,sscale,ampl,bgval;
     int flag;  
{
  int i,j;
  int xc,yc;
  float x,y,xx,yy,f,a,b,c,d,thetar,lo2,wo2,db,dbx,dby,sd,sd4,newval;
  lo2 = len/2.0;
  wo2 = wid/2.0;
  sd = sdaa * sscale;  
  sd4 = sd * 4.0;      
  while(theta >= 180.0)
    theta -= 180.0;
  while(theta < 0.0)
    theta += 180.0;
  thetar = -theta * M_PI/180.0;
  a =  cos(thetar); b = sin(thetar); 
  c = -sin(thetar); d = cos(thetar);
  xc = (xn-1)/2; 
  yc = (yn-1)/2; 
  for(i=0;i<xn;i++){
    xx = (float)(i-xc)*sscale - cbx;  
    for(j=0;j<yn;j++){
      yy = (float)(j-yc)*sscale - cby; 
      x = a*xx + c*yy;  
      y = b*xx + d*yy;
      if (x > wo2)
	dbx = x - wo2;
      else if (x < -wo2)
	dbx = -wo2 - x;
      else
	dbx = 0.0;
      if (y > lo2)
	dby = y - lo2;
      else if (y < -lo2)
	dby = -lo2 - y;
      else
	dby = 0.0;
      db = sqrt(dbx*dbx + dby*dby);
      if (db > sd4)
	f = 0.0;     
      else if (db > 0.0)
	f = func_gaussian_one(db,0.0,sd);
      else
	f = 1.0;
      newval = bgval + f * (ampl-bgval);
      if (flag == 0) 
	data[x0+i][y0+j][frame_num] = newval;
      else if (f > 0.0){ 
	if (ampl >= bgval){
	  if (data[x0+i][y0+j][frame_num] < newval)
	    data[x0+i][y0+j][frame_num] = newval;
	}else{
	  if (data[x0+i][y0+j][frame_num] > newval)
	    data[x0+i][y0+j][frame_num] = newval;
	}
      }
    }
  }
}
void make_frame_bar_0(data,xn,yn,cbx,cby,theta,len,wid,
		      sdaa,sscale,ampl,bgval,flag)
     float **data;
     int xn,yn;
     float cbx,cby,theta,len,wid,sdaa,sscale,ampl,bgval;
     int flag;  
{
  int i,j;
  int xc,yc;
  float x,y,xx,yy,f,a,b,c,d,thetar,lo2,wo2,db,dbx,dby,sd,sd4,newval;
  lo2 = len/2.0;
  wo2 = wid/2.0;
  sd = sdaa * sscale;  
  sd4 = sd * 4.0;      
  while(theta >= 180.0)
    theta -= 180.0;
  while(theta < 0.0)
    theta += 180.0;
  thetar = -theta * M_PI/180.0;
  a =  cos(thetar); b = sin(thetar); 
  c = -sin(thetar); d = cos(thetar);
  xc = (xn-1)/2; 
  yc = (yn-1)/2; 
  for(i=0;i<xn;i++){
    xx = (float)(i-xc)*sscale - cbx;  
    for(j=0;j<yn;j++){
      yy = (float)(j-yc)*sscale - cby; 
      x = a*xx + c*yy;  
      y = b*xx + d*yy;
      if (x > wo2)
	dbx = x - wo2;
      else if (x < -wo2)
	dbx = -wo2 - x;
      else
	dbx = 0.0;
      if (y > lo2)
	dby = y - lo2;
      else if (y < -lo2)
	dby = -lo2 - y;
      else
	dby = 0.0;
      db = sqrt(dbx*dbx + dby*dby);
      if (db > sd4)
	f = 0.0;     
      else if (db > 0.0)
	f = func_gaussian_one(db,0.0,sd);
      else
	f = 1.0;
      newval = bgval + f * (ampl-bgval);
      if (flag == 0) 
	data[i][j] = newval;
      else if (f > 0.0){ 
	if (ampl >= bgval){
	  if (data[i][j] < newval)
	    data[i][j] = newval;
	}else{
	  if (data[i][j] > newval)
	    data[i][j] = newval;
	}
      }
    }
  }
}
void make_frame_bars(data,x0,xn,y0,yn,z0,zn,frame_num,nbar,bw,bl,theta,
		     bar_val,bgval)
     float ***data;
     int x0,xn,y0,yn,z0,zn;
     int frame_num;    
     int nbar;         
     float bw,bl;      
     float theta;      
     float *bar_val;   
     float bgval;      
{
  int i,j;
  int w,l,bi,xx0,xx1,yy0,yy1,x1,y1;
  if (theta != 0){
    exit_error("MAKE_FRAME_BARS","Direction must be zero, others not imp'd");
  }
  x1 = x0 + xn - 1;  
  y1 = y0 + yn - 1;  
  w = my_rint(bw);  
  l = my_rint(bl);  
  for(i=x0;i<(x0+xn);i++){
    for(j=y0;j<(y0+yn);j++){
      data[i][j][frame_num] = bgval;
    }
  }
  yy0 = y0 + yn/2 - l/2;
  yy1 = y0 + yy0 + l - 1;
  if (yy0 < y0)
    yy0 = y0;
  if (yy1 > y1)
    yy1 = y1;
  xx0 = x0 + xn/2 - nbar*w/2;
  for(bi=0;bi<nbar;bi++){
    xx1 = xx0 + w - 1;
    for(i=xx0;i<=xx1;i++){
      if ((i >= x0) && (i <= x1)){
	for(j=yy0;j<=yy1;j++){
	  data[i][j][frame_num] = bar_val[bi];
	}
      }
    }
    xx0 += w;
  }
}
float **make_frame_bars_tmplt(bartemp,xn,yn,nbar,bar_val,bgval)
     float **bartemp;  
     int xn,yn;        
     int nbar;         
     float *bar_val;   
     float bgval;      
{
  int i,j;
  int bi;
  float **d,tv,v0,v1,rem;
  d = get_2d_farray(xn,yn);
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      tv = bartemp[i][j];    
      bi = (int)tv;          
      rem = tv - (float)bi;  
      if (bi < 1){
	v0 = bgval;
	v1 = bar_val[0];  
      }else if (bi > nbar){  
	v0 = bgval;
	v1 = bgval;
      }else if (bi == nbar){
	v0 = bar_val[nbar-1];  
	v1 = bgval;
      }else{
	v0 = bar_val[bi-1];   
	v1 = bar_val[bi];
      }
      if (rem == 0.0){
	d[i][j] = v0;  
      }else{
	d[i][j] = (1.0 - rem) * v0 + rem*v1;  
      }
    }
  }
  return d;
}
float **make_frame_barpatmo(xn,yn,x0,y0,nbar,bwpix,blpix,seq,seqn,si,pi,
			    altsign,val1,val2,bgval,idir)
     int xn,yn;        
     int x0,y0;        
     int nbar;         
     int bwpix;        
     int blpix;        
     int *seq;         
     int seqn;         
     int si;           
     int pi;           
     int altsign;      
     float val1,val2;  
     float bgval;      
     int idir;         
{
  int i,j;
  int irev,x1,y1,seqval;
  float **d,bval;
  d = get_const_2d_farray(xn,yn,bgval);  
  x1 = x0 + nbar*bwpix;
  y1 = y0 + blpix;
  if (y0 < 0)
    y0 = 0;
  if (y1 > yn)  
    y1 = yn;
  for(i=x0;i<x1;i++){
    if (si >= seqn)
      exit_error("MAKE_FRAME_BARPATMO","Sequence index too large");
    seqval = seq[si];  
    if (altsign == 1){  
      if (seqval == -1)
	bval = val1;
      else if (seqval == 1)
	bval = val2;
      else
	bval = bgval;
    }else{
      if (seqval == 1)
	bval = val1;
      else if (seqval == -1)
	bval = val2;
      else
	bval = bgval;
    }
    if ((i >= 0) && (i < xn)){  
      if (idir == 180){
	for(j=y0;j<y1;j++)
	  d[i][j] = bval;
      }else if (idir == 0){
	irev = x1-1 - (i-x0);
	for(j=y0;j<y1;j++)
	  d[irev][j] = bval;
      }
    }
    pi += 1;
    if (pi >= bwpix){
      pi = 0;
      si += 1;  
    }
  }
  return d;
}
void make_frame_add_2d_gauss(data,xn,yn,amp,sd,x0,y0,sscale)
     float **data;
     int xn,yn;       
     float amp;       
     float sd,x0,y0;  
     float sscale;    
{
  int i,j;
  float xci,yci;
  float x,y;
  xci = (xn-1)/2;
  yci = (yn-1)/2;
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      x = (xci - (float)i)*sscale - x0;
      y = (yci - (float)j)*sscale - y0;
      data[i][j] += exp(-(x*x + y*y)/(0.5*sd*sd));
    }
  }
}
void make_frame_add_rect_pix(data,x0,xn,y0,yn,z0,zn,frame_num,x,y,w,h,val)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     int x,y;    
     int w,h;    
     float val;  
{
  int i,j;
  int x1,x2,y1,y2;
  x1 = x;
  if (x1<x0)
    x1 = x0;
  x2 = x+w-1;
  if (x2 >= (x0+xn))
    x2 = (x0+xn-1);
  y1 = y;
  if (y1<y0)
    y1 = y0;
  y2 = y+h-1;
  if (y2 >= (y0+yn))
    y2 = (y0+yn-1);
  for(i=x1;i<=x2;i++){
    for(j=y1;j<=y2;j++){
      data[i][j][frame_num] += val;
    }
  }
}
void make_frame_add_rect_pix_0(data,xn,yn,x,y,w,h,val)
     float **data;
     int xn,yn;
     int x,y;    
     int w,h;    
     float val;  
{
  int i,j;
  int x1,x2,y1,y2;
  x1 = x;
  if (x1 < 0)
    x1 = 0;
  x2 = x+w-1;
  if (x2 >= xn)
    x2 = xn-1;
  y1 = y;
  if (y1 < 0)
    y1 = 0;
  y2 = y+h-1;
  if (y2 >= yn)
    y2 = yn-1;
  for(i=x1;i<=x2;i++){
    for(j=y1;j<=y2;j++){
      data[i][j] += val;
    }
  }
}
void make_frame_add_sine_bump(data,x0,xn,y0,yn,z0,zn,frame_num,x,y,diam,val)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float x,y;   
     float diam;  
     float val;   
{
  int i,j;
  int x1,x2,y1,y2;
  float c,do2,w,dx,dy,dist;
  x1 = (int)(x - diam/2.0);      
  x2 = (int)(x + diam/2.0 + 1);  
  y1 = (int)(y - diam/2.0);      
  y2 = (int)(y + diam/2.0 + 1);  
  if (x1 < x0)
    x1 = x0;
  if (x2 >= (x0+xn))
    x2 = x0 + xn - 1;
  if (y1 < y0)
    y1 = y0;
  if (y2 >= (y0+yn))
    y2 = y0 + yn - 1;
  do2 = diam/2.0;
  c = M_PI/do2;
  for(i=x1;i<=x2;i++){
    for(j=y1;j<=y2;j++){
      dx = (float)i - x;
      dy = (float)j - y;
      dist = sqrt(dx*dx + dy*dy);
      if (dist > do2)
	w = 0.0;
      else
	w = 0.5 + 0.5*cos(dist * c);
      data[i][j][frame_num] += val * w;
    }
  }
}
void make_frame_add_sine_bump_0(data,xn,yn,x,y,diam,val)
     float **data;
     int xn,yn;
     float x,y;   
     float diam;  
     float val;   
{
  int i,j;
  int x1,x2,y1,y2;
  float c,do2,w,dx,dy,dist;
  x1 = (int)(x - diam/2.0);      
  x2 = (int)(x + diam/2.0 + 1);  
  y1 = (int)(y - diam/2.0);      
  y2 = (int)(y + diam/2.0 + 1);  
  if (x1 < 0)
    x1 = 0;
  if (x2 >= xn)
    x2 = xn-1;
  if (y1 < 0)
    y1 = 0;
  if (y2 >= yn)
    y2 = yn-1;
  do2 = diam/2.0;
  c = M_PI/do2;
  for(i=x1;i<=x2;i++){
    for(j=y1;j<=y2;j++){
      dx = (float)i - x;
      dy = (float)j - y;
      dist = sqrt(dx*dx + dy*dy);
      if (dist > do2)
	w = 0.0;
      else
	w = 0.5 + 0.5*cos(dist * c);
      data[i][j] += val * w;
    }
  }
}
void make_frame_binarize(data,x0,xn,y0,yn,z0,zn,frame_num,thresh,a,b)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float thresh,a,b;
{
  int i,j;
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      if (data[x0+i][y0+j][frame_num] >= thresh)
	data[x0+i][y0+j][frame_num] = a;
      else
	data[x0+i][y0+j][frame_num] = b;
    }
  }
}
void make_frame_binarize_0(data,xn,yn,thresh,a,b)
     float **data;
     int xn,yn;
     float thresh,a,b;
{
  int i,j;
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      if (data[i][j] >= thresh)
	data[i][j] = a;
      else
	data[i][j] = b;
    }
  }
}
void make_frame_add_dots(data,x0,xn,y0,yn,z0,zn,frame_num,dotx,doty,dotn,
			 ampl,ampmin,ampmax,dsize,varamp)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float *dotx,*doty;               
     int dotn;
     float ampl,ampmin,ampmax,dsize;  
     float *varamp;                   
{
  int i,j,k;
  int nio2,ni,xi,yi,xfin,yfin;
  float x1,y1,d,damp;
  nio2 = (int)(0.5 + dsize*3.0);
  if (nio2 < 1)
    nio2 = 1;
  ni = 2*nio2 + 1;
  for(i=0;i<dotn;i++){
    x1 = dotx[i];  
    y1 = doty[i];
    if (varamp == NULL)
      damp = ampl;
    else
      damp = varamp[i];
    xi = my_rint(x1) - nio2;
    yi = my_rint(y1) - nio2;
    xfin = xi+ni;
    yfin = yi+ni;
    for(j=xi;j<xfin;j++){
      for(k=yi;k<yfin;k++){  
	if ((j>=0) && (j<xn) && (k>=0) && (k<yn)){
	  d = data[x0+j][y0+k][frame_num];
	  d += damp * func_2d_gaussian((float)j,(float)k,x1,y1,dsize,dsize,0);
	  if (d > ampmax)
	    d = ampmax;
	  else if (d < ampmin)
	    d = ampmin;
	  data[x0+j][y0+k][frame_num] = d;
	}
      }
    }
  }
}
void make_frame_add_dots_0(data,xn,yn,dotx,doty,dotn,ampl,ampmin,ampmax,dsize,
			   varamp)
     float **data;
     int xn,yn;
     float *dotx,*doty;
     int dotn;
     float ampl,ampmin,ampmax,dsize;
     float *varamp;                   
{
  int i,j,k;
  int nio2,ni,xi,yi,xfin,yfin;
  float x1,y1,d,damp;
  nio2 = (int)(0.5 + dsize*3.0);
  if (nio2 < 1)
    nio2 = 1;
  ni = 2*nio2 + 1;
  for(i=0;i<dotn;i++){
    x1 = dotx[i];  
    y1 = doty[i];
    if (varamp == NULL)
      damp = ampl;
    else
      damp = varamp[i];
    xi = my_rint(x1) - nio2;
    yi = my_rint(y1) - nio2;
    xfin = xi+ni;
    yfin = yi+ni;
    for(j=xi;j<xfin;j++){
      for(k=yi;k<yfin;k++){  
	if ((j>=0) && (j<xn) && (k>=0) && (k<yn)){
	  d = data[j][k];
	  d += damp * func_2d_gaussian((float)j,(float)k,x1,y1,dsize,dsize,0);
	  if (d > ampmax)
	    d = ampmax;
	  else if (d < ampmin)
	    d = ampmin;
	  data[j][k] = d;
	}
      }
    }
  }
}
void make_frame_add_dots_clipr(data,xn,yn,dotx,doty,dotn,ampl,ampmin,ampmax,
			       dsize,varamp,crx1,crx2,cry1,cry2)
     float **data;        
     int xn,yn;           
     float *dotx,*doty;   
     int dotn;            
     float ampl;          
     float ampmin,ampmax; 
     float dsize;         
     float *varamp;       
     float crx1,crx2;     
     float cry1,cry2;     
{
  int i,j,k;
  int nio2,ni,xi,yi,xfin,yfin,flag,inflag,ix1,ix2,iy1,iy2;
  float x1,y1,d,damp;
  nio2 = (int)(0.5 + dsize*3.0);
  if (nio2 < 1)
    nio2 = 1;
  ni = 2*nio2 + 1;
  ix1 = my_rint(crx1);  
  ix2 = my_rint(crx2);  
  iy1 = my_rint(cry1);
  iy2 = my_rint(cry2);
  for(i=0;i<dotn;i++){
    x1 = dotx[i];  
    y1 = doty[i];
    if (varamp == NULL)
      damp = ampl;
    else
      damp = varamp[i];
    xi = my_rint(x1) - nio2;
    yi = my_rint(y1) - nio2;
    xfin = xi+ni - 1;
    yfin = yi+ni - 1;
    if ((x1 >= crx1) && (x1 <= crx2) && (y1 >= cry1) && (y1 <= cry2)){
      inflag = 1; 
      if (xi   < ix1)  xi   = ix1;
      if (xfin > ix2)  xfin = ix2;
      if (yi   < iy1)  yi   = iy1;
      if (yfin > iy2)  yfin = iy2;
    }else{
      inflag = 0;
    }
    for(j=xi;j<=xfin;j++){
      for(k=yi;k<=yfin;k++){  
	flag = 1;
	if (inflag == 0){
	  if ((j >= ix1) && (j <= ix2) &&
	      (k >= iy1) && (k <= iy2))
	    flag = 0;
	}
	if ((j>=0) && (j<xn) && (k>=0) && (k<yn) && (flag==1)){
	  d = data[j][k];
	  d += damp * func_2d_gaussian((float)j,(float)k,x1,y1,dsize,dsize,0);
	  if (d > ampmax)
	    d = ampmax;
	  else if (d < ampmin)
	    d = ampmin;
	  data[j][k] = d;
	}
      }
    }
  }
}
void make_frame_gp_trans(data,x0,xn,y0,yn,z0,zn,frame_num,sscale,r,theta,
			 amp1,amp2,ampbg,ampmin,ampmax,dsize,xf,dn,rseed)
     float ***data;
     int x0,xn,y0,yn,z0,zn,frame_num;
     float sscale,r,theta,amp1,amp2,ampbg,ampmin,ampmax,dsize,xf;
     int dn,*rseed;
{
  int i,j,k;
  int xi,yi,ni,nio2,xfin,yfin;
  float x,y,x1,y1,x2,y2,fxn,fyn;
  float dx,dy;
  dx = (r/2.0)/sscale * cos(theta/180.0 * M_PI);
  dy = (r/2.0)/sscale * sin(theta/180.0 * M_PI);
  fxn = xf * (float)xn;
  fyn = xf * (float)yn;
  for(i=0;i<xn;i++)
    for(j=0;j<yn;j++)
      data[x0+i][y0+j][frame_num] = ampbg;
  nio2 = (int)(0.5 + dsize*3.0);
  if (nio2 < 1)
    nio2 = 1;
  ni = 2*nio2 + 1;
  for(i=0;i<dn;i++){
    x = fxn * myrand_util_ran2(rseed);
    y = fyn * myrand_util_ran2(rseed);
    x1 = x + dx;
    y1 = y + dy;
    x2 = x - dx;
    y2 = y - dy;
    while (x1 <    0) x1 += fxn;    while (x1 >= fxn) x1 -= fxn;
    while (y1 <    0) y1 += fyn;    while (y1 >= fyn) y1 -= fyn;
    while (x2 <    0) x2 += fxn;    while (x2 >= fxn) x2 -= fxn;
    while (y2 <    0) y2 += fyn;    while (y2 >= fyn) y2 -= fyn;
    xi = my_rint(x1) - nio2;
    yi = my_rint(y1) - nio2;
    xfin = xi+ni;
    yfin = yi+ni;
    for(j=xi;j<xfin;j++){
      for(k=yi;k<yfin;k++){
	if ((j>=0) && (j<xn) && (k>=0) && (k<yn)){
	  data[x0+j][y0+k][frame_num] += amp1*
	    (float)func_2d_gaussian((float)j,(float)k,x1,y1,dsize,dsize,0);
	  if (data[x0+j][y0+k][frame_num] > ampmax)
	    data[x0+j][y0+k][frame_num] = ampmax;
	  else if (data[x0+j][y0+k][frame_num] < ampmin)
	    data[x0+j][y0+k][frame_num] = ampmin;
	}
      }
    }
    xi = my_rint(x2) - nio2;
    yi = my_rint(y2) - nio2;
    xfin = xi+ni;
    yfin = yi+ni;
    for(j=xi;j<xfin;j++){
      for(k=yi;k<yfin;k++){
	if ((j>=0) && (j<xn) && (k>=0) && (k<yn)){
	  data[x0+j][y0+k][frame_num] += amp2*
	    (float)func_2d_gaussian((float)j,(float)k,x2,y2,dsize,dsize,0);
	  if (data[x0+j][y0+k][frame_num] > ampmax)
	    data[x0+j][y0+k][frame_num] = ampmax;
	  if (data[x0+j][y0+k][frame_num] < ampmin)
	    data[x0+j][y0+k][frame_num] = ampmin;
	}
      }
    }
  }
}
void make_frame_gp_trans_0(data,xn,yn,sscale,r,theta,
			   amp1,amp2,ampbg,ampmin,ampmax,dsize,xf,dn,seed)
     float **data;
     int xn,yn;
     float sscale,r,theta,amp1,amp2,ampbg,ampmin,ampmax,dsize,xf;
     int dn,seed;
{
  int i,j,k;
  int xi,yi,ni,nio2,xfin,yfin;
  float x,y,x1,y1,x2,y2,fxn,fyn;
  float dx,dy;
  dx = (r/2.0)/sscale * cos(theta/180.0 * M_PI);
  dy = (r/2.0)/sscale * sin(theta/180.0 * M_PI);
  fxn = xf * (float)xn;
  fyn = xf * (float)yn;
  for(i=0;i<xn;i++)
    for(j=0;j<yn;j++)
      data[i][j] = ampbg;
  nio2 = (int)(0.5 + dsize*3.0);
  if (nio2 < 1)
    nio2 = 1;
  ni = 2*nio2 + 1;
  if (seed > 0)
    seed = -seed;
  for(i=0;i<dn;i++){
    x = fxn * myrand_util_ran2(&seed);
    y = fyn * myrand_util_ran2(&seed);
    x1 = x + dx;
    y1 = y + dy;
    x2 = x - dx;
    y2 = y - dy;
    while (x1 <    0) x1 += fxn;    while (x1 >= fxn) x1 -= fxn;
    while (y1 <    0) y1 += fyn;    while (y1 >= fyn) y1 -= fyn;
    while (x2 <    0) x2 += fxn;    while (x2 >= fxn) x2 -= fxn;
    while (y2 <    0) y2 += fyn;    while (y2 >= fyn) y2 -= fyn;
    xi = my_rint(x1) - nio2;
    yi = my_rint(y1) - nio2;
    xfin = xi+ni;
    yfin = yi+ni;
    for(j=xi;j<xfin;j++){
      for(k=yi;k<yfin;k++){
	if ((j>=0) && (j<xn) && (k>=0) && (k<yn)){
	  data[j][k] += amp1*
	    (float)func_2d_gaussian((float)j,(float)k,x1,y1,dsize,dsize,0);
	  if (data[j][k] > ampmax)
	    data[j][k] = ampmax;
	  else if (data[j][k] < ampmin)
	    data[j][k] = ampmin;
	}
      }
    }
    xi = my_rint(x2) - nio2;
    yi = my_rint(y2) - nio2;
    xfin = xi+ni;
    yfin = yi+ni;
    for(j=xi;j<xfin;j++){
      for(k=yi;k<yfin;k++){
	if ((j>=0) && (j<xn) && (k>=0) && (k<yn)){
	  data[j][k] += amp2*
	    (float)func_2d_gaussian((float)j,(float)k,x2,y2,dsize,dsize,0);
	  if (data[j][k] > ampmax)
	    data[j][k] = ampmax;
	  if (data[j][k] < ampmin)
	    data[j][k] = ampmin;
	}
      }
    }
  }
}
void make_frame_binary_noise(data,x0,xn,y0,yn,frame_num,pix_size,value,pseed)
     float ***data;
     int x0,xn,y0,yn,frame_num,pix_size;
     float value;
     int *pseed;
{
  int i,j,k,l;
  float rvalue;
  for(i=0;i<xn;i+=pix_size)
    for(j=0;j<yn;j+=pix_size){
      if (myrand_util_ran2(pseed) > 0.5)
	rvalue = value;
      else
	rvalue = -value;
      for(k=0;k<pix_size;k++)
	for(l=0;l<pix_size;l++)
	  if (((i+k) < xn) && ((j+l) < yn))
	    data[x0+i+k][y0+j+l][frame_num] = rvalue;
    }
}
void stimu_frame_disk_array(data,xn,yn,x,y,r,n,amp)
     float **data;  
     int xn,yn;     
     float *x,*y;   
     float r;       
     int n;         
     float amp;     
{
  int i,j;
  int di,x0,y0,x1,y1;
  float xx,yy,d2,r2;
  r2 = r*r;  
  for(di=0;di<n;di++){  
    xx = x[di];
    yy = y[di];
    x0 = (int)(xx - r);
    y0 = (int)(yy - r);
    x1 = my_rint(xx + r + 0.5);
    y1 = my_rint(yy + r + 0.5);
    if (x0 <  0)   x0 = 0;
    if (y0 <  0)   y0 = 0;
    if (x1 >= xn)  x1 = xn-1;
    if (y1 >= yn)  y1 = yn-1;
    for(i=x0;i<=x1;i++){
      for(j=y0;j<=y1;j++){
	d2 = ((float)i-xx)*((float)i-xx) + ((float)j-yy)*((float)j-yy);
	if (d2 <= r2)
	  data[i][j] = amp;
      }
    }
  }
}
void stim_util_limit_3d(data,x0,xn,y0,yn,z0,zn,min,max)
     float ***data;
     int x0,xn,y0,yn,z0,zn;
     float min,max;
{
  int i,j,k;
  for(i=x0;i<(x0+xn);i++)
    for(j=y0;j<(y0+yn);j++)
      for(k=z0;k<(z0+zn);k++){
	if (data[i][j][k] < min)
	  data[i][j][k] = min;
	else if (data[i][j][k] > max)
	  data[i][j][k] = max;
      }
}
void stim_util_limit_2d(data,xn,yn,min,max)
     float **data;
     int xn,yn;
     float min,max;
{
  int i,j;
  for(i=0;i<xn;i++)
    for(j=0;j<yn;j++){
      if (data[i][j] < min)
	data[i][j] = min;
      else if (data[i][j] > max)
	data[i][j] = max;
    }
}
void stimx_pixel(ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,rframe)
     struct param_pair_list *ppl;  
     int xn,yn,zn;                 
     float sscale,tscale;          
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframe;              
{
  int i,j;
  int pw,ph,pcx,pcy;
  float t,**tframe;
  static int px,py,px2,py2;
  static float bgval,ampl,t0,tn;
  if (task == -1){  
    ;
  }else if (task == 0){
    t0        = param_getf_exit(ppl,"st0");
    tn        = param_getf_exit(ppl,"stn");
    pcx       = param_geti_dflt(ppl,"pix_cx",xn/2);  
    pcy       = param_geti_dflt(ppl,"pix_cy",yn/2);  
    px        = param_geti_exit(ppl,"pix_x");        
    py        = param_geti_exit(ppl,"pix_y");        
    pw        = param_geti_dflt(ppl,"pix_w",1);      
    ph        = param_geti_dflt(ppl,"pix_h",1);      
    ampl      = param_getf_exit(ppl,"ampl");
    bgval     = param_getf_exit(ppl,"bgval");
    px += pcx;
    py += pcy;
    px2 = px + pw - 1;
    py2 = py + ph - 1;
    if (px  < 0)    exit_error("STIMX_PIXEL","pix_x is less than zero");
    if (py  < 0)    exit_error("STIMX_PIXEL","pix_y is less than zero");
    if (px2 >= xn)  exit_error("STIMX_PIXEL","pix_x + pix_w is too large");
    if (py2 >= yn)  exit_error("STIMX_PIXEL","pix_y + pix_h is too large");
  }else if (task == 1){
    tframe = get_const_2d_farray(xn,yn,bgval);
    t = ti*tscale; 
    if ((t >= t0) && (t < t0+tn)){
      for(i=px;i<=px2;i++)
	for(j=py;j<=py2;j++)
	  tframe[i][j] = ampl;
    }
    *rframe = tframe;
  }else{
    exit_error("STIMX_PIXEL","unknown task");
  }
}
void stimx_bar(ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,rframl,rframr)
     struct param_pair_list *ppl;  
     int xn,yn,zn;                 
     float sscale,tscale;          
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframl;              
     float ***rframr;              
{
  float **tframl,**tframr,t,r,x,y,maxlum;
  static float costh,sinth,sdaa,bgval;
  static float t0  ,tn  ,cx ,cy, len ,wid,theta ,ampl ;
  static float t0_2,tn_2,cx2,cy2,len2,wid2,speed2,theta2,ampl2;
  static int make_left,make_right;
  static float speed_l,speed_r,x0_l,x0_r,y0_l,y0_r,disp_x,disp_y;
  static char *stimform = NULL;
  static char *monoflag;
  if (task == -1){  
    ;  
  }else if (task == 0){
    t0       = param_getf_exit(ppl,"st0");
    tn       = param_getf_exit(ppl,"stn");
    cx       = param_getf_exit(ppl,"cx");
    cy       = param_getf_exit(ppl,"cy");
    theta    = param_getf_exit(ppl,"direction");
    len      = param_getf_exit(ppl,"length");
    wid      = param_getf_exit(ppl,"width");
    ampl     = param_getf_exit(ppl,"ampl");
    bgval    = param_getf_exit(ppl,"bgval");
    maxlum   = param_getf_exit(ppl,"maxlum");
    sdaa     = param_getf_exit(ppl,"sdaa");
    stimform = param_getc_dflt(ppl,"stim_form","3d");
    monoflag = param_getc_dflt(ppl,"stim_monocular","both"); 
    costh = cos(theta*M_PI/180.0);
    sinth = sin(theta*M_PI/180.0);
    make_left = make_right = 1;
    if (strcmp(monoflag,"left")==0)
      make_right = 0;
    else if (strcmp(monoflag,"right")==0)
      make_left = 0;
    myfree(monoflag);
    if (strcmp(stimform,"3d_b")==0){
      disp_x   = param_getf_dflt(ppl,"disparity_x",0.0);  
      disp_y   = param_getf_dflt(ppl,"disparity_y",0.0);  
      speed_l  = param_getf_exit(ppl,"speed_l");          
      speed_r  = param_getf_exit(ppl,"speed_r");          
      x0_l = cx          - 0.5 * tn * speed_l * costh;
      x0_r = cx + disp_x - 0.5 * tn * speed_r * costh;
      y0_l = cy          - 0.5 * tn * speed_l * sinth;
      y0_r = cy + disp_y - 0.5 * tn * speed_r * sinth;
    }else{
      if (strcmp(monoflag,"both")==0)  
	make_right = 0;
      speed_l  = param_getf_exit(ppl,"speed");
      if (paramfile_test_param(ppl,"cx2")){
	t0_2      = param_getf_exit(ppl,"st0_2");
	tn_2      = param_getf_exit(ppl,"stn_2");
	cx2       = param_getf_exit(ppl,"cx2");
	cy2       = param_getf_exit(ppl,"cy2");
	theta2    = param_getf_exit(ppl,"direction2");
	len2      = param_getf_exit(ppl,"length2");
	wid2      = param_getf_exit(ppl,"width2");
	speed2    = param_getf_exit(ppl,"speed2");
	ampl2     = param_getf_exit(ppl,"ampl2");
      }else{
	len2 = -1.0;   
      }
    }
  }else if (task == 1){
    t = ti*tscale; 
    tframl = get_zero_2d_farray(xn,yn);
    if (strcmp(stimform,"3d_b")==0)
      tframr = get_zero_2d_farray(xn,yn);
    if ((t >= t0) && (t < t0+tn)){
      if (strcmp(stimform,"3d_b")==0){
	x = x0_l + speed_l * (t - t0) * costh;
	y = y0_l + speed_l * (t - t0) * sinth;
	if (make_left == 1){
	  make_frame_bar_add_0(tframl,xn,yn,x,y,theta,len,wid,sdaa,
			       sscale,(ampl-bgval));
	}
	if (make_right == 1){
	  x = x0_r + speed_r * (t - t0) * costh;
	  y = y0_r + speed_r * (t - t0) * sinth;
	  make_frame_bar_add_0(tframr,xn,yn,x,y,theta,len,wid,sdaa,
			       sscale,(ampl-bgval));
	}
      }else{
	r = speed_l*(t-t0);
	x = cx + r*costh;
	y = cy + r*sinth;
	make_frame_bar_add_0(tframl,xn,yn,x,y,theta,len,wid,sdaa,
			     sscale,(ampl-bgval));
      }
    }
    if (len2 >= 0.0){  
      if ((t >= t0_2) && (t < t0_2+tn_2)){
	r = speed2*(t-t0);
	x = cx2 + r*cos(theta2*M_PI/180.0);
	y = cy2 + r*sin(theta2*M_PI/180.0);
	make_frame_bar_add_0(tframl,xn,yn,x,y,theta2,
			     len2,wid2,sdaa,sscale,(ampl2-bgval));
      }
    }
    *rframl = tframl;
    if (strcmp(stimform,"3d_b")==0)
      *rframr = tframr;
  }else{
    exit_error("STIMX_BAR","unknown task");
  }
}
void stimx_barnoise(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,
		    rframl,rframr)
     char *mylogf;
     struct param_pair_list *ppl;  
     int xn,yn,zn;                 
     float sscale,tscale;          
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframl;              
     float ***rframr;              
{
  int i,j,k;
  int seed,seed_r,distrib,nn,mask_seed,mask_distr,ii,dx_bi;
  float v1,v2,v3,t0,tn,bw,bl,bgval,cx,cy,**mt,**mask,v,dx_pix,dx;
  float maxlum,contrast,mask_speed;
  char *monoflag;
  static float **bartemp = NULL;
  static float **seq = NULL;
  static float *mask_seq = NULL;
  static float **seq_r = NULL;
  static int mask_flag = 0;
  static float bgamp,mask_speed_pix,mask_diroff;
  static float dir,bwpix,blpix,bord,cxpix,cypix;
  static int nbar,nseq,t0i,dwell,make_left,make_right,mask_seqn;
  static char *stimform = NULL;
  if (task == -1){  
    if (bartemp != NULL)
      free_2d_farray(bartemp,xn);
    if (seq != NULL)
      free_2d_farray(seq,nseq);
    if (seq_r != NULL)
      free_2d_farray(seq_r,nseq);
    if (stimform != NULL)
      myfree(stimform);
  }else if (task == 0){
    nbar     = param_geti_exit(ppl,"nbar");
    if (paramfile_test_param(ppl,"bar_width_pix") == 1)
      bwpix    = (float)param_geti_exit(ppl,"bar_width_pix");
    else{
      bw       = param_getf_exit(ppl,"bar_width");  
      bwpix    = bw / sscale;
    }
    bl        = param_getf_exit(ppl,"bar_length");
    blpix     = bl / sscale;
    cx        = param_getf_dflt(ppl,"cx",0.0);
    cy        = param_getf_dflt(ppl,"cy",0.0);
    t0        = param_getf_exit(ppl,"st0");
    tn        = param_getf_exit(ppl,"stn");
    dir       = param_getf_exit(ppl,"direction");
    dwell     = param_geti_exit(ppl,"dwell");  
    distrib   = param_geti_exit(ppl,"distrib");
    seed      = param_geti_exit(ppl,"seed");
    seed_r    = param_geti_dflt(ppl,"seed_r",seed);
    contrast  = param_getf_exit(ppl,"contrast");
    maxlum    = param_getf_exit(ppl,"maxlum");
    bgval     = param_getf_exit(ppl,"bgval");
    bord      = param_getf_dflt(ppl,"border",0.0);  
    stimform  = param_getc_dflt(ppl,"stim_form","3d");
    monoflag  = param_getc_dflt(ppl,"stim_monocular","both"); 
    bgamp = bgval;
    v1 = bgval + (maxlum - bgval)*contrast;
    v2 = bgval - (maxlum - bgval)*contrast;
    v3 = bgval;  
    t0i = my_rint(t0 / tscale);  
    cxpix = cx / sscale;  
    cypix = cy / sscale;  
    make_left = make_right = 1;
    if (strcmp(monoflag,"left")==0)
      make_right = 0;
    else if (strcmp(monoflag,"right")==0)
      make_left = 0;
    myfree(monoflag);
    bartemp = stm_barnoise_get_template(mylogf,xn,yn,nbar,bwpix,blpix,dir,bord,
					cxpix,cypix,0.0);
    if ((distrib >= 2) || (distrib <= 3)){
      stm_get_ran_seq_2d(NULL,nbar,distrib,seed,1.0/tscale,tn,dwell,v1,v2,v3,
			 &seq,&nseq);
      if (strcmp(stimform,"3d_b")==0){
	stm_get_ran_seq_2d(NULL,nbar,distrib,seed_r,1.0/tscale,tn,dwell,v1,v2,
			   v3,&seq_r,&nseq);
      }
    }else{
      exit_error("STIMX_BARNOISE","bad 'distrib', must be 2 or 3");
    }
    if (param_test(ppl,"mask_speed") == 1){
      mask_flag = 1;  
      mask_speed   = param_getf_dflt(ppl,"mask_speed",0.0);  
      mask_diroff  = param_getf_dflt(ppl,"mask_dir_offset",90.0);
      mask_seed    = param_geti_exit(ppl,"mask_seed");
      mask_distr   = param_geti_dflt(ppl,"mask_distrib",distrib);
      mask_speed_pix = mask_speed / sscale;
      mask_seqn = 2.0 * xn / bwpix;  
      mask_seqn += tn * mask_speed / sscale  / bwpix;  
      stm_get_ran_seq(mylogf,mask_distr,0,mask_seed,1.0,(float)mask_seqn,1,
		      v1,v2,v3,&mask_seq,&nn);
      if (nn != mask_seqn)
	mylog_exit(mylogf,"STIMX_BARNOISE  'mask_seqn' error\n");
    }
  }else if (task == 1){
    if ((bartemp == NULL) || (seq == NULL))
      exit_error("STIMX_BARNOISE","Not prepared to generate stim");
    k = (int)((ti-t0i)/dwell);
    if ((k < 0) || (k >= nseq))
      exit_error("STIMX_BARNOISE","index exceeds random sequence length");
    if (make_left == 1)
      *rframl = make_frame_bars_tmplt(bartemp,xn,yn,nbar,seq[k],bgamp);
    else
      *rframl = get_const_2d_farray(xn,yn,bgamp);
    if (mask_flag == 1){
      dx_pix = (float)(ti-t0i)*tscale  *  mask_speed_pix;  
      dx_bi  = (int)(dx_pix / bwpix);  
      dx = dx_pix - ((float)dx_bi * bwpix);
      ii = (mask_seqn - nbar) - dx_bi;  
      if (ii < 0)
	mylog_exit(mylogf,"STIMX_BARNOISE  bar index < 0\n");
      mt = stm_barnoise_get_template(mylogf,xn,yn,nbar,bwpix,blpix,
				     dir+mask_diroff,bord,cxpix,cypix,dx);
      mask = make_frame_bars_tmplt(mt,xn,yn,nbar,&(mask_seq[ii]),bgamp);
      for(i=0;i<xn;i++){
	for(j=0;j<yn;j++){
	  v = ((*rframl)[i][j] + mask[i][j]) / 2.0;
	  (*rframl)[i][j] = v;
	}
      }
      free_2d_farray(mask,xn);
      free_2d_farray(mt,xn);
    }
    if (strcmp(stimform,"3d_b")==0){
      if (make_right == 1)
	*rframr = make_frame_bars_tmplt(bartemp,xn,yn,nbar,seq_r[k],bgamp);
      else
	*rframr = get_const_2d_farray(xn,yn,bgamp);
    }
  }else{
    exit_error("STIMX_BARNOISE","unknown task");
  }
}
void stimx_barpatmo(ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,rframe)
     struct param_pair_list *ppl;  
     int xn,yn,zn;                 
     float sscale,tscale;          
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframe;              
{
  int i,k;
  int seed,distrib,npatframe,npixnew,si,pi;
  float dir,t0,tn,bw,bl,cx,cy;
  static int nbar,seqn,t0i,dwell,bwpix,blpix,speedpix,x0,y0,altcon,altsign;
  static int idir;
  static int *seqi = NULL;
  static float bgval,val1,val2;
  if (task == -1){  
    if (seqi != NULL)
      myfree(seqi);
  }else if (task == 0){
    nbar      = param_geti_exit(ppl,"nbar");
    if (param_test(ppl,"bar_width_pix") == 1)
      bwpix   = param_geti_exit(ppl,"bar_width_pix");
    else{
      bw      = param_getf_exit(ppl,"bar_width");  
      bwpix    = bw / sscale;
    }
    bl        = param_getf_exit(ppl,"bar_length");
    cx        = param_getf_dflt(ppl,"cx",0.0);
    cy        = param_getf_dflt(ppl,"cy",0.0);
    t0        = param_getf_exit(ppl,"st0");
    tn        = param_getf_exit(ppl,"stn");
    dir       = param_getf_exit(ppl,"direction");
    dwell     = param_geti_exit(ppl,"dwell");  
    distrib   = param_geti_exit(ppl,"distrib");
    seed      = param_geti_exit(ppl,"seed");
    speedpix  = param_geti_exit(ppl,"speed_pix");  
    val1      = param_getf_dflt(ppl,"bar_val_1",1.0);
    val2      = param_getf_dflt(ppl,"bar_val_2",0.0);
    bgval     = param_getf_exit(ppl,"bgval");
    altcon    = param_geti_dflt(ppl,"alternate",0);
    idir = my_rint(dir);
    if ((idir != 0) && (idir != 180)){
      exit_error("STIMX_BARPATMO","direction must be 0 or 180 deg");
    }
    blpix    = bl / sscale;
    t0i       = my_rint(t0 / tscale);  
    x0 = my_rint(xn/2 + cx / sscale - (float)(nbar * bwpix)/2.0);
    y0 = my_rint(yn/2 + cy / sscale - (float)blpix/2.0);
    if (seed > 0)
      seed = -seed;
    npatframe = (int)(tn / (dwell*tsamp*tscale));
    seqn = nbar; 
    if (speedpix > 0){
      npixnew = speedpix * npatframe;   
      seqn += npixnew / bwpix + 1;      
    }
    if (distrib == 0){
      seqi = (int *)myalloc(seqn*sizeof(int));
      for(i=0;i<seqn;i++){ 
	if (i%2 == 0)
	  seqi[i] = 1;
	else
	  seqi[i] = -1;
      }
    }else if (distrib == 2){
      seqi = myrand_get_std_bin_seq(seqn,seed);
      for(i=0;i<seqn;i++) 
	if (seqi[i] < 1)
	  seqi[i] = -1;
    }else if (distrib == 3){
      seqi = myrand_get_std_tern_seq(seqn,seed);
    }else{
      exit_error("STIMX_BARPATMO","bad 'distrib', must be 2 or 3");
    }
    altsign = 1;  
  }else if (task == 1){
    if (seqi == NULL)
      exit_error("STIMX_BARPATMO","Not prepared to generate stim");
    k =  (int)((ti-t0i)/dwell);  
    si = k * speedpix / bwpix;   
    pi = k * speedpix % bwpix;   
    if ((k < 0) || (k >= npatframe)){  
      *rframe = get_const_2d_farray(xn,yn,bgval);
    }else{
      if (altcon == 1){
	if (k%2 == 1)  
	  altsign = -1;
	else
	  altsign = 1;
      }
    }
    *rframe = make_frame_barpatmo(xn,yn,x0,y0,nbar,bwpix,blpix,seqi,seqn,
				  si,pi,altsign,val1,val2,bgval,idir);
  }else{
    exit_error("STIMX_BARPATMO","unknown task");
  }
}
void stimx_barray(ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,rframe)
     struct param_pair_list *ppl;  
     int xn,yn,zn;                 
     float sscale,tscale;          
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframe;              
{
  int i,j,k;
  int si,bi,seed;
  int dt_off,bar_off;
  float t0,tn,contrast,maxlum,**tframe,t,x,y;
  float bar_gap,pos_gap,size;
  static float **bar_cx,**bar_cy;
  static float theta,barw,barl,barval,bgval,sdaa,cx,cy;
  static int n,nbar,npos,t0i,dtt,seqtype,dt;
  static int **seqi;
  if (task == -1){  
    if (bar_cx != NULL)
      free_2d_farray(bar_cx,nbar);
    if (bar_cy != NULL)
      free_2d_farray(bar_cy,nbar);
    if (seqi != NULL)
      free_2d_iarray(seqi,n);
  }else if (task == 0){
    t0       = param_getf_exit(ppl,"st0");
    tn       = param_getf_exit(ppl,"stn");
    cx       = param_getf_exit(ppl,"cx");
    cy       = param_getf_exit(ppl,"cy");
    theta    = param_getf_exit(ppl,"direction");
    barw     = param_getf_exit(ppl,"bar_w");
    bar_gap  = param_getf_exit(ppl,"bar_gap");
    pos_gap  = param_getf_exit(ppl,"pos_gap");
    nbar     = param_geti_exit(ppl,"bar_n");
    npos     = param_geti_exit(ppl,"pos_n");
    dt       = param_geti_exit(ppl,"dt");
    dt_off   = param_geti_exit(ppl,"dt_off");
    seed     = param_geti_exit(ppl,"seed");
    contrast = param_getf_exit(ppl,"contrast");
    barval   = param_getf_exit(ppl,"bar_amp");
    bgval    = param_getf_exit(ppl,"bgval");
    maxlum   = param_getf_exit(ppl,"maxlum");
    seqtype  = param_geti_exit(ppl,"seq_type");
    size     = param_getf_exit(ppl,"size");
    sdaa     = param_getf_dflt(ppl,"sdaa",0.0);
    dtt = dt + dt_off;
    barl = (size - (float)(nbar-1)*bar_gap)/(float)nbar; 
    n = (int)(tn/tscale / (float)(dt+dt_off)); 
    seqi = stm_barray_get_seq(NULL,n,nbar,npos,seqtype,seed);
    stm_barray_get_bar_centers(NULL,nbar,npos,theta,barw,barl,bar_gap,
			       pos_gap,&bar_cx,&bar_cy);
    t0i = my_rint(t0 / tscale);  
  }else if (task == 1){
    if (seqi == NULL)
      exit_error("STIMX_BARRAY","Not prepared to generate stim");
    si =  (int)((ti-t0i)/dtt);
    if (((ti-t0i) - dtt*si) >= dt)
      bar_off = 1;
    else
      bar_off = 0;
    if ((si < 0) || (si >= n)){
      printf("  si = %d\n",si);
      exit_error("STIMX_BARRAY","index exceeds random sequence length");
    }
    tframe = get_2d_farray(xn,yn);
    for(i=0;i<xn;i++)
      for(j=0;j<yn;j++)
	tframe[i][j] = bgval;
    if (bar_off == 0){
      for(j=0;j<nbar;j++){
	bi = seqi[si][j] - 1;
	if (bi >= 0){ 
	  if (seqtype == 99){ 
	    for(k=0;k<npos;k++){
	      x = bar_cx[j][k] + cx;
	      y = bar_cy[j][k] + cy;
	      make_frame_bar_0(tframe,xn,yn,x,y,theta,barl,barw,
			       sdaa,sscale,barval,bgval,1);
	    }
	  }else{
	    x = bar_cx[j][bi] + cx;
	    y = bar_cy[j][bi] + cy;
	    make_frame_bar_0(tframe,xn,yn,x,y,theta,barl,barw,
			     sdaa,sscale,barval,bgval,1);
	  }
	}
      }
    }
    *rframe = tframe;
  }else{
    exit_error("STIMX_BARRAY","unknown task");
  }
}
void stimx_bar2ran(ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,rframe)
     struct param_pair_list *ppl;  
     int xn,yn,zn;                 
     float sscale,tscale;          
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframe;              
{
  int i,j;
  int seed,ri,*seedlist,bwflag;
  int xr0,yr0,xr1,yr1,hpix,wpix;
  float t0,tn,cx,cy,theta,w,h,barw,barh,contrast,maxlum,wf,hf;
  float **tframe,t,x,y;
  float xv1,yv1,xv0,yv0;
  static int nn,x0,y0,bw,bh,t0i,dwell;
  static int *xpix0,*xpix1,*ypix0,*ypix1;
  static float bgval,val1,val2,diamf;
  static float *xf0,*xf1,*yf0,*yf1;  
  static char *shape;
  if (task == -1){  
    if (xpix0 != NULL)  myfree(xpix0);
    if (xpix1 != NULL)  myfree(xpix1);
    if (ypix0 != NULL)  myfree(ypix0);
    if (ypix1 != NULL)  myfree(ypix1);
    if (xf0 != NULL)  myfree(xf0);
    if (xf1 != NULL)  myfree(xf1);
    if (yf0 != NULL)  myfree(yf0);
    if (yf1 != NULL)  myfree(yf1);
  }else if (task == 0){
    t0       = param_getf_exit(ppl,"st0");
    tn       = param_getf_exit(ppl,"stn");
    cx       = param_getf_exit(ppl,"cx");
    cy       = param_getf_exit(ppl,"cy");
    theta    = param_getf_exit(ppl,"direction");
    w        = param_getf_exit(ppl,"ranw");
    h        = param_getf_exit(ppl,"ranh");
    barw     = param_getf_exit(ppl,"barw");
    barh     = param_getf_exit(ppl,"barh");
    seed     = param_geti_exit(ppl,"seed");
    contrast = param_getf_exit(ppl,"contrast");
    bgval    = param_getf_exit(ppl,"bgval");
    maxlum   = param_getf_exit(ppl,"maxlum");
    dwell    = param_geti_exit(ppl,"dwell");
    bwflag   = param_geti_dflt(ppl,"black_white",0);
    shape    = paramfile_get_char_param_default(ppl,"shape","rect");
    if (paramfile_test_param(ppl,"stim_void") == 1){
      exit_error("STIMX_BAR2RAN","Change stim_void to stim_blank_val");
    }
    if (theta != 0.0)
      exit_error("STIMX_BAR2RAN","Direction must be zero");
    bw = my_rint(barw/sscale);  
    bh = my_rint(barh/sscale);  
    wpix = my_rint(w/sscale);   
    hpix = my_rint(h/sscale);   
    diamf = barw/sscale;    
    wf = w/sscale;              
    hf = h/sscale;              
    if (bwflag == 0){
      val1 = contrast/2.0;      
      val2 = -contrast/2.0;     
    }else if (bwflag == -1){
      val1 = -contrast/2.0;     
      val2 = -contrast/2.0;     
    }else if (bwflag == 1){
      val1 = contrast/2.0;     
      val2 = contrast/2.0;     
    }
    x0 = xn/2 + (cx - w/2.0 - barw/2.0)/sscale; 
    y0 = yn/2 + (cy - h/2.0 - barh/2.0)/sscale; 
    nn = stm_util_count_new_frames(zn,tscale,t0,tn,tsamp,dwell);
    seedlist = get_seeds(seed,100000,4);
    if (strcmp(shape,"rect")==0){
      xpix0 = myrand_get_std_unif_int_seq(nn,seedlist[0],wpix);
      xpix1 = myrand_get_std_unif_int_seq(nn,seedlist[1],wpix);
      if (h > 0.0){ 
	ypix0 = myrand_get_std_unif_int_seq(nn,seedlist[2],hpix);
	ypix1 = myrand_get_std_unif_int_seq(nn,seedlist[3],hpix);
      }else{
	ypix0 = get_const_iarray(nn,0);
	ypix1 = get_const_iarray(nn,0);
      }
    }else if (strcmp(shape,"sine_bump")==0){
      xf0 = myrand_get_std_unif_float_seq(nn,seedlist[0],wf);
      xf1 = myrand_get_std_unif_float_seq(nn,seedlist[1],wf);
      yf0 = myrand_get_std_unif_float_seq(nn,seedlist[2],hf);
      yf1 = myrand_get_std_unif_float_seq(nn,seedlist[3],hf);
    }else{
      exit_error("STIMX_BAR2RAN","Unknown shape");
    }
    t0i = my_rint(t0 / tscale);  
  }else if (task == 1){
    if ((xpix1 == NULL) && (xf1 == NULL))
      exit_error("STIMX_BAR2RAN","Not prepared to generate stim");
    ri = (int)((ti-t0i)/(dwell*tsamp));
    if ((ri < 0) || (ri >= nn)){
      printf("  ti = %d\n",ti);
      printf("  dwell = %d\n",dwell);
      printf("  tsamp = %d\n",tsamp);
      printf("  nn = %d\n",nn);
      printf("  ri = %d\n",ri);
      exit_error("STIMX_BAR2RAN","index exceeds random sequence length");
    }
    if (strcmp(shape,"rect")==0){
      xr1 = x0 + xpix1[ri]; 
      yr1 = y0 + ypix1[ri];
      xr0 = x0 + xpix0[ri]; 
      yr0 = y0 + ypix0[ri];
    }else if (strcmp(shape,"sine_bump")==0){
      xv1 = (float)x0 + xf1[ri]; 
      yv1 = (float)y0 + yf1[ri];
      xv0 = (float)x0 + xf0[ri]; 
      yv0 = (float)y0 + yf0[ri];
    }
    tframe = get_2d_farray(xn,yn);
    for(i=0;i<xn;i++)
      for(j=0;j<yn;j++)
	tframe[i][j] = bgval;
    if (strcmp(shape,"rect")==0){
      make_frame_add_rect_pix_0(tframe,xn,yn,xr1,yr1,bw,bh,val1);
      make_frame_add_rect_pix_0(tframe,xn,yn,xr0,yr0,bw,bh,val2);
    }else if (strcmp(shape,"sine_bump")==0){
      make_frame_add_sine_bump_0(tframe,xn,yn,xv1,yv1,diamf,val1);
      make_frame_add_sine_bump_0(tframe,xn,yn,xv0,yv0,diamf,val2);
    }
    *rframe = tframe;
  }else{
    exit_error("STIMX_BAR2RAN","unknown task");
  }
}
void stimx_bar1ran(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,
		   rframl,rframr)
     char *mylogf;                 
     struct param_pair_list *ppl;  
     int xn,yn,zn;                 
     float sscale,tscale;          
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframl;              
     float ***rframr;              
{
  int i,j,k;
  int seed_l,seed_r,ri,bwflag,*tvall,*tvalr;
  float t0,tn,cx,cy,contrast,maxlum,fi,tdx,tdy,amp;
  float **tframl,**tframr;
  static int nbar,nn,t0i,dwell,*bpos_l,*bpos_r;
  static float barw,barh,theta;
  static float bgval,val0,val1,sdaa,*bx,*by,*bval_l,*bval_r;
  if (task == -1){  
    if (bpos_l != NULL)  myfree(bpos_l);
    if (bval_l != NULL)  myfree(bval_l);
    if (bpos_r != NULL)  myfree(bpos_r);
    if (bval_r != NULL)  myfree(bval_r);
    if (bx     != NULL)  myfree(bx);
    if (by     != NULL)  myfree(by);
  }else if (task == 0){
    t0       = param_getf_exit(ppl,"st0");
    tn       = param_getf_exit(ppl,"stn");
    cx       = param_getf_exit(ppl,"cx");
    cy       = param_getf_exit(ppl,"cy");
    theta    = param_getf_exit(ppl,"direction");
    nbar     = param_geti_exit(ppl,"nbar");
    barw     = param_getf_exit(ppl,"barw");  
    barh     = param_getf_exit(ppl,"barh");  
    seed_l   = param_geti_exit(ppl,"seed");
    seed_r   = param_geti_exit(ppl,"seed_r");
    contrast = param_getf_exit(ppl,"contrast");
    bgval    = param_getf_exit(ppl,"bgval");
    maxlum   = param_getf_exit(ppl,"maxlum");
    dwell    = param_geti_exit(ppl,"dwell");
    bwflag   = param_geti_dflt(ppl,"black_white",0);
    sdaa     = param_getf_dflt(ppl,"sdaa",0.0);
    amp = (maxlum - bgval) * contrast;
    if (bwflag == 0){
      val0 = -amp;     
      val1 = amp;      
    }else if (bwflag == -1){
      val0 = val1 = -amp;     
    }else if (bwflag == 1){
      val0 = val1 =  amp;     
    }
    bx = (float *)myalloc(nbar*sizeof(float));
    by = (float *)myalloc(nbar*sizeof(float));
    tdx = barw * cos(M_PI*theta/180.0);
    tdy = barw * sin(M_PI*theta/180.0);
    for(i=0;i<nbar;i++){
      fi = (float)i - (float)(nbar - 1)/2.0;
      bx[i] = tdx * fi + cx;
      by[i] = tdy * fi + cy;
    }
    nn = stm_util_count_new_frames(zn,tscale,t0,tn,tsamp,dwell);
    bpos_l = myrand_get_std_unif_int_seq(nn,seed_l,nbar);
    bpos_r = myrand_get_std_unif_int_seq(nn,seed_r,nbar);
    tvall = myrand_get_std_bin_seq(nn,seed_l*3+1019);
    tvalr = myrand_get_std_bin_seq(nn,seed_r*3+1019);
    bval_l = (float *)myalloc(nn*sizeof(float));
    bval_r = (float *)myalloc(nn*sizeof(float));
    for(i=0;i<nn;i++){
      if (tvall[i] == 0)
	bval_l[i] = val0;
      else
	bval_l[i] = val1;
      if (tvalr[i] == 0)
	bval_r[i] = val0;
      else
	bval_r[i] = val1;
    }
    myfree(tvall);
    myfree(tvalr);
    t0i = my_rint(t0 / tscale);  
  }else if (task == 1){
    if (bpos_l == NULL)
      exit_error("STIMX_BAR1RAN","Not prepared to generate stim");
    ri = (int)((ti-t0i)/(dwell*tsamp));
    if ((ri < 0) || (ri >= nn)){
      printf("  ti = %d\n",ti);
      printf("  dwell = %d\n",dwell);
      printf("  tsamp = %d\n",tsamp);
      printf("  nn = %d\n",nn);
      printf("  ri = %d\n",ri);
      exit_error("STIMX_BAR1RAN","index exceeds random sequence length");
    }
    tframl = get_2d_farray(xn,yn);
    tframr = get_2d_farray(xn,yn);
    for(i=0;i<xn;i++)
      for(j=0;j<yn;j++){
	tframr[i][j] = bgval;
	tframl[i][j] = bgval;
      }
    k = bpos_l[ri];  
    make_frame_bar_add_0(tframl,xn,yn,bx[k],by[k],theta,barh,barw,sdaa,
			 sscale,bval_l[ri]);
    k = bpos_r[ri];  
    make_frame_bar_add_0(tframr,xn,yn,bx[k],by[k],theta,barh,barw,sdaa,
			 sscale,bval_r[ri]);
    *rframl = tframl;
    *rframr = tframr;
  }else{
    exit_error("STIMX_BAR1RAN","unknown task");
  }
}
void stimx_dirmod(ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,rframl,rframr)
     struct param_pair_list *ppl;  
     int xn,yn,zn;                 
     float sscale,tscale;          
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframl;              
     float ***rframr;              
{
  int i,j,k;
  int distrib,seed1,seed2,ord,si,seqn;
  float t0,tn,contrast,maxlum,**tframe,**tframe1,**tframe2,t,x,y,fps;
  float **tframe1r,**tframr;
  float etf1p,etf1a,etf2p,etf2a,phase1,phase2,size1,size2;
  float v1p,v1a,v2p,v2a,bgval,*seq1,*seq2,ph,tt;
  static int aptype,nstim,seqcn,dt,t0i,dicho,dichopp;
  static float sf1,theta1,sz1,con1;
  static float sf2,theta2,sz2,con2;
  static float xc,yc,cx,cy,bgamp,*seq1cum,*seq2cum,mid,*seq1cumr = NULL;
  static char *stimform = NULL;
  stimform = param_getc_dflt(ppl,"stim_form","3d");
  if (strcmp(stimform,"3d_b")==0){
    dicho   = param_geti_exit(ppl,"dichoptic"); 
    dichopp = param_geti_dflt(ppl,"dicho_opp",0);
  }else
    dicho = -1;  
  if (task == -1){  
    if (seq1cum  != NULL)  myfree(seq1cum);
    if (seq1cumr != NULL)  myfree(seq1cumr);
    if (seq2cum  != NULL)  myfree(seq2cum);
  }else if (task == 0){
    nstim = 1;  
    cx = param_getf_dflt(ppl,"cx",0.0);
    cy = param_getf_dflt(ppl,"cy",0.0);
    if (param_test(ppl,"sf2")){  
      printf("  *** OLD WAY - Please convert to new param names:\n");
      printf("  sf2    -->  s2_sf\n");
      printf("  etf1a  -->  s1_etfa\n");
      printf("         ...\n");
    }else{
      if (param_test(ppl,"etf")){
	etf1p  = param_getf_exit(ppl,"etf");
	etf1a  = etf1p;
	etf2p  = etf1p;
	etf2a  = etf1a;
      }else if (param_test(ppl,"s1_etf")){
	param_getf_s2_exit(ppl,"etf",&etf1p,&etf2p,&nstim);
	etf1a = etf1p;
	etf2a = etf2p;
      }else{
	param_getf_s2_exit(ppl,"etfp",&etf1p,&etf2p,&nstim);
	param_getf_s2_exit(ppl,"etfa",&etf1a,&etf2a,&nstim);
      }
      param_getf_s2_exit(ppl,"sf",&sf1,&sf2,&nstim);
      param_getf_s2_exit(ppl,"phase",&phase1,&phase2,&nstim);
      theta1   = param_getf_exit(ppl,"direction");
      param_getf_s2_exit(ppl,"contrast",&con1,&con2,&nstim);
      param_getf_s2_exit(ppl,"size",&size1,&size2,&nstim);
      param_geti_s2_exit(ppl,"seed",&seed1,&seed2,&nstim);
    }
    maxlum   = param_getf_dflt(ppl,"maxlum",1.0);
    aptype   = param_geti_exit(ppl,"aptype");
    bgval    = param_getf_exit(ppl,"bgval");
    bgamp = bgval * 2.0 - 1.0; 
    theta2 = theta1 + 90.0;
    mid = (float)maxlum/2.0;
    sz1 = size1/sscale;
    sz2 = size2/sscale;
    t0       = param_getf_exit(ppl,"st0");
    tn       = param_getf_exit(ppl,"stn");
    distrib  = param_geti_exit(ppl,"distrib");
    dt       = param_geti_exit(ppl,"dt");
    if (distrib == 7){
      ord = param_geti_exit(ppl,"mseq_ord");
    }else
      ord = -1;
    fps = 1.0/(tsamp*tscale);  
    v1p =  etf1p/fps * 360.0;  
    v1a = -etf1a/fps * 360.0;
    v2p =  etf2p/fps * 360.0;
    v2a = -etf2a/fps * 360.0;
    stm_get_ran_seq(NULL,distrib,ord,seed1,fps,tn,dt,v1p,v1a,0.0,&seq1,&seqn);
    seqcn = seqn*dt+1;    
    seq1cum  = get_farray(seqcn);
    seq1cumr = get_farray(seqcn);
    seq1cum[0]  = phase1;
    seq1cumr[0] = phase1;
    k = 1;
    for(i=0;i<seqn;i++){
      for(j=0;j<dt;j++){
	seq1cum[k]  = seq1cum[k-1]  + seq1[i];
	if (dichopp == 1){ 
	  seq1cumr[k] = seq1cumr[k-1] - seq1[i];
	}else
	  seq1cumr[k] = seq1cumr[k-1] + seq1[i];
	k += 1;
      }
    }
    myfree(seq1);
    if (nstim == 2){
      stm_get_ran_seq(NULL,distrib,ord,seed2,fps,tn,dt,v2p,v2a,0.0,&seq2,&seqn);
      seq2cum = get_farray(seqcn);
      seq2cum[0] = phase2;
      k = 1;
      for(i=0;i<seqn;i++){
	for(j=0;j<dt;j++){
	  seq2cum[k] = seq2cum[k-1] + seq2[i];
	  k += 1;
	}
      }
      myfree(seq2);
    }
    xc = (float)(xn-1)/2.0 + cx/sscale;  
    yc = (float)(yn-1)/2.0 + cy/sscale;  
    t0i = my_rint(t0 / tscale);  
  }else if (task == 1){
    if (seq1cum == NULL)
      exit_error("STIMX_DIRMOD","Not prepared to generate stim");
    si = (ti-t0i)/tsamp;  
    tframe1 = get_2d_farray(xn,yn);
    for(i=0;i<xn;i++)
      for(j=0;j<yn;j++)
	tframe1[i][j] = bgamp;
    if (dicho >= 0){
      tframe1r = get_2d_farray(xn,yn);
      for(i=0;i<xn;i++)
	for(j=0;j<yn;j++)
	  tframe1r[i][j] = bgamp;
    }
    if (nstim == 2){
      tframe2 = get_2d_farray(xn,yn);
      for(i=0;i<xn;i++)
	for(j=0;j<yn;j++)
	  tframe2[i][j] = bgamp;
      if (dicho >= 0)
	exit_error("STIMX_DIRMOD","'dichoptic' not implemented for 2nd patch");
    }
    if ((si >= 0) && (si < seqcn)){
      ph = seq1cum[si];
      if ((dicho == -1)||(dicho == 0)||(dicho == 3))  
	make_frame_sinusoid_0(tframe1,xn,yn,sf1,theta1,sscale,ph,cx,cy,1.0);
      if ((dicho == 1)||(dicho == 3)){
	ph = seq1cumr[si];
	make_frame_sinusoid_0(tframe1r,xn,yn,sf1,theta1,sscale,ph,cx,cy,1.0);
      }
      if (nstim == 2){
	ph = seq2cum[si];
	make_frame_sinusoid_0(tframe2,xn,yn,sf2,theta2,sscale,ph,cx,cy,1.0);
      }
    }
    apply_aperture_scale(tframe1,xn,yn,aptype,xc,yc,sz1,sz1,0.0,bgamp,
			 con1*mid);
    if (dicho >= 0){
      apply_aperture_scale(tframe1r,xn,yn,aptype,xc,yc,sz1,sz1,0.0,bgamp,
			   con1*mid);
    }
    if (nstim == 2){
      apply_aperture_scale(tframe2,xn,yn,aptype,xc,yc,sz2,sz2,0.0,bgamp,
			   con2*mid);
    }
    if (nstim == 1){
      tframe = tframe1;
      tframr = tframe1r;
    }else if (nstim == 2){
      tframe = add_2d_farrays(tframe1,tframe2,xn,yn);
      for(i=0;i<xn;i++){
	for(j=0;j<yn;j++){
	  tt = tframe[i][j];
	  if (tt < -mid)
	    tframe[i][j] = -mid;
	  else if (tt > mid)
	    tframe[i][j] = mid;
	}
      }
    }
    for(i=0;i<xn;i++)
      for(j=0;j<yn;j++)
	tframe[i][j] += mid;
    if (dicho >= 0){
      for(i=0;i<xn;i++)
	for(j=0;j<yn;j++)
	  tframr[i][j] += mid;
    }
    if (nstim == 2){
      free_2d_farray(tframe1,xn);
      free_2d_farray(tframe2,xn);
    }
    *rframl = tframe;
    if (dicho >= 0){
      *rframr = tframr;
    }
  }else{
    exit_error("STIMX_DIRMOD","unknown task");
  }
}
void stimx_plaid(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,
		 rframl,rframr)
     char *mylogf;
     struct param_pair_list *ppl;  
     int xn,yn,zn;                 
     float sscale,tscale;          
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframl;              
     float ***rframr;              
{
  int i,j;
  float ph1,ph2,dir,theta1,theta2,t,size;
  float **tframe,**tframe1,**tframe2;
  char *stimform;
  static int nstim,aptype,pldflag,dicho,meanzero;
  static float cx1,cx2,cy1,cy2,sf1,sf2,th1,th2,tf1,tf2,phase1,phase2;
  static float xc1,yc1,xc2,yc2;
  static float t0,tn,t0_2,tn_2,con1,con2,mid,sz,v0v,v1v,bgval,bgamp,maxlum;
  if (task == -1){  
    ;
  }else if (task == 0){
    param_getf_2(ppl,"cx","cx1","cx2",&cx1,&cx2);
    param_getf_2(ppl,"cy","cy1","cy2",&cy1,&cy2);
    t0       = param_getf_exit(ppl,"st0");
    tn       = param_getf_exit(ppl,"stn");
    t0_2     = param_getf_dflt(ppl,"st0_2",t0);
    tn_2     = param_getf_dflt(ppl,"stn_2",tn);
    dir      = param_getf_exit(ppl,"direction");
    size     = param_getf_exit(ppl,"size");
    maxlum   = param_getf_exit(ppl,"maxlum");
    aptype   = param_geti_exit(ppl,"aptype");
    pldflag  = param_geti_dflt(ppl,"plaid_flag",0);
    bgval    = param_getf_exit(ppl,"bgval");
    stimform = param_getc_dflt(ppl,"stim_form","3d");
    meanzero = param_geti_dflt(ppl,"stim_mean_zero",0);
    param_getf_2(ppl,"sf","sf1","sf2",&sf1,&sf2);
    param_getf_2(ppl,"tf","tf1","tf2",&tf1,&tf2);
    param_getf_2(ppl,"phase","phase1","phase2",&phase1,&phase2);
    param_getf_2(ppl,"theta","theta1","theta2",&theta1,&theta2);
    param_getf_2(ppl,"contrast","contrast1","contrast2",&con1,&con2);
    if (strcmp(stimform,"3d_b")==0)
      dicho = param_geti_exit(ppl,"dichoptic");
    else
      dicho = -1;  
    th1 = dir + theta1;
    th2 = dir + theta2;
    if (meanzero == 0){
      mid = maxlum/2.0;
      bgamp = bgval * 2.0 - 1.0; 
      v0v = maxlum/2.0;  
      v1v = maxlum/2.0;  
    }else{
      v0v = 0.0;      
      v1v = 1.0;      
      bgamp = bgval;  
    }
    sz = size/sscale;
    nstim = 1;
    myfree(stimform);
  }else if (task == 1){
    tframe1 = get_2d_farray(xn,yn);
    for(i=0;i<xn;i++)
      for(j=0;j<yn;j++)
	tframe1[i][j] = bgamp;
    tframe2 = get_2d_farray(xn,yn);
    for(i=0;i<xn;i++)
      for(j=0;j<yn;j++)
	tframe2[i][j] = bgamp;
    xc1 = (float)(xn-1)/2.0 + cx1/sscale;  
    yc1 = (float)(yn-1)/2.0 + cy1/sscale;  
    xc2 = (float)(xn-1)/2.0 + cx2/sscale;  
    yc2 = (float)(yn-1)/2.0 + cy2/sscale;  
    t = (float)ti*tscale;
    ph1 = phase1 + (float)ti*tscale*tf1 * 360.0;
    ph2 = phase2 + (float)ti*tscale*tf2 * 360.0;
    if ((t >= t0) && (t < t0+tn))
      make_frame_sinusoid_0(tframe1,xn,yn,sf1,th1,sscale,ph1,cx1,cy1,con1*v1v);
    if ((t >= t0_2) && (t < t0_2+tn_2))
      make_frame_sinusoid_0(tframe2,xn,yn,sf2,th2,sscale,ph2,cx2,cy2,con2*v1v);
    if (pldflag == 2){  
      make_frame_binarize_0(tframe1,xn,yn,0.0,con1*v1v,-con1*v1v);
      make_frame_binarize_0(tframe2,xn,yn,0.0,con2*v1v,-con2*v1v);
    }
    if (dicho == 2){
      add_const_2d_farray(tframe1,0,xn,0,yn,v0v);
      add_const_2d_farray(tframe2,0,xn,0,yn,v0v);
      apply_aperture_scale(tframe1,xn,yn,aptype,xc1,yc1,sz,sz,0.0,bgval,1.0);
      apply_aperture_scale(tframe2,xn,yn,aptype,xc2,yc2,sz,sz,0.0,bgval,1.0);
      *rframl = tframe1;
      *rframr = tframe2;
    }else{
      apply_aperture_scale(tframe1,xn,yn,aptype,xc1,yc1,sz,sz,0.0, 0.0  ,1.0);
      apply_aperture_scale(tframe2,xn,yn,aptype,xc2,yc2,sz,sz,0.0, 0.0  ,1.0);
      if (pldflag == 3) 
	tframe = and_2d_farrays(tframe1,tframe2,xn,yn,v1v,-v1v);
      else if (pldflag == 4) 
	tframe = and_2d_farrays(tframe1,tframe2,xn,yn,-v1v,v1v);
      else
	tframe = add_2d_farrays(tframe1,tframe2,xn,yn);
      free_2d_farray(tframe1,xn);
      free_2d_farray(tframe2,xn);
      add_const_2d_farray(tframe,0,xn,0,yn,v0v); 
      if (meanzero == 0)
	stim_util_limit_2d(tframe,xn,yn,0.0,maxlum);
      else
	stim_util_limit_2d(tframe,xn,yn,-1.0,1.0);
      *rframl = tframe;  
    }
  }else{
    exit_error("STIMX_PLAID","Unknown task");
  }
}
void stimx_dots(ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,rframe)
     struct param_pair_list *ppl;  
     int xn,yn,zn;                 
     float sscale,tscale;          
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframe;              
{
  int i,j,k;
  int dpf,dtf,aptype,seed;
  float **tframe,x0,y0,fps,szx,szy;
  float t0,tn,theta,coh,speed,ddens,xf,cx,cy;
  static int t0i,nframes;
  static int *dotn;
  static float ampl,bgval,minlum,maxlum,dsize,size;
  static float **dotx,**doty;
  if (task == -1){  
    if (dotx != NULL)
      free_2d_farray(dotx,nframes);
    if (doty != NULL)
      free_2d_farray(doty,nframes);
    if (dotn != NULL)
      myfree(dotn);
  }else if (task == 0){
    t0     = param_getf_exit(ppl,"st0");
    tn     = param_getf_exit(ppl,"stn");
    cx     = param_getf_dflt(ppl,"cx",0.0);
    cy     = param_getf_dflt(ppl,"cy",0.0);
    theta  = param_getf_exit(ppl,"direction");
    coh    = param_getf_exit(ppl,"coherence");
    speed  = param_getf_exit(ppl,"speed");
    ampl   = param_getf_exit(ppl,"ampl");
    bgval  = param_getf_exit(ppl,"bgval");
    maxlum = param_getf_exit(ppl,"maxlum");
    dsize  = param_getf_exit(ppl,"dotsize");
    ddens  = param_getf_exit(ppl,"dotdens");
    size   = param_getf_exit(ppl,"size");
    xf     = param_getf_exit(ppl,"exp_factor");
    dtf    = param_geti_exit(ppl,"dt_frames");
    aptype = param_geti_exit(ppl,"aptype");
    seed   = param_geti_exit(ppl,"seed");
    minlum = 0.0;
    if (xf < 1.0)
      xf = 1.0;
    fps = 1.0/(tsamp*tscale); 
    dpf = (int)((float)(xn*yn)*xf*xf*sscale*sscale * ddens); 
    szx = (float)xn * xf;
    szy = (float)yn * xf;
    nframes = (int)(tn/(tscale*tsamp));
    get_coherence_dot_movie(sscale,fps,coh,speed,theta,szx,szy,nframes,
			    dpf,dtf,seed,&dotx,&doty,&dotn);
    x0 = (float)((int)(xn-1)/2);  
    y0 = (float)((int)(yn-1)/2);  
    if ((aptype > 0) && (aptype != 3))
      mask_dot_movie(dotx,doty,NULL,dotn,nframes,x0,y0,cx,cy,size,size,sscale,
		     aptype);
    t0i = my_rint(t0 / tscale);  
  }else if (task == 1){
    if (dotx == NULL)
      exit_error("STIMX_DOTS","Not prepared to generate stim");
    k = (ti-t0i)/tsamp;  
    tframe = get_2d_farray(xn,yn);
    for(i=0;i<xn;i++)
      for(j=0;j<yn;j++)
	tframe[i][j] = bgval;
    if ((k >= 0) && (k < nframes)){
      make_frame_add_dots_0(tframe,xn,yn,dotx[k],doty[k],dotn[k],
			    ampl,minlum,maxlum,dsize,NULL);
      if (aptype == 3)
	multiply_frame_gaussian_0(tframe,xn,yn,0.0,0.0,size,sscale);
    }
    *rframe = tframe;
  }else{
    exit_error("STIMX_DOTS","unknown task");
  }
}
void stimx_dots_stereogram(ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,
			   rframl,rframr)
     struct param_pair_list *ppl;  
     int xn,yn,zn;                 
     float sscale,tscale;          
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframl;              
     float ***rframr;              
{
  int i,j,k;
  int dpf,dtf,aptype,seed,dotcorr,ptype,dispc,disps;
  float **tframl,**tframr,x0,y0,fps,szx,szy,tf;
  float t0,tn,theta,coh,speed,ddens,xf,cx,cy,*vampl,*vampr;
  float px,py,pw,ph,pdx,pdy,px0_pix,py0_pix,pw_pix,ph_pix,dx_pix,dy_pix;
  float ***dl,***dr,pdx0,pdy0,dx0_pix,dy0_pix,disp0,dispr;
  char *monoflag;
  char *pwf = NULL;
  static int t0i,nframes,meanzero,dwell,make_right,make_left;
  static int *dotn_l,*dotn_r,bipol;
  static float crx1,cry1,crx2,cry2;
  static float ampl,bgval,minlum,maxlum,dsize,size;
  static float **dotx_l,**doty_l,**dotx_r,**doty_r,**dampl,**dampr;
  static char *stimtype = NULL;
  if (task == -1){  
    if (dotx_l != NULL)  free_2d_farray(dotx_l,nframes);
    if (doty_l != NULL)  free_2d_farray(doty_l,nframes);
    if (dotn_l != NULL)  myfree(dotn_l);
    if (dotx_r != NULL)  free_2d_farray(dotx_r,nframes);
    if (doty_r != NULL)  free_2d_farray(doty_r,nframes);
    if (dotn_r != NULL)  myfree(dotn_r);
    if (stimtype != NULL)  myfree(stimtype);
  }else if (task == 0){
    stimtype = param_getc_exit(ppl,"stim_type");
    t0      = param_getf_exit(ppl,"st0");
    tn      = param_getf_exit(ppl,"stn");
    cx      = param_getf_dflt(ppl,"cx",0.0);
    cy      = param_getf_dflt(ppl,"cy",0.0);
    theta   = param_getf_dflt(ppl,"direction",0.0);
    coh     = param_getf_dflt(ppl,"coherence",0.0);
    speed   = param_getf_dflt(ppl,"speed",0.0);
    ampl    = param_getf_exit(ppl,"ampl");
    bgval   = param_getf_exit(ppl,"bgval");
    maxlum  = param_getf_exit(ppl,"maxlum");
    dsize   = param_getf_exit(ppl,"dotsize");
    ddens   = param_getf_exit(ppl,"dotdens");
    size    = param_getf_exit(ppl,"size");
    tf      = param_getf_dflt(ppl,"tf",0.0);
    xf      = param_getf_dflt(ppl,"exp_factor",1.0);
    bipol   = param_geti_dflt(ppl,"bipolar",1);
    dotcorr = param_geti_dflt(ppl,"dotcorr",1);
    dwell   = param_geti_dflt(ppl,"dwell",1);
    dtf     = param_geti_dflt(ppl,"dt_frames",1);
    aptype  = param_geti_exit(ppl,"aptype");
    seed    = param_geti_exit(ppl,"seed");
    meanzero= param_geti_dflt(ppl,"stim_mean_zero",0);
    monoflag= param_getc_dflt(ppl,"stim_monocular","both"); 
    if (strcmp(stimtype,"rds_disp_mod")==0){
      disp0 = param_getf_exit(ppl,"disp_mid");    
      dispr = param_getf_exit(ppl,"disp_range");  
      disps = param_getf_exit(ppl,"disp_sign");   
      dispc = param_geti_dflt(ppl,"disp_mod_corr",1); 
      if (tf == 0.0)
	exit_error("STIMX_DOTS_STEREOGRAM","TF should not be zero");
    }else{
      ptype   = param_geti_dflt(ppl,"patch_type",0);  
      if (ptype == 0){
	px = py = 0.0;
	pw = ph = -1.0;
      }else if (ptype != 0){
	px      = param_getf_exit(ppl,"patch_cx");
	py      = param_getf_exit(ppl,"patch_cy");
	pw      = param_getf_exit(ppl,"patch_w");
	ph      = param_getf_exit(ppl,"patch_h");
      }
      pdx     = param_getf_exit(ppl,"patch_dx");
      pdy     = param_getf_exit(ppl,"patch_dy");
      pdx0    = param_getf_dflt(ppl,"patch_dx0",-pdx);
      pdy0    = param_getf_dflt(ppl,"patch_dy0",-pdy);
      pwf     = param_getc_dflt(ppl,"patch_waveform","const"); 
    }
    make_left = make_right = 1;
    if (strcmp(monoflag,"left")==0)
      make_right = 0;
    else if (strcmp(monoflag,"right")==0)
      make_left = 0;
    pw_pix  = pw/sscale;
    ph_pix  = ph/sscale;
    px0_pix = (float)xn/2.0 + px/sscale - pw_pix/2.0;
    py0_pix = (float)yn/2.0 + py/sscale - ph_pix/2.0;
    if ((pw < 0.0) || (ph < 0.0)){
      crx1 = 0.0;
      crx2 = (float)xn;
      cry1 = 0.0;
      cry2 = (float)yn;
    }else{
      crx1 = px0_pix;  
      crx2 = px0_pix + pw_pix - 1.0;
      cry1 = py0_pix;
      cry2 = py0_pix + ph_pix - 1.0;
    }
    dx_pix  = pdx/sscale;
    dy_pix  = pdy/sscale;
    dx0_pix  = pdx0/sscale;
    dy0_pix  = pdy0/sscale;
    if (meanzero == 1){
      minlum = -maxlum;
    }else
      minlum = 0.0;
    if (xf < 1.0)
      xf = 1.0;
    fps = 1.0/(dwell*tsamp*tscale); 
    dpf = (int)((float)(xn*yn)*xf*xf*sscale*sscale * ddens); 
    szx = (float)xn * xf;
    szy = (float)yn * xf;
    nframes = (int)(tn/((float)dwell*tscale*tsamp));
    if (strcmp(stimtype,"rds_disp_mod")==0){
      get_rds_disp_mod(sscale,fps,disp0,dispr,disps,theta,tf,szx,szy,
		       dx_pix,dy_pix,dx0_pix,dy0_pix,nframes,dpf,seed,dispc,
		       &dotx_l,&doty_l,&dotn_l,&dotx_r,&doty_r,&dotn_r,
		       &dampl,&dampr);
    }else{
      get_dot_stereogram(sscale,fps,coh,speed,theta,tf,pwf,szx,szy,
			 crx1,crx2,cry1,cry2,dx_pix,dy_pix,dx0_pix,dy0_pix,
			 nframes,dpf,dtf,seed,dotcorr,
			 &dotx_l,&doty_l,&dotn_l,&dotx_r,&doty_r,&dotn_r,
			 &dampl,&dampr);
    }
    if (bipol == 1){
      if ((meanzero == 1) && (bgval != 0.0))
	exit_error("STIMX_DOTS_STEREOGRAM","Expecting bgval to be 0.0");
      else if (bgval == 0.5){
	for(i=0;i<nframes;i++){
	  multiply_farray(dampl[i],dotn_l[i],ampl/2.0);
	  multiply_farray(dampr[i],dotn_r[i],ampl/2.0);
	}
      }
    }
    if (dotcorr == -1){
      for(i=0;i<nframes;i++){
	multiply_farray(dampr[i],dotn_r[i],-1.0);
      }
    }
    x0 = (float)((int)(xn-1)/2);  
    y0 = (float)((int)(yn-1)/2);  
    if ((aptype > 0) && (aptype != 3)){
      mask_dot_movie(dotx_l,doty_l,dampl,dotn_l,nframes,x0,y0,cx,cy,size,size,
		     sscale,aptype);
      mask_dot_movie(dotx_r,doty_r,dampr,dotn_r,nframes,x0,y0,cx,cy,size,size,
		     sscale,aptype);
    }
    t0i = my_rint(t0 / tscale);  
    myfree(monoflag);
    if (pwf != NULL)  myfree(pwf);
  }else if (task == 1){
    if (dotx_l == NULL)
      exit_error("STIMX_DOTS_STEREOGRAM","Not prepared to generate stim");
    k = (ti-t0i)/(dwell*tsamp);  
    tframl = get_2d_farray(xn,yn);
    tframr = get_2d_farray(xn,yn);
    for(i=0;i<xn;i++)
      for(j=0;j<yn;j++){
	tframl[i][j] = bgval;
	tframr[i][j] = bgval;
      }
    if ((k >= 0) && (k < nframes)){
      if (bipol == 1){
	vampl = dampl[k];
	vampr = dampr[k];
      }else{
	vampl = vampr = NULL;
      }
      if (make_left == 1){
	make_frame_add_dots_clipr(tframl,xn,yn,dotx_l[k],doty_l[k],dotn_l[k],
				  ampl,minlum,maxlum,dsize,vampl,crx1,crx2,
				  cry1,cry2);
	if (aptype == 3)
	  multiply_frame_gaussian_0(tframl,xn,yn,0.0,0.0,size,sscale);
      }
      if (make_right == 1){
	make_frame_add_dots_clipr(tframr,xn,yn,dotx_r[k],doty_r[k],dotn_r[k],
				  ampl,minlum,maxlum,dsize,vampr,crx1,crx2,
				  cry1,cry2);
	if (aptype == 3)
	  multiply_frame_gaussian_0(tframr,xn,yn,0.0,0.0,size,sscale);
      }
    }
    *rframl = tframl;
    *rframr = tframr;
  }else{
    exit_error("STIMX_DOTS_STEREOGRAM","unknown task");
  }
}
void stimx_gp(ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,rframe)
     struct param_pair_list *ppl;  
     int xn,yn,zn;                 
     float sscale,tscale;          
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframe;              
{
  int i,j,k;
  int seed;
  float **tframe,t0,tn,ddens,size,cx,cy;
  static int t0i,nframes,aptype,dn;
  static int *seedlist;
  static float r,theta,amp1,amp2,bgval,ampmin,ampmax,dsize,meandot,xf,xc,yc,sz;
  if (task == -1){  
    if (seedlist != NULL)
      myfree(seedlist);
  }else if (task == 0){
    t0     = param_getf_exit(ppl,"st0");
    tn     = param_getf_exit(ppl,"stn");
    cx     = param_getf_dflt(ppl,"cx",0.0);
    cy     = param_getf_dflt(ppl,"cy",0.0);
    r      = param_getf_exit(ppl,"gp_r");
    theta  = param_getf_exit(ppl,"gp_theta");
    amp1   = param_getf_exit(ppl,"dot1_amp");
    amp2   = param_getf_exit(ppl,"dot2_amp");
    bgval  = param_getf_exit(ppl,"bgval");
    ampmin = param_getf_exit(ppl,"ampmin");
    ampmax = param_getf_exit(ppl,"ampmax");
    dsize  = param_getf_exit(ppl,"dotsize");
    ddens  = param_getf_exit(ppl,"dotdens");
    xf     = param_getf_exit(ppl,"exp_factor");
    size   = param_getf_exit(ppl,"size");
    seed   = param_geti_exit(ppl,"seed");
    aptype = param_geti_exit(ppl,"aptype");
    xc = (float)(xn-1)/2.0 + cx/sscale;  
    yc = (float)(yn-1)/2.0 + cy/sscale;  
    meandot = (float)(xn*yn)*xf*xf*sscale*sscale * ddens; 
    sz = size/sscale;
    nframes = (int)(tn/(tscale*tsamp));
    seedlist = get_seeds(seed,100000,nframes);
    t0i = my_rint(t0 / tscale);  
  }else if (task == 1){
    if (seedlist == NULL)
      exit_error("STIMX_GP","Not prepared to generate stim");
    k = (ti-t0i)/tsamp;  
    tframe = get_2d_farray(xn,yn);
    for(i=0;i<xn;i++)
      for(j=0;j<yn;j++)
	tframe[i][j] = bgval;
    if ((k >= 0) && (k < nframes)){
      dn = myrand_poisson_count(meandot,seedlist[k]);
      make_frame_gp_trans_0(tframe,xn,yn,sscale,r,theta,amp1,amp2,
			    bgval,ampmin,ampmax,dsize,xf,dn,seedlist[k]);
      apply_aperture_scale(tframe,xn,yn,aptype,xc,yc,sz,sz,0.0,bgval,1.0);
    }
    *rframe = tframe;
  }else{
    exit_error("STIMX_GP","unknown task");
  }
}
void stimx_image_set(ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,rframe)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframe;              
{
  int k;
  int seed;
  float bgval,st0,stn,cx,cy,**gdata;
  static int t0i,nframes,x0,y0,gxn,gyn,boxw,boxh,dwell;
  static int *seedlist = NULL;
  static float bgamp;
  static char *image_dir = NULL;
  static float **fprev = NULL;
  static int fprevk = -1;
  if (task == -1){  
    if (seedlist != NULL)
      myfree(seedlist);
    if (image_dir != NULL)
      myfree(image_dir);
    if (fprev  != NULL){
      free_2d_farray(fprev,xn);
      fprev = NULL;
    }
    fprevk = -1;
  }else if (task == 0){
    st0     = param_getf_exit(ppl,"st0");
    stn     = param_getf_exit(ppl,"stn");
    cx      = param_getf_dflt(ppl,"cx",0.0);
    cy      = param_getf_dflt(ppl,"cy",0.0);
    gxn     = param_geti_exit(ppl,"grid_w");
    gyn     = param_geti_exit(ppl,"grid_h");
    boxw    = param_geti_exit(ppl,"box_w");
    boxh    = param_geti_exit(ppl,"box_h");
    dwell   = param_geti_exit(ppl,"dwell");
    seed    = param_geti_exit(ppl,"seed");
    bgval   = param_getf_exit(ppl,"bgval");
    image_dir = param_getc_exit(ppl,"set_dir");
    bgamp = bgval * 2.0 - 1.0; 
    nframes = stm_get_n(zn,tscale,st0,stn,dwell,tsamp);  
    seedlist = get_seeds(seed,100000,nframes);  
    t0i = stm_get_ti0(zn,tscale,st0,tsamp);  
    x0 = (int)((float)(xn - gxn*boxw)/2.0);  
    y0 = (int)((float)(yn - gyn*boxh)/2.0);
    x0 += my_rint(cx/sscale);  
    y0 += my_rint(cy/sscale);  
    fprev = NULL;  
    fprevk = -1;
  }else if (task == 1){
    if (seedlist == NULL)
      exit_error("STIMX_IMAGE_SET","Not prepared to generate stim");
    k =  (int)((ti-t0i)/(dwell*tsamp)); 
    if ((k < 0) || (k >= nframes)){
      *rframe = NULL;  
      return;
    }
    if (k != fprevk){ 
      gdata = stm_vanhat_get_patch(seedlist[k],gxn,gyn,image_dir,"-1 to 1");
      if (fprev != NULL)
	free_2d_farray(fprev,xn);
      fprev = stm_noise_get_grid(xn,yn,gxn,gyn,boxw,boxh,x0,y0,gdata,bgamp);
      fprevk = k;
      free_2d_farray(gdata,gxn);
    }
    *rframe = fprev;
  }else{
    exit_error("STIMX_IMAGE_SET","unknown task");
  }
}
void stimx_noise(ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,rframe)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframe;              
{
  int i,j,k;
  int seed,nrpt;
  float bgval,st0,stn,cx,cy,**pow_data;
  static int t0i,nframes,x0,y0,gxn,gyn,boxw,boxh,dwell,ncol;
  static int *seedlist = NULL;
  static float bgamp,fpow;
  static float **gdata = NULL;
  static char *rgen = NULL;
  if (task == -1){  
    if (seedlist != NULL)
      myfree(seedlist);
    if (gdata != NULL)
      free_2d_farray(gdata,gxn);
    if (rgen != NULL)
      myfree(rgen);
  }else if (task == 0){
    st0     = param_getf_exit(ppl,"st0");
    stn     = param_getf_exit(ppl,"stn");
    cx      = param_getf_dflt(ppl,"cx",0.0);
    cy      = param_getf_dflt(ppl,"cy",0.0);
    gxn     = param_geti_exit(ppl,"grid_w");
    gyn     = param_geti_exit(ppl,"grid_h");
    boxw    = param_geti_exit(ppl,"box_w");
    boxh    = param_geti_exit(ppl,"box_h");
    dwell   = param_geti_exit(ppl,"dwell");
    ncol    = param_geti_dflt(ppl,"n_color",2);
    seed    = param_geti_exit(ppl,"seed");
    rgen    = param_getc_dflt(ppl,"randgen","default");
    bgval   = param_getf_exit(ppl,"bgval");
    fpow    = param_getf_dflt(ppl,"power_law_2d",0.0);
    bgamp = bgval * 2.0 - 1.0; 
    nframes = stm_get_n(zn,tscale,st0,stn,dwell,tsamp);  
    if (strcmp(rgen,"default")==0){
      seedlist = get_seeds(seed,100000,nframes);  
    }else if (strcmp(rgen,"ejrand")==0){
      seedlist = ejrand_get_seeds(seed,gxn*gyn,nframes);
    }else if (strcmp(rgen,"ejrand_genseq")==0){
      nrpt = param_geti_exit(ppl,"stim_nrpt");
      printf("    Generating a seed list for %d repeats.\n",nrpt);
      printf("      %d x %d  grid\n",gxn,gyn);
      printf("      %d frames per stimulus\n",nframes);
      seedlist = ejrand_get_seeds(seed,gxn*gyn*nframes,nrpt);
      for(i=0;i<nrpt;i++)
	printf(" %d",seedlist[i]);
      printf("\n");
      exit_error("STIMX_NOISE","Generated sequence to use as VAR param");
    }else{
      printf("  *** randgen = %s\n",rgen);
      exit_error("STIMX_NOISE","Unknown 'randgen' value");
    }
    gdata = get_2d_farray(gxn,gyn);  
    t0i = stm_get_ti0(zn,tscale,st0,tsamp);
    x0 = (int)((float)(xn - gxn*boxw)/2.0);  
    y0 = (int)((float)(yn - gyn*boxh)/2.0);
    x0 += my_rint(cx/sscale);  
    y0 += my_rint(cy/sscale);  
  }else if (task == 1){
    if (seedlist == NULL)
      exit_error("STIMX_NOISE","Not prepared to generate stim");
    k =  (int)((ti-t0i)/(dwell*tsamp)); 
    if ((k < 0) || (k >= nframes)){
      *rframe = NULL;  
      return;
    }
    if (ncol == 2)
      gdata = myrand_get_std_bin_float_2d(gxn,gyn,seedlist[k]);
    else if (ncol == 4){
      if (strcmp(rgen,"ejrand")==0){
	gdata = myrand_get_std_quad_ejrand_2d(gxn,gyn,seedlist[k]);
      }else{
	gdata = myrand_get_std_quad_float_2d(gxn,gyn,seedlist[k]);
      }
    }else
      exit_error("STIMX_NOISE","Number of colors, n_color, must be 2 or 4");
    if (param_test(ppl,"power_law_2d"))
      power_law_2d_transform(gdata,gxn,gyn,fpow,"1 max 0.5 mid");
    *rframe = stm_noise_get_grid(xn,yn,gxn,gyn,boxw,boxh,x0,y0,gdata,bgamp);
  }else{
    exit_error("STIMX_NOISE","unknown task");
  }
}
void stimx_pasupathy_shape(ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,rframe)
     struct param_pair_list *ppl;  
     int xn,yn,zn;                 
     float sscale,tscale;          
     int tsamp;                    
     int ti;                       
     int task;                     
     float ***rframe;              
{
  int i,j,k;
  int occ_seed,occ_gn;
  float **tframe,t0,tn,size,cx,cy,occ_diam,occ_gw,occ_jit,x0,y0;
  static int t0i,nframes,shid,fill,normfl,occ_n;
  static float r,theta,fgval,bgval,xc,yc,sz,aa_sd;
  static char *shpset = NULL;
  static float spot_amp,spot_sd,spot_x,spot_y;
  static float *occ_x,*occ_y,occ_r,occ_amp;
  if (task == -1){  
    if (shpset != NULL)  myfree(shpset);
    if (occ_x  != NULL)   myfree(occ_x);
    if (occ_y  != NULL)   myfree(occ_y);
  }else if (task == 0){
    t0     = param_getf_exit(ppl,"st0");
    tn     = param_getf_exit(ppl,"stn");
    cx     = param_getf_dflt(ppl,"cx",0.0);
    cy     = param_getf_dflt(ppl,"cy",0.0);
    shid   = param_geti_exit(ppl,"shape_id");
    theta  = param_getf_exit(ppl,"rotation");
    size   = param_getf_exit(ppl,"size");
    fgval  = param_getf_exit(ppl,"fgval");
    bgval  = param_getf_exit(ppl,"bgval");
    aa_sd  = param_getf_exit(ppl,"antialias");
    normfl = param_geti_dflt(ppl,"norm_flag",0);
    fill   = param_geti_dflt(ppl,"fill",1);
    shpset = param_getc_dflt(ppl,"shape_set","pc2001"); 
    spot_amp = param_getf_dflt(ppl,"spot_amp",0.0);
    if (spot_amp != 0.0){
      spot_sd = param_getf_exit(ppl,"spot_sd");
      spot_x  = param_getf_exit(ppl,"spot_x");
      spot_y  = param_getf_exit(ppl,"spot_y");
      printf("  spot_amp = %f\n",spot_amp);
    }
    occ_n = param_geti_dflt(ppl,"occluder_count",0);   
    if (occ_n > 0){
      occ_gn   = param_geti_exit(ppl,"occluder_grid_n");     
      occ_gw   = param_getf_exit(ppl,"occluder_grid_width"); 
      occ_amp  = param_getf_exit(ppl,"occluder_ampl");       
      occ_diam = param_getf_exit(ppl,"occluder_diameter");   
      occ_jit  = param_getf_exit(ppl,"occluder_jitter");     
      occ_seed = param_geti_exit(ppl,"occluder_seed");       
      x0 = (xn*sscale - occ_gw) / 2.0;   
      y0 = (yn*sscale - occ_gw) / 2.0;   
      stimu_rangrid(sscale,x0,y0,occ_gw,occ_gn,occ_n,occ_jit,occ_seed,
		    &occ_x,&occ_y);
      occ_r = 0.5 * occ_diam / sscale;  
    }else{
      occ_x = occ_y = NULL;
    }
    xc = (float)(xn-1)/2.0 + cx/sscale;  
    yc = (float)(yn-1)/2.0 + cy/sscale;  
    nframes = (int)(tn/(tscale*tsamp));
    sz = size/sscale;
    t0i = my_rint(t0 / tscale);  
  }else if (task == 1){
    k = (ti-t0i)/tsamp;  
    tframe = get_2d_farray(xn,yn);
    for(i=0;i<xn;i++)
      for(j=0;j<yn;j++)
	tframe[i][j] = bgval;
    if (spot_amp != 0.0){
      make_frame_add_2d_gauss(tframe,xn,yn,spot_amp,spot_sd,spot_x,spot_y,
			      sscale);
    }
    if ((k >= 0) && (k < nframes)){
      if (1){
	stm_pasupathy_shape(NULL,tframe,xn,yn,xc,yc,shpset,shid,theta,sz,
			    fgval,bgval,aa_sd,fill,normfl);
      }else if (strcmp(shpset,"yasm")==0){
	;
      }else{
	exit_error("STIMX_PASUPATHY_SHAPE","unknown 'shape_set'");
      }
      if (occ_n > 0){  
	stimu_frame_disk_array(tframe,xn,yn,occ_x,occ_y,occ_r,occ_n,occ_amp);
      }
    }
    *rframe = tframe;
  }else{
    exit_error("STIMX_PASUPATHY_SHAPE","unknown task");
  }
}
void stimx_rgb_sine(ppl,xn,yn,zn,sscale,tscale,tsamp,ti,task,rframe)
     struct param_pair_list *ppl;  
     int xn,yn,zn;                 
     float sscale,tscale;          
     int tsamp;                    
     int ti;                       
     int task;                     
     int ***rframe;                
{
  int i,j,k;
  int **tframe,tc;
  float t0,tn,tr,tg,tb,ph0;
  static int t0i,nframes;
  static float tf,sv,r_off,r_amp,r_pha,g_off,g_amp,g_pha,b_off,b_amp,b_pha;
  if (task == -1){  
    ;
  }else if (task == 0){
    t0     = param_getf_exit(ppl,"st0");
    tn     = param_getf_exit(ppl,"stn");
    tf     = param_getf_exit(ppl,"tf");
    sv     = param_getf_exit(ppl,"c_scale");
    r_off  = param_getf_exit(ppl,"r_offset");
    r_amp  = param_getf_exit(ppl,"r_ampl");
    r_pha  = param_getf_exit(ppl,"r_phase");
    g_off  = param_getf_exit(ppl,"g_offset");
    g_amp  = param_getf_exit(ppl,"g_ampl");
    g_pha  = param_getf_exit(ppl,"g_phase");
    b_off  = param_getf_exit(ppl,"b_offset");
    b_amp  = param_getf_exit(ppl,"b_ampl");
    b_pha  = param_getf_exit(ppl,"b_phase");
    nframes = (int)(tn/(tscale*tsamp));
    t0i = my_rint(t0 / tscale);  
  }else if (task == 1){
    ph0 = (float)(ti-t0i)*tscale*tf * 360.0;
    tr = r_off + r_amp*sin(M_PI/180.0 * (r_pha + ph0));
    tg = g_off + g_amp*sin(M_PI/180.0 * (g_pha + ph0));
    tb = b_off + b_amp*sin(M_PI/180.0 * (b_pha + ph0));
    tc = data_util_t11_int_for_rgb(sv*tr,sv*tg,sv*tb);
    tframe = get_2d_iarray(xn,yn);
    for(i=0;i<xn;i++)
      for(j=0;j<yn;j++)
	tframe[i][j] = tc;
    *rframe = tframe;
  }else{
    exit_error("STIMX_RGB_SINE","unknown task");
  }
}
int ***stim_util_3c_from_tern_3d(data,x0,xn,y0,yn,z0,zn,r0,g0,b0,r1,g1,b1,
				 r2,g2,b2)
     float ***data;           
     int x0,xn,y0,yn,z0,zn;   
     float r0,g0,b0;          
     float r1,g1,b1;          
     float r2,g2,b2;          
{
  int i,j,k;
  int ***dc,c0,c1,c2,*tc;
  float *t;
  c0 = data_util_t11_int_for_rgb(r0,g0,b0);
  c1 = data_util_t11_int_for_rgb(r1,g1,b1);
  c2 = data_util_t11_int_for_rgb(r2,g2,b2);
  dc = get_3d_iarray(xn,yn,zn);
  for(i=x0;i<(x0+xn);i++){
    for(j=y0;j<(y0+yn);j++){
      t = data[i][j];
      tc = dc[i-x0][j-y0];
      for(k=z0;k<(z0+zn);k++){
	if (t[k] < 0.001)
	  tc[k-z0] = c0;
	else if (t[k] > 0.999)
	  tc[k-z0] = c1;
	else
	  tc[k-z0] = c2;
      }
    }
  }
  return dc;
}
int ***stim_util_3c_2col_from_3d(data,x0,xn,y0,yn,z0,zn,r0,g0,b0,r1,g1,b1)
     float ***data;           
     int x0,xn,y0,yn,z0,zn;   
     float r0,g0,b0;          
     float r1,g1,b1;          
{
  int i,j,k;
  int ***dc,*tc;
  float *t,ro,go,bo,ra,ga,ba,tr,tg,tb,ts;
  ro = r0;  ra = r1 - r0;
  go = g0;  ga = g1 - g0;
  bo = b0;  ba = b1 - b0;
  dc = get_3d_iarray(xn,yn,zn);
  for(i=x0;i<(x0+xn);i++){
    for(j=y0;j<(y0+yn);j++){
      t = data[i][j];
      tc = dc[i-x0][j-y0];
      for(k=z0;k<(z0+zn);k++){
	ts = t[k];
	if ((ts > 0.4999) && (ts < 0.5001))
	  ts = 0.5;
	tr = ro + ts * ra;  
	tg = go + ts * ga;  
	tb = bo + ts * ba;  
	tc[k-z0] = data_util_t11_int_for_rgb(tr,tg,tb);
      }
    }
  }
  return dc;
}
int ***stim_util_3c_4col_from_3d(data,x0,xn,y0,yn,z0,zn,r0,g0,b0,r1,g1,b1,
				 r2,g2,b2,r3,g3,b3,r4,g4,b4)
     float ***data;           
     int x0,xn,y0,yn,z0,zn;   
     float r0,g0,b0;          
     float r1,g1,b1;          
     float r2,g2,b2;          
     float r3,g3,b3;          
     float r4,g4,b4;          
{
  int i,j,k;
  int ***dc,*tc;
  float *t,tr,tg,tb,ts;
  dc = get_3d_iarray(xn,yn,zn);
  for(i=x0;i<(x0+xn);i++){
    for(j=y0;j<(y0+yn);j++){
      t = data[i][j];
      tc = dc[i-x0][j-y0];
      for(k=z0;k<(z0+zn);k++){
	ts = t[k];
	if ((ts > 0.4999) && (ts < 0.5001)){
	  tr = r4; tg = g4; tb = b4;
	}else if (ts < 0.15){
	  tr = r0; tg = g0; tb = b0;
	}else if (ts < 0.45){
	  tr = r1; tg = g1; tb = b1;
	}else if (ts < 0.85){
	  tr = r2; tg = g2; tb = b2;
	}else{
	  tr = r3; tg = g3; tb = b3;
	}
	tc[k-z0] = data_util_t11_int_for_rgb(tr,tg,tb);
      }
    }
  }
  return dc;
}
float ***stim_util_blur(mylogf,ppl,sdata,xn,yn,tn,sscale,tscale)
     char *mylogf;
     struct param_pair_list *ppl;
     float ***sdata;
     int xn,yn,tn;
     float sscale,tscale;
{
  int i,j,k;
  float sig,ts,tss,xc,yc;
  float ***d,***smf,**smf_s,***r;
  char ggstr[SLEN];
  sig = paramfile_get_float_param_default(ppl,"stim_smooth",0.0);
  sig /= sscale;  
  ts  = paramfile_get_float_param_default(ppl,"stim_smooth_t",0.0);
  ts /= tscale;  
  if ((sig > 0.0) || (ts > 0.0)){
    mylog(mylogf,"  STIM_UTIL_BLUR\n");
    smf = get_stim_impulse(xn,yn,tn,1,1,1,0.0); 
    xc = (float)(xn/2 + 1);
    yc = (float)(yn/2 + 1);
    if ((sig > 0.0) && (ts == 0.0)){  
      sprintf(ggstr,"      Spatial smoothing, Gaussian SD %.2f pix\n",sig);
      mylog(mylogf,ggstr);
      for(i=1;i<=xn;i++)
	for(j=1;j<=yn;j++)
	  smf[i][j][1] = func_2d_gaussian((float)i,(float)j,xc,yc,sig,sig,1);
    }else if ((sig == 0.0) && (ts > 0.0)){  
      sprintf(ggstr,"      Temporal smooth, Maxwell peaks at %.2f pix\n",ts);
      mylog(mylogf,ggstr);
      tss = ts/sqrt(2.0);  
      for(k=1;k<tn/2;k++)
	smf[xn/2+1][yn/2+1][k] = func_maxwell((float)(k-1),tss);
    }else{
      sprintf(ggstr,"      Spatial smooth, Gaussian SD %.2f pix\n",sig);
      mylog(mylogf,ggstr);
      sprintf(ggstr,"      Temporal smooth, Maxwell func peak %.2f pix\n",ts);
      mylog(mylogf,ggstr);
      mylog_exit(mylogf,"STIM_UTIL_BLUR  x and t smooth not impl'd yet!!!\n");
    }
    smf_s = matrix(1,xn,1,2*yn);
    contort_real_3d_farray(smf,1,1,1,xn,yn,tn);
    rlft3(smf,smf_s,xn,yn,tn,1);
    compute_response_single_from_ft(sdata,smf,smf_s,xn,yn,tn,0,&r); 
    free_f3tensor(smf,1,xn,1,yn,1,tn);
    free_matrix(smf_s,1,xn,1,2*yn);
  }else{
    r = NULL;
  }
  return r;
}
void stim_util_add_modspot(ppl,data,x0,xn,y0,yn,z0,zn,tsamp,tscale,sscale)
     struct param_pair_list *ppl;
     float ***data;
     int x0,xn,y0,yn,z0,zn;
     int tsamp;      
     float tscale;   
     float sscale;   
{
  int i,k;
  int xi,yi,x0pix,x1pix,y0pix,y1pix;
  int spot_type,varflag,seed,dt,distrib,ord,seqn,spotsz;
  float spotcon,stn,fps,v1,v2,*seqf,xc,yc,spotx,spoty,c;
  if (tsamp != 1){
    printf("  tsamp = %d\n",tsamp);
    exit_error("STIM_UTIL_ADD_MODSPOT","tsamp > 1 not implemented");
  }
  spot_type = paramfile_get_int_param_or_exit(ppl,"spot_type");
  varflag   = paramfile_get_int_param_or_exit(ppl,"var");
  seed      = paramfile_get_int_param_or_exit(ppl,"seed");
  dt        = paramfile_get_int_param_or_exit(ppl,"dt");
  distrib   = param_getf_exit(ppl,"distrib");
  spotcon   = param_getf_exit(ppl,"spot_contrast");
  stn       = param_getf_exit(ppl,"stn");
  spotx     = param_getf_exit(ppl,"spot_x");
  spoty     = param_getf_exit(ppl,"spot_y");
  spotsz    = paramfile_get_int_param_or_exit(ppl,"spot_size_pix");
  xc = (float)(1+xn)/2.0 + spotx/sscale;
  yc = (float)(1+yn)/2.0 + spoty/sscale;
  x0pix = my_rint(xc - (float)spotsz/2.0);
  x1pix = x0pix + spotsz - 1;
  if (x0pix < 1)
    x0pix = 1;
  if (x1pix > xn)
    x0pix = xn;
  y0pix = my_rint(yc - (float)spotsz/2.0);
  y1pix = y0pix + spotsz - 1;
  if (y0pix < 1)
    y0pix = 1;
  if (y1pix > yn)
    y0pix = yn;
  v1 = 0.5 + 0.5*spotcon;
  if (v1 > 1.0)
    v1 = 1.0;
  v2 = 0.5 - 0.5*spotcon;
  if (v2 < 0.0)
    v2 = 0.0;
  if (distrib == 7)
    ord = param_geti_exit(ppl,"mseq_ord");
  else
    ord = 0;
  fps = 1.0/tscale;
  stm_get_ran_seq(NULL,distrib,ord,seed,fps,stn,dt,v1,v2,0.0,&seqf,&seqn);
  k = 0; 
  for(i=1;i<=zn;i++){
    if (((i-1)%dt) == 0){
      if (k >= seqn)
	exit_error("STIM_UTIL_ADD_MODSPOT","k too large");
      c = seqf[k];
      k += 1;
    }
    for(xi=x0pix;xi<=x1pix;xi++){    
      for(yi=y0pix;yi<=y1pix;yi++){
	data[xi][yi][i] = c;
      }
    }
  }
  myfree(seqf);
}
float ***get_stim_3d_noise(xn,yn,zn,pixsize,pixdur,seed,amp,tensorflag)
     int xn,yn,zn;
     int pixsize,pixdur,seed;
     float amp;
     int tensorflag;
{
  int i,j,k;
  int x0,y0,z0,tseed;
  float ***data;
  if (tensorflag == 1){
    data = f3tensor(1,xn,1,yn,1,zn); 
    exit_error("GET_STIM_3D_NOISE","Not implemented yet");
    x0 = y0 = z0 = 1;
  }else{
    data = get_3d_farray(xn,yn,zn);
    x0 = y0 = z0 = 0;
  }
  tseed = seed;
  if (tseed > 0)
    tseed = -tseed;
  for(i=z0;i<(z0+zn);i++)
    if (((i-z0)%pixdur)==0){
      make_frame_binary_noise(data,x0,xn,y0,yn,i,pixsize,amp,&tseed);
    }else{ 
      for(j=0;j<xn;j++)
	for(k=0;k<yn;k++)
	  data[j+x0][k+y0][i] = data[j+x0][k+y0][i-1];
    }
  return data;
}
void offset_block_stim_3d_noise(data,xn,yn,zn,pixsize,pixdur,seed,amp,
				bx0,by0,bxn,byn,bt0,btn,dx,dy)
     float ***data;
     int xn,yn,zn;
     int pixsize,pixdur,seed;
     float amp;
     int bx0,by0,bxn,byn,bt0,btn,dx,dy;
{
  int i,j,k;
  int tseed,j1,j2,k1,k2,dj,dk;
  int mx0,mxn,my0,myn;
  float **tframe;
  tseed = seed;
  if (tseed > 0)
    tseed = -tseed;
  tframe = get_2d_farray(bxn*pixsize,byn*pixsize);
  j1 = bx0*pixsize;
  j2 = j1 + bxn*pixsize;
  k1 = by0*pixsize;
  k2 = k1 + byn*pixsize;
  dj = dx*pixsize;
  dk = dy*pixsize;
  for(i=bt0;i<(bt0+btn);i++){ 
    for(j=j1;j<j2;j++)
      for(k=k1;k<k2;k++)
	tframe[j-j1][k-k1] = data[j][k][i];
    for(j=j1;j<j2;j++)
      for(k=k1;k<k2;k++)
	data[j+dj][k+dk][i] = tframe[j-j1][k-k1];
    if (dx != 0){
      if (dx > 0){
	mx0 = bx0*pixsize;
	mxn = dj;
	my0 = by0*pixsize;
	myn = byn*pixsize;
      }else{
	mx0 = bxn+dx - 1;
	mxn = dj;
	printf("****** WYETH what should my0 and myn be here? Using 0?\n");
	my0 = 0;  
	myn = 0;
      }
      if (((i-bt0)%pixdur)==0)
	make_frame_binary_noise(data,mx0,mxn,my0,myn,i,pixsize,amp,&tseed);
      else{ 
	for(j=mx0;j<(mx0+mxn);j++)
	  for(k=my0;k<(my0+myn);k++)
	    data[j][k][i] = data[j][k][i-1];
      }
    }
    if (dy != 0){
      exit_error("XXXXXXXXXXX","Not implemented yet");
    }
  }
  free_2d_farray(tframe,bxn*pixsize);
}
float ***get_stim_quad_sine(xn,yn,zn,sscale,tscale,tsamp,sf,tf,phase,theta,
			  contrast,maxlum)
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
     float sf,tf,phase,theta,contrast,maxlum;
{
  int i,k;
  float ***data,phi,mid,xc,yc;
  data = f3tensor(1,xn,1,yn,1,zn); 
  xc = yc = 0.0;
  k = 0;
  for(i=1;i<=zn;i++){
    if (((i-1)%tsamp) == 0){
      if ((k%2)==0){ 
	make_frame_sinusoid(data,1,xn,1,yn,1,zn,i,sf,theta,sscale,0.0,xc,yc);
	phi = (float)i*tscale*tf * 2.0*M_PI;
	multiply_frame(data,1,xn,1,yn,1,zn,i,cos(phi));
      }else{ 
	make_frame_sinusoid(data,1,xn,1,yn,1,zn,i,sf,theta,sscale,90.0,xc,yc);
	phi = (float)i*tscale*tf * 2.0*M_PI;
	multiply_frame(data,1,xn,1,yn,1,zn,i,sin(phi));
      }
      k += 1;
    }else
      make_frame_flat(data,1,xn,1,yn,1,zn,i,-1.0);
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data,1,xn,1,yn,1,zn,contrast*mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  return data;
}
float ***get_stim_3d_sine(xn,yn,zn,sscale,tscale,tsamp,sf,tf,phase,theta,
			  contrast,maxlum)
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
     float sf,tf,phase,theta,contrast,maxlum;
{
  int i;
  float ***data,ph,mid,xc,yc;
  data = f3tensor(1,xn,1,yn,1,zn); 
  printf("*** GET_STIM_3D_SINE - this is not the conventional center\n");
  xc = (float)xn/2.0 * sscale;
  yc = (float)yn/2.0 * sscale;
  for(i=1;i<=zn;i++){
    if (((i-1)%tsamp) == 0){
      ph = phase + (float)(i-1)*tscale*tf * 360.0;
      make_frame_sinusoid(data,1,xn,1,yn,1,zn,i,sf,theta,sscale,ph,xc,yc);
    }else
      make_frame_flat(data,1,xn,1,yn,1,zn,i,-1.0);
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data,1,xn,1,yn,1,zn,contrast*mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  return data;
}
float ***get_stim_sine_int_noise(xn,yn,zn,sscale,tscale,tsamp,sf,tf,phase,
				 theta,contrast,maxlum,noise_contrast,npix,
				 seed)
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
     float sf,tf,phase,theta,contrast,maxlum,noise_contrast;
     int npix;
     long seed;
{
  int i,j,k;
  int kk,tseed;
  float ***data,mid;
  printf("*** WARNING - WYETH changed usage of seed to send addr. ***\n");
  tseed = seed;
  if (tseed > 0)
    tseed = -tseed; 
  data = get_stim_3d_sine(xn,yn,zn,sscale,tscale,tsamp,sf,tf,phase,theta,
			  contrast,maxlum);
  mid = (float)maxlum/2.0;
  kk = 1+tsamp;
  if (zn >= 2){
    make_frame_binary_noise(data,1,xn,1,yn,kk,npix,noise_contrast*mid,
			    &tseed);
    for(i=1;i<=xn;i++)
      for(j=1;j<=yn;j++)
	data[i][j][kk] += mid;
    for(k=(kk+2*tsamp);k<=zn;k+=2*tsamp)
      for(i=1;i<=xn;i++)
	for(j=1;j<=yn;j++)
	  data[i][j][k] = data[i][j][kk];
  }
  return data;
}
float ***get_stim_impulse(xn,yn,zn,x,y,z,ampl)
     int xn,yn,zn,x,y,z;
     float ampl;
{
  int i,j,k;
  float ***data;
  data = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=xn;i++)
    for(j=1;j<=yn;j++)
      for(k=1;k<=zn;k++)
	data[i][j][k] = 0.0;
  data[x][y][z] = ampl;
  return data;
}
float ***get_stim_3d_ppl_dynedge(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i;
  int seed;
  float ***data,t,t0,tn,ampl,bgval;
  float amp,sd,maxlum,contrast,mid;
  sd       = param_getf_exit(ppl,"sd");
  maxlum   = param_getf_exit(ppl,"maxlum");
  contrast = param_getf_exit(ppl,"contrast");
  seed     =   paramfile_get_int_param_or_exit(ppl,"seed");
  data = f3tensor(1,xn,1,yn,1,zn); 
  if (seed > 0)
    seed = -seed;
  amp = 1.0;
  for(i=1;i<=zn;i++){
    make_frame_edge_01(data,1,xn,1,yn,1,zn,i,amp,sd,&seed);
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data,1,xn,1,yn,1,zn,contrast*mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  data[1][1][1] = -1.0;
  data[1][1][2] =  1.0;
  return data;
}
float ***get_stim_3d_ppl_disk(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i;
  float ***data,t,t0,tn,size,ampl,bgval;
  size     = param_getf_exit(ppl,"size");
  ampl     = param_getf_exit(ppl,"ampl");
  bgval   = param_getf_exit(ppl,"bgval");
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  data = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if ((((i-1)%tsamp) == 0) && (t >= t0) && (t < t0+tn)){
      make_frame_disk_flat(data,1,xn,1,yn,1,zn,i,size,sscale,ampl,bgval);
    }else
      make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
  }
  return data;
}
float ***get_stim_3d_ppl_sine(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i;
  int i0,binflag,aptype,spot_type,phjit_seed,*iseq,meanzero,cntrph,phorg;
  int customi;
  float ***data,ph,mid,sf,tf,phase,theta,contrast,maxlum,t0,tn,t,bgamp,size;
  float t0_2,tn_2,ph_off,phase2,tf2,sf2,theta2,size2,cx2,cy2,xc2,yc2;
  float binthr,sz,bgval,blankval,phase_t,pht,a,tfx,tfy;
  float phjit_sd,phjit_tsd,jsd,jsdt,*phj,blnk;
  float ff,ffrac,phtau,cx,cy,xc,yc;
  char *phjit;
  cx       = param_getf_dflt(ppl,"cx",0.0);
  cy       = param_getf_dflt(ppl,"cy",0.0);
  maxlum   = param_getf_exit(ppl,"maxlum");
  sf       = param_getf_exit(ppl,"sf");
  if (paramfile_test_param(ppl,"tfx")){
    tfx    = param_getf_exit(ppl,"tfx");
    tfy    = param_getf_exit(ppl,"tfy");
    tf     = sqrt(tfx*tfx + tfy*tfy);
    theta  = 180.0 * atan2(tfy,tfx)/M_PI;
    while(theta < 0.0)
      theta += 360.0;
    while(theta >= 360.0)
      theta -= 360.0;
  }else{
    theta    = param_getf_exit(ppl,"direction");
    tf       = param_getf_exit(ppl,"tf");
  }
  contrast = param_getf_exit(ppl,"contrast");
  phase    = param_getf_exit(ppl,"phase");
  phorg    = param_geti_dflt(ppl,"phase_origin",0);
  cntrph   = param_geti_dflt(ppl,"counterphase",0);
  phase_t  = param_getf_dflt(ppl,"t_phase",0.0);
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  bgval    = param_getf_exit(ppl,"bgval");
  size     = param_getf_exit(ppl,"size");
  aptype   = param_geti_exit(ppl,"aptype");
  phtau    = param_getf_dflt(ppl,"stim_phtau",0.006);
  binflag  = paramfile_test_param(ppl,"square_thresh");
  binthr   = param_getf_dflt(ppl,"square_thresh",0.0);
  meanzero = param_geti_dflt(ppl,"stim_mean_zero",0);
  blankval = param_getf_dflt(ppl,"stim_blank_val",0.0);
  customi  = param_geti_dflt(ppl,"custom",0);  
  tn_2     = param_getf_dflt(ppl,"stn_2",-1.0);
  if (tn_2 > 0.0){  
    t0_2   = param_getf_exit(ppl,"st0_2");
    sf2    = param_getf_dflt(ppl,"sf2",sf);
    tf2    = param_getf_dflt(ppl,"tf2",tf);
    theta2 = param_getf_dflt(ppl,"theta2",theta);
    size2  = param_getf_dflt(ppl,"size2",size);
    cx2    = param_getf_dflt(ppl,"cx2",cx);
    cy2    = param_getf_dflt(ppl,"cy2",cy);
    if (paramfile_test_param(ppl,"phase_offset")){
      ph_off = param_getf_exit(ppl,"phase_offset");
      phase2 = phase + ph_off;
    }else{
      phase2 = param_getf_dflt(ppl,"phase2",phase);
    }
  }else{
    t0_2 = -1.0;
  }
  if (blankval < 0.0)
    exit_error("*** WYETH ****  Blankval no longers goes neg, use [0..1]\n");
  blnk = 2.0*blankval - 1.0;
  phjit = paramfile_get_char_param_default(ppl,"phase_jit",NULL);
  if (phjit == NULL){
    phjit_sd = 0; 
  }else if (strcmp(phjit,"gfgwn")==0){
    phjit_sd = paramfile_get_float_param_default(ppl,"phase_jit_sd",0.0);
    phjit_tsd = param_getf_exit(ppl,"phase_jit_tsd");
    phjit_seed = paramfile_get_int_param_or_exit(ppl,"phase_jit_seed");
    jsd  = phjit_sd * sf * 360.0;  
    jsdt = phjit_tsd / tscale;     
    phj = gaussian_corr_noise(jsdt,0.0,jsd,zn,phjit_seed);
  }else if (strcmp(phjit,"rwalk")==0){
    phjit_sd = paramfile_get_float_param_default(ppl,"phase_jit_step",0.0);
    phjit_seed = paramfile_get_int_param_or_exit(ppl,"phase_jit_seed");
    iseq = myrand_get_std_bin_seq(zn,phjit_seed);  
    phj = (float *)myalloc(zn*sizeof(float));
    phj[0] = 0.0;
    jsd  = phjit_sd * sf * 360.0;  
    for(i=1;i<zn;i++){
      if (iseq[i] == 1)
	phj[i] = phj[i-1] + jsd;
      else
	phj[i] = phj[i-1] - jsd;
    }
    myfree(iseq);
  }
  if (phjit != NULL)
    myfree(phjit);
  sz = size/sscale;
  xc = (float)(xn-1)/2.0 + cx/sscale;  
  yc = (float)(yn-1)/2.0 + cy/sscale;  
  if (tn_2 > 0.0){
    xc2 = (float)(xn-1)/2.0 + cx2/sscale;  
    yc2 = (float)(yn-1)/2.0 + cy2/sscale;  
  }
  if (phtau > 0.0)
    ffrac = exp(-tscale/phtau);
  else
    ffrac = 0.0;
  ff = ffrac;   
  data = f3tensor(1,xn,1,yn,1,zn); 
  bgamp = bgval * 2.0 - 1.0; 
  i0 = 1 + my_rint(t0 / tscale);
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if (((i-1)%tsamp) == 0){
      if ((t >= t0) && (t < t0+tn)){
	if (cntrph == 0){
	  ph = phase + (float)(i-i0)*tscale*tf * 360.0;
	  a = 1.0;  
	}else{
	  pht = phase_t/360.0 + (float)(i-i0)*tscale*tf;  
	  a = sin(2.0*M_PI*pht); 
	  ph = phase;
	}
	if (customi == 1){ 
	  theta += 0.35;  
	  printf("  (stim_util) theta = %f\n",theta);
	}else if (customi == 2){ 
	  sf = 0.3 + 5.7 * (float)i/(float)zn;
	  printf("  (stim_util) sf = %f\n",sf);
	}else if (customi == 3){ 
	  xc =  20.0 + 80.0 * (float)i/(float)zn;
	  printf("  (stim_util) xc = %f\n",xc);
	}
	if (phjit_sd > 0.0){
	  ph += phj[i-i0];
	}
	make_frame_sinusoid_scale(data,1,xn,1,yn,1,zn,i,sf,theta,sscale,ph,
				  cx,cy,a*contrast,phorg);
	if (binflag){
	  make_frame_binarize(data,1,xn,1,yn,1,zn,i,binthr,contrast,-contrast);
	}
	if (aptype == 3){
	  multiply_frame_gaussian(data,1,1,1,xn,yn,zn,i,xc,yc,size,sscale);
	}
      }else if ((t >= t0_2) && (t < t0_2+tn_2)){
	ph = phase2 + (float)(i-i0)*tscale*tf2 * 360.0;
	make_frame_sinusoid_scale(data,1,xn,1,yn,1,zn,i,sf2,theta2,sscale,ph,
				  cx2,cy2,contrast,phorg);
	if (binflag){
	  make_frame_binarize(data,1,xn,1,yn,1,zn,i,binthr,contrast,-contrast);
	}
	if (aptype == 3){
	  multiply_frame_gaussian(data,1,1,1,xn,yn,zn,i,xc2,yc2,size2,sscale);
	}
      }else
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgamp);
      ff = ffrac; 
    }else{
      if ((ff > 0.0)&&(i>1)){ 
	make_frame_scale_frame_zmid(data,1,xn,1,yn,1,zn,i,i-1,ff,blnk);
      }else
	make_frame_flat(data,1,xn,1,yn,1,zn,i,blnk); 
      ff *= ffrac; 
    }
    if (aptype != 3){
      frame_apply_aperture(data,1,xn,1,yn,1,zn,i,aptype,xc,yc,sz,sz,theta,
			   bgamp);
    }
  }
  if (meanzero == 0){
    mid = (float)maxlum/2.0;
    multiply_3d_farray(data,1,xn,1,yn,1,zn,mid);
    add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  }else{
    if (maxlum != 1.0)
      multiply_3d_farray(data,1,xn,1,yn,1,zn,maxlum);
  }
  spot_type = paramfile_get_int_param_default(ppl,"spot_type",0);
  if (spot_type > 0){
    stim_util_add_modspot(ppl,data,1,xn,1,yn,1,zn,tsamp,tscale,sscale);
  }
  if (phjit_sd > 0.0){
    myfree(phj);
  }
  return data;
}
void get_stim_3db_ppl_sine(ppl,xn,yn,zn,sscale,tscale,tsamp,rdl,rdr)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
     float ****rdl,****rdr;
{
  int i;
  int i0,binflag,aptype,res,make_right,make_left,meanzero;
  float ***dl,***dr,mid,maxlum,t0,tn,t,bgamp,size;
  float phase_l,phase_r,phl,phr,cxl,cxr,cyl,cyr;
  float xcl,xcr,ycl,ycr,thetal,thetar,sfl,sfr,tfl,tfr,conl,conr;
  float binthr,sz,bgval,ff,ffrac,phtau,cx,cy,xc,yc;
  char *monoflag;
  param_getf_lrd("GET_STIM_3DB_PPL_SINE",ppl,"cx",&cxl,&cxr);
  param_getf_lrd("GET_STIM_3DB_PPL_SINE",ppl,"cy",&cyl,&cyr);
  param_getf_lrd("GET_STIM_3DB_PPL_SINE",ppl,"phase",&phase_l,&phase_r);
  param_getf_lrd("GET_STIM_3DB_PPL_SINE",ppl,"direction",&thetal,&thetar);
  param_getf_lrd("GET_STIM_3DB_PPL_SINE",ppl,"sf",&sfl,&sfr);
  param_getf_lrd("GET_STIM_3DB_PPL_SINE",ppl,"tf",&tfl,&tfr);
  param_getf_lrd("GET_STIM_3DB_PPL_SINE",ppl,"contrast",&conl,&conr);
  maxlum   = param_getf_exit(ppl,"maxlum");
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  bgval    = param_getf_exit(ppl,"bgval");
  size     = param_getf_exit(ppl,"size");
  aptype   = param_geti_exit(ppl,"aptype");
  phtau    = param_getf_dflt(ppl,"stim_phtau",0.006);
  monoflag = param_getc_dflt(ppl,"stim_monocular","both"); 
  meanzero = param_geti_dflt(ppl,"stim_mean_zero",0);
  binflag  = paramfile_test_param(ppl,"square_thresh");
  binthr   = paramfile_get_float_param_default(ppl,"square_thresh",0.0);
  make_left = make_right = 1;
  if (strcmp(monoflag,"left")==0)
    make_right = 0;
  else if (strcmp(monoflag,"right")==0)
    make_left = 0;
  sz = size/sscale;
  xcl = (float)(xn-1)/2.0 + cxl/sscale;  
  ycl = (float)(yn-1)/2.0 + cyl/sscale;  
  xcr = (float)(xn-1)/2.0 + cxr/sscale;
  ycr = (float)(yn-1)/2.0 + cyr/sscale;
  if (phtau > 0.0)
    ffrac = exp(-tscale/phtau);
  else
    ffrac = 0.0;
  ff = ffrac;   
  dl = f3tensor(1,xn,1,yn,1,zn); 
  dr = f3tensor(1,xn,1,yn,1,zn); 
  bgamp = bgval * 2.0 - 1.0; 
  i0 = 1 + my_rint(t0 / tscale);
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if (((i-1)%tsamp) == 0){
      if ((t >= t0) && (t < t0+tn)){
	phl = phase_l + (float)(i-i0)*tscale*tfl * 360.0;
	phr = phase_r + (float)(i-i0)*tscale*tfr * 360.0;
	if (make_left == 1)
	  make_frame_sinusoid(dl,1,xn,1,yn,1,zn,i,sfl,thetal,sscale,phl,
			      cxl,cyl);
	else
	  make_frame_flat(dl,1,xn,1,yn,1,zn,i,bgamp);
	if (make_right == 1)
	  make_frame_sinusoid(dr,1,xn,1,yn,1,zn,i,sfr,thetar,sscale,phr,
			      cxr,cyr);
	else
	  make_frame_flat(dr,1,xn,1,yn,1,zn,i,bgamp);
	if (binflag){
	  if (make_left == 1)
	    make_frame_binarize(dl,1,xn,1,yn,1,zn,i,binthr,1.0,-1.0);
	  if (make_right == 1)
	    make_frame_binarize(dr,1,xn,1,yn,1,zn,i,binthr,1.0,-1.0);
	}
	if (aptype == 3){
	  if (make_left == 1)
	    multiply_frame_gaussian(dl,1,1,1,xn,yn,zn,i,xcl,ycl,size,sscale);
	  if (make_right == 1)
	    multiply_frame_gaussian(dr,1,1,1,xn,yn,zn,i,xcr,ycr,size,sscale);
	}
      }else{
	make_frame_flat(dl,1,xn,1,yn,1,zn,i,bgamp);
	make_frame_flat(dr,1,xn,1,yn,1,zn,i,bgamp);
      }
      ff = ffrac; 
    }else{
      if ((ff > 0.0)&&(i>1)){ 
	make_frame_scale_frame_zmid(dl,1,xn,1,yn,1,zn,i,i-1,ff,-1.0);
	make_frame_scale_frame_zmid(dr,1,xn,1,yn,1,zn,i,i-1,ff,-1.0);
      }else{
	make_frame_flat(dl,1,xn,1,yn,1,zn,i,-1.0); 
	make_frame_flat(dr,1,xn,1,yn,1,zn,i,-1.0); 
      }
      ff *= ffrac; 
    }
    if (aptype != 3){
      if (make_left == 1)
	frame_apply_aperture(dl,1,xn,1,yn,1,zn,i,aptype,xcl,ycl,sz,sz,0.0,
			     bgamp);
      if (make_right == 1)
	frame_apply_aperture(dr,1,xn,1,yn,1,zn,i,aptype,xcr,ycr,sz,sz,0.0,
			     bgamp);
    }
  }
  if (meanzero == 0){
    mid = (float)maxlum/2.0;
    multiply_3d_farray(dl,1,xn,1,yn,1,zn,conl*mid);
    multiply_3d_farray(dr,1,xn,1,yn,1,zn,conr*mid);
    add_const_3d_farray(dl,1,xn,1,yn,1,zn,mid);
    add_const_3d_farray(dr,1,xn,1,yn,1,zn,mid);
  }else{
    if (conl*maxlum != 1.0)
      multiply_3d_farray(dl,1,xn,1,yn,1,zn,conl*maxlum);
    if (conr*maxlum != 1.0)
      multiply_3d_farray(dr,1,xn,1,yn,1,zn,conr*maxlum);
  }
  *rdl = dl;
  *rdr = dr;
}
void get_stim_3db_ppl_randot_stereogram(ppl,xn,yn,zn,sscale,tscale,tsamp,
					rdl,rdr)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
     float ****rdl,****rdr;
{
  int i,j,k;
  float ***dl,***dr,t,t0,tn,bgval,**tframl,**tframr;
  stimx_dots_stereogram(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL,NULL);
  t0        = param_getf_exit(ppl,"st0");
  tn        = param_getf_exit(ppl,"stn");
  bgval     = param_getf_exit(ppl,"bgval");
  dl = f3tensor(1,xn,1,yn,1,zn); 
  dr = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    if (((i-1)%tsamp) == 0){
      stimx_dots_stereogram(ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,
			    &tframl,&tframr);
      for(j=0;j<xn;j++){
	for(k=0;k<yn;k++){
	  dl[j+1][k+1][i] = tframl[j][k];
	  dr[j+1][k+1][i] = tframr[j][k];
	}
      }
      free_2d_farray(tframl,xn);
      free_2d_farray(tframr,xn);
    }else{
      make_frame_flat(dl,1,xn,1,yn,1,zn,i,bgval);
      make_frame_flat(dr,1,xn,1,yn,1,zn,i,bgval);
    }
  }
  stimx_dots_stereogram(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL,NULL);
  *rdl = dl;
  *rdr = dr;
}
void stim_util_check_set_nseq(rnseq,n)
     int *rnseq,n;
{
  if (*rnseq > 0){
    if (n > 0){
      if (n != *rnseq)
	exit_error("STIM_UTIL_CHECK_SET_NSEQ","conflicting number of values");
    }
  }else{
    if (n > 0){
      *rnseq = n;
    }
  }
}
float ***get_stim_3d_ppl_sine_seq(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i;
  int i0,si,binflag,aptype,dt,cnt,seqdone;
  float ***data,ph,mid,sf,tf,phase,theta,contrast,maxlum,t0,tn,t,bgamp,size;
  float binthr,sz,bgval,dir0;
  float ff,ffrac,phtau,cx,cy,xc,yc;
  int  nseq,seq_dir,seq_ph,seq_sf,seq_tf,seq_con,seq_sz;
  cx       = paramfile_get_float_param_default(ppl,"cx",0.0);
  cy       = paramfile_get_float_param_default(ppl,"cy",0.0);
  maxlum   = param_getf_exit(ppl,"maxlum");
  dir0     = param_getf_exit(ppl,"direction");
  sf       = param_getf_exit(ppl,"sf");
  tf       = param_getf_exit(ppl,"tf");
  contrast = param_getf_exit(ppl,"contrast");
  phase    = param_getf_exit(ppl,"phase");
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  dt       =   paramfile_get_int_param_or_exit(ppl,"dt");
  bgval    = param_getf_exit(ppl,"bgval");
  size     = param_getf_exit(ppl,"size");
  aptype   = paramfile_get_int_param_or_exit(ppl,"aptype");
  phtau    = paramfile_get_float_param_default(ppl,"stim_phtau",0.006);
  binflag  = paramfile_test_param(ppl,"square_thresh");
  binthr   = paramfile_get_float_param_default(ppl,"square_thresh",0.0);
  seq_dir = paramfile_count_values_param(ppl,"seq_dir"); 
  seq_ph  = paramfile_count_values_param(ppl,"seq_ph");  
  seq_sf  = paramfile_count_values_param(ppl,"seq_sf");  
  seq_tf  = paramfile_count_values_param(ppl,"seq_tf");  
  seq_con = paramfile_count_values_param(ppl,"seq_con"); 
  seq_sz  = paramfile_count_values_param(ppl,"seq_sz");  
  nseq = 0;
  stim_util_check_set_nseq(&nseq,seq_dir);
  stim_util_check_set_nseq(&nseq,seq_ph);
  stim_util_check_set_nseq(&nseq,seq_sf);
  stim_util_check_set_nseq(&nseq,seq_tf);
  stim_util_check_set_nseq(&nseq,seq_con);
  stim_util_check_set_nseq(&nseq,seq_sz);
  if (nseq <= 0)
    exit_error("GET_STIM_3D_PPL_SIN_SEQ","No sequence values");
  sz = size/sscale;
  xc = (float)(xn-1)/2.0 + cx/sscale;  
  yc = (float)(yn-1)/2.0 + cy/sscale;  
  ffrac = exp(-tscale/phtau);
  ff = ffrac;   
  data = f3tensor(1,xn,1,yn,1,zn); 
  bgamp = bgval * 2.0 - 1.0; 
  mid = (float)maxlum/2.0;
  i0 = 1 + my_rint(t0 / tscale);
  si = 0; 
  seqdone = 0;
  cnt = dt;
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if (((i-1)%tsamp) == 0){
      if ((t >= t0) && (t < t0+tn) && (!seqdone)){
	if (cnt == dt){ 
	  if (seq_dir > 0){
	    theta = paramfile_get_nth_float_param_or_exit(ppl,"seq_dir",si);
	    theta += dir0;
	  }
	  if (seq_ph > 0)
	    phase = paramfile_get_nth_float_param_or_exit(ppl,"seq_ph",si);
	  if (seq_sf > 0)
	    sf = paramfile_get_nth_float_param_or_exit(ppl,"seq_sf",si);
	  if (seq_tf > 0)
	    tf = paramfile_get_nth_float_param_or_exit(ppl,"seq_tf",si);
	  if (seq_con > 0)
	    contrast = paramfile_get_nth_float_param_or_exit(ppl,"seq_con",si);
	  if (seq_sz > 0){
	    size = paramfile_get_nth_float_param_or_exit(ppl,"seq_sz",si);
	    sz = size/sscale;
	  }
	  si += 1;
	  cnt = 0;
	}
	ph = phase + (float)(i-i0)*tscale*tf * 360.0;
	make_frame_sinusoid(data,1,xn,1,yn,1,zn,i,sf,theta,sscale,ph,cx,cy);
	if (binflag){
	  make_frame_binarize(data,1,xn,1,yn,1,zn,i,binthr,1.0,-1.0);
	}
	if (aptype == 3){
	  multiply_frame_gaussian(data,1,1,1,xn,yn,zn,i,0.0,0.0,size,sscale);
	}
	cnt += 1;
	if ((si >= nseq) && (cnt >= dt))
	  seqdone = 1;  
      }else
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgamp);
      ff = ffrac; 
    }else{
      if ((ff > 0.0)&&(i>1)){ 
	make_frame_scale_frame_zmid(data,1,xn,1,yn,1,zn,i,i-1,ff,-1.0);
      }else
	make_frame_flat(data,1,xn,1,yn,1,zn,i,-1.0); 
      ff *= ffrac; 
    }
    if (aptype != 3)
      frame_apply_aperture(data,1,xn,1,yn,1,zn,i,aptype,xc,yc,sz,sz,0.0,bgamp);
    multiply_frame(data,1,xn,1,yn,1,zn,i,contrast*mid);
  }
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  return data;
}
float ***get_stim_3d_ppl_sos(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i;
  int i0,aptype,vskn,pcomp;
  float ***data,mid,theta,sf,phase,contrast,maxlum,t0,tn,t,bgampl,size;
  float sz,pratio,f,toff,bgval,*fot,cx,cy,xc,yc;
  cx       = paramfile_get_float_param_default(ppl,"cx",0.0);
  cy       = paramfile_get_float_param_default(ppl,"cy",0.0);
  maxlum   = param_getf_exit(ppl,"maxlum");
  theta    = param_getf_exit(ppl,"orientation");
  sf       = param_getf_exit(ppl,"sf");
  contrast = param_getf_exit(ppl,"contrast");
  phase    = param_getf_exit(ppl,"phase");
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  bgval    = param_getf_exit(ppl,"bgval");
  size     = param_getf_exit(ppl,"size");
  aptype   =   paramfile_get_int_param_or_exit(ppl,"aptype");
  vskn     =   paramfile_get_int_param_or_exit(ppl,"vskn");
  pcomp    =   paramfile_get_int_param_or_exit(ppl,"pcomp",-1);
  pratio   = param_getf_exit(ppl,"pratio",1.0);
  toff     = param_getf_exit(ppl,"toff");
  data = f3tensor(1,xn,1,yn,1,zn); 
  xc = (float)(xn-1)/2.0 + cx/sscale;  
  yc = (float)(yn-1)/2.0 + cy/sscale;  
  bgampl = bgval * 2.0 - 1.0; 
  i0 = 1 + my_rint(t0 / tscale);
  fot = (float *)myalloc(zn*sizeof(float));
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if (((i-1)%tsamp) == 0){
      if ((t >= t0) && (t < t0+tn)){
	make_frame_sinusoid(data,1,xn,1,yn,1,zn,i,sf,theta,sscale,phase,cx,cy);
	f = get_vsk_sum_of_sinusoids(vskn,pcomp,pratio,(t-t0+toff));
	fot[i] = f;
	multiply_frame(data,1,xn,1,yn,1,zn,i,f);
	if (aptype == 3)
	  multiply_frame_gaussian(data,1,1,1,xn,yn,zn,i,0.0,0.0,size,sscale);
      }else
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgampl);
    }else
      make_frame_flat(data,1,xn,1,yn,1,zn,i,-1.0);
    sz = size/sscale;
    if (aptype != 3)
      frame_apply_aperture(data,1,xn,1,yn,1,zn,i,aptype,xc,yc,
			   sz,sz,0.0,bgampl);
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data,1,xn,1,yn,1,zn,contrast*mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  printf("APPENDING time-varying modulation to 'zz.VSK.pl'\n");
  append_farray_plot("zz.VSK.pl","VSKt",fot,zn,1);
  return data;
}
float ***get_stim_3d_ppl_cpsine(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i;
  int i0;
  float ***data,ph,con,mid;
  float sf,tf,phase,theta,contrast,maxlum,tphase,t0,tn,t,cx,cy;
  cx       = paramfile_get_float_param_default(ppl,"cx",0.0);
  cy       = paramfile_get_float_param_default(ppl,"cy",0.0);
  maxlum   = param_getf_exit(ppl,"maxlum");
  theta    = param_getf_exit(ppl,"orientation");
  sf       = param_getf_exit(ppl,"sf");
  tf       = param_getf_exit(ppl,"tf");
  contrast = param_getf_exit(ppl,"contrast");
  phase    = param_getf_exit(ppl,"phase");
  tphase   = param_getf_exit(ppl,"tphase");
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  data = f3tensor(1,xn,1,yn,1,zn); 
  i0 = 1 + my_rint(t0 / tscale);
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if ((((i-1)%tsamp) == 0) && (t >= t0) && (t < t0+tn)){
      make_frame_sinusoid(data,1,xn,1,yn,1,zn,i,sf,theta,sscale,phase,cx,cy);
      ph = tphase + (float)(i-i0)*tscale*tf * 360.0;
      con = cos(ph*M_PI/180.0);
      multiply_frame(data,1,xn,1,yn,1,zn,i,con);
    }else
      make_frame_flat(data,1,xn,1,yn,1,zn,i,-1.0);
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data,1,xn,1,yn,1,zn,contrast*mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  return data;
}
float ***get_stim_3d_ppl_plaid(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp)
     char *mylogf;
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;  
     int tsamp;
{
  int i,j,k;
  float ***data,t,maxlum,t0,tn,t0_2,tn_2,bgamp,bgval,**tframe,blackval;
  stimx_plaid(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL,NULL);
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  t0_2     = paramfile_get_float_param_default(ppl,"st0_2",t0);
  tn_2     = paramfile_get_float_param_default(ppl,"stn_2",tn);
  maxlum   = param_getf_exit(ppl,"maxlum");
  bgval    = param_getf_exit(ppl,"bgval");
  blackval = 2.0*bgval - maxlum;
  data = f3tensor(1,xn,1,yn,1,zn);
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;  
    if (((i-1)%tsamp) == 0){  
      if (((t >= t0)   && (t < t0+tn)) ||
	  ((t >= t0_2) && (t < t0_2+tn_2))){
	stimx_plaid(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframe,
		    NULL);
	for(j=0;j<xn;j++){
	  for(k=0;k<yn;k++){
	    data[j+1][k+1][i] = tframe[j][k];
	  }
	}
	free_2d_farray(tframe,xn);
      }else{
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
      }
    }else{
      make_frame_flat(data,1,xn,1,yn,1,zn,i,blackval);  
    }
  }
  stimx_plaid(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL,NULL);
  return data;
}
void get_stim_3db_ppl_plaid(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,rdl,rdr)
     char *mylogf;
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;  
     int tsamp;
     float ****rdl,****rdr;
{
  int i,j,k;
  int dicho,make_left,make_right;
  float **tframl,**tframr;
  float ***dl,***dr,t,maxlum,t0,tn,t0_2,tn_2,bgamp,bgval,blackval;
  stimx_plaid(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL,NULL);
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  t0_2     = param_getf_dflt(ppl,"st0_2",t0);
  tn_2     = param_getf_dflt(ppl,"stn_2",tn);
  maxlum   = param_getf_exit(ppl,"maxlum");
  dicho    = param_geti_exit(ppl,"dichoptic");
  bgval    = param_getf_exit(ppl,"bgval");
  blackval = 2.0*bgval - maxlum;
  make_left = make_right = 0;
  if ((dicho == 0) || (dicho == 3))
    make_left = 1;
  if ((dicho == 1) || (dicho == 3))
    make_right = 1;
  dl = f3tensor(1,xn,1,yn,1,zn);
  dr = f3tensor(1,xn,1,yn,1,zn);
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;  
    if (((i-1)%tsamp) == 0){  
      if (((t >= t0)   && (t < t0+tn)) ||
	  ((t >= t0_2) && (t < t0_2+tn_2))){
	stimx_plaid(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframl,
		    &tframr);
	if (dicho == 0){
	  for(j=0;j<xn;j++){
	    for(k=0;k<yn;k++){
	      dl[j+1][k+1][i] = tframl[j][k];  
	      dr[j+1][k+1][i] = bgval;
	    }
	  }
	}else if (dicho == 1){
	  for(j=0;j<xn;j++){
	    for(k=0;k<yn;k++){
	      dl[j+1][k+1][i] = bgval;
	      dr[j+1][k+1][i] = tframl[j][k];  
	    }
	  }
	}else if (dicho == 2){
	  for(j=0;j<xn;j++){
	    for(k=0;k<yn;k++){
	      dl[j+1][k+1][i] = tframl[j][k];  
	      dr[j+1][k+1][i] = tframr[j][k];
	    }
	  }
	  free_2d_farray(tframr,xn);
	}else if (dicho == 3){
	  for(j=0;j<xn;j++){
	    for(k=0;k<yn;k++){
	      dl[j+1][k+1][i] = tframl[j][k];  
	      dr[j+1][k+1][i] = tframl[j][k];  
	    }
	  }
	}
	free_2d_farray(tframl,xn);
      }else{
	make_frame_flat(dl,1,xn,1,yn,1,zn,i,bgval);
	make_frame_flat(dr,1,xn,1,yn,1,zn,i,bgval);
      }
    }else{
      make_frame_flat(dl,1,xn,1,yn,1,zn,i,blackval);  
      make_frame_flat(dr,1,xn,1,yn,1,zn,i,blackval);  
    }
  }
  stimx_plaid(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL,NULL);
  *rdl = dl;
  *rdr = dr;
}
float ***get_stim_3d_ppl_dmmask(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i;
  int seed1,seed2,distrib,ord,dt,seqn,cnt,si,aptype,overcount,nstim,dirflag;
  float ***data1,***data2,***data,ph1,ph2,mid,sz;
  float sf1,sf2,etf1p,etf1a,etf2p,etf2a,phase1,phase2,theta1,theta2,con1,con2;
  float size1,size2,maxlum,t0,tn,t,bgval,bgamp,cx,cy,xc,yc;
  float v1a,v1p,v2a,v2p,*seq1,*seq2,fps;
  nstim = 1;  
  cx       = param_getf_dflt(ppl,"cx",0.0);
  cy       = param_getf_dflt(ppl,"cy",0.0);
  if (param_test(ppl,"sf2")){  
    printf("  *** OLD WAY - Please convert to new param names:\n");
    printf("  sf2    -->  s2_sf\n");
    printf("  etf1a  -->  s1_etfa\n");
    printf("         ...\n");
    etf1p    = param_getf_exit(ppl,"etf1p");
    etf1a    = param_getf_exit(ppl,"etf1a");
    etf2p    = param_getf_exit(ppl,"etf2p");
    etf2a    = param_getf_exit(ppl,"etf2a");
    sf1      = param_getf_exit(ppl,"sf");
    sf2      = param_getf_exit(ppl,"sf2");
    phase1   = param_getf_exit(ppl,"phase");
    phase2   = param_getf_dflt(ppl,"phase2",0.0);
    theta1   = param_getf_exit(ppl,"direction");
    con1     = param_getf_exit(ppl,"contrast");
    con2     = param_getf_exit(ppl,"contrast2");
    size1    = param_getf_exit(ppl,"size");
    size2    = param_getf_dflt(ppl,"size2",size1);
    seed1    = param_geti_exit(ppl,"seed1");
    seed2    = param_geti_exit(ppl,"seed2");
    nstim = 2;
  }else{
    if (param_test(ppl,"etf")){
      etf1p  = param_getf_exit(ppl,"etf");
      etf1a  = etf1p;
      etf2p  = etf1p;
      etf2a  = etf1a;
    }else if (param_test(ppl,"s1_etf")){
      param_getf_s2_exit(ppl,"etf",&etf1p,&etf2p,&nstim);
      etf1a = etf1p;
      etf2a = etf2p;
    }else{
      param_getf_s2_exit(ppl,"etfp",&etf1p,&etf2p,&nstim);
      param_getf_s2_exit(ppl,"etfa",&etf1a,&etf2a,&nstim);
    }
    param_getf_s2_exit(ppl,"sf",&sf1,&sf2,&nstim);
    param_getf_s2_exit(ppl,"phase",&phase1,&phase2,&nstim);
    dirflag = 1;  
    param_getf_s2_exit(ppl,"direction",&theta1,&theta2,&dirflag);
    param_getf_s2_exit(ppl,"contrast",&con1,&con2,&nstim);
    param_getf_s2_exit(ppl,"size",&size1,&size2,&nstim);
    param_geti_s2_exit(ppl,"seed",&seed1,&seed2,&nstim);
  }
  maxlum   = param_getf_dflt(ppl,"maxlum",1.0);
  aptype   = param_geti_exit(ppl,"aptype");
  bgval    = param_getf_exit(ppl,"bgval");
  bgamp = bgval * 2.0 - 1.0; 
  if (dirflag == 1)  
    theta2 = theta1 + 90.0;
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  distrib  = param_geti_exit(ppl,"distrib");
  dt       = param_geti_exit(ppl,"dt");
  if (distrib == 7){
    ord = param_geti_exit(ppl,"mseq_ord");
  }else
    ord = -1;
  fps = 1.0/(tsamp*tscale); 
  v1p =  etf1p/fps * 360.0;  
  v1a = -etf1a/fps * 360.0;
  v2p =  etf2p/fps * 360.0;
  v2a = -etf2a/fps * 360.0;
  stm_get_ran_seq(NULL,distrib,ord,seed1,fps,tn,dt,v1p,v1a,0.0,&seq1,&seqn);
  if (nstim == 2)
    stm_get_ran_seq(NULL,distrib,ord,seed2,fps,tn,dt,v2p,v2a,0.0,&seq2,&seqn);
  data1 = f3tensor(1,xn,1,yn,1,zn);
  if (nstim == 2)
    data2 = f3tensor(1,xn,1,yn,1,zn);
  xc = (float)(xn-1)/2.0 + cx/sscale;  
  yc = (float)(yn-1)/2.0 + cy/sscale;  
  ph1 = phase1;
  ph2 = phase2;
  cnt = 0;       
  si = 0;   
  overcount = 0;
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if (((i-1)%tsamp) == 0){
      if ((t >= t0) && (t < t0+tn) && (si < seqn)){
	ph1 += seq1[si];
	make_frame_sinusoid(data1,1,xn,1,yn,1,zn,i,sf1,theta1,sscale,ph1,
			    cx,cy);
	if (nstim == 2){
	  ph2 += seq2[si];
	  make_frame_sinusoid(data2,1,xn,1,yn,1,zn,i,sf2,theta2,sscale,ph2,
			      cx,cy);
	}
	cnt += 1;
	if (cnt == dt){
	  si += 1;  
	  cnt = 0;
	}
      }else{
	make_frame_flat(data1,1,xn,1,yn,1,zn,i,bgamp);
	if (nstim == 2)
	  make_frame_flat(data2,1,xn,1,yn,1,zn,i,bgamp);
	if (si >= seqn)
	  overcount += 1;
      }
    }else{
      make_frame_flat(data1,1,xn,1,yn,1,zn,i,-1.0);
      if (nstim == 2)
	make_frame_flat(data2,1,xn,1,yn,1,zn,i,-1.0);
    }
    sz = size1/sscale;
    frame_apply_aperture(data1,1,xn,1,yn,1,zn,i,aptype,xc,yc,sz,sz,0.0,bgamp);
    if (nstim == 2){
      sz = size2/sscale;
      frame_apply_aperture(data2,1,xn,1,yn,1,zn,i,aptype,xc,yc,sz,sz,0.0,bgamp);
    }
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data1,1,xn,1,yn,1,zn,con1*mid);
  if (nstim == 2){
    multiply_3d_farray(data2,1,xn,1,yn,1,zn,con2*mid);
    data = add_3d_tensors(data1,data2,xn,yn,zn);
    stim_util_limit_3d(data,1,xn,1,yn,1,zn,-mid,mid);
  }
  if (nstim == 1)
    data = data1;
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  if (nstim == 2){
    free_f3tensor(data1,1,xn,1,yn,1,zn);
    free_f3tensor(data2,1,xn,1,yn,1,zn);
  }
  return data;
}
float ***get_stim_3d_ppl_dirmod(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i,j,k;
  float ***data,t,t0,tn,bgval,**tframe;
  stimx_dirmod(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL,NULL);
  t0    = param_getf_exit(ppl,"st0");
  tn    = param_getf_exit(ppl,"stn");
  bgval = param_getf_exit(ppl,"bgval");
  data = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if (((i-1)%tsamp) == 0){
      if ((t >= t0) && (t < t0+tn)){
	stimx_dirmod(ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframe,NULL);
	for(j=0;j<xn;j++){
	  for(k=0;k<yn;k++){
	    data[j+1][k+1][i] = tframe[j][k];
	  }
	}
	free_2d_farray(tframe,xn);
      }else{
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
      }
    }else{
      make_frame_flat(data,1,xn,1,yn,1,zn,i,0.0);  
    }
  }
  stimx_dirmod(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL,NULL);  
  return data;
}
void get_stim_3db_ppl_dirmod(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,rdl,rdr)
     char *mylogf;
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
     float ****rdl,****rdr;
{
  int i,j,k;
  float ***dl,***dr,t,t0,tn,bgval,**tframl,**tframr;
  stimx_dirmod(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL,NULL);
  t0    = param_getf_exit(ppl,"st0");
  tn    = param_getf_exit(ppl,"stn");
  bgval = param_getf_exit(ppl,"bgval");
  dl = f3tensor(1,xn,1,yn,1,zn); 
  dr = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if (((i-1)%tsamp) == 0){
      if ((t >= t0) && (t < t0+tn)){
	stimx_dirmod(ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframl,&tframr);
	for(j=0;j<xn;j++){
	  for(k=0;k<yn;k++){
	    dl[j+1][k+1][i] = tframl[j][k];
	    dr[j+1][k+1][i] = tframr[j][k];
	  }
	}
	free_2d_farray(tframl,xn);
	free_2d_farray(tframr,xn);
      }else{
	make_frame_flat(dl,1,xn,1,yn,1,zn,i,bgval);
	make_frame_flat(dr,1,xn,1,yn,1,zn,i,bgval);
      }
    }else{
      make_frame_flat(dl,1,xn,1,yn,1,zn,i,0.0);  
      make_frame_flat(dr,1,xn,1,yn,1,zn,i,0.0);  
    }
  }
  stimx_dirmod(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL,NULL);  
  *rdl = dl;
  *rdr = dr;
}
float ***get_stim_3d_ppl_ransinphase(ppl,xn,yn,zn,sscale,tscale,tsamp,sflag)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
     int sflag;  
{
  int i;
  int ri,cnt,dt,aptype,seed,*rseq,nrseq,nif,antiflag,aflag,distrib,dumpflag;
  int ms_ord,szn,epoch1,epoch2,ecnt,test_flag;
  float *frseq,bgval,gmu,con2,c2f,phase2,dmvar_fact,ffact;
  float ***data,ph,th,mid,sf,phase,theta,contrast,maxlum,size,bgampl,sz;
  float ff,ffrac,phtau,t0,tn,t,ph_anti,cx,cy,xc,yc,blankval,blnk;
  cx       = paramfile_get_float_param_default(ppl,"cx",0.0);
  cy       = paramfile_get_float_param_default(ppl,"cy",0.0);
  maxlum   = param_getf_exit(ppl,"maxlum");
  theta    = param_getf_exit(ppl,"direction");
  sf       = param_getf_exit(ppl,"sf");
  contrast = param_getf_exit(ppl,"contrast");
  size     = param_getf_exit(ppl,"size");
  phase    = param_getf_exit(ppl,"phase");
  ph_anti  = paramfile_get_float_param_default(ppl,"phase_anti",phase);
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  distrib  =   paramfile_get_int_param_or_exit(ppl,"distrib");
  dt       =   paramfile_get_int_param_or_exit(ppl,"dt");
  seed     =   paramfile_get_int_param_or_exit(ppl,"seed");
  aptype   =   paramfile_get_int_param_or_exit(ppl,"aptype");
  aflag    =   paramfile_get_int_param_or_exit(ppl,"antiflag");
  bgval    = param_getf_exit(ppl,"bgval");
  phtau    = paramfile_get_float_param_default(ppl,"stim_phtau",0.006);
  blankval = paramfile_get_float_param_default(ppl,"stim_blank_val",0.0);
  blnk = 2.0*blankval - 1.0;
  dmvar_fact = 1.0;  
  epoch1 = paramfile_get_int_param_default(ppl,"epoch1",0);
  if (epoch1 > 0){
    epoch2 = paramfile_get_int_param_or_exit(ppl,"epoch2");
    if (paramfile_test_param(ppl,"phase2")){ 
      phase2 = param_getf_exit(ppl,"phase2");
      dmvar_fact = phase2 / phase;
      c2f = 1.0;  
    }else{
      con2 = paramfile_get_float_param_default(ppl,"contrast2",-1.0);
      if (con2 > contrast){
	exit_error("GET_STIM_3D_PPL_RANSINPHASE","contrast2 > contrast");
      }
      c2f = con2/contrast;  
    }
  }
  dumpflag = paramfile_get_int_param_default(ppl,"dumpflag",0);
  if (phtau > 0.0)
    ffrac = exp(-tscale/phtau); 
  else
    ffrac = 0.0;
  ff = ffrac;   
  bgampl = bgval * 2.0 - 1.0; 
  if (0) printf("%f %d\n",size,aptype);
  data = f3tensor(1,xn,1,yn,1,zn); 
  xc = (float)(xn-1)/2.0 + cx/sscale;  
  yc = (float)(yn-1)/2.0 + cy/sscale;  
  if ((sflag == 0)||(sflag == 1))
    ph = phase;
  else{
    ph = paramfile_get_float_param_default(ppl,"ph0",0.0); 
  }
  th = theta;
  szn = (int)(tn/tscale);  
  if (szn > zn)
    szn = zn;
  nif = (int)((szn + tsamp - 1)/tsamp); 
  nrseq = 1 + (int)((nif + dt -1)/ dt); 
  rseq = NULL;
  frseq = NULL;
  if (distrib == 1){
    frseq = myrand_get_std_gauss_seq(nrseq,seed);
    gmu = param_getf_exit(ppl,"mu");
  }else if (distrib == 2){
    rseq = myrand_get_std_bin_seq(nrseq,seed);
  }else if (distrib == 7){
    ms_ord = paramfile_get_int_param_or_exit(ppl,"mu");
    rseq = myrand_get_std_mseq(nrseq,seed,ms_ord);
  }else
    exit_error("GET_STIM_3D_PPL_RANSINPHASE","Unknown distrib value");
  if ((sflag == 2) && (distrib != 1)){ 
    frseq = i2farray(rseq,nrseq);
    for(i=0;i<nrseq;i++){
      if (rseq[i])
	frseq[i] = phase;
      else
	frseq[i] = -ph_anti;
    }
    myfree(rseq);
    rseq = NULL;
  }
  test_flag = paramfile_get_int_param_default(ppl,"test_pat",-1);
  if (test_flag >= 0){
    int t_pat,n_anti,t_dur,t_int;
    float t_etf,fps;
    fps = 1.0/(tsamp*tscale); 
    t_etf  = param_getf_exit(ppl,"test_etf");
    t_pat  = paramfile_get_int_param_or_exit(ppl,"test_pat");
    n_anti = paramfile_get_int_param_default(ppl,"test_nanti",3);
    t_dur  = paramfile_get_int_param_or_exit(ppl,"test_dur");
    t_int  = paramfile_get_int_param_or_exit(ppl,"test_int");
    stm_dirmod_test_seq(NULL,t_dur,t_int,t_etf,t_pat,n_anti,fps,1,1,
			&frseq,&nrseq);
  }
  if (dumpflag == 1){
    printf("  Dumping, nrseq = %d\n",nrseq);
    if (rseq != NULL)
      append_iarray_plot("zzz.STIM.pl","rseq",rseq,nrseq,1);
    if (frseq != NULL)
      append_farray_plot("zzz.STIM.pl","fseq",frseq,nrseq,1);
    printf("Writing random time sequence to 'zzz.STIM.pl'\n");
  }
  antiflag = 0;
  ffact = 1.0;
  cnt = dt;
  ri = 0;
  ecnt = 0;   
  for(i=1;i<=zn;i++){
    if (((i-1)%tsamp) == 0){
      t = (float)(i-1)*tscale;     
      if ((t >= t0) && (t < (t0+tn))){
	if (cnt==dt){
	  if (ri >= nrseq){
	    printf("ri=%d  nrseq=%d  t,t0,tn= %f %f %f\n",ri,nrseq,t,t0,tn);
	    exit_error("GET_STIM_3D_PPL_RANSINPHASE","Exceeded rand sequence");
	  }
          if (rseq != NULL){
	    if (rseq[ri])
	      antiflag = 0;
	    else
	      antiflag = 1;
	  }
	  if (sflag == 0){          
	    if (rseq[ri])
	      ph = phase;
	    else
	      ph = phase + 180.0;
	  }else if (sflag == 1){    
	    if (rseq[ri])
	      th = theta;
	    else
	      th = theta + 90.0;
	  }else if (sflag == 2){    
	    if (dmvar_fact != 1.0){
	      if (ecnt < epoch1){
		ffact = 1.0;
	      }else{
		ffact = dmvar_fact;
	      }
	    }
	    if (distrib == 1){
	      ph += gmu + phase* ffact * frseq[ri]; 
	    }else{
	      ph += ffact * frseq[ri];              
	    }
	  }else
	    exit_error("get_stim_3d_ransinphase","Unknown sflag value");
	  ri += 1;
	  cnt = 0;
	}else{
	  if (sflag == 2){ 
	    if (distrib == 1){
	      ph += (ffact * frseq[ri-1] * phase); 
	    }else{
	      ph += ffact * frseq[ri-1];           
	    }
	  }
	}
	if ((aflag==0) && antiflag) 
	  make_frame_flat(data,1,xn,1,yn,1,zn,i,0.0);
	else{
	  if (epoch1 <= 0){ 
	    make_frame_sinusoid(data,1,xn,1,yn,1,zn,i,sf,th,sscale,ph,cx,cy);
	  }else{
	    if (ecnt < epoch1){
	      make_frame_sinusoid(data,1,xn,1,yn,1,zn,i,sf,th,sscale,ph,cx,cy);
	    }else{
	      make_frame_sinusoid_scale(data,1,xn,1,yn,1,zn,i,sf,th,sscale,ph,
					cx,cy,c2f,0);
	    }
	  }
	}
	cnt += 1;
      }else{
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgampl); 
      }
      ff = ffrac;
    }else{
      if ((ff > 0.0)&&(i>1))
	make_frame_scale_frame_zmid(data,1,xn,1,yn,1,zn,i,i-1,ff,blnk);
      else
	make_frame_flat(data,1,xn,1,yn,1,zn,i,blnk);
      ff *= ffrac;
    }
    sz = size/sscale;
    frame_apply_aperture(data,1,xn,1,yn,1,zn,i,aptype,xc,yc,sz,sz,0.0,bgampl);
    ecnt += 1;
    if (ecnt >= (epoch1+epoch2))
      ecnt = 0;
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data,1,xn,1,yn,1,zn,contrast*mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  if (frseq != NULL)
    myfree(frseq);
  if (rseq != NULL)
    myfree(rseq);
  return data;
}
float ***get_stim_3d_ppl_ranstep(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i;
  int ri,cnt,aptype,dumpflag,jn,jzero,dt,seed,seqn,meanzero;
  float sf,fps,*seqf,phase,jsz,st0,stn,bgval,t,cx,cy,xc,yc;
  float ***data,ph,th,mid,theta,contrast,maxlum,size,bgampl,sz;
  float blankval,blnk;
  cx       = paramfile_get_float_param_default(ppl,"cx",0.0);
  cy       = paramfile_get_float_param_default(ppl,"cy",0.0);
  sf       = param_getf_exit(ppl,"sf");
  size     = param_getf_exit(ppl,"size");
  theta    = param_getf_exit(ppl,"direction");
  bgval    = param_getf_exit(ppl,"bgval");
  contrast = param_getf_exit(ppl,"contrast");
  st0      = param_getf_exit(ppl,"st0");
  stn      = param_getf_exit(ppl,"stn");
  dt       = paramfile_get_int_param_or_exit(ppl,"dt");
  seed     = paramfile_get_int_param_or_exit(ppl,"seed");
  jn       = paramfile_get_int_param_or_exit(ppl,"step_n");
  jsz      = param_getf_exit(ppl,"step_size");
  jzero    = paramfile_get_int_param_or_exit(ppl,"step_zero");
  phase    = param_getf_exit(ppl,"phase");
  maxlum   = param_getf_exit(ppl,"maxlum");
  aptype   =   paramfile_get_int_param_or_exit(ppl,"aptype");
  dumpflag =   paramfile_get_int_param_default(ppl,"dumpflag",0);
  meanzero = paramfile_get_int_param_default(ppl,"stim_mean_zero",0);
  blankval = paramfile_get_float_param_default(ppl,"stim_blank_val",0.0);
  blnk = 2.0*blankval - 1.0;
  fps = 1.0/(tsamp*tscale); 
  seqf = stm_ranstep_get_stim(NULL,sf,jsz,jzero,jn,seed,stn,fps,dt,0,&seqn);
  bgampl = bgval * 2.0 - 1.0; 
  data = f3tensor(1,xn,1,yn,1,zn);  
  xc = (float)(xn-1)/2.0 + cx/sscale;  
  yc = (float)(yn-1)/2.0 + cy/sscale;  
  ph = phase*360.0;  
  th = theta;
  if (dumpflag == 1){
    printf("  Dumping, nrseq = %d\n",seqn);
    append_farray_plot("zzz.STIM.pl","seqf",seqf,seqn,1);
    printf("Writing random time sequence to 'zzz.STIM.pl'\n");
  }
  cnt = dt;
  ri = 0;
  for(i=1;i<=zn;i++){
    if (((i-1)%tsamp) == 0){
      t = (float)(i-1)*tscale;     
      if ((t >= st0) && (t < (st0+stn)) && (ri < seqn)){
	if (cnt==dt){
	  if (ri >= seqn){
	    printf("ri=%d  nrseq=%d  t,t0,tn= %f %f %f\n",ri,seqn,t,st0,stn);
	    exit_error("GET_STIM_3D_PPL_RANSINPHASE","Exceeded rand sequence");
	  }
	  ph -= seqf[ri]*360.0;  
	  ri += 1;
	  cnt = 0;
	}else{
	  ph -= seqf[ri-1]*360.0;  
	}
	make_frame_sinusoid(data,1,xn,1,yn,1,zn,i,sf,th,sscale,ph,cx,cy);
	cnt += 1;
      }else{
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgampl); 
      }
    }else{
      make_frame_flat(data,1,xn,1,yn,1,zn,i,blnk);
    }
    sz = size/sscale;
    frame_apply_aperture(data,1,xn,1,yn,1,zn,i,aptype,xc,yc,sz,sz,0.0,bgampl);
  }
  if (meanzero == 0){
    mid = (float)maxlum/2.0;
    multiply_3d_farray(data,1,xn,1,yn,1,zn,contrast*mid);
    add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  }else{
    if (contrast*maxlum != 1.0)
      multiply_3d_farray(data,1,xn,1,yn,1,zn,contrast*maxlum);
  }
  myfree(seqf);
  return data;
}
float ***get_stim_3d_ppl_test_shape(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i,j,k;
  float ***data,mid,t,contrast,maxlum,t0,tn,bgval,bgamp,**tframe;
  float sbot,sleft,sright,cx,cy,ampl;
  t0        = param_getf_exit(ppl,"st0");
  tn        = param_getf_exit(ppl,"stn");
  cx        = param_getf_dflt(ppl,"tr1_cx",0.0);
  cy        = param_getf_dflt(ppl,"tr1_cy",0.0);
  sbot      = param_getf_exit(ppl,"tr1_bottom");
  sleft     = param_getf_exit(ppl,"tr1_left");
  sright    = param_getf_exit(ppl,"tr1_right");
  ampl      = param_getf_exit(ppl,"tr1_ampl");
  bgval     = param_getf_exit(ppl,"bgval");
  contrast  = param_getf_exit(ppl,"contrast");
  maxlum    = param_getf_exit(ppl,"maxlum");
  data = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;  
    if (((i-1)%tsamp) == 0){  
      if ((t >= t0) && (t < t0+tn)){
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
	make_frame_add_triangle(data,1,xn,1,yn,1,zn,i,sbot,sleft,sright,
				cx,cy,sscale,ampl,bgval);
      }else{
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
      }
    }else{
      make_frame_flat(data,1,xn,1,yn,1,zn,i,-1.0); 
    }
  }
  return data;
}
float ***get_stim_3d_ppl_adamk(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i;
  int ri,cnt,dt,aptype,seed,nrseq,nif,aflag,dumpflag;
  int szn,tau,std1,std2,period,offset,floorp;
  float *frseq,bgval,scalep;
  float ***data,ph,th,mid,sf,phase,theta,contrast,maxlum,size,bgampl,sz;
  float ff,ffrac,phtau,t0,tn,t,cx,cy,xc,yc;
  cx       = paramfile_get_float_param_default(ppl,"cx",0.0);
  cy       = paramfile_get_float_param_default(ppl,"cy",0.0);
  maxlum   = param_getf_exit(ppl,"maxlum");
  theta    = param_getf_exit(ppl,"direction");
  sf       = param_getf_exit(ppl,"sf");
  contrast = param_getf_exit(ppl,"contrast");
  size     = param_getf_exit(ppl,"size");
  phase    = param_getf_exit(ppl,"phase0");
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  dt       =   paramfile_get_int_param_or_exit(ppl,"dt");
  aptype   =   paramfile_get_int_param_or_exit(ppl,"aptype");
  bgval    = param_getf_exit(ppl,"bgval");
  phtau    = paramfile_get_float_param_default(ppl,"stim_phtau",0.0);
  tau      =   paramfile_get_int_param_or_exit(ppl,"tau");
  seed     =   paramfile_get_int_param_or_exit(ppl,"seed");
  std1     =   paramfile_get_int_param_or_exit(ppl,"std1");
  std2     =   paramfile_get_int_param_or_exit(ppl,"std1");
  period   =   paramfile_get_int_param_or_exit(ppl,"period");
  offset   =   paramfile_get_int_param_or_exit(ppl,"offset");
  floorp   =   paramfile_get_int_param_or_exit(ppl,"floorp");
  scalep   =   param_getf_exit(ppl,"scalep");
  dumpflag = paramfile_get_int_param_default(ppl,"dumpflag",0);
  if (phtau > 0.0)
    ffrac = exp(-tscale/phtau); 
  else
    ffrac = 0.0;
  ff = ffrac;   
  bgampl = bgval * 2.0 - 1.0; 
  data = f3tensor(1,xn,1,yn,1,zn); 
  xc = (float)(xn-1)/2.0 + cx/sscale;  
  yc = (float)(yn-1)/2.0 + cy/sscale;  
  ph = phase;
  th = theta;
  szn = (int)(tn/tscale);  
  if (szn > zn)
    szn = zn;
  nif = (int)((szn + tsamp - 1)/tsamp); 
  nrseq = 1 + (int)((nif + dt -1)/ dt); 
  frseq = akstim(tau,seed,std1,std2,period,offset,floorp,scalep,nrseq);
  if (dumpflag == 1){
    append_farray_plot("zzz.STIM.pl","fseq",frseq,nrseq,1);
    printf("Writing random time sequence to 'zzz.STIM.pl'\n");
  }
  cnt = dt;
  ri = 0;
  for(i=1;i<=zn;i++){
    if (((i-1)%tsamp) == 0){
      t = (float)(i-1)*tscale;     
      if ((t >= t0) && (t < (t0+tn))){
	if (cnt==dt){
	  if (ri >= nrseq){
	    printf("ri=%d  nrseq=%d  t,t0,tn= %f %f %f\n",ri,nrseq,t,t0,tn);
	    exit_error("GET_STIM_3D_PPL_RANSINPHASE","Exceeded rand sequence");
	  }
	  ph += frseq[ri]; 
	  ri += 1;
	  cnt = 0;
	}else{
	  ph += frseq[ri-1]; 
	}
	make_frame_sinusoid(data,1,xn,1,yn,1,zn,i,sf,th,sscale,ph,cx,cy);
	cnt += 1;
      }else{
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgampl);
      }
      ff = ffrac;
    }else{
      if ((ff > 0.0)&&(i>1))
	make_frame_scale_frame_zmid(data,1,xn,1,yn,1,zn,i,i-1,ff,-1.0);
      else
	make_frame_flat(data,1,xn,1,yn,1,zn,i,-1.0);
      ff *= ffrac;
    }
    sz = size/sscale;
    frame_apply_aperture(data,1,xn,1,yn,1,zn,i,aptype,xc,yc,sz,sz,0.0,bgampl);
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data,1,xn,1,yn,1,zn,contrast*mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  myfree(frseq);
  return data;
}
float ***get_stim_3d_ppl_ran_sin(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i,j,k,l;
  int m,ri,cnt,dt,aptype,seed,*rseq,nrseq,nif,szn,ori_n,ph_n,sf_n,blank_n;
  float bgval,t0,tn,t,sf_m,sf_low,ori,phase,cx,cy,xc,yc;
  float ***data,or,ph,mid,sf,contrast,maxlum,size,bgamp,sz;
  float *tab1_or,*tab2_ph,*tab3_sf;
  cx       = paramfile_get_float_param_default(ppl,"cx",0.0);
  cy       = paramfile_get_float_param_default(ppl,"cy",0.0);
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  maxlum   = param_getf_exit(ppl,"maxlum");
  bgval    = param_getf_exit(ppl,"bgval");
  contrast = param_getf_exit(ppl,"contrast");
  blank_n  =   paramfile_get_int_param_or_exit(ppl,"blank_n");
  ori_n    =   paramfile_get_int_param_or_exit(ppl,"ori_n");
  ori      = paramfile_get_float_param_default(ppl,"ori",0.0);
  ph_n     =   paramfile_get_int_param_or_exit(ppl,"phase_n");
  phase    = paramfile_get_float_param_default(ppl,"phase",0.0);
  sf_n     =   paramfile_get_int_param_or_exit(ppl,"sf_n");
  sf_low   = param_getf_exit(ppl,"sf_low");
  sf_m     = param_getf_exit(ppl,"sf_m");
  seed     =   paramfile_get_int_param_or_exit(ppl,"seed");
  size     = param_getf_exit(ppl,"size");
  dt       =   paramfile_get_int_param_or_exit(ppl,"dt");
  aptype   =   paramfile_get_int_param_or_exit(ppl,"aptype");
  bgamp = bgval * 2.0 - 1.0; 
  data = f3tensor(1,xn,1,yn,1,zn); 
  szn = (int)(tn/tscale);  
  if (szn > zn)
    szn = zn;
  sz = size/sscale;
  xc = (float)(xn-1)/2.0 + cx/sscale;  
  yc = (float)(yn-1)/2.0 + cy/sscale;  
  nif = (int)((szn + tsamp - 1)/tsamp); 
  nrseq = 1 + (int)((nif + dt -1)/ dt); 
  m = ori_n * ph_n * sf_n + blank_n;
  tab1_or = (float *)myalloc(m*sizeof(float));
  tab2_ph = (float *)myalloc(m*sizeof(float));
  tab3_sf = (float *)myalloc(m*sizeof(float));
  rseq = myrand_get_std_unif_int_seq(nrseq,seed,m);
  l = 0;
  for(i=0;i<ori_n;i++){
    for(j=0;j<ph_n;j++){
      for(k=0;k<sf_n;k++){
	tab1_or[l] = ori + (float)i * 180.0/(float)ori_n;
	tab2_ph[l] = phase + (float)j * 360.0/(float)ph_n;
	tab3_sf[l] = sf_low * pow(sf_m,(float)k);
	l += 1;
      }
    }
  }
  for(i=0;i<blank_n;i++){ 
    tab1_or[l] = 0.0;
    tab2_ph[l] = 0.0;
    tab3_sf[l] = 0.0;  
    l += 1;
  }
  cnt = dt;
  ri = 0;
  for(i=1;i<=zn;i++){
    if (((i-1)%tsamp) == 0){
      t = (float)(i-1)*tscale;     
      if ((t >= t0) && (t < (t0+tn))){
	if (cnt == dt){ 
	  if (ri >= nrseq){
	    printf("ri=%d  nrseq=%d  t,t0,tn= %f %f %f\n",ri,nrseq,t,t0,tn);
	    exit_error("GET_STIM_3D_PPL_RAN_SIN","Exceeded rand sequence");
	  }
	  k = rseq[ri];     
	  ri += 1;
	  or = tab1_or[k];
	  ph = tab2_ph[k];
	  sf = tab3_sf[k];
	  cnt = 0;
	}
	if (sf == 0.0)
	  make_frame_flat(data,1,xn,1,yn,1,zn,i,bgamp);
	else
	  make_frame_sinusoid(data,1,xn,1,yn,1,zn,i,sf,or,sscale,ph,cx,cy);
	cnt += 1;
      }else{
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgamp);
      }
    }else{
      make_frame_flat(data,1,xn,1,yn,1,zn,i,-1.0); 
    }
    frame_apply_aperture(data,1,xn,1,yn,1,zn,i,aptype,xc,yc,sz,sz,0.0,bgamp);
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data,1,xn,1,yn,1,zn,contrast*mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  myfree(rseq);
  myfree(tab1_or);  myfree(tab2_ph);  myfree(tab3_sf);
  return data;
}
float ***get_stim_3d_ppl_bar(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i,j,k;
  float ***data,bgval,blankval,**tframe;
  stimx_bar(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL,NULL);
  bgval    = param_getf_exit(ppl,"bgval");
  blankval = param_getf_dflt(ppl,"stim_blank_val",0.0);
  data = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    if (((i-1)%tsamp) == 0){
      stimx_bar(ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframe,NULL);
      for(j=0;j<xn;j++){
	for(k=0;k<yn;k++){
	  data[j+1][k+1][i] = tframe[j][k];
	}
      }
      free_2d_farray(tframe,xn);
    }else{
      make_frame_flat(data,1,xn,1,yn,1,zn,i,blankval-bgval); 
    }
  }
  add_const_3d_farray(data,1,xn,1,yn,1,zn,bgval);
  stimx_bar(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL,NULL);  
  return data;
}
float ***get_stim_3d_ppl_pixel(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp)
     char *mylogf;
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i,j,k;
  float bgval,blankval,**tframl,***dl;
  stimx_pixel(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL);
  bgval    = param_getf_exit(ppl,"bgval");
  blankval = param_getf_dflt(ppl,"stim_blank_val",0.0);
  dl = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    if (((i-1)%tsamp) == 0){
      stimx_pixel(ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframl);
      for(j=0;j<xn;j++){
	for(k=0;k<yn;k++){
	  dl[j+1][k+1][i] = tframl[j][k];
	}
      }
      free_2d_farray(tframl,xn);
    }else{
      make_frame_flat(dl,1,xn,1,yn,1,zn,i,blankval-bgval); 
    }
  }
  stimx_pixel(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL);  
  return dl;
}
void get_stim_3db_ppl_bar(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,rdl,rdr)
     char *mylogf;
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
     float ****rdl,****rdr;
{
  int i,j,k;
  float bgval,blankval,**tframl,**tframr;
  float ***dl,***dr;
  stimx_bar(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL,NULL);
  bgval    = param_getf_exit(ppl,"bgval");
  blankval = param_getf_dflt(ppl,"stim_blank_val",0.0);
  dl = f3tensor(1,xn,1,yn,1,zn); 
  dr = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    if (((i-1)%tsamp) == 0){
      stimx_bar(ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframl,&tframr);
      for(j=0;j<xn;j++){
	for(k=0;k<yn;k++){
	  dl[j+1][k+1][i] = tframl[j][k];
	  dr[j+1][k+1][i] = tframr[j][k];
	}
      }
      free_2d_farray(tframl,xn);
      free_2d_farray(tframr,xn);
    }else{
      make_frame_flat(dl,1,xn,1,yn,1,zn,i,blankval-bgval); 
      make_frame_flat(dr,1,xn,1,yn,1,zn,i,blankval-bgval); 
    }
  }
  add_const_3d_farray(dl,1,xn,1,yn,1,zn,bgval);
  add_const_3d_farray(dr,1,xn,1,yn,1,zn,bgval);
  stimx_bar(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL,NULL);  
  *rdl = dl;
  *rdr = dr;
}
float ***get_stim_3d_ppl_bar2ran(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp; 
{
  int i,j,k;
  float ***data,t,t0,tn,blankval,bgval,**tframe;
  stimx_bar2ran(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL);
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  bgval    = param_getf_exit(ppl,"bgval");
  blankval  = param_getf_dflt(ppl,"stim_blank_val",0.0);
  data = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if (((i-1)%tsamp) == 0){
      if ((t >= t0) && (t < t0+tn)){
	stimx_bar2ran(ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframe);
	for(j=0;j<xn;j++){
	  for(k=0;k<yn;k++){
	    data[j+1][k+1][i] = tframe[j][k];
	  }
	}
	free_2d_farray(tframe,xn);
      }else
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
    }else
      make_frame_flat(data,1,xn,1,yn,1,zn,i,blankval); 
  }
  stimx_bar2ran(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL);  
  return data;
}
float ***get_stim_3d_ppl_barray_old(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp; 
{
  int i,j,k;
  int n,si,bi,cnt,seed,x0,y0,flag;
  int dt,dt_off,nbar,npos,seqtype,**seqi;
  float t0,tn,cx,cy,theta,barw,barl,contrast,bgval,maxlum,***data,t,x,y;
  float bar_gap,pos_gap,barval,size,**bar_cx,**bar_cy,sdaa;
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  cx       = param_getf_exit(ppl,"cx");
  cy       = param_getf_exit(ppl,"cy");
  theta    = param_getf_exit(ppl,"direction");
  barw     = param_getf_exit(ppl,"bar_w");
  bar_gap  = param_getf_exit(ppl,"bar_gap");
  pos_gap  = param_getf_exit(ppl,"pos_gap");
  nbar     = paramfile_get_int_param_or_exit(ppl,"bar_n");
  npos     = paramfile_get_int_param_or_exit(ppl,"pos_n");
  dt       = paramfile_get_int_param_or_exit(ppl,"dt");
  dt_off   = paramfile_get_int_param_or_exit(ppl,"dt_off");
  seed     = paramfile_get_int_param_or_exit(ppl,"seed");
  contrast = param_getf_exit(ppl,"contrast");
  barval   = param_getf_exit(ppl,"bar_amp");
  bgval    = param_getf_exit(ppl,"bgval");
  maxlum   = param_getf_exit(ppl,"maxlum");
  seqtype  = paramfile_get_int_param_or_exit(ppl,"seq_type");
  size     = param_getf_exit(ppl,"size");
  sdaa     = paramfile_get_float_param_default(ppl,"sdaa",0.0);
  barl = (size - (float)(nbar-1)*bar_gap)/(float)nbar; 
  n = (int)(tn/tscale / (float)(dt+dt_off)); 
  seqi = stm_barray_get_seq(NULL,n,nbar,npos,seqtype,seed);
  stm_barray_get_bar_centers(NULL,nbar,npos,theta,barw,barl,bar_gap,
			     pos_gap,&bar_cx,&bar_cy);
  data = f3tensor(1,xn,1,yn,1,zn); 
  si = 0;  
  cnt = 0;
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if (((i-1)%tsamp) == 0){
      if ((t >= t0) && (t < t0+tn)){
	if (cnt >= dt){
	  make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
	}else{
	  make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
	  for(j=0;j<nbar;j++){ 
	    if (si >= n){
	      printf("  si = %d\n",si);
	      exit_error("GET_STIM_3D_PPL_BARRAY","Sequence too short");
	    }
	    bi = seqi[si][j] - 1;
	    if (bi >= 0){ 
	      if (seqtype == 99){ 
		for(k=0;k<npos;k++){
		  x = bar_cx[j][k] + cx;
		  y = bar_cy[j][k] + cy;
		  make_frame_bar(data,1,xn,1,yn,1,zn,i,x,y,theta,barl,barw,
				 sdaa,sscale,barval,bgval,1);
		}
	      }else{
		x = bar_cx[j][bi] + cx;
		y = bar_cy[j][bi] + cy;
		make_frame_bar(data,1,xn,1,yn,1,zn,i,x,y,theta,barl,barw,
			       sdaa,sscale,barval,bgval,1);
	      }
	    }
	  }
	}
	cnt += 1;
	if (cnt >= (dt+dt_off)){
	  cnt = 0;
	  si += 1;  
	}
      }else
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
    }else
      make_frame_flat(data,1,xn,1,yn,1,zn,i,0.0); 
  }
  free_2d_farray(bar_cx,nbar);
  free_2d_farray(bar_cy,nbar);
  free_2d_iarray(seqi,n);
  return data;
}
float ***get_stim_3d_ppl_barray(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp; 
{
  int i,j,k;
  float ***data,t,t0,tn,bgval,**tframe;
  stimx_barray(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL);
  t0    = param_getf_exit(ppl,"st0");
  tn    = param_getf_exit(ppl,"stn");
  bgval = param_getf_exit(ppl,"bgval");
  data = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;  
    if (((i-1)%tsamp) == 0){  
      if ((t >= t0) && (t < t0+tn)){
	stimx_barray(ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframe);
	for(j=0;j<xn;j++){
	  for(k=0;k<yn;k++){
	    data[j+1][k+1][i] = tframe[j][k];
	  }
	}
	free_2d_farray(tframe,xn);
      }else{
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
      }
    }else{
      make_frame_flat(data,1,xn,1,yn,1,zn,i,0.0);
    }
  }
  stimx_barray(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL);  
  return data;
}
float ***get_stim_3d_ppl_surrt(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i;
  int i0,cs_flag;
  float t0,tn,t20,t2n,cx,cy,t,cn1,cn2;
  float ***data,ph1,ph2,mid;
  float size,idiam,odiam,sf1,sf2,tf1,tf2,phase1,phase2,theta1,theta2;
  float con1,con2,maxlum,bgamp,bgval;
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  cx       = param_getf_exit(ppl,"cx");
  cy       = param_getf_exit(ppl,"cy");
  t20      = param_getf_exit(ppl,"s2t0");
  t2n      = param_getf_exit(ppl,"s2tn");
  size     = param_getf_exit(ppl,"size");
  idiam    = param_getf_exit(ppl,"idiam");
  odiam    = param_getf_exit(ppl,"odiam");
  sf1      = param_getf_exit(ppl,"sf1");
  sf2      = param_getf_exit(ppl,"sf2");
  tf1      = param_getf_exit(ppl,"tf1");
  tf2      = param_getf_exit(ppl,"tf2");
  phase1   = param_getf_exit(ppl,"phase1");
  phase2   = param_getf_exit(ppl,"phase2");
  theta1   = param_getf_exit(ppl,"direction1");
  theta2   = param_getf_exit(ppl,"direction2");
  con1     = param_getf_exit(ppl,"contrast1");
  con2     = param_getf_exit(ppl,"contrast2");
  maxlum   = param_getf_exit(ppl,"maxlum");
  bgval    = param_getf_exit(ppl,"bgval");
  cs_flag  = paramfile_get_int_param_default(ppl,"cs_flag",3);
  data = f3tensor(1,xn,1,yn,1,zn); 
  bgamp = bgval * 2.0 - 1.0; 
  i0 = 1 + my_rint(t0 / tscale);
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if (((i-1)%tsamp) == 0){
      if ((t >= t0) && (t < t0+tn)) 
	cn1 = con1;
      else
	cn1 = 0.0;
      if ((t >= t20) && (t < t20+t2n)) 
	cn2 = con2;
      else
	cn2 = 0.0;
      if ((cn1 != 0.0) || (cn2 != 0.0)){
	ph1 = phase1 + (float)(i-i0)*tscale*tf1 * 360.0;
	ph2 = phase2 + (float)(i-i0)*tscale*tf2 * 360.0;
	make_frame_circ_cs_sine(data,1,xn,1,yn,1,zn,i,size,idiam,odiam,sf1,sf2,
				theta1,theta2,ph1,ph2,sscale,cn1,cn2,bgamp,
				cx,cy,cs_flag);
      }else
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgamp);
    }else{
      make_frame_flat(data,1,xn,1,yn,1,zn,i,-1.0); 
    }
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data,1,xn,1,yn,1,zn,mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  return data;
}
float ***get_stim_3d_ppl_wy4st(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i,k;
  int dwell,n,*seqi,seed,state,cnt,nst;
  float ***data,ph1,ph2,mid,ttc,tts,t0,tn,t;
  float size,idiam,odiam,sf1,sf2,tf1,tf2,phase1,phase2,theta1,theta2;
  float con1,con2,maxlum,bgamp,bgval,cx,cy;
  char *ststr;
  cx       = param_getf_exit(ppl,"cx");
  cy       = param_getf_exit(ppl,"cy");
  size     = param_getf_exit(ppl,"size");
  idiam    = param_getf_exit(ppl,"idiam");
  odiam    = param_getf_exit(ppl,"odiam");
  sf1      = param_getf_exit(ppl,"sf1");
  sf2      = param_getf_exit(ppl,"sf2");
  tf1      = param_getf_exit(ppl,"tf1");
  tf2      = param_getf_exit(ppl,"tf2");
  phase1   = param_getf_exit(ppl,"phase1");
  phase2   = param_getf_exit(ppl,"phase2");
  theta1   = param_getf_exit(ppl,"direction1");
  theta2   = param_getf_exit(ppl,"direction2");
  con1     = param_getf_exit(ppl,"contrast1");
  con2     = param_getf_exit(ppl,"contrast2");
  maxlum   = param_getf_exit(ppl,"maxlum");
  bgval    = param_getf_exit(ppl,"bgval");
  seed     = paramfile_get_int_param_or_exit(ppl,"seed");
  ststr    = paramfile_get_char_param_default(ppl,"state_seq",NULL);
  t0       = param_getf_exit(ppl,"st0");
  nst      = paramfile_get_float_param_default(ppl,"stn_state",-1);
  if (nst == -1)
    tn     = param_getf_exit(ppl,"stn");
  else{
    tn = tscale * zn;
  }
  bgamp = bgval * 2.0 - 1.0; 
  data = f3tensor(1,xn,1,yn,1,zn); 
  dwell = my_rint(1.0/(tf1*tscale));  
  if (nst >= 0){
    n = nst;
  }else{
    n = zn/dwell;
  }
  stm_wy4st_get_seq(NULL,n,seed,ststr,&seqi); 
  if (seed > 0)
    seed = -seed;
  k = 0;        
  cnt = dwell;  
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if (((i-1)%tsamp) == 0){
      if ((t >= t0) && (t < t0+tn) &&              
	  ((k < n) || ((k==n) && (cnt < dwell)))){ 
	if (cnt == dwell){
	  state = seqi[k];
	  if ((state == 0)||(state == 1))
	    ttc = theta1 + 90.0;
	  else
	    ttc = theta1;
	  if ((state == 0)||(state == 2))
	    tts = theta2 + 90.0;
	  else
	    tts = theta2;
	  cnt = 1; 
	  k += 1;  
	}else{
	  cnt += 1; 
	}
	ph1 = phase1 + (float)(i-1)*tscale*tf1 * 360.0;
	ph2 = phase2 + (float)(i-1)*tscale*tf2 * 360.0;
	make_frame_circ_cs_sine(data,1,xn,1,yn,1,zn,i,size,idiam,odiam,sf1,sf2,
				ttc,tts,ph1,ph2,sscale,con1,con2,bgamp,cx,cy,
				3);
      }else{
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgamp);  
      }
    }else{
      make_frame_flat(data,1,xn,1,yn,1,zn,i,-1.0); 
    }
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data,1,xn,1,yn,1,zn,mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  return data;
}
float ***get_stim_3d_ppl_x4st(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i,k;
  int dwell,n,*seqi,seed,state,cnt,nst,aptype;
  float ***data,***data1,***data2,ph1,ph2,mid,t0,tn,t,sz;
  float size,sf1,sf2,tf1,tf2,phase1,phase2,theta1,theta2;
  float con1,con2,c1,c2,maxlum,bgamp,bgval,cx,cy,xc,yc;
  char *ststr;
  cx       = paramfile_get_float_param_default(ppl,"cx",0.0);
  cy       = paramfile_get_float_param_default(ppl,"cy",0.0);
  size     = param_getf_exit(ppl,"size");
  sf1      = param_getf_exit(ppl,"sf1");
  sf2      = param_getf_exit(ppl,"sf2");
  tf1      = param_getf_exit(ppl,"tf1");
  tf2      = param_getf_exit(ppl,"tf2");
  phase1   = param_getf_exit(ppl,"phase1");
  phase2   = param_getf_exit(ppl,"phase2");
  theta1   = param_getf_exit(ppl,"direction1");
  theta2   = param_getf_exit(ppl,"direction2");
  con1     = param_getf_exit(ppl,"contrast1");
  con2     = param_getf_exit(ppl,"contrast2");
  maxlum   = param_getf_exit(ppl,"maxlum");
  bgval    = param_getf_exit(ppl,"bgval");
  seed     = paramfile_get_int_param_or_exit(ppl,"seed");
  ststr    = paramfile_get_char_param_default(ppl,"state_seq",NULL);
  aptype   = paramfile_get_int_param_or_exit(ppl,"aptype");
  t0       = param_getf_exit(ppl,"st0");
  nst      = paramfile_get_float_param_default(ppl,"stn_state",-1);
  if (nst == -1)
    tn     = param_getf_exit(ppl,"stn");
  else{
    tn = tscale * zn;
  }
  bgamp = bgval * 2.0 - 1.0; 
  sz = size/sscale;
  data1 = f3tensor(1,xn,1,yn,1,zn); 
  data2 = f3tensor(1,xn,1,yn,1,zn);
  xc = (float)(xn-1)/2.0 + cx/sscale;  
  yc = (float)(yn-1)/2.0 + cy/sscale;  
  dwell = my_rint(1.0/(tf1*tscale));  
  if (nst >= 0){
    n = nst;
  }else{
    n = zn/dwell;
  }
  stm_wy4st_get_seq(NULL,n,seed,ststr,&seqi); 
  if (seed > 0)
    seed = -seed;
  k = 0;        
  cnt = dwell;  
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if (((i-1)%tsamp) == 0){
      if ((t >= t0) && (t < t0+tn) &&              
	  ((k < n) || ((k==n) && (cnt < dwell)))){ 
	if (cnt == dwell){
	  state = seqi[k];
	  c1 = con1;
	  if ((state == 0)||(state==1))
	    c1 = 0.0;
	  c2 = con2;
	  if ((state == 0)||(state==2))
	    c2 = 0.0;
	  cnt = 1; 
	  k += 1;  
	}else{
	  cnt += 1; 
	}
	ph1 = phase1 + (float)(i-1)*tscale*tf1 * 360.0;
	ph2 = phase2 + (float)(i-1)*tscale*tf2 * 360.0;
	make_frame_sinusoid(data1,1,xn,1,yn,1,zn,i,sf1,theta1,sscale,ph1,
			    cx,cy);
	make_frame_sinusoid(data2,1,xn,1,yn,1,zn,i,sf2,theta2,sscale,ph2,
			    cx,cy);
	multiply_frame(data1,1,xn,1,yn,1,zn,i,c1);
	multiply_frame(data2,1,xn,1,yn,1,zn,i,c2);
	frame_apply_aperture(data1,1,xn,1,yn,1,zn,i,aptype,xc,yc,
			     sz,sz,0.0,bgamp);
	frame_apply_aperture(data2,1,xn,1,yn,1,zn,i,aptype,xc,yc,
			     sz,sz,0.0,bgamp);
      }else{
	make_frame_flat(data1,1,xn,1,yn,1,zn,i,bgamp);  
	make_frame_flat(data2,1,xn,1,yn,1,zn,i,bgamp);  
      }
    }else{
      make_frame_flat(data1,1,xn,1,yn,1,zn,i,-1.0); 
      make_frame_flat(data2,1,xn,1,yn,1,zn,i,-1.0); 
    }
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data1,1,xn,1,yn,1,zn,mid);
  multiply_3d_farray(data2,1,xn,1,yn,1,zn,mid);
  data = add_3d_tensors(data1,data2,xn,yn,zn);
  free_f3tensor(data1,1,xn,1,yn,1,zn);
  free_f3tensor(data2,1,xn,1,yn,1,zn);
  stim_util_limit_3d(data,1,xn,1,yn,1,zn,-mid,mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid); 
  return data;
}
float ***get_stim_3d_ppl_x4st_OLD(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i;
  int state,dwell,aptype,seed,i0;
  float ***data,***data1,***data2,mid,rv,con1,con2,c1,c2,maxlum,bgampl,bgval;
  float size,sz,sf1,sf2,tf1,tf2,phase1,phase2,ph1,ph2,theta1,theta2,tt,t0,tn,t;
  float cx,cy,xc,yc;
  printf("  GET_STIM_3D_PPL_X4ST\n");
  cx       = paramfile_get_float_param_default(ppl,"cx",0.0);
  cy       = paramfile_get_float_param_default(ppl,"cy",0.0);
  size     = param_getf_exit(ppl,"size");
  sf1      = param_getf_exit(ppl,"sf1");
  sf2      = param_getf_exit(ppl,"sf2");
  tf1      = param_getf_exit(ppl,"tf1");
  tf2      = param_getf_exit(ppl,"tf2");
  phase1   = param_getf_exit(ppl,"phase1");
  phase2   = param_getf_exit(ppl,"phase2");
  theta1   = param_getf_exit(ppl,"direction1");
  theta2   = param_getf_exit(ppl,"direction2");
  con1     = param_getf_exit(ppl,"contrast1");
  con2     = param_getf_exit(ppl,"contrast2");
  maxlum   = param_getf_exit(ppl,"maxlum");
  bgval    = param_getf_exit(ppl,"bgval");
  aptype   =   paramfile_get_int_param_or_exit(ppl,"aptype");
  seed     =   paramfile_get_int_param_or_exit(ppl,"seed");
  t0       = param_getf_exit(ppl,"st0");
  tn       = param_getf_exit(ppl,"stn");
  bgampl = bgval * 2.0 - 1.0; 
  if (seed > 0)
    seed = -seed;
  sz = size/sscale;
  dwell = my_rint(1.0/(tf1*tscale));
  tt = dwell*tf1*tscale;
  printf("    Dwell = %d (1/tf*tscale = %f)\n",dwell,1.0/(tf1*tscale));
  if (((tt-1.0) > 0.001)||((tt-1.0) < -0.001))
    exit_error("GET_STIM_3D_PPL_X4ST","Dwell, TF and tscale are incompatible");
  data1 = f3tensor(1,xn,1,yn,1,zn);
  data2 = f3tensor(1,xn,1,yn,1,zn);
  xc = (float)(xn-1)/2.0 + cx/sscale;  
  yc = (float)(yn-1)/2.0 + cy/sscale;  
  state = 0;
  i0 = 1 + my_rint(t0 / tscale);
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if (((i-i0)%dwell) == 0){
      rv = myrand_util_ran2(&seed);
      if (rv < 0.25)
	state = 3;
      else if (rv < 0.50)
	state = 2;
      else if (rv < 0.75)
	state = 1;
      else
	state = 0;
    }
    printf("WYETH - Does this routine work?, not last time I checked\n");
    printf("State = %d\n",state);
    c1 = con1;
    if ((state == 0)||(state==1))
      c1 = 0.0;
    c2 = con2;
    if ((state == 0)||(state==2))
      c2 = 0.0;
    printf("con1,2  = %f %f\n",con1,con2);
    if (((i-1)%tsamp) == 0){
      if ((t >= t0) && (t < t0+tn)){
	ph1 = phase1 + (float)(i-i0)*tscale*tf1 * 360.0;
	ph2 = phase2 + (float)(i-i0)*tscale*tf2 * 360.0;
	make_frame_sinusoid(data1,1,xn,1,yn,1,zn,i,sf1,theta1,sscale,ph1,
			    cx,cy);
	make_frame_sinusoid(data2,1,xn,1,yn,1,zn,i,sf2,theta2,sscale,ph2,
			    cx,cy);
	multiply_frame(data1,1,xn,1,yn,1,zn,i,c1);
	multiply_frame(data2,1,xn,1,yn,1,zn,i,c2);
	frame_apply_aperture(data1,1,xn,1,yn,1,zn,i,aptype,xc,yc,
			     sz,sz,0.0,bgampl);
	frame_apply_aperture(data2,1,xn,1,yn,1,zn,i,aptype,xc,yc,
			     sz,sz,0.0,bgampl);
      }else{
	make_frame_flat(data1,1,xn,1,yn,1,zn,i,bgampl);
	make_frame_flat(data2,1,xn,1,yn,1,zn,i,bgampl);
      }
    }else{
      make_frame_flat(data1,1,xn,1,yn,1,zn,i,-1.0);
      make_frame_flat(data2,1,xn,1,yn,1,zn,i,-1.0);
    }
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data1,1,xn,1,yn,1,zn,mid);
  multiply_3d_farray(data2,1,xn,1,yn,1,zn,mid);
  data = add_3d_tensors(data1,data2,xn,yn,zn);
  free_f3tensor(data1,1,xn,1,yn,1,zn);
  free_f3tensor(data2,1,xn,1,yn,1,zn);
  stim_util_limit_3d(data,1,xn,1,yn,1,zn,-mid,mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  return data;
}
float ***get_stim_3d_ppl_wy2pa(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i;
  int count,full,tstatic,pflag,maxj1,minj1,maxj2,minj2;
  int toverlap,prefdur,antidur,antimax,p0,p1,a0,a1,tanti,apat,ppat,jump1,jump2;
  float ***data,ph1,ph2,mid,cx,cy,tcx,tcy,r,theta;
  float size,pdist,ptheta,sf1,sf2,tf1,tf2,phase1,phase2,theta1,theta2;
  float maxlum,bgampl,con1,con2,bgval;
  int seed;
  size    = param_getf_exit(ppl,"size");
  pdist   = param_getf_exit(ppl,"pdist");
  ptheta  = param_getf_exit(ppl,"ptheta");
  sf1     = param_getf_exit(ppl,"sf1");
  sf2     = param_getf_exit(ppl,"sf2");
  tf1     = param_getf_exit(ppl,"tf1");
  tf2     = param_getf_exit(ppl,"tf2");
  phase1     = param_getf_exit(ppl,"phase1");
  phase2     = param_getf_exit(ppl,"phase2");
  theta1     = param_getf_exit(ppl,"direction1");
  theta2     = param_getf_exit(ppl,"direction2");
  con1     = param_getf_exit(ppl,"contrast1");
  con2     = param_getf_exit(ppl,"contrast2");
  maxlum   = param_getf_exit(ppl,"maxlum");
  bgval   = param_getf_exit(ppl,"bgval");
  seed     = paramfile_get_int_param_or_exit(ppl,"seed");
  bgampl = bgval * 2.0 - 1.0; 
  printf("  GET_STIM_3D_PPL_WY2PA\n");
  printf("    Only partially implemented --- many params ignored.\n");
  printf("  SCALE = %f\n",sscale);
  printf("  size = %f\n",size);
  printf("  phase1,phase2 = %f %f\n",phase1,phase2);
  data = f3tensor(1,xn,1,yn,1,zn); 
  if (seed > 0)
    seed = -seed;
  prefdur = 4;   
  antidur = 0;   
  toverlap = 0;  
  cx = cy = 0.0; 
  maxj1 =  tf1*tscale * 360.0;  
  minj1 = -tf1*tscale * 360.0;  
  maxj2 =  tf2*tscale * 360.0;  
  minj2 = -tf2*tscale * 360.0;  
  tstatic = 4;
  pflag = 0;
  if (antidur < 0){ 
    pflag = 1;
    tstatic = -antidur;
    antidur = prefdur;
    antimax = 0;
  }else if (antidur == 0) 
    antimax = 10;
  else
    antimax = antidur;
  if (pflag){
    p0 = tstatic;
    p1 = p0+prefdur-1;
    a1 = p1;
    full = tstatic + prefdur;
    toverlap = 0;
  }else{
    p0 = antimax + tstatic - toverlap;    
    p1 = p0+prefdur-1;                    
    full = p0+prefdur + 2;
    a1 = p0-1 + toverlap;                 
  }
  a0 = apat = ppat = 0; 
  ph1 = ph2 = 0.0;
  count = full;
  for(i=0;i<zn;i++){
    if (count == full){
      count = 0;
      if (antidur == 0){
	tanti = (int)(myrand_util_ran2(&seed)*8.0);
	if (tanti == 5)
	  tanti = 6;
	else if (tanti == 6)
	  tanti = 8;
	else if (tanti == 7)
	  tanti = 10;
      }else{
	if (myrand_util_ran2(&seed) < 0.5)
	  tanti = 0;
	else
	  tanti = antidur;
      }
      a0 = a1 - tanti + 1;
      if (myrand_util_ran2(&seed) < 0.5)   
	apat = 0;
      else
	apat = 1;
      if (myrand_util_ran2(&seed) < 0.5)   
	ppat = 0;
      else
	ppat = 1;
    }
    jump1 = jump2 = 0;
    if ((count >= a0)&&(count <= a1)){  
      if (apat)
	jump1 = minj1;
      else
	jump2 = minj2;
    }
    if ((count >= p0)&&(count <= p1)){  
      if (ppat)
	jump1 = maxj1;
      else
	jump2 = maxj2;
    }
    ph1 -= jump1;
    ph2 -= jump2;
    if (((i-1)%tsamp) == 0){
      make_frame_flat(data,1,xn,1,yn,1,zn,i,bgampl);
      r = (float)pdist/2.0;
      theta = (float)ptheta*M_PI/180.0;
      tcx = cx + r*cos(theta);
      tcy = cy + r*sin(theta); 
      draw_circ_sine_in_frame(data,1,xn,1,yn,1,zn,i,tcx,tcy,size,sf1,theta1,
			      ph1,sscale,con1);
      tcx = cx - r*cos(theta);
      tcy = cy - r*sin(theta); 
      draw_circ_sine_in_frame(data,1,xn,1,yn,1,zn,i,tcx,tcy,size,sf2,theta2,
			      ph2,sscale,con2);
    }else
      make_frame_flat(data,1,xn,1,yn,1,zn,i,-1.0);
    count += 1;
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data,1,xn,1,yn,1,zn,mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  return data;
}
float ***get_stim_3d_ppl_gp(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i,j,k;
  float ***data,t,t0,tn,bgval,**tframe;
  stimx_gp(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL);
  t0        = param_getf_exit(ppl,"st0");
  tn        = param_getf_exit(ppl,"stn");
  bgval     = param_getf_exit(ppl,"bgval");
  data = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    if (((i-1)%tsamp) == 0){
      stimx_gp(ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframe);
      for(j=0;j<xn;j++){
	for(k=0;k<yn;k++){
	  data[j+1][k+1][i] = tframe[j][k];
	}
      }
      free_2d_farray(tframe,xn);
    }else
      make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
  }
  stimx_gp(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL);  
  return data;
}
float ***get_stim_3d_ppl_noise(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;  
     int tsamp;            
{
  int i,j,k;
  float ***data,mid,contrast,maxlum,bgval,bgamp,**tframe;
  stimx_noise(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL);
  contrast  = param_getf_exit(ppl,"contrast");
  maxlum    = param_getf_exit(ppl,"maxlum");
  bgval     = param_getf_exit(ppl,"bgval");
  bgamp = 2.0*bgval - 1.0; 
  data = f3tensor(1,xn,1,yn,1,zn); 
  for(i=0;i<zn;i++){
    if ((i % tsamp) == 0){  
      stimx_noise(ppl,xn,yn,zn,sscale,tscale,tsamp,i,1,&tframe);
      if (tframe != NULL){
	for(j=0;j<xn;j++)  
	  for(k=0;k<yn;k++)
	    data[j+1][k+1][i+1] = tframe[j][k];
	free_2d_farray(tframe,xn);
      }else{
	make_frame_flat(data,1,xn,1,yn,1,zn,i+1,bgamp);
      }
    }else{
      make_frame_flat(data,1,xn,1,yn,1,zn,i+1,-1.0); 
    }
  }
  if (param_test(ppl,"power_law_3d")){
    float ***pow_data;
    float fpow,min,max;
    exit_error("GET_STIM_3D_PPL_NOISE","WYETH - CHANGE IMPLEMENTATION");
    fpow   = param_getf_exit(ppl,"power_law_3d");
    pow_data = apply_power_law_3d(data,xn,yn,zn,fpow,1);  
    free_f3tensor(data,1,xn,1,yn,1,zn);
    data = pow_data;
    get_min_max_3d_farray(data,1,xn,1,yn,1,zn,&min,&max);
    if (-min > max)
      multiply_3d_farray(data,1,xn,1,yn,1,zn,1.0/-min);
    else
      multiply_3d_farray(data,1,xn,1,yn,1,zn,1.0/max);
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data,1,xn,1,yn,1,zn,contrast*mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  stimx_noise(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL);  
  return data;
}
float ***get_stim_3d_ppl_image_set(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;  
     int tsamp;            
{
  int i,j,k;
  float ***data,mid,contrast,maxlum,bgval,bgamp,**tframe;
  stimx_image_set(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL);
  contrast  = param_getf_exit(ppl,"contrast");
  maxlum    = param_getf_exit(ppl,"maxlum");
  bgval     = param_getf_exit(ppl,"bgval");
  bgamp = 2.0*bgval - 1.0; 
  data = f3tensor(1,xn,1,yn,1,zn); 
  for(i=0;i<zn;i++){
    if ((i % tsamp) == 0){  
      stimx_image_set(ppl,xn,yn,zn,sscale,tscale,tsamp,i,1,&tframe);
      if (tframe != NULL){
	for(j=0;j<xn;j++)
	  for(k=0;k<yn;k++)
	    data[j+1][k+1][i+1] = tframe[j][k];
      }else{
	make_frame_flat(data,1,xn,1,yn,1,zn,i+1,bgamp);
      }
    }else{
      make_frame_flat(data,1,xn,1,yn,1,zn,i+1,-1.0); 
    }
  }
  mid = (float)maxlum/2.0;
  multiply_3d_farray(data,1,xn,1,yn,1,zn,contrast*mid);
  add_const_3d_farray(data,1,xn,1,yn,1,zn,mid);
  stimx_image_set(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL);  
  return data;
}
float ***get_stim_3d_ppl_barnoise(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp)
     char *mylogf;
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;  
     int tsamp;
{
  int i,j,k;
  float ***data,t,maxlum,t0,tn,bgval,**tframe,blackval;
  stimx_barnoise(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL,NULL);
  t0        = param_getf_exit(ppl,"st0");
  tn        = param_getf_exit(ppl,"stn");
  maxlum    = param_getf_exit(ppl,"maxlum");
  bgval     = param_getf_exit(ppl,"bgval");
  blackval = 2.0*bgval - maxlum;
  data = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;  
    if (((i-1)%tsamp) == 0){  
      if ((t >= t0) && (t < t0+tn)){
	stimx_barnoise(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframe,
		       NULL);
	for(j=0;j<xn;j++){
	  for(k=0;k<yn;k++){
	    data[j+1][k+1][i] = tframe[j][k];
	  }
	}
	free_2d_farray(tframe,xn);
      }else{
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
      }
    }else{
      make_frame_flat(data,1,xn,1,yn,1,zn,i,blackval); 
    }
  }
  stimx_barnoise(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL,NULL);
  return data;
}
void get_stim_3db_ppl_barnoise(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,rdl,rdr)
     char *mylogf;
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;  
     int tsamp;
     float ****rdl,****rdr;
{
  int i,j,k;
  float ***dl,***dr,t,maxlum,t0,tn,bgval,**tframl,**tframr;
  float blackval;
  stimx_barnoise(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL,NULL);
  t0        = param_getf_exit(ppl,"st0");
  tn        = param_getf_exit(ppl,"stn");
  maxlum    = param_getf_exit(ppl,"maxlum");
  bgval     = param_getf_exit(ppl,"bgval");
  blackval = 2.0*bgval - maxlum;
  dl = f3tensor(1,xn,1,yn,1,zn); 
  dr = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;  
    if (((i-1)%tsamp) == 0){  
      if ((t >= t0) && (t < t0+tn)){
	stimx_barnoise(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,
		       &tframl,&tframr);
	for(j=0;j<xn;j++){
	  for(k=0;k<yn;k++){
	    dl[j+1][k+1][i] = tframl[j][k];
	    dr[j+1][k+1][i] = tframr[j][k];
	  }
	}
	free_2d_farray(tframl,xn);
	free_2d_farray(tframr,xn);
      }else{
	make_frame_flat(dl,1,xn,1,yn,1,zn,i,bgval);
	make_frame_flat(dr,1,xn,1,yn,1,zn,i,bgval);
      }
    }else{
      make_frame_flat(dl,1,xn,1,yn,1,zn,i,blackval); 
      make_frame_flat(dr,1,xn,1,yn,1,zn,i,blackval); 
    }
  }
  stimx_barnoise(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL,NULL);
  *rdl = dl;
  *rdr = dr;
}
void get_stim_3db_ppl_bar1ran(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,rdl,rdr)
     char *mylogf;
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;  
     int tsamp;
     float ****rdl,****rdr;
{
  int i,j,k;
  float ***dl,***dr,t,t0,tn,bgval,maxlum,blackval,**tframl,**tframr;
  stimx_bar1ran(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL,NULL);
  t0        = param_getf_exit(ppl,"st0");
  tn        = param_getf_exit(ppl,"stn");
  bgval     = param_getf_exit(ppl,"bgval");
  maxlum    = param_getf_exit(ppl,"maxlum");
  blackval = 2.0*bgval - maxlum;  
  dl = f3tensor(1,xn,1,yn,1,zn); 
  dr = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;  
    if (((i-1)%tsamp) == 0){  
      if ((t >= t0) && (t < t0+tn)){
	stimx_bar1ran(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,
		      &tframl,&tframr);
	for(j=0;j<xn;j++){
	  for(k=0;k<yn;k++){
	    dl[j+1][k+1][i] = tframl[j][k];
	    dr[j+1][k+1][i] = tframr[j][k];
	  }
	}
	free_2d_farray(tframl,xn);
	free_2d_farray(tframr,xn);
      }else{
	make_frame_flat(dl,1,xn,1,yn,1,zn,i,bgval);
	make_frame_flat(dr,1,xn,1,yn,1,zn,i,bgval);
      }
    }else{
      make_frame_flat(dl,1,xn,1,yn,1,zn,i,blackval);
      make_frame_flat(dr,1,xn,1,yn,1,zn,i,blackval);
    }
  }
  stimx_bar1ran(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL,NULL);
  *rdl = dl;
  *rdr = dr;
}
float ***get_stim_3d_ppl_barpatmo(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i,j,k;
  float ***data,t,t0,tn,bgval,**tframe;
  stimx_barpatmo(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL);
  t0        = param_getf_exit(ppl,"st0");
  tn        = param_getf_exit(ppl,"stn");
  bgval     = param_getf_exit(ppl,"bgval");
  data = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;  
    if (((i-1)%tsamp) == 0){  
      if ((t >= t0) && (t < t0+tn)){
	stimx_barpatmo(ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframe);
	for(j=0;j<xn;j++){
	  for(k=0;k<yn;k++){
	    data[j+1][k+1][i] = tframe[j][k];
	  }
	}
	free_2d_farray(tframe,xn);
      }else{
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
      }
    }else{
      make_frame_flat(data,1,xn,1,yn,1,zn,i,0.0); 
    }
  }
  stimx_barpatmo(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL);  
  return data;
}
float ***get_stim_3d_ppl_dots(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp; 
{
  int i,j,k;
  float ***data,t,t0,tn,bgval,**tframe;
  stimx_dots(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL);
  t0        = param_getf_exit(ppl,"st0");
  tn        = param_getf_exit(ppl,"stn");
  bgval     = param_getf_exit(ppl,"bgval");
  data = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    if (((i-1)%tsamp) == 0){
      stimx_dots(ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframe);
      for(j=0;j<xn;j++){
	for(k=0;k<yn;k++){
	  data[j+1][k+1][i] = tframe[j][k];
	}
      }
      free_2d_farray(tframe,xn);
    }else
      make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
  }
  stimx_dots(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL);  
  return data;
}
float ***get_stim_3d_ppl_pasupathy_shape(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;               
{
  int i,j,k;
  float ***data,t,bgval,**tframe;
  stimx_pasupathy_shape(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL);
  bgval     = param_getf_exit(ppl,"bgval");
  data = f3tensor(1,xn,1,yn,1,zn); 
  for(i=1;i<=zn;i++){
    if (((i-1)%tsamp) == 0){
      stimx_pasupathy_shape(ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframe);
      for(j=0;j<xn;j++){
	for(k=0;k<yn;k++){
	  data[j+1][k+1][i] = tframe[j][k];
	}
      }
      free_2d_farray(tframe,xn);
    }else
      make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
  }
  stimx_pasupathy_shape(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL);
  return data;
}
float ***get_stim_3d_ppl_frameset(mylogf,s,ppl,xn,yn,zn,sscale,tscale,tsamp)
     char *mylogf;
     struct stim_struct *s;
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int txn,tyn,ttn,drange,fcode,binoc,colcode;
  float ***data;
  char *stim_file,*path,infile[SLEN],ggstr[SLEN];
  mylog(mylogf,"  GET_STIM_3D_PPL_FRAMESET\n");
  stim_file = paramfile_get_char_param_or_exit(ppl,"filename");
  path = get_path_without_name(s->paramfile);
  sprintf(infile,"%s%s",path,stim_file);
  sprintf(ggstr,"    Reading  %s\n",infile);
  mylog(mylogf,ggstr);
  drange = 0;
  data = data_util_fst_read(infile,drange,&txn,&tyn,&ttn,&fcode,&binoc,
			    &colcode);
  sprintf(ggstr,"    %d x %d x %d  (binoc %d, fcode %d, color %d, range %d)\n",
	  txn,tyn,ttn,binoc,fcode,colcode,drange);
  mylog(mylogf,ggstr);
  if ((xn != txn)||(yn != tyn)||(zn != ttn)){
    exit_error("GET_STIM_3D_PPL_FRAMESET","Stimulus size mismatch");
  }
  return data;
}
float ***get_stim_3d_ppl_upload(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i,k;
  int dxn,dyn,dtn,nbytes,tcode,winx0,winy0,winxn,winyn,destx0,desty0;
  float ***data,***d,bgval,maxlum,t0,stim_samp,mod_samp,t,stim_max;
  char *data_format,*stim_path,*stim_file,infile[SLEN];
  data_format  =  paramfile_get_char_param_or_exit(ppl,"data_format");
  stim_path    =  paramfile_get_char_param_or_exit(ppl,"stim_path");
  stim_file    =  paramfile_get_char_param_or_exit(ppl,"stim_file");
  stim_max     = param_getf_exit(ppl,"stim_max");
  bgval        = param_getf_exit(ppl,"bgval");
  t0           = param_getf_exit(ppl,"t0");
  stim_samp    = param_getf_exit(ppl,"stim_samp");
  mod_samp = my_rint(1.0/tscale);
  if (stim_samp > mod_samp){
    printf("    stim_samp = %f   >   tscale = %f\n",stim_samp,tscale);
    exit_error("GET_STIM_3D_PPL_UPLOAD","stim_samp is too high");
  }
  sprintf(infile,"%s/%s",stim_path,stim_file);
  if (strcmp(data_format,"3d")==0){
    read_3d_data(infile,&d,&dxn,&dyn,&dtn,&nbytes,&tcode,1);
    if ((nbytes != 4) || (tcode != 2))
      exit_error("GET_STIM_3D_PPL_UPLOAD","Expecting 4 byte float format");
  }else
    exit_error("GET_STIM_3D_PPL_UPLOAD","Unknown data format");
  myfree(data_format); myfree(stim_path); myfree(stim_file);
  if ((dxn != xn) || (dyn != yn)){
    printf("  Data:  %d X %d\n",dxn,dyn);
    exit_error("GET_STIM_3D_PPL_UPLOAD","Spatial size does not match model");
  }
  multiply_3d_farray(d,0,dxn,0,dyn,0,dtn,1.0/stim_max);
  data = f3tensor(1,xn,1,yn,1,zn); 
  maxlum = 1.0;           
  destx0 = desty0 = 1;
  winx0 = winy0 = 0;
  winxn = xn;
  winyn = yn;
  k = 0; 
  for(i=1;i<=zn;i++){
    t = (float)(i-1)*tscale;
    if (((i-1)%tsamp) == 0){
      if ((t >= t0) && (k < dtn)){  
	make_frame_from_3d(data,1,xn,1,yn,1,zn,i,d,dxn,dyn,dtn,k,winx0,winy0,
			   winxn,winyn,destx0,desty0,bgval,maxlum);
	k += 1;
      }else
	make_frame_flat(data,1,xn,1,yn,1,zn,i,bgval);
    }else
      make_frame_flat(data,1,xn,1,yn,1,zn,i,-1.0);
  }
  return data;
}
int ***get_stim_3c_ppl_sine(mylogf,ppl,xn,yn,zn,sscale,tscale,tsamp)
     char *mylogf;
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int ***data;
  float ***fdata,***smooth;
  float r0,g0,b0,r1,g1,b1;
  fdata = get_stim_3d_ppl_sine(ppl,xn,yn,zn,sscale,tscale,tsamp);
  smooth = stim_util_blur(mylogf,ppl,fdata,xn,yn,zn,sscale,tscale);
  if (smooth != NULL){
    free_f3tensor(fdata,1,xn,1,yn,1,zn);
    fdata = smooth;
  }
  r0 = param_getf_exit(ppl,"color0_r");
  g0 = param_getf_exit(ppl,"color0_g");
  b0 = param_getf_exit(ppl,"color0_b");
  r1 = param_getf_exit(ppl,"color1_r");
  g1 = param_getf_exit(ppl,"color1_g");
  b1 = param_getf_exit(ppl,"color1_b");
  data = stim_util_3c_2col_from_3d(fdata,1,xn,1,yn,1,zn,r0,g0,b0,r1,g1,b1);
  free_f3tensor(fdata,1,xn,1,yn,1,zn);
  return data;
}
int ***get_stim_3c_ppl_noise(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int ***data,ncol;
  float ***fdata;
  float r0,g0,b0,r1,g1,b1,r2,g2,b2,r3,g3,b3;
  float bg_r,bg_g,bg_b,bgval;
  fdata = get_stim_3d_ppl_noise(ppl,xn,yn,zn,sscale,tscale,tsamp);
  r0 = param_getf_exit(ppl,"color0_r");
  g0 = param_getf_exit(ppl,"color0_g");
  b0 = param_getf_exit(ppl,"color0_b");
  r1 = param_getf_exit(ppl,"color1_r");
  g1 = param_getf_exit(ppl,"color1_g");
  b1 = param_getf_exit(ppl,"color1_b");
  if (paramfile_test_param(ppl,"bg_r")){ 
    bg_r = param_getf_exit(ppl,"bg_r");
    bg_g = param_getf_exit(ppl,"bg_g");
    bg_b = param_getf_exit(ppl,"bg_b");
  }else{
    bgval = param_getf_exit(ppl,"bgval"); 
    bg_r = bg_g = bg_b = bgval;
  }
  ncol = param_geti_dflt(ppl,"n_color",2);
  if (ncol == 4){
    r2 = param_getf_exit(ppl,"color2_r");
    g2 = param_getf_exit(ppl,"color2_g");
    b2 = param_getf_exit(ppl,"color2_b");
    r3 = param_getf_exit(ppl,"color3_r");
    g3 = param_getf_exit(ppl,"color3_g");
    b3 = param_getf_exit(ppl,"color3_b");
    data = stim_util_3c_4col_from_3d(fdata,1,xn,1,yn,1,zn,r0,g0,b0,r1,g1,b1,
				     r2,g2,b2,r3,g3,b3,bg_r,bg_g,bg_b);
  }else{
    data = stim_util_3c_2col_from_3d(fdata,1,xn,1,yn,1,zn,r0,g0,b0,r1,g1,b1);
  }
  free_f3tensor(fdata,1,xn,1,yn,1,zn);
  return data;
}
int ***get_stim_3c_ppl_surrt(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int ***data;
  float ***fdata;
  float r0,g0,b0,r1,g1,b1;
  fdata = get_stim_3d_ppl_surrt(ppl,xn,yn,zn,sscale,tscale,tsamp);
  r0 = param_getf_exit(ppl,"color0_r");
  g0 = param_getf_exit(ppl,"color0_g");
  b0 = param_getf_exit(ppl,"color0_b");
  r1 = param_getf_exit(ppl,"color1_r");
  g1 = param_getf_exit(ppl,"color1_g");
  b1 = param_getf_exit(ppl,"color1_b");
  data = stim_util_3c_2col_from_3d(fdata,1,xn,1,yn,1,zn,r0,g0,b0,r1,g1,b1);
  free_f3tensor(fdata,1,xn,1,yn,1,zn);
  return data;
}
int ***get_stim_3c_ppl_rgb_sine(ppl,xn,yn,zn,sscale,tscale,tsamp)
     struct param_pair_list *ppl;
     int xn,yn,zn;
     float sscale,tscale;
     int tsamp;
{
  int i,j,k;
  int ***data,**tframe,bgval;
  float r0,g0,b0,sv;
  r0        = param_getf_exit(ppl,"r_offset");
  g0        = param_getf_exit(ppl,"g_offset");
  b0        = param_getf_exit(ppl,"b_offset");
  sv        = param_getf_exit(ppl,"c_scale");
  bgval = data_util_t11_int_for_rgb(sv*r0,sv*g0,sv*b0);
  stimx_rgb_sine(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,0,NULL);
  data = get_3d_iarray(xn,yn,zn);
  for(i=0;i<zn;i++){
    if ((i%tsamp) == 0){
      stimx_rgb_sine(ppl,xn,yn,zn,sscale,tscale,tsamp,i-1,1,&tframe);
      for(j=0;j<xn;j++){
	for(k=0;k<yn;k++){
	  data[j][k][i] = tframe[j][k];
	}
      }
      free_2d_iarray(tframe,xn);
    }else{
      for(j=0;j<xn;j++){
	for(k=0;k<yn;k++){
	  data[j][k][i] = bgval;
	}
      }
    }
  }
  stimx_rgb_sine(ppl,xn,yn,zn,sscale,tscale,tsamp,-1,-1,NULL);
  return data;
}
float ***get_stim_3d_ppl(mylogf,s,xn,yn,tn,sscale,tscale,tsamp)
     char *mylogf;
     struct stim_struct *s;  
     int xn,yn,tn;
     float sscale,tscale;
     int tsamp;
{
  float ***d;
  char ggstr[SLEN];
  struct param_pair_list *sppl;
  char *stimtype;
  sppl = s->ppl;
  stimtype = param_getc_exit(sppl,"stim_type");
  if (strcmp(stimtype,"adamk")==0){
    d = get_stim_3d_ppl_adamk(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"disk")==0){
    d = get_stim_3d_ppl_disk(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"sine")==0){
    d = get_stim_3d_ppl_sine(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"sine_seq")==0){
    d = get_stim_3d_ppl_sine_seq(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"sos")==0){
    d = get_stim_3d_ppl_sos(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"pixel")==0){
    d = get_stim_3d_ppl_pixel(mylogf,sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"bar")==0){
    d = get_stim_3d_ppl_bar(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"barnoise")==0){
    d = get_stim_3d_ppl_barnoise(mylogf,sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"barpatmo")==0){
    d = get_stim_3d_ppl_barpatmo(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"barray")==0){
    d = get_stim_3d_ppl_barray(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"barray_old")==0){
    d = get_stim_3d_ppl_barray_old(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"bar2ran")==0){
    d = get_stim_3d_ppl_bar2ran(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"cpsine")==0){
    d = get_stim_3d_ppl_cpsine(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"plaid")==0){
    d = get_stim_3d_ppl_plaid(mylogf,sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"dmmask")==0){
    d = get_stim_3d_ppl_dmmask(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"dirmod")==0){
    d = get_stim_3d_ppl_dirmod(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"surrt")==0){
    d = get_stim_3d_ppl_surrt(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"wy4st")==0){
    d = get_stim_3d_ppl_wy4st(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"x4st")==0){
    d = get_stim_3d_ppl_x4st(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"wy2pa")==0){
    d = get_stim_3d_ppl_wy2pa(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"grid")==0){
    exit_error("GET_STIM_3D_PPL","'grid' has been changed to 'noise'");
  }else if (strcmp(stimtype,"noise")==0){
    d = get_stim_3d_ppl_noise(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"gp")==0){
    d = get_stim_3d_ppl_gp(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"ransinphase")==0){
    d = get_stim_3d_ppl_ransinphase(sppl,xn,yn,tn,sscale,tscale,tsamp,0);
  }else if (strcmp(stimtype,"ransinori")==0){
    d = get_stim_3d_ppl_ransinphase(sppl,xn,yn,tn,sscale,tscale,tsamp,1);
  }else if (strcmp(stimtype,"ransindir")==0){
    d = get_stim_3d_ppl_ransinphase(sppl,xn,yn,tn,sscale,tscale,tsamp,2);
  }else if (strcmp(stimtype,"ran_sin")==0){
    d = get_stim_3d_ppl_ran_sin(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"ranstep")==0){
    d = get_stim_3d_ppl_ranstep(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"test_shape")==0){
    d = get_stim_3d_ppl_test_shape(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"dots")==0){
    d = get_stim_3d_ppl_dots(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"dynedge")==0){
    d = get_stim_3d_ppl_dynedge(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"pasupathy_shape")==0){
    d = get_stim_3d_ppl_pasupathy_shape(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"upload")==0){
    d = get_stim_3d_ppl_upload(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"frameset")==0){
    d = get_stim_3d_ppl_frameset(mylogf,s,sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"image_set")==0){
    mylog(mylogf,"    Constructing stimulus from image set ...\n");
    d = get_stim_3d_ppl_image_set(sppl,xn,yn,tn,sscale,tscale,tsamp);
    mylog(mylogf,"    ... done.\n");
  }else if (strcmp(stimtype,"null")==0){
    d = NULL;
  }else{
    sprintf(ggstr,"stimtype %s\n",stimtype);
    mylog(mylogf,ggstr);
    mylogx(mylogf,"GET_STIM_3D_PPL","Unknown stimulus type");
  }
  myfree(stimtype);
  return d;
}
int ***get_stim_3c_ppl(mylogf,stimtype,sppl,xn,yn,tn,sscale,tscale,tsamp)
     char *mylogf;
     char *stimtype;
     struct param_pair_list *sppl;
     int xn,yn,tn;
     float sscale,tscale;
     int tsamp;
{
  int ***d;
  if (strcmp(stimtype,"sine")==0){
    d = get_stim_3c_ppl_sine(mylogf,sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"grid")==0){
    exit_error("GET_STIM_3C_PPL","'grid' has been changed to 'noise'");
  }else if (strcmp(stimtype,"noise")==0){
    d = get_stim_3c_ppl_noise(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"surrt")==0){
    d = get_stim_3c_ppl_surrt(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else if (strcmp(stimtype,"rgb_sine")==0){
    d = get_stim_3c_ppl_rgb_sine(sppl,xn,yn,tn,sscale,tscale,tsamp);
  }else{
    printf("stimtype %s\n",stimtype);
    exit_error("GET_STIM_3C_PPL","Unknown stimulus type");
  }
  return d;
}
void get_stim_3d_b_ppl(mylogf,stimtype,sppl,xn,yn,tn,sscale,tscale,tsamp,
		       rdl,rdr)  
     char *mylogf;
     char *stimtype;
     struct param_pair_list *sppl;
     int xn,yn,tn;
     float sscale,tscale;
     int tsamp;
     float ****rdl,****rdr;
{
  float ***dr,***dl;
  if (strcmp(stimtype,"dot_stereo")==0){
    dl = (float ***)NULL;
    dr = (float ***)NULL;
  }else if (strcmp(stimtype,"sine")==0){
    get_stim_3db_ppl_sine(sppl,xn,yn,tn,sscale,tscale,tsamp,&dl,&dr);
  }else if (strcmp(stimtype,"randot_stereogram")==0){
    get_stim_3db_ppl_randot_stereogram(sppl,xn,yn,tn,sscale,tscale,tsamp,
				       &dl,&dr);
  }else if (strcmp(stimtype,"rds_disp_mod")==0){
    get_stim_3db_ppl_randot_stereogram(sppl,xn,yn,tn,sscale,tscale,tsamp,
				       &dl,&dr);
  }else if (strcmp(stimtype,"barnoise")==0){
    get_stim_3db_ppl_barnoise(mylogf,sppl,xn,yn,tn,sscale,tscale,tsamp,
			      &dl,&dr);
  }else if (strcmp(stimtype,"bar1ran")==0){
    get_stim_3db_ppl_bar1ran(mylogf,sppl,xn,yn,tn,sscale,tscale,tsamp,
			       &dl,&dr);
  }else if (strcmp(stimtype,"bar")==0){
    get_stim_3db_ppl_bar(mylogf,sppl,xn,yn,tn,sscale,tscale,tsamp,
			 &dl,&dr);
  }else if (strcmp(stimtype,"plaid")==0){
    get_stim_3db_ppl_plaid(mylogf,sppl,xn,yn,tn,sscale,tscale,tsamp,&dl,&dr);
  }else if (strcmp(stimtype,"dirmod")==0){
    get_stim_3db_ppl_dirmod(mylogf,sppl,xn,yn,tn,sscale,tscale,tsamp,&dl,&dr);
  }else{
    printf("stimtype %s\n",stimtype);
    exit_error("GET_STIM_3D_B_PPL","Unknown stimulus type");
  }
  *rdl = dl;
  *rdr = dr;
}
float **stim_get_2d_impulse(xn,yn,x0,y0,ampl0,ampl)
     int xn,yn,x0,y0;
     float ampl0,ampl;
{
  float **s;
  s = get_zero_2d_farray(xn,yn);
  add_const_2d_farray(s,0,xn,0,yn,ampl0);
  s[x0][y0] = ampl;
  return s;
}
float **stim_make_xt_impulse(p)
     struct param_pair_list *p;
{
  int xn,tn,x0,t0;
  float **s,stim_null,ampl;
  xn = paramfile_get_int_param_or_exit(p,"xn");
  tn = paramfile_get_int_param_or_exit(p,"tn");
  x0 = paramfile_get_int_param_or_exit(p,"stim_x0");
  t0 = paramfile_get_int_param_or_exit(p,"stim_t0");
  stim_null = param_getf_exit(p,"stim_null");
  ampl = param_getf_exit(p,"stim_ampl");
  s = stim_get_2d_impulse(xn,tn,x0,t0,stim_null,ampl);
  return s;
}
float **stim_make_xt_drifting_grating(p)
     struct param_pair_list *p;
{
  int i,j;
  int xn,tn,x0,stim_xn,t0,stim_tn,dt,dir;
  float tt,**s,sscale,tscale,sf,tf,phase,stim_null,ampl,ampl0;
  xn = paramfile_get_int_param_or_exit(p,"xn");
  tn = paramfile_get_int_param_or_exit(p,"tn");
  sscale = param_getf_exit(p,"sscale");
  tscale = param_getf_exit(p,"tscale");
  x0 = paramfile_get_int_param_or_exit(p,"stim_x0");
  stim_xn = paramfile_get_int_param_or_exit(p,"stim_xn");
  t0 = paramfile_get_int_param_or_exit(p,"stim_t0");
  stim_tn = paramfile_get_int_param_or_exit(p,"stim_tn");
  dt = paramfile_get_int_param_or_exit(p,"stim_dt");
  sf = param_getf_exit(p,"stim_sf");       
  tf = param_getf_exit(p,"stim_tf");       
  dir = paramfile_get_int_param_or_exit(p,"stim_dir");     
  phase = param_getf_exit(p,"stim_phase"); 
  stim_null = param_getf_exit(p,"stim_null");
  ampl0 = param_getf_exit(p,"stim_ampl0");
  ampl = param_getf_exit(p,"stim_ampl");
  phase /= 360.0; 
  s = (float **)myalloc(tn*sizeof(float *));
  tf *= (float)dir;
  for(i=0;i<tn;i++){
    s[i] = (float *)myalloc(xn*sizeof(float));
    if ((i%dt) == 0){
      if ((i > t0)&&(i < t0+stim_tn)){
	tt = (float)(i-t0)*tscale*tf;
	for(j=0;j<xn;j++){
	  if ((j >= x0)&&(j < x0+stim_xn))
	    s[i][j] = ampl0 + ampl*sin(((float)(j-x0)*sscale*sf - phase - tt) *
				       2.0*M_PI);
	  else
	    s[i][j] = ampl0;
	}
      }else{
	for(j=0;j<xn;j++)
	  s[i][j] = ampl0;
      }
    }else{
      for(j=0;j<xn;j++)
	s[i][j] = stim_null; 
    }
  }
  transpose_2d_farray(&s,tn,xn);
  return s;
}
float **stim_make_xt_jumping_grating(p)
     struct param_pair_list *p;
{
  int i,j;
  int xn,tn,x0,stim_xn,t0,stim_tn,dt,dir,seed;
  float **s,sscale,tscale,sf,tf,phase,stim_null,ampl,ampl0,delta;
  xn = paramfile_get_int_param_or_exit(p,"xn");
  tn = paramfile_get_int_param_or_exit(p,"tn");
  sscale = param_getf_exit(p,"sscale");
  tscale = param_getf_exit(p,"tscale");
  x0 = paramfile_get_int_param_or_exit(p,"stim_x0");
  stim_xn = paramfile_get_int_param_or_exit(p,"stim_xn");
  t0 = paramfile_get_int_param_or_exit(p,"stim_t0");
  stim_tn = paramfile_get_int_param_or_exit(p,"stim_tn");
  dt = paramfile_get_int_param_or_exit(p,"stim_dt");
  sf = param_getf_exit(p,"stim_sf");       
  tf = param_getf_exit(p,"stim_tf");       
  dir = paramfile_get_int_param_or_exit(p,"stim_dir");     
  phase = param_getf_exit(p,"stim_phase"); 
  stim_null = param_getf_exit(p,"stim_null");
  ampl0 = param_getf_exit(p,"stim_ampl0");
  ampl = param_getf_exit(p,"stim_ampl");
  seed = paramfile_get_int_param_or_exit(p,"stim_jumpseed");
  if (seed > 0)
    seed *= -1;
  delta = tf * tscale * (float)dt;
  printf("delta = %f\n",delta);
  phase /= 360.0; 
  s = (float **)myalloc(tn*sizeof(float *));
  tf *= (float)dir;
  for(i=0;i<tn;i++){
    s[i] = (float *)myalloc(xn*sizeof(float));
    if ((i%dt) == 0)
      if ((i > t0)&&(i < t0+stim_tn)){
	if (myrand_util_ran2(&seed) > 0.5)
	  phase -= delta;
	else
	  phase += delta;
	for(j=0;j<xn;j++)
	  if ((j >= x0)&&(j < x0+stim_xn))
	    s[i][j] = ampl0 + ampl*sin(((float)(j-x0)*sscale*sf - phase)*
				       2.0*M_PI);
	  else
	    s[i][j] = ampl0;
      }else
	for(j=0;j<xn;j++)
	  s[i][j] = ampl0;
    else
      for(j=0;j<xn;j++)
	s[i][j] = stim_null; 
  }
  transpose_2d_farray(&s,tn,xn);
  return s;
}
float **stim_make_xt_amc_grating(p)
     struct param_pair_list *p;
{
  int i,j;
  int xn,tn,x0,stim_xn,t0,stim_tn,dt,dir,seed,curramp,step,maxamp;
  float tt,**s,sscale,tscale,sf,tf,phase,stim_null,ampl,ampl0;
  xn = paramfile_get_int_param_or_exit(p,"xn");
  tn = paramfile_get_int_param_or_exit(p,"tn");
  sscale = param_getf_exit(p,"sscale");
  tscale = param_getf_exit(p,"tscale");
  x0 = paramfile_get_int_param_or_exit(p,"stim_x0");
  stim_xn = paramfile_get_int_param_or_exit(p,"stim_xn");
  t0 = paramfile_get_int_param_or_exit(p,"stim_t0");
  stim_tn = paramfile_get_int_param_or_exit(p,"stim_tn");
  dt = paramfile_get_int_param_or_exit(p,"stim_dt");
  sf = param_getf_exit(p,"stim_sf");       
  tf = param_getf_exit(p,"stim_tf");       
  dir = paramfile_get_int_param_or_exit(p,"stim_dir");     
  phase = param_getf_exit(p,"stim_phase"); 
  stim_null = param_getf_exit(p,"stim_null");
  ampl0 = param_getf_exit(p,"stim_ampl0");
  seed = paramfile_get_int_param_or_exit(p,"stim_jumpseed");
  step = paramfile_get_int_param_or_exit(p,"stim_step");
  maxamp = paramfile_get_int_param_or_exit(p,"stim_maxamp");
  if (seed > 0)
    seed *= -1;
  phase /= 360.0; 
  s = (float **)myalloc(tn*sizeof(float *));
  tf *= (float)dir;
  curramp = 0;
  for(i=0;i<tn;i++){
    s[i] = (float *)myalloc(xn*sizeof(float));
    if ((i%dt) == 0)
      if ((i > t0)&&(i < t0+stim_tn)){
	if (myrand_util_ran2(&seed) > 0.5)
	  curramp -= step;
	else
	  curramp += step;
	while((curramp < -maxamp)||(curramp > maxamp)){
	  if (curramp > maxamp)
	    curramp = maxamp-(curramp-maxamp); 
	  if (curramp < -maxamp)
	    curramp = -maxamp-(curramp+maxamp); 
	}
	ampl = (float)curramp/maxamp;
	tt = (float)(i-t0)*tscale*tf;
	for(j=0;j<xn;j++)
	  if ((j >= x0)&&(j < x0+stim_xn))
	    s[i][j] = ampl0 + ampl*sin(((float)(j-x0)*sscale*sf - phase - tt)*
				       2.0*M_PI);
	  else
	    s[i][j] = ampl0;
      }else
	for(j=0;j<xn;j++)
	  s[i][j] = ampl0;
    else
      for(j=0;j<xn;j++)
	s[i][j] = stim_null; 
  }
  transpose_2d_farray(&s,tn,xn);
  return s;
}
float **stim_make_xt_sumosin_grating(p)
     struct param_pair_list *p;
{
  int i,j;
  int xn,tn,x0,stim_xn,t0,stim_tn,dt,vskn,pcomp;
  float **s,sscale,tscale,sf,phase,stim_null,ampl,ampl0,sos_ampl,pratio;
  float *tmp;
  vskn = paramfile_get_int_param_or_exit(p,"stim_vsk_n");
  xn = paramfile_get_int_param_or_exit(p,"xn");
  tn = paramfile_get_int_param_or_exit(p,"tn");
  sscale = param_getf_exit(p,"sscale");
  tscale = param_getf_exit(p,"tscale");
  x0 = paramfile_get_int_param_or_exit(p,"stim_x0");
  stim_xn = paramfile_get_int_param_or_exit(p,"stim_xn");
  t0 = paramfile_get_int_param_or_exit(p,"stim_t0");
  stim_tn = paramfile_get_int_param_or_exit(p,"stim_tn");
  dt = paramfile_get_int_param_or_exit(p,"stim_dt");
  sf = param_getf_exit(p,"stim_sf");       
  phase = param_getf_exit(p,"stim_phase"); 
  stim_null = param_getf_exit(p,"stim_null");
  ampl0 = param_getf_exit(p,"stim_ampl0");
  ampl = param_getf_exit(p,"stim_ampl");
  pcomp = paramfile_get_int_param_default(p,"stim_vsk_perturb_comp",-1);
  pratio = paramfile_get_float_param_default(p,"stim_vsk_perturb_ratio",1.0);
  tmp = get_zero_farray(tn);
  phase /= 360.0; 
  s = (float **)myalloc(tn*sizeof(float *));
  for(i=0;i<tn;i++){
    s[i] = (float *)myalloc(xn*sizeof(float));
    if ((i%dt) == 0)
      if ((i > t0)&&(i < t0+stim_tn)){
	tmp[i]   =        get_vsk_sum_of_sinusoids(vskn,pcomp,pratio,
						   (float)(i-t0)*tscale);
	sos_ampl = ampl * get_vsk_sum_of_sinusoids(vskn,pcomp,pratio,
						   (float)(i-t0)*tscale);
	for(j=0;j<xn;j++)
	  if ((j >= x0)&&(j < x0+stim_xn))
	    s[i][j] = ampl0 + sos_ampl*sin(((float)(j-x0)*sscale*sf - phase)*
					   2.0*M_PI);
	  else
	    s[i][j] = ampl0;
      }else
	for(j=0;j<xn;j++)
	  s[i][j] = ampl0;
    else
      for(j=0;j<xn;j++)
	s[i][j] = stim_null; 
  }
  transpose_2d_farray(&s,tn,xn);
  append_farray_plot("zzt.VSK.pl","VSKt",tmp,tn,1);
  return s;
}
float **get_xt_stim(p)
     struct param_pair_list *p;
{
  char *stimtype;
  float **s;
  stimtype = paramfile_get_char_param_or_exit(p,"stim_type");
  s = NULL;
  if (strcmp(stimtype,"xt_drifting_grating")==0)
    s = stim_make_xt_drifting_grating(p);
  else if (strcmp(stimtype,"xt_jumping_grating")==0)
    s = stim_make_xt_jumping_grating(p);
  else if (strcmp(stimtype,"xt_amc_grating")==0)
    s = stim_make_xt_amc_grating(p);
  else if (strcmp(stimtype,"xt_sumosin_grating")==0)
    s = stim_make_xt_sumosin_grating(p);
  else if (strcmp(stimtype,"xt_impulse")==0)
    s = stim_make_xt_impulse(p);
  else
    exit_error("GET_XT_STIM","Unknown stim_type");
  myfree(stimtype);
  return s;
}
float **compute_fprod_array(stim,x0,xn,y0,yn,z0,zn,filter,fx0,fxn,fy0,fyn,
			    fz0,fzn)
     float ***stim;
     int x0,xn,y0,yn,z0,zn;
     float ***filter;
     int fx0,fxn,fy0,fyn,fz0,fzn;
{
  int i,j,k,l,jrev;
  float **fprod,sum,norm,**pf,**ps;
  int xoff,yoff,xc,yc;
  xoff = x0 + (xn-fxn)/2;
  yoff = y0 + (yn-fyn)/2;
  xc = xoff-fx0;
  yc = yoff-fy0;
  norm = (float)(fxn*fyn);
  fprod = get_2d_farray(zn,fzn);
  for(i=z0;i<(z0+zn);i++){ 
    for(j=fz0;j<(fz0+fzn);j++){
      jrev = 2*fz0+fzn - j - 1; 
      sum = 0.0;
      for(k=fx0;k<(fx0+fxn);k++){
	pf = filter[k];
	ps = stim[k+xc];
	for(l=fy0;l<(fy0+fyn);l++)
	  sum += pf[l][jrev] * ps[l+yc][i];
      }
      fprod[i-z0][j-fz0] = sum/norm;
    }
  }
  return fprod;
}
float **compute_fprod_array_periodic(stim,x0,xn,y0,yn,z0,zn,period,
				     filter,fx0,fxn,fy0,fyn,fz0,fzn)
     float ***stim;
     int x0,xn,y0,yn,z0,zn,period;
     float ***filter;
     int fx0,fxn,fy0,fyn,fz0,fzn;
{
  int i,j,k,l,jrev;
  float **fprod,sum,norm;
  int xoff,yoff,xc,yc;
  xoff = x0 + (xn-fxn)/2;
  yoff = y0 + (yn-fyn)/2;
  xc = xoff-fx0;
  yc = yoff-fy0;
  norm = (float)(fxn*fyn);
  fprod = (float **)myalloc(zn*sizeof(float *));
  for(i=z0;i<(z0+period);i++){ 
    fprod[i-z0] = (float *)myalloc(fzn*sizeof(float));
    for(j=fz0;j<(fz0+fzn);j++){
      jrev = j; 
      sum = 0.0;
      for(k=fx0;k<(fx0+fxn);k++)
	for(l=fy0;l<(fy0+fyn);l++)
	  sum += filter[k][l][jrev]*stim[k+xc][l+yc][i];
      fprod[i-z0][j-fz0] = sum/norm;
    }
  }
  for(i=(z0+period);i<(z0+zn);i++){ 
    k = (i-z0)%period + z0;
    fprod[i-z0] = fprod[k];
  }
  return fprod;
}
float *get_response_from_fprod(fprod,nstim,nfilt,fseq,nfr,mag,t0flag,tdelay)
     float **fprod;
     int nstim,nfilt,*fseq,nfr,mag,t0flag,tdelay;
{
  int i,j,k,jstim;
  int n,dtmi,a,b,t1,t2,t,dt;
  float *response,r;
  if (t0flag == 0)
    dt = nfilt-1 + tdelay;
  else
    dt = nfilt/2 + tdelay;
  n = mag*nfr;
  response = get_zero_farray(n);
  for(i=0;i<n;i++){
    a = i-dt;  
    b = a + nfilt-1;
    if (a<0)
      t1 = 0;
    else
      t1 = a;
    if (b >= n)
      t2 = n-1;
    else
      t2 = b;
    t = t1+mag-1 - ((t1+mag-1)%mag);
    k = t/mag; 
    dtmi = dt-i; 
    r = 0.0;
    for(j=t;j<=t2;j+=mag){
      jstim = fseq[k++]; 
      r += fprod[jstim][j + dtmi];
    }
    response[i] = r;
  }
  return response;
}
void time_domain_response(mtype,stim,x0,xn,y0,yn,z0,zn,period,filter,fx0,fxn,
			  fy0,fyn,fz0,fzn,stim_samp,filt_samp,fseq,nseq,rresp,
			  rn)
     int mtype;
     float ***stim;
     int x0,xn,y0,yn,z0,zn,period;
     float ***filter;
     int fx0,fxn,fy0,fyn,fz0,fzn;
     float stim_samp,filt_samp;  
     int *fseq,nseq;
     float **rresp;
     int *rn;
{
  int i;
  float *response,**fprod;
  int mag,n,*tseq;
  if ((period > 0) && (mtype == 0))
    fprod = compute_fprod_array_periodic(stim,x0,xn,y0,yn,z0,zn,period,
					 filter,fx0,fxn,fy0,fyn,fz0,fzn);
  else
    fprod = compute_fprod_array(stim,x0,xn,y0,yn,z0,zn,filter,fx0,fxn,fy0,fyn,
				fz0,fzn);
  mag = (int)(0.5 + filt_samp/stim_samp);
  n = mag * nseq;
  tseq = (int *)myalloc(nseq*sizeof(int));
  if (mtype == 0){
    for(i=0;i<nseq;i++){
      tseq[i] = fseq[i]%NPAT;
      if (tseq[i] != fseq[i])
	printf("WYETH *\n");
    }
  }else if (mtype == 1){
    for(i=0;i<nseq;i++){
      tseq[i] = fseq[i];
      if (tseq[i] >= NAMP)
	printf("WYETH * ERROR *\n");
    }
  }
  response = get_response_from_fprod(fprod,zn,fzn,tseq,nseq,mag,1,0);
  if (period > 0){
    for(i=0;i<period;i++)
      myfree(fprod[i]);
    myfree(fprod);
  }else
    free_2d_farray(fprod,zn);
  myfree(tseq);
  *rresp = response;
  *rn = n;
}
int *sine_pattern(n,sper,max_amp)
     int n,sper,max_amp;
{
  int i;
  int *p;
  float cf;
  if (max_amp > 512)
    max_amp = 512;
  cf = 2.0*M_PI/(float)sper;
  p = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++){
    p[i] = (int)((float)max_amp*sin(cf*(float)i)) + 512;
    if (p[i] > 1024)
      p[i] = 1024;
    else if (p[i] < 0)
      p[i] = 0;
  }
  return p;
}
void make_frame_set_pos_noise(min_wavlen,wh,rstim,x0,xn,y0,yn,z0,zn,hpos)
     int min_wavlen,wh; 
     float ****rstim;
     int *x0,*xn,*y0,*yn,*z0,*zn,hpos;
{
  int i,j,k,l;
  int *pattern,win_w,win_h,bar_width,patamp,nframes,pati;
  float ***stim; 
  bar_width = 1;
  patamp = 512;
  nframes = NPAT; 
  win_w = win_h = wh;
  if ((hpos < 0)||((hpos+win_w/bar_width) > NPAT)){
    printf("hpos = %d\n",hpos);
    exit_error("MAKE_FRAME_SET_POS_NOISE","Invalid hpos");
  }
  pattern = sine_pattern(NPAT,min_wavlen,patamp);
  stim = f3tensor(1,win_w,1,win_h,1,nframes);
  for(i=0;i<nframes;i++){
    for(j=0;j<(win_w/bar_width);j++){ 
      pati = (i+hpos+j)%NPAT;
      for(l=0;l<bar_width;l++) 
	for(k=1;k<=win_h;k++){
	  stim[bar_width*j+l+1][k][i+1] = (float)pattern[pati]/4 - 128.0;
	}
    }
  }
  *rstim = stim;
  *x0 = *y0 = *z0 = 1;
  *xn = win_w; *yn = win_h;
  *zn = nframes;
}
void make_frame_set_wyphasm_noise(sper,nsper,rstim,x0,xn,y0,yn,z0,zn,hpos)
     int sper,nsper;
     float ****rstim;
     int *x0,*xn,*y0,*yn,*z0,*zn,hpos;
{
  int i,j,k;
  int *pattern,win_w,win_h,patamp,nframes,pati,tsper,tpos;
  float ***stim; 
  patamp = 512;
  nframes = 2*nsper;
  win_w = win_h = 64;
  stim = f3tensor(1,win_w,1,win_h,1,nframes);
  if ((hpos < 0)||((hpos+win_w) > NPAT))
    exit_error("MAKE_FRAME_SET_WYPHASM_NOISE","Invalid hpos");
  tsper = sper;
  for(i=0;i<nsper;i++){
    pattern = sine_pattern(NPAT,tsper,patamp);
    tpos = NPAT + tsper/4 - win_w/2; 
    for(j=0;j<win_w;j++){ 
      pati = (tpos+hpos+j + tsper/2)%NPAT;
      for(k=1;k<=win_h;k++)
	stim[j+1][k][i*2+1] = (float)pattern[pati]/4 - 128.0;
    }
    for(j=0;j<win_w;j++){ 
      pati = (tpos+hpos+j)%NPAT;
      for(k=1;k<=win_h;k++)
	stim[j+1][k][i*2+2] = (float)pattern[pati]/4 - 128.0;
    }
    myfree(pattern);
    tsper *= 2;
  }
  *rstim = stim;
  *x0 = *y0 = *z0 = 1;
  *xn = win_w; *yn = win_h;
  *zn = nframes;
}
void make_frame_set_phase_con_noise(sper,ncon,rstim,x0,xn,y0,yn,z0,zn,hpos)
     int sper,ncon;
     float ****rstim;
     int *x0,*xn,*y0,*yn,*z0,*zn,hpos;
{
  int i,j,k;
  int *pattern,win_w,win_h,patamp,nframes,pati,tpos;
  float ***stim; 
  patamp = 512;
  nframes = 2*ncon;
  win_w = win_h = 64;
  stim = f3tensor(1,win_w,1,win_h,1,nframes);
  if ((hpos < 0)||((hpos+win_w) > NPAT))
    exit_error("MAKE_FRAME_SET_PHASE_CON_NOISE","Invalid hpos");
  pattern = sine_pattern(NPAT,sper,patamp);
  for(i=0;i<ncon;i++){
    tpos = NPAT + sper/4 - win_w/2; 
    for(j=0;j<win_w;j++){ 
      pati = (tpos+hpos+j + sper/2)%NPAT;
      for(k=1;k<=win_h;k++)
	stim[j+1][k][i*2+1] = (float)pattern[pati]/4 - 128.0;
    }
    for(j=0;j<win_w;j++){ 
      pati = (tpos+hpos+j)%NPAT;
      for(k=1;k<=win_h;k++)
	stim[j+1][k][i*2+2] = (float)pattern[pati]/4 - 128.0;
    }
  }
  myfree(pattern);
  *rstim = stim;
  *x0 = *y0 = *z0 = 1;
  *xn = win_w; *yn = win_h;
  *zn = nframes;
}
void make_frame_set_amp_noise(min_wavlen,rstim,x0,xn,y0,yn,z0,zn,hpos)
     int min_wavlen;
     float ****rstim;
     int *x0,*xn,*y0,*yn,*z0,*zn,hpos;
{
  int i,j,k,l;
  int *pattern,win_w,win_h,bar_width,patamp,nframes,pati;
  float ***stim,tamp,tp; 
  bar_width = 1;
  patamp = 512;
  nframes = NAMP;  
  win_w = win_h = 64;
  if ((hpos < 0)||((hpos+win_w/bar_width) > NPAT))
    exit_error("MAKE_FRAME_SET_AMP_NOISE","Invalid hpos");
  pattern = sine_pattern(NPAT,min_wavlen,patamp);
  stim = f3tensor(1,win_w,1,win_h,1,nframes);
  for(i=0;i<nframes;i++){
    tamp = (-(float)((NAMP-1)/2) + (float)i) / (float)((NAMP-1)/2);
    for(j=0;j<(win_w/bar_width);j++){ 
      pati = (hpos+j)%NPAT;  
      for(l=0;l<bar_width;l++) 
	for(k=1;k<=win_h;k++){
	  tp = (float)patamp + tamp * (float)(pattern[pati] - patamp);
	  stim[bar_width*j+l+1][k][i+1] = tp;  
	}
    }
  }
  *rstim = stim;
  *x0 = *y0 = *z0 = 1;
  *xn = win_w; *yn = win_h;
  *zn = nframes;
}
void get_frame_sequence_dirmod(framerate,jumpseed,dtframe,period,distrib,
			       minjump,maxjump,rpt,mu,sigma,rfseq,rn,rvel)
     int period,distrib,minjump,maxjump,rpt,mu,sigma,**rfseq,*rn,**rvel;
{
  int i;
  int n,offset,*fseq,*vel;
  float *xdata,*ydata;
  get_wn_stim_for_params(framerate,jumpseed,dtframe,period,distrib,mu,sigma,
			 minjump,maxjump,rpt,1.0,&xdata,&ydata,&n);
  offset = 0;
  fseq = (int *)myalloc(n*sizeof(int));
  vel = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++){
    vel[i] = my_rint(ydata[i]);
    offset += my_rint(ydata[i]); 
    if (offset >= NPAT) 
      offset -= NPAT;
    else if (offset < 0)
      offset += NPAT;
    fseq[i] = offset;
  }
  myfree(xdata); myfree(ydata);
  *rfseq = fseq; *rn = n; *rvel = vel;
}
void get_frame_sequence_amp(framerate,jumpseed,dtframe,period,distrib,minjump,
			    maxjump,mu,sigma,walkflag,steptype,amp0,dt,
			    rfseq,rn,rvel)
     int framerate,jumpseed,dtframe,period,distrib,minjump,maxjump,mu,sigma;
     int walkflag,steptype,amp0;
     float dt;
     int **rfseq,*rn,**rvel;
{
  int i;
  int n,offset,*fseq,*vel,maxampv;
  float *xdata,*ydata;
  get_amp_mod_stim_for_params(framerate,jumpseed,dtframe,period,distrib,mu,
			      sigma,minjump,maxjump,walkflag,steptype,amp0,
			      dt,&xdata,&ydata,&n);
  maxampv = (NAMP-1);
  fseq = (int *)myalloc(n*sizeof(int));
  vel = (int *)myalloc(n*sizeof(int));
  offset = (NAMP-1)/2; 
  for(i=0;i<n;i++){
    vel[i] = my_rint(ydata[i]); 
    offset += my_rint(ydata[i]); 
    if ((offset < 0) || (offset > maxampv)){
      printf("offset = %d\n",offset);
      exit_error("GET_FRAME_SEQUENCE_AMP","Offset out of bounds");
    }
    fseq[i] = offset;
  }
  myfree(xdata); myfree(ydata);
  *rfseq = fseq; *rn = n; *rvel = vel;
}
void get_frame_sequence_wyphasm(framerate,jumpseed,dtframe,period,distrib,
				minjump,maxjump,rpt,mu,sigma,rfseq,rn,rvel)
     int period,distrib,minjump,maxjump,rpt,mu,sigma,**rfseq,*rn,**rvel;
{
  int i;
  int n,offset,*fseq,*vel;
  float *xdata,*ydata;
  get_wn_stim_for_params(framerate,jumpseed,dtframe,period,distrib,mu,sigma,
			 minjump,maxjump,rpt,1.0,&xdata,&ydata,&n);
  offset = 0; 
  fseq = (int *)myalloc(n*sizeof(int));
  vel = (int *)myalloc(n*sizeof(int));
  for(i=0;i<n;i++){
    vel[i] = my_rint(ydata[i]);
    if (vel[i] == 0)
      exit_error("GET_FRAME_SEQUENCE_WYPHASM","vel is 0\n");
    offset += my_rint(ydata[i]); 
    if (vel[i] > 0)
      fseq[i] = 1;
    else
      fseq[i] = 0;
  }
  myfree(xdata); myfree(ydata);
  *rfseq = fseq; *rn = n; *rvel = vel;
}
